/* web-process-extension.c generated by valac 0.44.1, the Vala compiler
 * generated from web-process-extension.vala, do not modify */

/*
 * Copyright 2016 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <webkit2/webkit-web-extension.h>
#include <glib.h>
#include "geary-engine.h"
#include <stdio.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>
#include <gdk/gdk.h>
#include <JavaScriptCore/JavaScript.h>

#define TYPE_GEARY_WEB_EXTENSION (geary_web_extension_get_type ())
#define GEARY_WEB_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_WEB_EXTENSION, GearyWebExtension))
#define GEARY_WEB_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_WEB_EXTENSION, GearyWebExtensionClass))
#define IS_GEARY_WEB_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_WEB_EXTENSION))
#define IS_GEARY_WEB_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_WEB_EXTENSION))
#define GEARY_WEB_EXTENSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_WEB_EXTENSION, GearyWebExtensionClass))

typedef struct _GearyWebExtension GearyWebExtension;
typedef struct _GearyWebExtensionClass GearyWebExtensionClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GearyWebExtensionPrivate GearyWebExtensionPrivate;
enum  {
	GEARY_WEB_EXTENSION_0_PROPERTY,
	GEARY_WEB_EXTENSION_NUM_PROPERTIES
};
static GParamSpec* geary_web_extension_properties[GEARY_WEB_EXTENSION_NUM_PROPERTIES];
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))

struct _GearyWebExtension {
	GObject parent_instance;
	GearyWebExtensionPrivate * priv;
};

struct _GearyWebExtensionClass {
	GObjectClass parent_class;
};

struct _GearyWebExtensionPrivate {
	WebKitWebExtension* extension;
};

struct _Block1Data {
	int _ref_count_;
	GearyWebExtension* self;
	WebKitWebPage* web_page;
};

static gint GearyWebExtension_private_offset;
static gpointer geary_web_extension_parent_class = NULL;

void webkit_web_extension_initialize_with_user_data (WebKitWebExtension* extension,
                                                     GVariant* data);
GType geary_web_extension_get_type (void) G_GNUC_CONST;
GearyWebExtension* geary_web_extension_new (WebKitWebExtension* extension);
GearyWebExtension* geary_web_extension_construct (GType object_type,
                                                  WebKitWebExtension* extension);
static void __lambda4_ (GearyWebExtension* self,
                 WebKitWebExtension* extension,
                 WebKitWebPage* web_page);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void geary_web_extension_on_console_message (GearyWebExtension* self,
                                             WebKitWebPage* page,
                                             WebKitConsoleMessage* message);
static void _geary_web_extension_on_console_message_webkit_web_page_console_message_sent (WebKitWebPage* _sender,
                                                                                   WebKitConsoleMessage* console_message,
                                                                                   gpointer self);
static gboolean geary_web_extension_on_send_request (GearyWebExtension* self,
                                              WebKitWebPage* page,
                                              WebKitURIRequest* request,
                                              WebKitURIResponse* response);
static gboolean _geary_web_extension_on_send_request_webkit_web_page_send_request (WebKitWebPage* _sender,
                                                                            WebKitURIRequest* request,
                                                                            WebKitURIResponse* redirected_response,
                                                                            gpointer self);
static void __lambda5_ (Block1Data* _data1_);
static void geary_web_extension_selection_changed (GearyWebExtension* self,
                                            WebKitWebPage* page);
static void ___lambda5__webkit_web_editor_selection_changed (WebKitWebEditor* _sender,
                                                      gpointer self);
static void ___lambda4__webkit_web_extension_page_created (WebKitWebExtension* _sender,
                                                    WebKitWebPage* web_page,
                                                    gpointer self);
const gchar* webkit_console_message_level_to_string (WebKitConsoleMessageLevel self);
const gchar* webkit_console_message_source_to_string (WebKitConsoleMessageSource self);
static gboolean _vala_string_array_contains (const gchar* * stack,
                                      int stack_length,
                                      const const gchar* needle);
static gboolean geary_web_extension_should_load_remote_images (GearyWebExtension* self,
                                                        WebKitWebPage* page);
static void geary_web_extension_remote_image_load_blocked (GearyWebExtension* self,
                                                    WebKitWebPage* page);
static void _vala_SoupURI_free (SoupURI* self);
static const struct OpaqueJSValue* geary_web_extension_execute_script (GearyWebExtension* self,
                                                                const struct OpaqueJSContext* context,
                                                                const gchar* script,
                                                                gint line,
                                                                GError** error);
static void geary_web_extension_finalize (GObject * obj);

static const gchar* GEARY_WEB_EXTENSION_ALLOWED_SCHEMES[3] = {"cid", "geary", "data"};

/**
 * Initialises GearyWebExtension for WebKit web processes.
 */
void
webkit_web_extension_initialize_with_user_data (WebKitWebExtension* extension,
                                                GVariant* data)
{
	gboolean logging_enabled = FALSE;
	GearyWebExtension* instance = NULL;
	GearyWebExtension* _tmp1_;
#line 11 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (extension != NULL);
#line 11 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (data != NULL);
#line 13 "../src/client/web-process/web-process-extension.vala"
	logging_enabled = g_variant_get_boolean (data);
#line 15 "../src/client/web-process/web-process-extension.vala"
	geary_logging_init ();
#line 16 "../src/client/web-process/web-process-extension.vala"
	if (logging_enabled) {
#line 140 "web-process-extension.c"
		FILE* _tmp0_;
#line 17 "../src/client/web-process/web-process-extension.vala"
		_tmp0_ = stdout;
#line 17 "../src/client/web-process/web-process-extension.vala"
		geary_logging_log_to (_tmp0_);
#line 146 "web-process-extension.c"
	}
#line 19 "../src/client/web-process/web-process-extension.vala"
	g_debug ("web-process-extension.vala:19: Initialising...");
#line 22 "../src/client/web-process/web-process-extension.vala"
	_tmp1_ = geary_web_extension_new (extension);
#line 22 "../src/client/web-process/web-process-extension.vala"
	instance = _tmp1_;
#line 23 "../src/client/web-process/web-process-extension.vala"
	g_object_ref ((GObject*) instance);
#line 11 "../src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (instance);
#line 158 "web-process-extension.c"
}

static inline gpointer
geary_web_extension_get_instance_private (GearyWebExtension* self)
{
	return G_STRUCT_MEMBER_P (self, GearyWebExtension_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/client/web-process/web-process-extension.vala"
	return self ? g_object_ref (self) : NULL;
#line 172 "web-process-extension.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 39 "../src/client/web-process/web-process-extension.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 39 "../src/client/web-process/web-process-extension.vala"
	return _data1_;
#line 182 "web-process-extension.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 39 "../src/client/web-process/web-process-extension.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 192 "web-process-extension.c"
		GearyWebExtension* self;
#line 39 "../src/client/web-process/web-process-extension.vala"
		self = _data1_->self;
#line 39 "../src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (_data1_->web_page);
#line 39 "../src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (self);
#line 39 "../src/client/web-process/web-process-extension.vala"
		g_slice_free (Block1Data, _data1_);
#line 202 "web-process-extension.c"
	}
}

static void
_geary_web_extension_on_console_message_webkit_web_page_console_message_sent (WebKitWebPage* _sender,
                                                                              WebKitConsoleMessage* console_message,
                                                                              gpointer self)
{
#line 40 "../src/client/web-process/web-process-extension.vala"
	geary_web_extension_on_console_message ((GearyWebExtension*) self, _sender, console_message);
#line 213 "web-process-extension.c"
}

static gboolean
_geary_web_extension_on_send_request_webkit_web_page_send_request (WebKitWebPage* _sender,
                                                                   WebKitURIRequest* request,
                                                                   WebKitURIResponse* redirected_response,
                                                                   gpointer self)
{
	gboolean result;
	result = geary_web_extension_on_send_request ((GearyWebExtension*) self, _sender, request, redirected_response);
#line 41 "../src/client/web-process/web-process-extension.vala"
	return result;
#line 226 "web-process-extension.c"
}

static void
__lambda5_ (Block1Data* _data1_)
{
	GearyWebExtension* self;
#line 46 "../src/client/web-process/web-process-extension.vala"
	self = _data1_->self;
#line 47 "../src/client/web-process/web-process-extension.vala"
	geary_web_extension_selection_changed (self, _data1_->web_page);
#line 237 "web-process-extension.c"
}

static void
___lambda5__webkit_web_editor_selection_changed (WebKitWebEditor* _sender,
                                                 gpointer self)
{
#line 46 "../src/client/web-process/web-process-extension.vala"
	__lambda5_ (self);
#line 246 "web-process-extension.c"
}

static void
__lambda4_ (GearyWebExtension* self,
            WebKitWebExtension* extension,
            WebKitWebPage* web_page)
{
	Block1Data* _data1_;
	WebKitWebPage* _tmp0_;
	WebKitWebEditor* _tmp1_;
#line 39 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (extension != NULL);
#line 39 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (web_page != NULL);
#line 39 "../src/client/web-process/web-process-extension.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 39 "../src/client/web-process/web-process-extension.vala"
	_data1_->_ref_count_ = 1;
#line 39 "../src/client/web-process/web-process-extension.vala"
	_data1_->self = g_object_ref (self);
#line 39 "../src/client/web-process/web-process-extension.vala"
	_tmp0_ = _g_object_ref0 (web_page);
#line 39 "../src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (_data1_->web_page);
#line 39 "../src/client/web-process/web-process-extension.vala"
	_data1_->web_page = _tmp0_;
#line 40 "../src/client/web-process/web-process-extension.vala"
	g_signal_connect_object (_data1_->web_page, "console-message-sent", (GCallback) _geary_web_extension_on_console_message_webkit_web_page_console_message_sent, self, 0);
#line 41 "../src/client/web-process/web-process-extension.vala"
	g_signal_connect_object (_data1_->web_page, "send-request", (GCallback) _geary_web_extension_on_send_request_webkit_web_page_send_request, self, 0);
#line 46 "../src/client/web-process/web-process-extension.vala"
	_tmp1_ = webkit_web_page_get_editor (_data1_->web_page);
#line 46 "../src/client/web-process/web-process-extension.vala"
	g_signal_connect_data (_tmp1_, "selection-changed", (GCallback) ___lambda5__webkit_web_editor_selection_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 39 "../src/client/web-process/web-process-extension.vala"
	block1_data_unref (_data1_);
#line 39 "../src/client/web-process/web-process-extension.vala"
	_data1_ = NULL;
#line 285 "web-process-extension.c"
}

static void
___lambda4__webkit_web_extension_page_created (WebKitWebExtension* _sender,
                                               WebKitWebPage* web_page,
                                               gpointer self)
{
#line 39 "../src/client/web-process/web-process-extension.vala"
	__lambda4_ ((GearyWebExtension*) self, _sender, web_page);
#line 295 "web-process-extension.c"
}

GearyWebExtension*
geary_web_extension_construct (GType object_type,
                               WebKitWebExtension* extension)
{
	GearyWebExtension * self = NULL;
	WebKitWebExtension* _tmp0_;
#line 37 "../src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 37 "../src/client/web-process/web-process-extension.vala"
	self = (GearyWebExtension*) g_object_new (object_type, NULL);
#line 38 "../src/client/web-process/web-process-extension.vala"
	_tmp0_ = _g_object_ref0 (extension);
#line 38 "../src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (self->priv->extension);
#line 38 "../src/client/web-process/web-process-extension.vala"
	self->priv->extension = _tmp0_;
#line 39 "../src/client/web-process/web-process-extension.vala"
	g_signal_connect_object (extension, "page-created", (GCallback) ___lambda4__webkit_web_extension_page_created, self, 0);
#line 37 "../src/client/web-process/web-process-extension.vala"
	return self;
#line 318 "web-process-extension.c"
}

GearyWebExtension*
geary_web_extension_new (WebKitWebExtension* extension)
{
#line 37 "../src/client/web-process/web-process-extension.vala"
	return geary_web_extension_construct (TYPE_GEARY_WEB_EXTENSION, extension);
#line 326 "web-process-extension.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 349 "web-process-extension.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 358 "web-process-extension.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 377 "web-process-extension.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 381 "web-process-extension.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 387 "web-process-extension.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 397 "web-process-extension.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 405 "web-process-extension.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 409 "web-process-extension.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 415 "web-process-extension.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 425 "web-process-extension.c"
}

static void
geary_web_extension_on_console_message (GearyWebExtension* self,
                                        WebKitWebPage* page,
                                        WebKitConsoleMessage* message)
{
	gchar* source = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	GEnumValue* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GEnumValue* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
#line 53 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (page != NULL);
#line 53 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (message != NULL);
#line 55 "../src/client/web-process/web-process-extension.vala"
	_tmp0_ = webkit_console_message_get_source_id (message);
#line 55 "../src/client/web-process/web-process-extension.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 55 "../src/client/web-process/web-process-extension.vala"
	source = _tmp1_;
#line 59 "../src/client/web-process/web-process-extension.vala"
	_tmp3_ = source;
#line 59 "../src/client/web-process/web-process-extension.vala"
	if (geary_string_is_empty (_tmp3_)) {
#line 59 "../src/client/web-process/web-process-extension.vala"
		_tmp2_ = "unknown";
#line 467 "web-process-extension.c"
	} else {
		const gchar* _tmp4_;
#line 59 "../src/client/web-process/web-process-extension.vala"
		_tmp4_ = source;
#line 59 "../src/client/web-process/web-process-extension.vala"
		_tmp2_ = _tmp4_;
#line 474 "web-process-extension.c"
	}
#line 57 "../src/client/web-process/web-process-extension.vala"
	_tmp5_ = g_enum_get_value (g_type_class_ref (webkit_console_message_level_get_type ()), webkit_console_message_get_level (message));
#line 56 "../src/client/web-process/web-process-extension.vala"
	_tmp6_ = strlen ("WEBKIT_CONSOLE_MESSAGE_LEVEL_");
#line 56 "../src/client/web-process/web-process-extension.vala"
	_tmp7_ = _tmp6_;
#line 56 "../src/client/web-process/web-process-extension.vala"
	_tmp8_ = string_substring ((_tmp5_ != NULL) ? _tmp5_->value_name : NULL, (glong) _tmp7_, (glong) -1);
#line 56 "../src/client/web-process/web-process-extension.vala"
	_tmp9_ = _tmp8_;
#line 58 "../src/client/web-process/web-process-extension.vala"
	_tmp10_ = g_enum_get_value (g_type_class_ref (webkit_console_message_source_get_type ()), webkit_console_message_get_source (message));
#line 56 "../src/client/web-process/web-process-extension.vala"
	_tmp11_ = strlen ("WEBKIT_CONSOLE_MESSAGE_SOURCE_");
#line 56 "../src/client/web-process/web-process-extension.vala"
	_tmp12_ = _tmp11_;
#line 56 "../src/client/web-process/web-process-extension.vala"
	_tmp13_ = string_substring ((_tmp10_ != NULL) ? _tmp10_->value_name : NULL, (glong) _tmp12_, (glong) -1);
#line 56 "../src/client/web-process/web-process-extension.vala"
	_tmp14_ = _tmp13_;
#line 56 "../src/client/web-process/web-process-extension.vala"
	_tmp15_ = webkit_console_message_get_text (message);
#line 56 "../src/client/web-process/web-process-extension.vala"
	g_debug ("web-process-extension.vala:56: Console: [%s] %s %s:%u: %s", _tmp9_, _tmp14_, _tmp2_, webkit_console_message_get_line (message), _tmp15_);
#line 56 "../src/client/web-process/web-process-extension.vala"
	_g_free0 (_tmp14_);
#line 56 "../src/client/web-process/web-process-extension.vala"
	_g_free0 (_tmp9_);
#line 53 "../src/client/web-process/web-process-extension.vala"
	_g_free0 (source);
#line 506 "web-process-extension.c"
}

static gboolean
_vala_string_array_contains (const gchar* * stack,
                             int stack_length,
                             const const gchar* needle)
{
	int i;
#line 70 "../src/client/web-process/web-process-extension.vala"
	for (i = 0; i < stack_length; i++) {
#line 70 "../src/client/web-process/web-process-extension.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 70 "../src/client/web-process/web-process-extension.vala"
			return TRUE;
#line 521 "web-process-extension.c"
		}
	}
#line 70 "../src/client/web-process/web-process-extension.vala"
	return FALSE;
#line 526 "web-process-extension.c"
}

static void
_vala_SoupURI_free (SoupURI* self)
{
#line 83 "../src/client/web-process/web-process-extension.vala"
	g_boxed_free (soup_uri_get_type (), self);
#line 534 "web-process-extension.c"
}

static gboolean
geary_web_extension_on_send_request (GearyWebExtension* self,
                                     WebKitWebPage* page,
                                     WebKitURIRequest* request,
                                     WebKitURIResponse* response)
{
	gboolean result = FALSE;
	gboolean should_load = FALSE;
	SoupURI* uri = NULL;
	const gchar* _tmp0_;
	SoupURI* _tmp1_;
	gboolean _tmp2_ = FALSE;
	SoupURI* _tmp3_;
	gboolean _tmp6_ = FALSE;
#line 65 "../src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (page != NULL, FALSE);
#line 65 "../src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (request != NULL, FALSE);
#line 68 "../src/client/web-process/web-process-extension.vala"
	should_load = FALSE;
#line 69 "../src/client/web-process/web-process-extension.vala"
	_tmp0_ = webkit_uri_request_get_uri (request);
#line 69 "../src/client/web-process/web-process-extension.vala"
	_tmp1_ = soup_uri_new (_tmp0_);
#line 69 "../src/client/web-process/web-process-extension.vala"
	uri = _tmp1_;
#line 70 "../src/client/web-process/web-process-extension.vala"
	_tmp3_ = uri;
#line 70 "../src/client/web-process/web-process-extension.vala"
	if (_tmp3_ != NULL) {
#line 569 "web-process-extension.c"
		SoupURI* _tmp4_;
		const gchar* _tmp5_;
#line 70 "../src/client/web-process/web-process-extension.vala"
		_tmp4_ = uri;
#line 70 "../src/client/web-process/web-process-extension.vala"
		_tmp5_ = soup_uri_get_scheme (_tmp4_);
#line 70 "../src/client/web-process/web-process-extension.vala"
		_tmp2_ = _vala_string_array_contains (GEARY_WEB_EXTENSION_ALLOWED_SCHEMES, G_N_ELEMENTS (GEARY_WEB_EXTENSION_ALLOWED_SCHEMES), _tmp5_);
#line 578 "web-process-extension.c"
	} else {
#line 70 "../src/client/web-process/web-process-extension.vala"
		_tmp2_ = FALSE;
#line 582 "web-process-extension.c"
	}
#line 70 "../src/client/web-process/web-process-extension.vala"
	if (_tmp2_) {
#line 72 "../src/client/web-process/web-process-extension.vala"
		should_load = TRUE;
#line 588 "web-process-extension.c"
	} else {
#line 76 "../src/client/web-process/web-process-extension.vala"
		if (geary_web_extension_should_load_remote_images (self, page)) {
#line 77 "../src/client/web-process/web-process-extension.vala"
			should_load = TRUE;
#line 594 "web-process-extension.c"
		} else {
#line 79 "../src/client/web-process/web-process-extension.vala"
			geary_web_extension_remote_image_load_blocked (self, page);
#line 598 "web-process-extension.c"
		}
	}
#line 83 "../src/client/web-process/web-process-extension.vala"
	if (should_load) {
#line 83 "../src/client/web-process/web-process-extension.vala"
		_tmp6_ = GDK_EVENT_PROPAGATE;
#line 605 "web-process-extension.c"
	} else {
#line 83 "../src/client/web-process/web-process-extension.vala"
		_tmp6_ = GDK_EVENT_STOP;
#line 609 "web-process-extension.c"
	}
#line 83 "../src/client/web-process/web-process-extension.vala"
	result = _tmp6_;
#line 83 "../src/client/web-process/web-process-extension.vala"
	__vala_SoupURI_free0 (uri);
#line 83 "../src/client/web-process/web-process-extension.vala"
	return result;
#line 617 "web-process-extension.c"
}

static gboolean
geary_web_extension_should_load_remote_images (GearyWebExtension* self,
                                               WebKitWebPage* page)
{
	gboolean result = FALSE;
	gboolean should_load = FALSE;
	WebKitFrame* frame = NULL;
	WebKitFrame* _tmp0_;
	WebKitFrame* _tmp1_;
	struct OpaqueJSContext* context = NULL;
	struct OpaqueJSContext* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 86 "../src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "../src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (page != NULL, FALSE);
#line 87 "../src/client/web-process/web-process-extension.vala"
	should_load = FALSE;
#line 88 "../src/client/web-process/web-process-extension.vala"
	_tmp0_ = webkit_web_page_get_main_frame (page);
#line 88 "../src/client/web-process/web-process-extension.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 88 "../src/client/web-process/web-process-extension.vala"
	frame = _tmp1_;
#line 90 "../src/client/web-process/web-process-extension.vala"
	_tmp2_ = webkit_frame_get_javascript_global_context (frame);
#line 90 "../src/client/web-process/web-process-extension.vala"
	context = (struct OpaqueJSContext*) _tmp2_;
#line 648 "web-process-extension.c"
	{
		const struct OpaqueJSValue* ret = NULL;
		const struct OpaqueJSValue* _tmp3_;
#line 93 "../src/client/web-process/web-process-extension.vala"
		_tmp3_ = geary_web_extension_execute_script (self, (const struct OpaqueJSContext*) context, "geary.allowRemoteImages", atoi ("__LINE__"), &_inner_error0_);
#line 93 "../src/client/web-process/web-process-extension.vala"
		ret = _tmp3_;
#line 93 "../src/client/web-process/web-process-extension.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 658 "web-process-extension.c"
			goto __catch0_g_error;
		}
#line 96 "../src/client/web-process/web-process-extension.vala"
		should_load = JSValueToBoolean ((const struct OpaqueJSContext*) context, ret);
#line 663 "web-process-extension.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 92 "../src/client/web-process/web-process-extension.vala"
		err = _inner_error0_;
#line 92 "../src/client/web-process/web-process-extension.vala"
		_inner_error0_ = NULL;
#line 98 "../src/client/web-process/web-process-extension.vala"
		_tmp4_ = err;
#line 98 "../src/client/web-process/web-process-extension.vala"
		_tmp5_ = _tmp4_->message;
#line 98 "../src/client/web-process/web-process-extension.vala"
		g_debug ("web-process-extension.vala:98: Error checking PageState::allowRemoteIm" \
"ages: %s", _tmp5_);
#line 92 "../src/client/web-process/web-process-extension.vala"
		_g_error_free0 (err);
#line 683 "web-process-extension.c"
	}
	__finally0:
#line 92 "../src/client/web-process/web-process-extension.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 688 "web-process-extension.c"
		gboolean _tmp6_ = FALSE;
#line 92 "../src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (frame);
#line 92 "../src/client/web-process/web-process-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "../src/client/web-process/web-process-extension.vala"
		g_clear_error (&_inner_error0_);
#line 92 "../src/client/web-process/web-process-extension.vala"
		return _tmp6_;
#line 698 "web-process-extension.c"
	}
#line 103 "../src/client/web-process/web-process-extension.vala"
	result = should_load;
#line 103 "../src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (frame);
#line 103 "../src/client/web-process/web-process-extension.vala"
	return result;
#line 706 "web-process-extension.c"
}

static void
geary_web_extension_remote_image_load_blocked (GearyWebExtension* self,
                                               WebKitWebPage* page)
{
	WebKitFrame* frame = NULL;
	WebKitFrame* _tmp0_;
	WebKitFrame* _tmp1_;
	struct OpaqueJSContext* context = NULL;
	struct OpaqueJSContext* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 106 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (page != NULL);
#line 107 "../src/client/web-process/web-process-extension.vala"
	_tmp0_ = webkit_web_page_get_main_frame (page);
#line 107 "../src/client/web-process/web-process-extension.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 107 "../src/client/web-process/web-process-extension.vala"
	frame = _tmp1_;
#line 109 "../src/client/web-process/web-process-extension.vala"
	_tmp2_ = webkit_frame_get_javascript_global_context (frame);
#line 109 "../src/client/web-process/web-process-extension.vala"
	context = (struct OpaqueJSContext*) _tmp2_;
#line 733 "web-process-extension.c"
	{
#line 112 "../src/client/web-process/web-process-extension.vala"
		geary_web_extension_execute_script (self, (const struct OpaqueJSContext*) context, "geary.remoteImageLoadBlocked();", atoi ("__LINE__"), &_inner_error0_);
#line 112 "../src/client/web-process/web-process-extension.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 739 "web-process-extension.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 111 "../src/client/web-process/web-process-extension.vala"
		err = _inner_error0_;
#line 111 "../src/client/web-process/web-process-extension.vala"
		_inner_error0_ = NULL;
#line 116 "../src/client/web-process/web-process-extension.vala"
		_tmp3_ = err;
#line 116 "../src/client/web-process/web-process-extension.vala"
		_tmp4_ = _tmp3_->message;
#line 116 "../src/client/web-process/web-process-extension.vala"
		g_debug ("web-process-extension.vala:116: Error calling PageState::remoteImageLo" \
"adBlocked: %s", _tmp4_);
#line 111 "../src/client/web-process/web-process-extension.vala"
		_g_error_free0 (err);
#line 761 "web-process-extension.c"
	}
	__finally1:
#line 111 "../src/client/web-process/web-process-extension.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (frame);
#line 111 "../src/client/web-process/web-process-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "../src/client/web-process/web-process-extension.vala"
		g_clear_error (&_inner_error0_);
#line 111 "../src/client/web-process/web-process-extension.vala"
		return;
#line 774 "web-process-extension.c"
	}
#line 106 "../src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (frame);
#line 778 "web-process-extension.c"
}

static void
geary_web_extension_selection_changed (GearyWebExtension* self,
                                       WebKitWebPage* page)
{
	WebKitFrame* frame = NULL;
	WebKitFrame* _tmp0_;
	WebKitFrame* _tmp1_;
	struct OpaqueJSContext* context = NULL;
	struct OpaqueJSContext* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 123 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/client/web-process/web-process-extension.vala"
	g_return_if_fail (page != NULL);
#line 124 "../src/client/web-process/web-process-extension.vala"
	_tmp0_ = webkit_web_page_get_main_frame (page);
#line 124 "../src/client/web-process/web-process-extension.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 124 "../src/client/web-process/web-process-extension.vala"
	frame = _tmp1_;
#line 126 "../src/client/web-process/web-process-extension.vala"
	_tmp2_ = webkit_frame_get_javascript_global_context (frame);
#line 126 "../src/client/web-process/web-process-extension.vala"
	context = (struct OpaqueJSContext*) _tmp2_;
#line 805 "web-process-extension.c"
	{
#line 129 "../src/client/web-process/web-process-extension.vala"
		geary_web_extension_execute_script (self, (const struct OpaqueJSContext*) context, "geary.selectionChanged();", atoi ("__LINE__"), &_inner_error0_);
#line 129 "../src/client/web-process/web-process-extension.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 811 "web-process-extension.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 128 "../src/client/web-process/web-process-extension.vala"
		err = _inner_error0_;
#line 128 "../src/client/web-process/web-process-extension.vala"
		_inner_error0_ = NULL;
#line 133 "../src/client/web-process/web-process-extension.vala"
		_tmp3_ = err;
#line 133 "../src/client/web-process/web-process-extension.vala"
		_tmp4_ = _tmp3_->message;
#line 133 "../src/client/web-process/web-process-extension.vala"
		g_debug ("web-process-extension.vala:133: Error calling PageStates::selectionCha" \
"nged: %s", _tmp4_);
#line 128 "../src/client/web-process/web-process-extension.vala"
		_g_error_free0 (err);
#line 833 "web-process-extension.c"
	}
	__finally2:
#line 128 "../src/client/web-process/web-process-extension.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "../src/client/web-process/web-process-extension.vala"
		_g_object_unref0 (frame);
#line 128 "../src/client/web-process/web-process-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 128 "../src/client/web-process/web-process-extension.vala"
		g_clear_error (&_inner_error0_);
#line 128 "../src/client/web-process/web-process-extension.vala"
		return;
#line 846 "web-process-extension.c"
	}
#line 123 "../src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (frame);
#line 850 "web-process-extension.c"
}

static const struct OpaqueJSValue*
geary_web_extension_execute_script (GearyWebExtension* self,
                                    const struct OpaqueJSContext* context,
                                    const gchar* script,
                                    gint line,
                                    GError** error)
{
	const struct OpaqueJSValue* result = NULL;
	struct OpaqueJSString* js_script = NULL;
	struct OpaqueJSString* _tmp0_;
	struct OpaqueJSString* js_source = NULL;
	struct OpaqueJSString* _tmp1_;
	const struct OpaqueJSValue* err = NULL;
	GError* _inner_error0_ = NULL;
#line 139 "../src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "../src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 139 "../src/client/web-process/web-process-extension.vala"
	g_return_val_if_fail (script != NULL, NULL);
#line 141 "../src/client/web-process/web-process-extension.vala"
	_tmp0_ = JSStringCreateWithUTF8CString (script);
#line 141 "../src/client/web-process/web-process-extension.vala"
	js_script = _tmp0_;
#line 142 "../src/client/web-process/web-process-extension.vala"
	_tmp1_ = JSStringCreateWithUTF8CString ("__FILE__");
#line 142 "../src/client/web-process/web-process-extension.vala"
	js_source = _tmp1_;
#line 143 "../src/client/web-process/web-process-extension.vala"
	err = NULL;
#line 883 "web-process-extension.c"
	{
		const struct OpaqueJSValue* ret = NULL;
		struct OpaqueJSString* _tmp2_;
		struct OpaqueJSString* _tmp3_;
		const struct OpaqueJSValue* _tmp4_ = NULL;
		const struct OpaqueJSValue* _tmp5_;
		const struct OpaqueJSValue* _tmp6_;
		const struct OpaqueJSValue* _tmp7_;
#line 145 "../src/client/web-process/web-process-extension.vala"
		_tmp2_ = js_script;
#line 145 "../src/client/web-process/web-process-extension.vala"
		_tmp3_ = js_source;
#line 145 "../src/client/web-process/web-process-extension.vala"
		_tmp5_ = JSEvaluateScript (context, _tmp2_, NULL, _tmp3_, line, &_tmp4_);
#line 145 "../src/client/web-process/web-process-extension.vala"
		_0 (err);
#line 145 "../src/client/web-process/web-process-extension.vala"
		err = _tmp4_;
#line 145 "../src/client/web-process/web-process-extension.vala"
		ret = _tmp5_;
#line 148 "../src/client/web-process/web-process-extension.vala"
		_tmp6_ = err;
#line 148 "../src/client/web-process/web-process-extension.vala"
		geary_js_check_exception (context, _tmp6_, &_inner_error0_);
#line 148 "../src/client/web-process/web-process-extension.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 910 "web-process-extension.c"
			goto __finally3;
		}
#line 149 "../src/client/web-process/web-process-extension.vala"
		_tmp7_ = ret;
#line 149 "../src/client/web-process/web-process-extension.vala"
		result = _tmp7_;
#line 917 "web-process-extension.c"
		{
			GError* _inner_error0_ = NULL;
		}
#line 149 "../src/client/web-process/web-process-extension.vala"
		_0 (err);
#line 149 "../src/client/web-process/web-process-extension.vala"
		_JSStringRelease0 (js_source);
#line 149 "../src/client/web-process/web-process-extension.vala"
		_JSStringRelease0 (js_script);
#line 149 "../src/client/web-process/web-process-extension.vala"
		return result;
#line 929 "web-process-extension.c"
	}
	__finally3:
	{
		GError* _inner_error1_ = NULL;
	}
#line 144 "../src/client/web-process/web-process-extension.vala"
	if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 144 "../src/client/web-process/web-process-extension.vala"
		g_propagate_error (error, _inner_error0_);
#line 144 "../src/client/web-process/web-process-extension.vala"
		_0 (err);
#line 144 "../src/client/web-process/web-process-extension.vala"
		_JSStringRelease0 (js_source);
#line 144 "../src/client/web-process/web-process-extension.vala"
		_JSStringRelease0 (js_script);
#line 144 "../src/client/web-process/web-process-extension.vala"
		return NULL;
#line 947 "web-process-extension.c"
	} else {
#line 144 "../src/client/web-process/web-process-extension.vala"
		_0 (err);
#line 144 "../src/client/web-process/web-process-extension.vala"
		_JSStringRelease0 (js_source);
#line 144 "../src/client/web-process/web-process-extension.vala"
		_JSStringRelease0 (js_script);
#line 144 "../src/client/web-process/web-process-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 144 "../src/client/web-process/web-process-extension.vala"
		g_clear_error (&_inner_error0_);
#line 144 "../src/client/web-process/web-process-extension.vala"
		return NULL;
#line 961 "web-process-extension.c"
	}
#line 139 "../src/client/web-process/web-process-extension.vala"
	_0 (err);
#line 139 "../src/client/web-process/web-process-extension.vala"
	_JSStringRelease0 (js_source);
#line 139 "../src/client/web-process/web-process-extension.vala"
	_JSStringRelease0 (js_script);
#line 969 "web-process-extension.c"
}

static void
geary_web_extension_class_init (GearyWebExtensionClass * klass,
                                gpointer klass_data)
{
#line 29 "../src/client/web-process/web-process-extension.vala"
	geary_web_extension_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/client/web-process/web-process-extension.vala"
	g_type_class_adjust_private_offset (klass, &GearyWebExtension_private_offset);
#line 29 "../src/client/web-process/web-process-extension.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_web_extension_finalize;
#line 982 "web-process-extension.c"
}

static void
geary_web_extension_instance_init (GearyWebExtension * self,
                                   gpointer klass)
{
#line 29 "../src/client/web-process/web-process-extension.vala"
	self->priv = geary_web_extension_get_instance_private (self);
#line 991 "web-process-extension.c"
}

static void
geary_web_extension_finalize (GObject * obj)
{
	GearyWebExtension * self;
#line 29 "../src/client/web-process/web-process-extension.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GEARY_WEB_EXTENSION, GearyWebExtension);
#line 34 "../src/client/web-process/web-process-extension.vala"
	_g_object_unref0 (self->priv->extension);
#line 29 "../src/client/web-process/web-process-extension.vala"
	G_OBJECT_CLASS (geary_web_extension_parent_class)->finalize (obj);
#line 1004 "web-process-extension.c"
}

/**
 * A WebExtension that manages Geary-specific behaviours in web processes.
 */
GType
geary_web_extension_get_type (void)
{
	static volatile gsize geary_web_extension_type_id__volatile = 0;
	if (g_once_init_enter (&geary_web_extension_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyWebExtensionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_web_extension_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyWebExtension), 0, (GInstanceInitFunc) geary_web_extension_instance_init, NULL };
		GType geary_web_extension_type_id;
		geary_web_extension_type_id = g_type_register_static (G_TYPE_OBJECT, "GearyWebExtension", &g_define_type_info, 0);
		GearyWebExtension_private_offset = g_type_add_instance_private (geary_web_extension_type_id, sizeof (GearyWebExtensionPrivate));
		g_once_init_leave (&geary_web_extension_type_id__volatile, geary_web_extension_type_id);
	}
	return geary_web_extension_type_id__volatile;
}

