/* autostart-manager.c generated by valac 0.44.1, the Vala compiler
 * generated from autostart-manager.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/*
 * A simple class for manipulating autostarting Geary as a hidden application through a simple
 * desktop file at $HOME/.config/autostart/geary.desktop
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define TYPE_AUTOSTART_MANAGER (autostart_manager_get_type ())
#define AUTOSTART_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AUTOSTART_MANAGER, AutostartManager))
#define AUTOSTART_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AUTOSTART_MANAGER, AutostartManagerClass))
#define IS_AUTOSTART_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AUTOSTART_MANAGER))
#define IS_AUTOSTART_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AUTOSTART_MANAGER))
#define AUTOSTART_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AUTOSTART_MANAGER, AutostartManagerClass))

typedef struct _AutostartManager AutostartManager;
typedef struct _AutostartManagerClass AutostartManagerClass;
typedef struct _AutostartManagerPrivate AutostartManagerPrivate;

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;
enum  {
	AUTOSTART_MANAGER_0_PROPERTY,
	AUTOSTART_MANAGER_NUM_PROPERTIES
};
static GParamSpec* autostart_manager_properties[AUTOSTART_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AutostartManager {
	GObject parent_instance;
	AutostartManagerPrivate * priv;
};

struct _AutostartManagerClass {
	GObjectClass parent_class;
};

struct _AutostartManagerPrivate {
	GearyApplication* instance;
	GFile* startup_file;
};

static gint AutostartManager_private_offset;
static gpointer autostart_manager_parent_class = NULL;

GType autostart_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AutostartManager, g_object_unref)
GType geary_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyApplication, g_object_unref)
#define AUTOSTART_MANAGER_AUTOSTART_FOLDER "autostart"
#define AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE "geary-autostart.desktop"
AutostartManager* autostart_manager_new (GearyApplication* instance);
AutostartManager* autostart_manager_construct (GType object_type,
                                               GearyApplication* instance);
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_configuration (GValue* value,
                              gpointer v_object);
void value_take_configuration (GValue* value,
                               gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Configuration, configuration_unref)
Configuration* geary_application_get_config (GearyApplication* self);
GSettings* configuration_get_settings (Configuration* self);
#define CONFIGURATION_STARTUP_NOTIFICATIONS_KEY "startup-notifications"
void autostart_manager_on_startup_notification_change (AutostartManager* self);
static void _autostart_manager_on_startup_notification_change_g_settings_changed (GSettings* _sender,
                                                                           const gchar* key,
                                                                           gpointer self);
GFile* autostart_manager_get_autostart_desktop_file (AutostartManager* self);
GFile* geary_application_get_install_dir (GearyApplication* self);
#define GEARY_APPLICATION_SOURCE_ROOT_DIR _SOURCE_ROOT_DIR
void autostart_manager_delete_startup_file (AutostartManager* self);
void autostart_manager_create_startup_file (AutostartManager* self);
gboolean configuration_get_startup_notifications (Configuration* self);
void autostart_manager_sync_with_config (AutostartManager* self);
void configuration_set_startup_notifications (Configuration* self,
                                              gboolean value);
static void autostart_manager_finalize (GObject * obj);

static inline gpointer
autostart_manager_get_instance_private (AutostartManager* self)
{
	return G_STRUCT_MEMBER_P (self, AutostartManager_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 20 "../src/client/application/autostart-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 130 "autostart-manager.c"
}

static void
_autostart_manager_on_startup_notification_change_g_settings_changed (GSettings* _sender,
                                                                      const gchar* key,
                                                                      gpointer self)
{
#line 25 "../src/client/application/autostart-manager.vala"
	autostart_manager_on_startup_notification_change ((AutostartManager*) self);
#line 140 "autostart-manager.c"
}

AutostartManager*
autostart_manager_construct (GType object_type,
                             GearyApplication* instance)
{
	AutostartManager * self = NULL;
	GearyApplication* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GearyApplication* _tmp7_;
	Configuration* _tmp8_;
	Configuration* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	gchar* _tmp12_;
#line 19 "../src/client/application/autostart-manager.vala"
	g_return_val_if_fail (IS_GEARY_APPLICATION (instance), NULL);
#line 19 "../src/client/application/autostart-manager.vala"
	self = (AutostartManager*) g_object_new (object_type, NULL);
#line 20 "../src/client/application/autostart-manager.vala"
	_tmp0_ = _g_object_ref0 (instance);
#line 20 "../src/client/application/autostart-manager.vala"
	_g_object_unref0 (self->priv->instance);
#line 20 "../src/client/application/autostart-manager.vala"
	self->priv->instance = _tmp0_;
#line 21 "../src/client/application/autostart-manager.vala"
	_tmp1_ = g_get_user_config_dir ();
#line 21 "../src/client/application/autostart-manager.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 21 "../src/client/application/autostart-manager.vala"
	_tmp3_ = _tmp2_;
#line 21 "../src/client/application/autostart-manager.vala"
	_tmp4_ = g_file_get_child (_tmp3_, AUTOSTART_MANAGER_AUTOSTART_FOLDER);
#line 21 "../src/client/application/autostart-manager.vala"
	_tmp5_ = _tmp4_;
#line 21 "../src/client/application/autostart-manager.vala"
	_tmp6_ = g_file_get_child (_tmp5_, AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE);
#line 21 "../src/client/application/autostart-manager.vala"
	_g_object_unref0 (self->priv->startup_file);
#line 21 "../src/client/application/autostart-manager.vala"
	self->priv->startup_file = _tmp6_;
#line 21 "../src/client/application/autostart-manager.vala"
	_g_object_unref0 (_tmp5_);
#line 21 "../src/client/application/autostart-manager.vala"
	_g_object_unref0 (_tmp3_);
#line 25 "../src/client/application/autostart-manager.vala"
	_tmp7_ = self->priv->instance;
#line 25 "../src/client/application/autostart-manager.vala"
	_tmp8_ = geary_application_get_config (_tmp7_);
#line 25 "../src/client/application/autostart-manager.vala"
	_tmp9_ = _tmp8_;
#line 25 "../src/client/application/autostart-manager.vala"
	_tmp10_ = configuration_get_settings (_tmp9_);
#line 25 "../src/client/application/autostart-manager.vala"
	_tmp11_ = _tmp10_;
#line 25 "../src/client/application/autostart-manager.vala"
	_tmp12_ = g_strconcat ("changed::", CONFIGURATION_STARTUP_NOTIFICATIONS_KEY, NULL);
#line 25 "../src/client/application/autostart-manager.vala"
	g_signal_connect_object (_tmp11_, _tmp12_, (GCallback) _autostart_manager_on_startup_notification_change_g_settings_changed, self, 0);
#line 25 "../src/client/application/autostart-manager.vala"
	_g_free0 (_tmp12_);
#line 19 "../src/client/application/autostart-manager.vala"
	return self;
#line 209 "autostart-manager.c"
}

AutostartManager*
autostart_manager_new (GearyApplication* instance)
{
#line 19 "../src/client/application/autostart-manager.vala"
	return autostart_manager_construct (TYPE_AUTOSTART_MANAGER, instance);
#line 217 "autostart-manager.c"
}

/**
     * Returns the system-wide autostart desktop file
     */
GFile*
autostart_manager_get_autostart_desktop_file (AutostartManager* self)
{
	GFile* result = NULL;
	GFile* install_dir = NULL;
	GearyApplication* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* desktop_file = NULL;
	GFile* _tmp17_;
	GFile* _tmp18_ = NULL;
	GFile* _tmp19_;
	GFile* _tmp21_;
#line 32 "../src/client/application/autostart-manager.vala"
	g_return_val_if_fail (IS_AUTOSTART_MANAGER (self), NULL);
#line 33 "../src/client/application/autostart-manager.vala"
	_tmp0_ = self->priv->instance;
#line 33 "../src/client/application/autostart-manager.vala"
	_tmp1_ = geary_application_get_install_dir (_tmp0_);
#line 33 "../src/client/application/autostart-manager.vala"
	install_dir = _tmp1_;
#line 34 "../src/client/application/autostart-manager.vala"
	_tmp3_ = install_dir;
#line 34 "../src/client/application/autostart-manager.vala"
	if (_tmp3_ != NULL) {
#line 249 "autostart-manager.c"
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
#line 35 "../src/client/application/autostart-manager.vala"
		_tmp4_ = install_dir;
#line 35 "../src/client/application/autostart-manager.vala"
		_tmp5_ = g_file_get_child (_tmp4_, "share");
#line 35 "../src/client/application/autostart-manager.vala"
		_tmp6_ = _tmp5_;
#line 35 "../src/client/application/autostart-manager.vala"
		_tmp7_ = g_file_get_child (_tmp6_, "applications");
#line 35 "../src/client/application/autostart-manager.vala"
		_tmp8_ = _tmp7_;
#line 35 "../src/client/application/autostart-manager.vala"
		_tmp9_ = g_file_get_child (_tmp8_, AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE);
#line 35 "../src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp2_);
#line 35 "../src/client/application/autostart-manager.vala"
		_tmp2_ = _tmp9_;
#line 35 "../src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp8_);
#line 35 "../src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp6_);
#line 276 "autostart-manager.c"
	} else {
		GFile* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
		GFile* _tmp16_;
#line 36 "../src/client/application/autostart-manager.vala"
		_tmp10_ = g_file_new_for_path (GEARY_APPLICATION_SOURCE_ROOT_DIR);
#line 36 "../src/client/application/autostart-manager.vala"
		_tmp11_ = _tmp10_;
#line 36 "../src/client/application/autostart-manager.vala"
		_tmp12_ = g_file_get_child (_tmp11_, "build");
#line 36 "../src/client/application/autostart-manager.vala"
		_tmp13_ = _tmp12_;
#line 36 "../src/client/application/autostart-manager.vala"
		_tmp14_ = g_file_get_child (_tmp13_, "desktop");
#line 36 "../src/client/application/autostart-manager.vala"
		_tmp15_ = _tmp14_;
#line 36 "../src/client/application/autostart-manager.vala"
		_tmp16_ = g_file_get_child (_tmp15_, AUTOSTART_MANAGER_AUTOSTART_DESKTOP_FILE);
#line 36 "../src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp2_);
#line 36 "../src/client/application/autostart-manager.vala"
		_tmp2_ = _tmp16_;
#line 36 "../src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp15_);
#line 36 "../src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp13_);
#line 36 "../src/client/application/autostart-manager.vala"
		_g_object_unref0 (_tmp11_);
#line 309 "autostart-manager.c"
	}
#line 34 "../src/client/application/autostart-manager.vala"
	_tmp17_ = _g_object_ref0 (_tmp2_);
#line 34 "../src/client/application/autostart-manager.vala"
	desktop_file = _tmp17_;
#line 38 "../src/client/application/autostart-manager.vala"
	_tmp19_ = desktop_file;
#line 38 "../src/client/application/autostart-manager.vala"
	if (g_file_query_exists (_tmp19_, NULL)) {
#line 319 "autostart-manager.c"
		GFile* _tmp20_;
#line 38 "../src/client/application/autostart-manager.vala"
		_tmp20_ = desktop_file;
#line 38 "../src/client/application/autostart-manager.vala"
		_tmp18_ = _tmp20_;
#line 325 "autostart-manager.c"
	} else {
#line 38 "../src/client/application/autostart-manager.vala"
		_tmp18_ = NULL;
#line 329 "autostart-manager.c"
	}
#line 38 "../src/client/application/autostart-manager.vala"
	_tmp21_ = _g_object_ref0 (_tmp18_);
#line 38 "../src/client/application/autostart-manager.vala"
	result = _tmp21_;
#line 38 "../src/client/application/autostart-manager.vala"
	_g_object_unref0 (desktop_file);
#line 38 "../src/client/application/autostart-manager.vala"
	_g_object_unref0 (_tmp2_);
#line 38 "../src/client/application/autostart-manager.vala"
	_g_object_unref0 (install_dir);
#line 38 "../src/client/application/autostart-manager.vala"
	return result;
#line 343 "autostart-manager.c"
}

/**
     * Deletes the desktop file from autostart directory.
     */
void
autostart_manager_delete_startup_file (AutostartManager* self)
{
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 44 "../src/client/application/autostart-manager.vala"
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
#line 45 "../src/client/application/autostart-manager.vala"
	_tmp0_ = self->priv->startup_file;
#line 45 "../src/client/application/autostart-manager.vala"
	if (g_file_query_exists (_tmp0_, NULL)) {
#line 360 "autostart-manager.c"
		{
			GFile* _tmp1_;
#line 47 "../src/client/application/autostart-manager.vala"
			_tmp1_ = self->priv->startup_file;
#line 47 "../src/client/application/autostart-manager.vala"
			g_file_delete (_tmp1_, NULL, &_inner_error0_);
#line 47 "../src/client/application/autostart-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 369 "autostart-manager.c"
				goto __catch10_g_error;
			}
		}
		goto __finally10;
		__catch10_g_error:
		{
			GError* err = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 46 "../src/client/application/autostart-manager.vala"
			err = _inner_error0_;
#line 46 "../src/client/application/autostart-manager.vala"
			_inner_error0_ = NULL;
#line 49 "../src/client/application/autostart-manager.vala"
			_tmp2_ = err;
#line 49 "../src/client/application/autostart-manager.vala"
			_tmp3_ = _tmp2_->message;
#line 49 "../src/client/application/autostart-manager.vala"
			g_message ("autostart-manager.vala:49: Failed to delete startup file: %s", _tmp3_);
#line 46 "../src/client/application/autostart-manager.vala"
			_g_error_free0 (err);
#line 391 "autostart-manager.c"
		}
		__finally10:
#line 46 "../src/client/application/autostart-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/client/application/autostart-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/client/application/autostart-manager.vala"
			g_clear_error (&_inner_error0_);
#line 46 "../src/client/application/autostart-manager.vala"
			return;
#line 402 "autostart-manager.c"
		}
	}
}

/**
     * Creates .desktop file in autostart directory (usually '$HOME/.config/autostart/') if no one exists.
     */
void
autostart_manager_create_startup_file (AutostartManager* self)
{
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 57 "../src/client/application/autostart-manager.vala"
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
#line 58 "../src/client/application/autostart-manager.vala"
	_tmp0_ = self->priv->startup_file;
#line 58 "../src/client/application/autostart-manager.vala"
	if (g_file_query_exists (_tmp0_, NULL)) {
#line 59 "../src/client/application/autostart-manager.vala"
		return;
#line 423 "autostart-manager.c"
	}
	{
		GFile* autostart_dir = NULL;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* autostart = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 62 "../src/client/application/autostart-manager.vala"
		_tmp1_ = self->priv->startup_file;
#line 62 "../src/client/application/autostart-manager.vala"
		_tmp2_ = g_file_get_parent (_tmp1_);
#line 62 "../src/client/application/autostart-manager.vala"
		autostart_dir = _tmp2_;
#line 63 "../src/client/application/autostart-manager.vala"
		_tmp3_ = autostart_dir;
#line 63 "../src/client/application/autostart-manager.vala"
		if (!g_file_query_exists (_tmp3_, NULL)) {
#line 443 "autostart-manager.c"
			GFile* _tmp4_;
#line 64 "../src/client/application/autostart-manager.vala"
			_tmp4_ = autostart_dir;
#line 64 "../src/client/application/autostart-manager.vala"
			g_file_make_directory_with_parents (_tmp4_, NULL, &_inner_error0_);
#line 64 "../src/client/application/autostart-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/client/application/autostart-manager.vala"
				_g_object_unref0 (autostart_dir);
#line 453 "autostart-manager.c"
				goto __catch11_g_error;
			}
		}
#line 65 "../src/client/application/autostart-manager.vala"
		_tmp5_ = autostart_manager_get_autostart_desktop_file (self);
#line 65 "../src/client/application/autostart-manager.vala"
		autostart = _tmp5_;
#line 66 "../src/client/application/autostart-manager.vala"
		_tmp6_ = autostart;
#line 66 "../src/client/application/autostart-manager.vala"
		if (_tmp6_ == NULL) {
#line 67 "../src/client/application/autostart-manager.vala"
			g_message ("autostart-manager.vala:67: Autostart file is not installed!");
#line 467 "autostart-manager.c"
		} else {
			GFile* _tmp7_;
			GFile* _tmp8_;
#line 69 "../src/client/application/autostart-manager.vala"
			_tmp7_ = autostart;
#line 69 "../src/client/application/autostart-manager.vala"
			_tmp8_ = self->priv->startup_file;
#line 69 "../src/client/application/autostart-manager.vala"
			g_file_copy (_tmp7_, _tmp8_, 0, NULL, NULL, NULL, &_inner_error0_);
#line 69 "../src/client/application/autostart-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/client/application/autostart-manager.vala"
				_g_object_unref0 (autostart);
#line 69 "../src/client/application/autostart-manager.vala"
				_g_object_unref0 (autostart_dir);
#line 483 "autostart-manager.c"
				goto __catch11_g_error;
			}
		}
#line 61 "../src/client/application/autostart-manager.vala"
		_g_object_unref0 (autostart);
#line 61 "../src/client/application/autostart-manager.vala"
		_g_object_unref0 (autostart_dir);
#line 491 "autostart-manager.c"
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* err = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 61 "../src/client/application/autostart-manager.vala"
		err = _inner_error0_;
#line 61 "../src/client/application/autostart-manager.vala"
		_inner_error0_ = NULL;
#line 72 "../src/client/application/autostart-manager.vala"
		_tmp9_ = err;
#line 72 "../src/client/application/autostart-manager.vala"
		_tmp10_ = _tmp9_->message;
#line 72 "../src/client/application/autostart-manager.vala"
		g_message ("autostart-manager.vala:72: Failed to create startup file: %s", _tmp10_);
#line 61 "../src/client/application/autostart-manager.vala"
		_g_error_free0 (err);
#line 511 "autostart-manager.c"
	}
	__finally11:
#line 61 "../src/client/application/autostart-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../src/client/application/autostart-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "../src/client/application/autostart-manager.vala"
		g_clear_error (&_inner_error0_);
#line 61 "../src/client/application/autostart-manager.vala"
		return;
#line 522 "autostart-manager.c"
	}
}

/**
     * Callback for startup notification option changes.
     */
void
autostart_manager_on_startup_notification_change (AutostartManager* self)
{
	GearyApplication* _tmp0_;
	Configuration* _tmp1_;
	Configuration* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 79 "../src/client/application/autostart-manager.vala"
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
#line 80 "../src/client/application/autostart-manager.vala"
	_tmp0_ = self->priv->instance;
#line 80 "../src/client/application/autostart-manager.vala"
	_tmp1_ = geary_application_get_config (_tmp0_);
#line 80 "../src/client/application/autostart-manager.vala"
	_tmp2_ = _tmp1_;
#line 80 "../src/client/application/autostart-manager.vala"
	_tmp3_ = configuration_get_startup_notifications (_tmp2_);
#line 80 "../src/client/application/autostart-manager.vala"
	_tmp4_ = _tmp3_;
#line 80 "../src/client/application/autostart-manager.vala"
	if (_tmp4_) {
#line 81 "../src/client/application/autostart-manager.vala"
		autostart_manager_create_startup_file (self);
#line 553 "autostart-manager.c"
	} else {
#line 83 "../src/client/application/autostart-manager.vala"
		autostart_manager_delete_startup_file (self);
#line 557 "autostart-manager.c"
	}
}

void
autostart_manager_sync_with_config (AutostartManager* self)
{
	GearyApplication* _tmp0_;
	Configuration* _tmp1_;
	Configuration* _tmp2_;
	GFile* _tmp3_;
#line 90 "../src/client/application/autostart-manager.vala"
	g_return_if_fail (IS_AUTOSTART_MANAGER (self));
#line 91 "../src/client/application/autostart-manager.vala"
	_tmp0_ = self->priv->instance;
#line 91 "../src/client/application/autostart-manager.vala"
	_tmp1_ = geary_application_get_config (_tmp0_);
#line 91 "../src/client/application/autostart-manager.vala"
	_tmp2_ = _tmp1_;
#line 91 "../src/client/application/autostart-manager.vala"
	_tmp3_ = self->priv->startup_file;
#line 91 "../src/client/application/autostart-manager.vala"
	configuration_set_startup_notifications (_tmp2_, g_file_query_exists (_tmp3_, NULL));
#line 580 "autostart-manager.c"
}

static void
autostart_manager_class_init (AutostartManagerClass * klass,
                              gpointer klass_data)
{
#line 11 "../src/client/application/autostart-manager.vala"
	autostart_manager_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/client/application/autostart-manager.vala"
	g_type_class_adjust_private_offset (klass, &AutostartManager_private_offset);
#line 11 "../src/client/application/autostart-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = autostart_manager_finalize;
#line 593 "autostart-manager.c"
}

static void
autostart_manager_instance_init (AutostartManager * self,
                                 gpointer klass)
{
#line 11 "../src/client/application/autostart-manager.vala"
	self->priv = autostart_manager_get_instance_private (self);
#line 602 "autostart-manager.c"
}

static void
autostart_manager_finalize (GObject * obj)
{
	AutostartManager * self;
#line 11 "../src/client/application/autostart-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AUTOSTART_MANAGER, AutostartManager);
#line 16 "../src/client/application/autostart-manager.vala"
	_g_object_unref0 (self->priv->instance);
#line 17 "../src/client/application/autostart-manager.vala"
	_g_object_unref0 (self->priv->startup_file);
#line 11 "../src/client/application/autostart-manager.vala"
	G_OBJECT_CLASS (autostart_manager_parent_class)->finalize (obj);
#line 617 "autostart-manager.c"
}

GType
autostart_manager_get_type (void)
{
	static volatile gsize autostart_manager_type_id__volatile = 0;
	if (g_once_init_enter (&autostart_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AutostartManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) autostart_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AutostartManager), 0, (GInstanceInitFunc) autostart_manager_instance_init, NULL };
		GType autostart_manager_type_id;
		autostart_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "AutostartManager", &g_define_type_info, 0);
		AutostartManager_private_offset = g_type_add_instance_private (autostart_manager_type_id, sizeof (AutostartManagerPrivate));
		g_once_init_leave (&autostart_manager_type_id__volatile, autostart_manager_type_id);
	}
	return autostart_manager_type_id__volatile;
}

