/* goa-mediator.c generated by valac 0.44.1, the Vala compiler
 * generated from goa-mediator.vala, do not modify */

/*
 * Copyright 2017 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include "geary-engine.h"
#include <gio/gio.h>
#include <glib.h>
#include <goa/goa.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_GOA_MEDIATOR (goa_mediator_get_type ())
#define GOA_MEDIATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GOA_MEDIATOR, GoaMediator))
#define GOA_MEDIATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GOA_MEDIATOR, GoaMediatorClass))
#define IS_GOA_MEDIATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GOA_MEDIATOR))
#define IS_GOA_MEDIATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GOA_MEDIATOR))
#define GOA_MEDIATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GOA_MEDIATOR, GoaMediatorClass))

typedef struct _GoaMediator GoaMediator;
typedef struct _GoaMediatorClass GoaMediatorClass;
typedef struct _GoaMediatorPrivate GoaMediatorPrivate;
enum  {
	GOA_MEDIATOR_0_PROPERTY,
	GOA_MEDIATOR_NUM_PROPERTIES
};
static GParamSpec* goa_mediator_properties[GOA_MEDIATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GoaMediatorUpdateData GoaMediatorUpdateData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GoaMediatorLoadTokenData GoaMediatorLoadTokenData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GoaMediator {
	GObject parent_instance;
	GoaMediatorPrivate * priv;
};

struct _GoaMediatorClass {
	GObjectClass parent_class;
	void (*load_token) (GoaMediator* self, GearyAccountInformation* account, GearyServiceInformation* service, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*load_token_finish) (GoaMediator* self, GAsyncResult* _res_, GError** error);
};

struct _GoaMediatorPrivate {
	GoaObject* handle;
};

struct _GoaMediatorUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GoaMediator* self;
	GearyAccountInformation* geary_account;
	GCancellable* cancellable;
	GearyServiceInformation* _tmp0_;
	GearyServiceInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GearyServiceInformation* _tmp3_;
	GError* _inner_error0_;
};

struct _GoaMediatorLoadTokenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GoaMediator* self;
	GearyAccountInformation* account;
	GearyServiceInformation* service;
	GCancellable* cancellable;
	gboolean result;
	GoaObject* _tmp0_;
	GoaAccount* _tmp1_;
	GoaAccount* _tmp2_;
	gboolean loaded;
	gchar* token;
	GearyCredentialsMethod _tmp3_;
	GoaObject* _tmp4_;
	GoaOAuth2Based* _tmp5_;
	GoaOAuth2Based* _tmp6_;
	gchar* _tmp7_;
	GearyProtocol _tmp8_;
	GearyProtocol _tmp9_;
	GoaObject* _tmp10_;
	GoaPasswordBased* _tmp11_;
	GoaPasswordBased* _tmp12_;
	gchar* _tmp13_;
	GoaObject* _tmp14_;
	GoaPasswordBased* _tmp15_;
	GoaPasswordBased* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	GearyCredentials* _tmp19_;
	GearyCredentials* _tmp20_;
	const gchar* _tmp21_;
	GearyCredentials* _tmp22_;
	GearyCredentials* _tmp23_;
	GError* _inner_error0_;
};

static gint GoaMediator_private_offset;
static gpointer goa_mediator_parent_class = NULL;
static GearyCredentialsMediatorIface * goa_mediator_geary_credentials_mediator_parent_iface = NULL;

GType goa_mediator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GoaMediator, g_object_unref)
GoaMediator* goa_mediator_new (GoaObject* handle);
GoaMediator* goa_mediator_construct (GType object_type,
                                     GoaObject* handle);
GearyServiceProvider goa_mediator_get_service_provider (GoaMediator* self);
gchar* goa_mediator_get_service_label (GoaMediator* self);
static void goa_mediator_update_data_free (gpointer _data);
void goa_mediator_update (GoaMediator* self,
                          GearyAccountInformation* geary_account,
                          GCancellable* cancellable,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_);
void goa_mediator_update_finish (GoaMediator* self,
                                 GAsyncResult* _res_,
                                 GError** error);
static gboolean goa_mediator_update_co (GoaMediatorUpdateData* _data_);
static GearyCredentialsMethod goa_mediator_get_auth_method (GoaMediator* self,
                                                     GError** error);
static void goa_mediator_update_imap_config (GoaMediator* self,
                                      GearyServiceInformation* service,
                                      GError** error);
static void goa_mediator_update_smtp_config (GoaMediator* self,
                                      GearyServiceInformation* service,
                                      GError** error);
static void goa_mediator_real_load_token_data_free (gpointer _data);
static void goa_mediator_real_load_token (GoaMediator* self,
                                   GearyAccountInformation* account,
                                   GearyServiceInformation* service,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
void goa_mediator_load_token (GoaMediator* self,
                              GearyAccountInformation* account,
                              GearyServiceInformation* service,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
gboolean goa_mediator_load_token_finish (GoaMediator* self,
                                         GAsyncResult* _res_,
                                         GError** error);
static gboolean goa_mediator_real_load_token_co (GoaMediatorLoadTokenData* _data_);
static void goa_mediator_parse_host_name (GoaMediator* self,
                                   GearyServiceInformation* service,
                                   const gchar* host_name);
static void goa_mediator_finalize (GObject * obj);

static inline gpointer
goa_mediator_get_instance_private (GoaMediator* self)
{
	return G_STRUCT_MEMBER_P (self, GoaMediator_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 17 "../src/client/application/goa-mediator.vala"
	return self ? g_object_ref (self) : NULL;
#line 173 "goa-mediator.c"
}

GoaMediator*
goa_mediator_construct (GType object_type,
                        GoaObject* handle)
{
	GoaMediator * self = NULL;
	GoaObject* _tmp0_;
#line 16 "../src/client/application/goa-mediator.vala"
	g_return_val_if_fail (GOA_IS_OBJECT (handle), NULL);
#line 16 "../src/client/application/goa-mediator.vala"
	self = (GoaMediator*) g_object_new (object_type, NULL);
#line 17 "../src/client/application/goa-mediator.vala"
	_tmp0_ = _g_object_ref0 (handle);
#line 17 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (self->priv->handle);
#line 17 "../src/client/application/goa-mediator.vala"
	self->priv->handle = _tmp0_;
#line 16 "../src/client/application/goa-mediator.vala"
	return self;
#line 194 "goa-mediator.c"
}

GoaMediator*
goa_mediator_new (GoaObject* handle)
{
#line 16 "../src/client/application/goa-mediator.vala"
	return goa_mediator_construct (TYPE_GOA_MEDIATOR, handle);
#line 202 "goa-mediator.c"
}

GearyServiceProvider
goa_mediator_get_service_provider (GoaMediator* self)
{
	GearyServiceProvider result = 0;
	GearyServiceProvider provider = 0;
	GoaObject* _tmp0_;
	GoaAccount* _tmp1_;
	GoaAccount* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GQuark _tmp8_ = 0U;
#line 22 "../src/client/application/goa-mediator.vala"
	static GQuark _tmp7_label0 = 0;
#line 22 "../src/client/application/goa-mediator.vala"
	static GQuark _tmp7_label1 = 0;
#line 20 "../src/client/application/goa-mediator.vala"
	g_return_val_if_fail (IS_GOA_MEDIATOR (self), 0);
#line 21 "../src/client/application/goa-mediator.vala"
	provider = GEARY_SERVICE_PROVIDER_OTHER;
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_account (_tmp0_);
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _tmp1_;
#line 22 "../src/client/application/goa-mediator.vala"
	g_object_get (_tmp2_, "provider-type", &_tmp3_, NULL);
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp4_ = _tmp3_;
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp5_ = _tmp4_;
#line 22 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_tmp2_);
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp6_ = _tmp5_;
#line 22 "../src/client/application/goa-mediator.vala"
	_tmp8_ = (NULL == _tmp6_) ? 0 : g_quark_from_string (_tmp6_);
#line 22 "../src/client/application/goa-mediator.vala"
	g_free (_tmp6_);
#line 22 "../src/client/application/goa-mediator.vala"
	if (_tmp8_ == ((0 != _tmp7_label0) ? _tmp7_label0 : (_tmp7_label0 = g_quark_from_static_string ("google")))) {
#line 22 "../src/client/application/goa-mediator.vala"
		switch (0) {
#line 250 "goa-mediator.c"
			default:
			{
#line 24 "../src/client/application/goa-mediator.vala"
				provider = GEARY_SERVICE_PROVIDER_GMAIL;
#line 25 "../src/client/application/goa-mediator.vala"
				break;
#line 257 "goa-mediator.c"
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label1) ? _tmp7_label1 : (_tmp7_label1 = g_quark_from_static_string ("windows_live")))) {
#line 22 "../src/client/application/goa-mediator.vala"
		switch (0) {
#line 263 "goa-mediator.c"
			default:
			{
#line 28 "../src/client/application/goa-mediator.vala"
				provider = GEARY_SERVICE_PROVIDER_OUTLOOK;
#line 29 "../src/client/application/goa-mediator.vala"
				break;
#line 270 "goa-mediator.c"
			}
		}
	}
#line 31 "../src/client/application/goa-mediator.vala"
	result = provider;
#line 31 "../src/client/application/goa-mediator.vala"
	return result;
#line 278 "goa-mediator.c"
}

gchar*
goa_mediator_get_service_label (GoaMediator* self)
{
	gchar* result = NULL;
	GoaObject* _tmp0_;
	GoaAccount* _tmp1_;
	GoaAccount* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 34 "../src/client/application/goa-mediator.vala"
	g_return_val_if_fail (IS_GOA_MEDIATOR (self), NULL);
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_account (_tmp0_);
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/client/application/goa-mediator.vala"
	g_object_get (_tmp2_, "provider-name", &_tmp3_, NULL);
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp4_ = _tmp3_;
#line 35 "../src/client/application/goa-mediator.vala"
	_tmp5_ = _tmp4_;
#line 35 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_tmp2_);
#line 35 "../src/client/application/goa-mediator.vala"
	result = _tmp5_;
#line 35 "../src/client/application/goa-mediator.vala"
	return result;
#line 311 "goa-mediator.c"
}

static void
goa_mediator_update_data_free (gpointer _data)
{
	GoaMediatorUpdateData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->geary_account);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/goa-mediator.vala"
	g_slice_free (GoaMediatorUpdateData, _data_);
#line 327 "goa-mediator.c"
}

void
goa_mediator_update (GoaMediator* self,
                     GearyAccountInformation* geary_account,
                     GCancellable* cancellable,
                     GAsyncReadyCallback _callback_,
                     gpointer _user_data_)
{
	GoaMediatorUpdateData* _data_;
	GoaMediator* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 10 "../src/client/application/goa-mediator.vala"
	_data_ = g_slice_new0 (GoaMediatorUpdateData);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/client/application/goa-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, goa_mediator_update_data_free);
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp1_ = _g_object_ref0 (geary_account);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->geary_account);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->geary_account = _tmp1_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->cancellable = _tmp2_;
#line 10 "../src/client/application/goa-mediator.vala"
	goa_mediator_update_co (_data_);
#line 365 "goa-mediator.c"
}

void
goa_mediator_update_finish (GoaMediator* self,
                            GAsyncResult* _res_,
                            GError** error)
{
	GoaMediatorUpdateData* _data_;
#line 10 "../src/client/application/goa-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/client/application/goa-mediator.vala"
	if (NULL == _data_) {
#line 10 "../src/client/application/goa-mediator.vala"
		return;
#line 380 "goa-mediator.c"
	}
}

static gboolean
goa_mediator_update_co (GoaMediatorUpdateData* _data_)
{
#line 38 "../src/client/application/goa-mediator.vala"
	switch (_data_->_state_) {
#line 38 "../src/client/application/goa-mediator.vala"
		case 0:
#line 391 "goa-mediator.c"
		goto _state_0;
		default:
#line 38 "../src/client/application/goa-mediator.vala"
		g_assert_not_reached ();
#line 396 "goa-mediator.c"
	}
	_state_0:
#line 43 "../src/client/application/goa-mediator.vala"
	goa_mediator_get_auth_method (_data_->self, &_data_->_inner_error0_);
#line 43 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 43 "../src/client/application/goa-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 43 "../src/client/application/goa-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 43 "../src/client/application/goa-mediator.vala"
		return FALSE;
#line 409 "goa-mediator.c"
	}
#line 45 "../src/client/application/goa-mediator.vala"
	_data_->_tmp0_ = geary_account_information_get_incoming (_data_->geary_account);
#line 45 "../src/client/application/goa-mediator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 45 "../src/client/application/goa-mediator.vala"
	goa_mediator_update_imap_config (_data_->self, _data_->_tmp1_, &_data_->_inner_error0_);
#line 45 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 45 "../src/client/application/goa-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 45 "../src/client/application/goa-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 45 "../src/client/application/goa-mediator.vala"
		return FALSE;
#line 425 "goa-mediator.c"
	}
#line 46 "../src/client/application/goa-mediator.vala"
	_data_->_tmp2_ = geary_account_information_get_outgoing (_data_->geary_account);
#line 46 "../src/client/application/goa-mediator.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 46 "../src/client/application/goa-mediator.vala"
	goa_mediator_update_smtp_config (_data_->self, _data_->_tmp3_, &_data_->_inner_error0_);
#line 46 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 46 "../src/client/application/goa-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 46 "../src/client/application/goa-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 46 "../src/client/application/goa-mediator.vala"
		return FALSE;
#line 441 "goa-mediator.c"
	}
#line 38 "../src/client/application/goa-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 38 "../src/client/application/goa-mediator.vala"
	if (_data_->_state_ != 0) {
#line 38 "../src/client/application/goa-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 38 "../src/client/application/goa-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 451 "goa-mediator.c"
		}
	}
#line 38 "../src/client/application/goa-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 38 "../src/client/application/goa-mediator.vala"
	return FALSE;
#line 458 "goa-mediator.c"
}

static void
goa_mediator_real_load_token_data_free (gpointer _data)
{
	GoaMediatorLoadTokenData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/goa-mediator.vala"
	g_slice_free (GoaMediatorLoadTokenData, _data_);
#line 476 "goa-mediator.c"
}

static void
goa_mediator_real_load_token (GoaMediator* self,
                              GearyAccountInformation* account,
                              GearyServiceInformation* service,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	GoaMediatorLoadTokenData* _data_;
	GoaMediator* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GCancellable* _tmp3_;
#line 10 "../src/client/application/goa-mediator.vala"
	_data_ = g_slice_new0 (GoaMediatorLoadTokenData);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/client/application/goa-mediator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, goa_mediator_real_load_token_data_free);
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->account);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->account = _tmp1_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _g_object_ref0 (service);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->service);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->service = _tmp2_;
#line 10 "../src/client/application/goa-mediator.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/goa-mediator.vala"
	_data_->cancellable = _tmp3_;
#line 10 "../src/client/application/goa-mediator.vala"
	goa_mediator_real_load_token_co (_data_);
#line 522 "goa-mediator.c"
}

static gboolean
goa_mediator_real_load_token_finish (GoaMediator* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	gboolean result;
	GoaMediatorLoadTokenData* _data_;
#line 10 "../src/client/application/goa-mediator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 10 "../src/client/application/goa-mediator.vala"
	if (NULL == _data_) {
#line 536 "goa-mediator.c"
		gboolean _tmp0_ = FALSE;
#line 10 "../src/client/application/goa-mediator.vala"
		return _tmp0_;
#line 540 "goa-mediator.c"
	}
#line 10 "../src/client/application/goa-mediator.vala"
	result = _data_->result;
#line 10 "../src/client/application/goa-mediator.vala"
	return result;
#line 546 "goa-mediator.c"
}

static gboolean
goa_mediator_real_load_token_co (GoaMediatorLoadTokenData* _data_)
{
#line 49 "../src/client/application/goa-mediator.vala"
	switch (_data_->_state_) {
#line 49 "../src/client/application/goa-mediator.vala"
		case 0:
#line 556 "goa-mediator.c"
		goto _state_0;
		default:
#line 49 "../src/client/application/goa-mediator.vala"
		g_assert_not_reached ();
#line 561 "goa-mediator.c"
	}
	_state_0:
#line 56 "../src/client/application/goa-mediator.vala"
	_data_->_tmp0_ = _data_->self->priv->handle;
#line 56 "../src/client/application/goa-mediator.vala"
	_data_->_tmp1_ = goa_object_get_account (_data_->_tmp0_);
#line 56 "../src/client/application/goa-mediator.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 56 "../src/client/application/goa-mediator.vala"
	goa_account_call_ensure_credentials_sync (_data_->_tmp2_, NULL, _data_->cancellable, &_data_->_inner_error0_);
#line 56 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_data_->_tmp2_);
#line 56 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 56 "../src/client/application/goa-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 56 "../src/client/application/goa-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 56 "../src/client/application/goa-mediator.vala"
		return FALSE;
#line 582 "goa-mediator.c"
	}
#line 60 "../src/client/application/goa-mediator.vala"
	_data_->loaded = FALSE;
#line 61 "../src/client/application/goa-mediator.vala"
	_data_->token = NULL;
#line 63 "../src/client/application/goa-mediator.vala"
	_data_->_tmp3_ = goa_mediator_get_auth_method (_data_->self, &_data_->_inner_error0_);
#line 63 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 63 "../src/client/application/goa-mediator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 63 "../src/client/application/goa-mediator.vala"
		_g_free0 (_data_->token);
#line 63 "../src/client/application/goa-mediator.vala"
		g_object_unref (_data_->_async_result);
#line 63 "../src/client/application/goa-mediator.vala"
		return FALSE;
#line 600 "goa-mediator.c"
	}
#line 63 "../src/client/application/goa-mediator.vala"
	switch (_data_->_tmp3_) {
#line 63 "../src/client/application/goa-mediator.vala"
		case GEARY_CREDENTIALS_METHOD_OAUTH2:
#line 606 "goa-mediator.c"
		{
#line 65 "../src/client/application/goa-mediator.vala"
			_data_->_tmp4_ = _data_->self->priv->handle;
#line 65 "../src/client/application/goa-mediator.vala"
			_data_->_tmp5_ = goa_object_get_oauth2_based (_data_->_tmp4_);
#line 65 "../src/client/application/goa-mediator.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 65 "../src/client/application/goa-mediator.vala"
			_data_->_tmp7_ = NULL;
#line 65 "../src/client/application/goa-mediator.vala"
			goa_oauth2_based_call_get_access_token_sync (_data_->_tmp6_, &_data_->_tmp7_, NULL, _data_->cancellable, &_data_->_inner_error0_);
#line 65 "../src/client/application/goa-mediator.vala"
			_g_free0 (_data_->token);
#line 65 "../src/client/application/goa-mediator.vala"
			_data_->token = _data_->_tmp7_;
#line 65 "../src/client/application/goa-mediator.vala"
			_g_object_unref0 (_data_->_tmp6_);
#line 65 "../src/client/application/goa-mediator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 65 "../src/client/application/goa-mediator.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 65 "../src/client/application/goa-mediator.vala"
				_g_free0 (_data_->token);
#line 65 "../src/client/application/goa-mediator.vala"
				g_object_unref (_data_->_async_result);
#line 65 "../src/client/application/goa-mediator.vala"
				return FALSE;
#line 634 "goa-mediator.c"
			}
#line 68 "../src/client/application/goa-mediator.vala"
			break;
#line 638 "goa-mediator.c"
		}
#line 63 "../src/client/application/goa-mediator.vala"
		case GEARY_CREDENTIALS_METHOD_PASSWORD:
#line 642 "goa-mediator.c"
		{
#line 71 "../src/client/application/goa-mediator.vala"
			_data_->_tmp8_ = geary_service_information_get_protocol (_data_->service);
#line 71 "../src/client/application/goa-mediator.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 71 "../src/client/application/goa-mediator.vala"
			switch (_data_->_tmp9_) {
#line 71 "../src/client/application/goa-mediator.vala"
				case GEARY_PROTOCOL_IMAP:
#line 652 "goa-mediator.c"
				{
#line 73 "../src/client/application/goa-mediator.vala"
					_data_->_tmp10_ = _data_->self->priv->handle;
#line 73 "../src/client/application/goa-mediator.vala"
					_data_->_tmp11_ = goa_object_get_password_based (_data_->_tmp10_);
#line 73 "../src/client/application/goa-mediator.vala"
					_data_->_tmp12_ = _data_->_tmp11_;
#line 73 "../src/client/application/goa-mediator.vala"
					_data_->_tmp13_ = NULL;
#line 73 "../src/client/application/goa-mediator.vala"
					goa_password_based_call_get_password_sync (_data_->_tmp12_, "imap-password", &_data_->_tmp13_, _data_->cancellable, &_data_->_inner_error0_);
#line 73 "../src/client/application/goa-mediator.vala"
					_g_free0 (_data_->token);
#line 73 "../src/client/application/goa-mediator.vala"
					_data_->token = _data_->_tmp13_;
#line 73 "../src/client/application/goa-mediator.vala"
					_g_object_unref0 (_data_->_tmp12_);
#line 73 "../src/client/application/goa-mediator.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 73 "../src/client/application/goa-mediator.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 73 "../src/client/application/goa-mediator.vala"
						_g_free0 (_data_->token);
#line 73 "../src/client/application/goa-mediator.vala"
						g_object_unref (_data_->_async_result);
#line 73 "../src/client/application/goa-mediator.vala"
						return FALSE;
#line 680 "goa-mediator.c"
					}
#line 76 "../src/client/application/goa-mediator.vala"
					break;
#line 684 "goa-mediator.c"
				}
#line 71 "../src/client/application/goa-mediator.vala"
				case GEARY_PROTOCOL_SMTP:
#line 688 "goa-mediator.c"
				{
#line 79 "../src/client/application/goa-mediator.vala"
					_data_->_tmp14_ = _data_->self->priv->handle;
#line 79 "../src/client/application/goa-mediator.vala"
					_data_->_tmp15_ = goa_object_get_password_based (_data_->_tmp14_);
#line 79 "../src/client/application/goa-mediator.vala"
					_data_->_tmp16_ = _data_->_tmp15_;
#line 79 "../src/client/application/goa-mediator.vala"
					_data_->_tmp17_ = NULL;
#line 79 "../src/client/application/goa-mediator.vala"
					goa_password_based_call_get_password_sync (_data_->_tmp16_, "smtp-password", &_data_->_tmp17_, _data_->cancellable, &_data_->_inner_error0_);
#line 79 "../src/client/application/goa-mediator.vala"
					_g_free0 (_data_->token);
#line 79 "../src/client/application/goa-mediator.vala"
					_data_->token = _data_->_tmp17_;
#line 79 "../src/client/application/goa-mediator.vala"
					_g_object_unref0 (_data_->_tmp16_);
#line 79 "../src/client/application/goa-mediator.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 79 "../src/client/application/goa-mediator.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 79 "../src/client/application/goa-mediator.vala"
						_g_free0 (_data_->token);
#line 79 "../src/client/application/goa-mediator.vala"
						g_object_unref (_data_->_async_result);
#line 79 "../src/client/application/goa-mediator.vala"
						return FALSE;
#line 716 "goa-mediator.c"
					}
#line 82 "../src/client/application/goa-mediator.vala"
					break;
#line 720 "goa-mediator.c"
				}
				default:
				{
#line 85 "../src/client/application/goa-mediator.vala"
					_data_->result = FALSE;
#line 85 "../src/client/application/goa-mediator.vala"
					_g_free0 (_data_->token);
#line 85 "../src/client/application/goa-mediator.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 85 "../src/client/application/goa-mediator.vala"
					if (_data_->_state_ != 0) {
#line 85 "../src/client/application/goa-mediator.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 85 "../src/client/application/goa-mediator.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 736 "goa-mediator.c"
						}
					}
#line 85 "../src/client/application/goa-mediator.vala"
					g_object_unref (_data_->_async_result);
#line 85 "../src/client/application/goa-mediator.vala"
					return FALSE;
#line 743 "goa-mediator.c"
				}
			}
#line 87 "../src/client/application/goa-mediator.vala"
			break;
#line 748 "goa-mediator.c"
		}
		default:
#line 63 "../src/client/application/goa-mediator.vala"
		break;
#line 753 "goa-mediator.c"
	}
#line 90 "../src/client/application/goa-mediator.vala"
	_data_->_tmp18_ = _data_->token;
#line 90 "../src/client/application/goa-mediator.vala"
	if (_data_->_tmp18_ != NULL) {
#line 91 "../src/client/application/goa-mediator.vala"
		_data_->_tmp19_ = geary_service_information_get_credentials (_data_->service);
#line 91 "../src/client/application/goa-mediator.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 91 "../src/client/application/goa-mediator.vala"
		_data_->_tmp21_ = _data_->token;
#line 91 "../src/client/application/goa-mediator.vala"
		_data_->_tmp22_ = geary_credentials_copy_with_token (_data_->_tmp20_, _data_->_tmp21_);
#line 91 "../src/client/application/goa-mediator.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 91 "../src/client/application/goa-mediator.vala"
		geary_service_information_set_credentials (_data_->service, _data_->_tmp23_);
#line 91 "../src/client/application/goa-mediator.vala"
		_g_object_unref0 (_data_->_tmp23_);
#line 92 "../src/client/application/goa-mediator.vala"
		_data_->loaded = TRUE;
#line 775 "goa-mediator.c"
	}
#line 94 "../src/client/application/goa-mediator.vala"
	_data_->result = _data_->loaded;
#line 94 "../src/client/application/goa-mediator.vala"
	_g_free0 (_data_->token);
#line 94 "../src/client/application/goa-mediator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 94 "../src/client/application/goa-mediator.vala"
	if (_data_->_state_ != 0) {
#line 94 "../src/client/application/goa-mediator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 94 "../src/client/application/goa-mediator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 789 "goa-mediator.c"
		}
	}
#line 94 "../src/client/application/goa-mediator.vala"
	g_object_unref (_data_->_async_result);
#line 94 "../src/client/application/goa-mediator.vala"
	return FALSE;
#line 796 "goa-mediator.c"
}

void
goa_mediator_load_token (GoaMediator* self,
                         GearyAccountInformation* account,
                         GearyServiceInformation* service,
                         GCancellable* cancellable,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
#line 10 "../src/client/application/goa-mediator.vala"
	GOA_MEDIATOR_GET_CLASS (self)->load_token (self, account, service, cancellable, _callback_, _user_data_);
#line 809 "goa-mediator.c"
}

gboolean
goa_mediator_load_token_finish (GoaMediator* self,
                                GAsyncResult* _res_,
                                GError** error)
{
#line 10 "../src/client/application/goa-mediator.vala"
	return GOA_MEDIATOR_GET_CLASS (self)->load_token_finish (self, _res_, error);
#line 819 "goa-mediator.c"
}

static GearyCredentialsMethod
goa_mediator_get_auth_method (GoaMediator* self,
                              GError** error)
{
	GearyCredentialsMethod result = 0;
	GoaObject* _tmp0_;
	GoaOAuth2Based* _tmp1_;
	GoaOAuth2Based* _tmp2_;
	gboolean _tmp3_;
	GoaObject* _tmp4_;
	GoaPasswordBased* _tmp5_;
	GoaPasswordBased* _tmp6_;
	gboolean _tmp7_;
	GError* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 97 "../src/client/application/goa-mediator.vala"
	g_return_val_if_fail (IS_GOA_MEDIATOR (self), 0);
#line 98 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 98 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_oauth2_based (_tmp0_);
#line 98 "../src/client/application/goa-mediator.vala"
	_tmp2_ = _tmp1_;
#line 98 "../src/client/application/goa-mediator.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 98 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_tmp2_);
#line 98 "../src/client/application/goa-mediator.vala"
	if (_tmp3_) {
#line 99 "../src/client/application/goa-mediator.vala"
		result = GEARY_CREDENTIALS_METHOD_OAUTH2;
#line 99 "../src/client/application/goa-mediator.vala"
		return result;
#line 855 "goa-mediator.c"
	}
#line 101 "../src/client/application/goa-mediator.vala"
	_tmp4_ = self->priv->handle;
#line 101 "../src/client/application/goa-mediator.vala"
	_tmp5_ = goa_object_get_password_based (_tmp4_);
#line 101 "../src/client/application/goa-mediator.vala"
	_tmp6_ = _tmp5_;
#line 101 "../src/client/application/goa-mediator.vala"
	_tmp7_ = _tmp6_ != NULL;
#line 101 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (_tmp6_);
#line 101 "../src/client/application/goa-mediator.vala"
	if (_tmp7_) {
#line 102 "../src/client/application/goa-mediator.vala"
		result = GEARY_CREDENTIALS_METHOD_PASSWORD;
#line 102 "../src/client/application/goa-mediator.vala"
		return result;
#line 873 "goa-mediator.c"
	}
#line 104 "../src/client/application/goa-mediator.vala"
	_tmp8_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_UNSUPPORTED, "GOA account supports neither password or OAuth2 auth");
#line 104 "../src/client/application/goa-mediator.vala"
	_inner_error0_ = _tmp8_;
#line 104 "../src/client/application/goa-mediator.vala"
	g_propagate_error (error, _inner_error0_);
#line 104 "../src/client/application/goa-mediator.vala"
	return 0;
#line 883 "goa-mediator.c"
}

static void
goa_mediator_update_imap_config (GoaMediator* self,
                                 GearyServiceInformation* service,
                                 GError** error)
{
	GoaMail* mail = NULL;
	GoaObject* _tmp0_;
	GoaMail* _tmp1_;
	GoaMail* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 109 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (IS_GOA_MEDIATOR (self));
#line 109 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (service));
#line 111 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 111 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_mail (_tmp0_);
#line 111 "../src/client/application/goa-mediator.vala"
	mail = _tmp1_;
#line 112 "../src/client/application/goa-mediator.vala"
	_tmp2_ = mail;
#line 112 "../src/client/application/goa-mediator.vala"
	if (_tmp2_ != NULL) {
#line 910 "goa-mediator.c"
		GoaMail* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GoaMail* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		GearyCredentialsMethod _tmp13_ = 0;
		GoaMail* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GearyCredentials* _tmp18_;
		GearyCredentials* _tmp19_;
		guint16 _tmp20_;
		guint16 _tmp21_;
#line 113 "../src/client/application/goa-mediator.vala"
		_tmp3_ = mail;
#line 113 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp3_, "imap-host", &_tmp4_, NULL);
#line 113 "../src/client/application/goa-mediator.vala"
		_tmp5_ = _tmp4_;
#line 113 "../src/client/application/goa-mediator.vala"
		_tmp6_ = _tmp5_;
#line 113 "../src/client/application/goa-mediator.vala"
		goa_mediator_parse_host_name (self, service, _tmp6_);
#line 113 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp6_);
#line 115 "../src/client/application/goa-mediator.vala"
		_tmp7_ = mail;
#line 115 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp7_, "imap-use-ssl", &_tmp8_, NULL);
#line 115 "../src/client/application/goa-mediator.vala"
		_tmp9_ = _tmp8_;
#line 115 "../src/client/application/goa-mediator.vala"
		if (_tmp9_) {
#line 116 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT);
#line 949 "goa-mediator.c"
		} else {
			GoaMail* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 117 "../src/client/application/goa-mediator.vala"
			_tmp10_ = mail;
#line 117 "../src/client/application/goa-mediator.vala"
			g_object_get (_tmp10_, "imap-use-tls", &_tmp11_, NULL);
#line 117 "../src/client/application/goa-mediator.vala"
			_tmp12_ = _tmp11_;
#line 117 "../src/client/application/goa-mediator.vala"
			if (_tmp12_) {
#line 118 "../src/client/application/goa-mediator.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_START_TLS);
#line 964 "goa-mediator.c"
			} else {
#line 120 "../src/client/application/goa-mediator.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_NONE);
#line 968 "goa-mediator.c"
			}
		}
#line 124 "../src/client/application/goa-mediator.vala"
		_tmp13_ = goa_mediator_get_auth_method (self, &_inner_error0_);
#line 124 "../src/client/application/goa-mediator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../src/client/application/goa-mediator.vala"
			g_propagate_error (error, _inner_error0_);
#line 124 "../src/client/application/goa-mediator.vala"
			_g_object_unref0 (mail);
#line 124 "../src/client/application/goa-mediator.vala"
			return;
#line 981 "goa-mediator.c"
		}
#line 123 "../src/client/application/goa-mediator.vala"
		_tmp14_ = mail;
#line 123 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp14_, "imap-user-name", &_tmp15_, NULL);
#line 123 "../src/client/application/goa-mediator.vala"
		_tmp16_ = _tmp15_;
#line 123 "../src/client/application/goa-mediator.vala"
		_tmp17_ = _tmp16_;
#line 123 "../src/client/application/goa-mediator.vala"
		_tmp18_ = geary_credentials_new (_tmp13_, _tmp17_, NULL);
#line 123 "../src/client/application/goa-mediator.vala"
		_tmp19_ = _tmp18_;
#line 123 "../src/client/application/goa-mediator.vala"
		geary_service_information_set_credentials (service, _tmp19_);
#line 123 "../src/client/application/goa-mediator.vala"
		_g_object_unref0 (_tmp19_);
#line 123 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp17_);
#line 127 "../src/client/application/goa-mediator.vala"
		_tmp20_ = geary_service_information_get_port (service);
#line 127 "../src/client/application/goa-mediator.vala"
		_tmp21_ = _tmp20_;
#line 127 "../src/client/application/goa-mediator.vala"
		if (((gint) _tmp21_) == 0) {
#line 128 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_port (service, geary_service_information_get_default_port (service));
#line 1009 "goa-mediator.c"
		}
	}
#line 109 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (mail);
#line 1014 "goa-mediator.c"
}

static void
goa_mediator_update_smtp_config (GoaMediator* self,
                                 GearyServiceInformation* service,
                                 GError** error)
{
	GoaMail* mail = NULL;
	GoaObject* _tmp0_;
	GoaMail* _tmp1_;
	GoaMail* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 133 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (IS_GOA_MEDIATOR (self));
#line 133 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (service));
#line 135 "../src/client/application/goa-mediator.vala"
	_tmp0_ = self->priv->handle;
#line 135 "../src/client/application/goa-mediator.vala"
	_tmp1_ = goa_object_get_mail (_tmp0_);
#line 135 "../src/client/application/goa-mediator.vala"
	mail = _tmp1_;
#line 136 "../src/client/application/goa-mediator.vala"
	_tmp2_ = mail;
#line 136 "../src/client/application/goa-mediator.vala"
	if (_tmp2_ != NULL) {
#line 1041 "goa-mediator.c"
		GoaMail* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GoaMail* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		GoaMail* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
		GoaMail* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		guint16 _tmp26_;
		guint16 _tmp27_;
#line 137 "../src/client/application/goa-mediator.vala"
		_tmp3_ = mail;
#line 137 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp3_, "smtp-host", &_tmp4_, NULL);
#line 137 "../src/client/application/goa-mediator.vala"
		_tmp5_ = _tmp4_;
#line 137 "../src/client/application/goa-mediator.vala"
		_tmp6_ = _tmp5_;
#line 137 "../src/client/application/goa-mediator.vala"
		goa_mediator_parse_host_name (self, service, _tmp6_);
#line 137 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp6_);
#line 139 "../src/client/application/goa-mediator.vala"
		_tmp7_ = mail;
#line 139 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp7_, "smtp-use-ssl", &_tmp8_, NULL);
#line 139 "../src/client/application/goa-mediator.vala"
		_tmp9_ = _tmp8_;
#line 139 "../src/client/application/goa-mediator.vala"
		if (_tmp9_) {
#line 140 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT);
#line 1079 "goa-mediator.c"
		} else {
			GoaMail* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 141 "../src/client/application/goa-mediator.vala"
			_tmp10_ = mail;
#line 141 "../src/client/application/goa-mediator.vala"
			g_object_get (_tmp10_, "smtp-use-tls", &_tmp11_, NULL);
#line 141 "../src/client/application/goa-mediator.vala"
			_tmp12_ = _tmp11_;
#line 141 "../src/client/application/goa-mediator.vala"
			if (_tmp12_) {
#line 142 "../src/client/application/goa-mediator.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_START_TLS);
#line 1094 "goa-mediator.c"
			} else {
#line 144 "../src/client/application/goa-mediator.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_NONE);
#line 1098 "goa-mediator.c"
			}
		}
#line 147 "../src/client/application/goa-mediator.vala"
		_tmp13_ = mail;
#line 147 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp13_, "smtp-use-auth", &_tmp14_, NULL);
#line 147 "../src/client/application/goa-mediator.vala"
		_tmp15_ = _tmp14_;
#line 147 "../src/client/application/goa-mediator.vala"
		if (_tmp15_) {
#line 148 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_CUSTOM);
#line 1111 "goa-mediator.c"
		} else {
#line 150 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_NONE);
#line 1115 "goa-mediator.c"
		}
#line 153 "../src/client/application/goa-mediator.vala"
		_tmp16_ = mail;
#line 153 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp16_, "smtp-use-auth", &_tmp17_, NULL);
#line 153 "../src/client/application/goa-mediator.vala"
		_tmp18_ = _tmp17_;
#line 153 "../src/client/application/goa-mediator.vala"
		if (_tmp18_) {
#line 1125 "goa-mediator.c"
			GearyCredentialsMethod _tmp19_ = 0;
			GoaMail* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			GearyCredentials* _tmp24_;
			GearyCredentials* _tmp25_;
#line 155 "../src/client/application/goa-mediator.vala"
			_tmp19_ = goa_mediator_get_auth_method (self, &_inner_error0_);
#line 155 "../src/client/application/goa-mediator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "../src/client/application/goa-mediator.vala"
				g_propagate_error (error, _inner_error0_);
#line 155 "../src/client/application/goa-mediator.vala"
				_g_object_unref0 (mail);
#line 155 "../src/client/application/goa-mediator.vala"
				return;
#line 1143 "goa-mediator.c"
			}
#line 154 "../src/client/application/goa-mediator.vala"
			_tmp20_ = mail;
#line 154 "../src/client/application/goa-mediator.vala"
			g_object_get (_tmp20_, "smtp-user-name", &_tmp21_, NULL);
#line 154 "../src/client/application/goa-mediator.vala"
			_tmp22_ = _tmp21_;
#line 154 "../src/client/application/goa-mediator.vala"
			_tmp23_ = _tmp22_;
#line 154 "../src/client/application/goa-mediator.vala"
			_tmp24_ = geary_credentials_new (_tmp19_, _tmp23_, NULL);
#line 154 "../src/client/application/goa-mediator.vala"
			_tmp25_ = _tmp24_;
#line 154 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_credentials (service, _tmp25_);
#line 154 "../src/client/application/goa-mediator.vala"
			_g_object_unref0 (_tmp25_);
#line 154 "../src/client/application/goa-mediator.vala"
			_g_free0 (_tmp23_);
#line 1163 "goa-mediator.c"
		}
#line 159 "../src/client/application/goa-mediator.vala"
		_tmp26_ = geary_service_information_get_port (service);
#line 159 "../src/client/application/goa-mediator.vala"
		_tmp27_ = _tmp26_;
#line 159 "../src/client/application/goa-mediator.vala"
		if (((gint) _tmp27_) == 0) {
#line 160 "../src/client/application/goa-mediator.vala"
			geary_service_information_set_port (service, geary_service_information_get_default_port (service));
#line 1173 "goa-mediator.c"
		}
	}
#line 133 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (mail);
#line 1178 "goa-mediator.c"
}

static void
goa_mediator_parse_host_name (GoaMediator* self,
                              GearyServiceInformation* service,
                              const gchar* host_name)
{
	GError* _inner_error0_ = NULL;
#line 165 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (IS_GOA_MEDIATOR (self));
#line 165 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (service));
#line 165 "../src/client/application/goa-mediator.vala"
	g_return_if_fail (host_name != NULL);
#line 170 "../src/client/application/goa-mediator.vala"
	geary_service_information_set_host (service, host_name);
#line 171 "../src/client/application/goa-mediator.vala"
	geary_service_information_set_port (service, (guint16) 0);
#line 1197 "goa-mediator.c"
	{
		GNetworkAddress* address = NULL;
		guint16 _tmp0_;
		guint16 _tmp1_;
		GNetworkAddress* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
#line 174 "../src/client/application/goa-mediator.vala"
		_tmp0_ = geary_service_information_get_port (service);
#line 174 "../src/client/application/goa-mediator.vala"
		_tmp1_ = _tmp0_;
#line 174 "../src/client/application/goa-mediator.vala"
		_tmp2_ = g_network_address_parse (host_name, _tmp1_, &_inner_error0_);
#line 174 "../src/client/application/goa-mediator.vala"
		address = _tmp2_;
#line 174 "../src/client/application/goa-mediator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1217 "goa-mediator.c"
			goto __catch67_g_error;
		}
#line 178 "../src/client/application/goa-mediator.vala"
		_tmp3_ = g_network_address_get_hostname (address);
#line 178 "../src/client/application/goa-mediator.vala"
		_tmp4_ = _tmp3_;
#line 178 "../src/client/application/goa-mediator.vala"
		geary_service_information_set_host (service, _tmp4_);
#line 179 "../src/client/application/goa-mediator.vala"
		_tmp5_ = g_network_address_get_port (address);
#line 179 "../src/client/application/goa-mediator.vala"
		_tmp6_ = _tmp5_;
#line 179 "../src/client/application/goa-mediator.vala"
		geary_service_information_set_port (service, (guint16) _tmp6_);
#line 173 "../src/client/application/goa-mediator.vala"
		_g_object_unref0 (address);
#line 1234 "goa-mediator.c"
	}
	goto __finally67;
	__catch67_g_error:
	{
		GError* err = NULL;
		GoaObject* _tmp7_;
		GoaAccount* _tmp8_;
		GoaAccount* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GearyProtocol _tmp13_;
		GearyProtocol _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 173 "../src/client/application/goa-mediator.vala"
		err = _inner_error0_;
#line 173 "../src/client/application/goa-mediator.vala"
		_inner_error0_ = NULL;
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp7_ = self->priv->handle;
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp8_ = goa_object_get_account (_tmp7_);
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp9_ = _tmp8_;
#line 181 "../src/client/application/goa-mediator.vala"
		g_object_get (_tmp9_, "id", &_tmp10_, NULL);
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp11_ = _tmp10_;
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp12_ = _tmp11_;
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp13_ = geary_service_information_get_protocol (service);
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp14_ = _tmp13_;
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp15_ = geary_protocol_to_value (_tmp14_);
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp16_ = _tmp15_;
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp17_ = err;
#line 181 "../src/client/application/goa-mediator.vala"
		_tmp18_ = _tmp17_->message;
#line 181 "../src/client/application/goa-mediator.vala"
		g_warning ("goa-mediator.vala:181: GOA account \"%s\" %s hostname \"%s\": %", _tmp12_, _tmp16_, host_name, _tmp18_);
#line 181 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp16_);
#line 181 "../src/client/application/goa-mediator.vala"
		_g_free0 (_tmp12_);
#line 181 "../src/client/application/goa-mediator.vala"
		_g_object_unref0 (_tmp9_);
#line 173 "../src/client/application/goa-mediator.vala"
		_g_error_free0 (err);
#line 1290 "goa-mediator.c"
	}
	__finally67:
#line 173 "../src/client/application/goa-mediator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../src/client/application/goa-mediator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 173 "../src/client/application/goa-mediator.vala"
		g_clear_error (&_inner_error0_);
#line 173 "../src/client/application/goa-mediator.vala"
		return;
#line 1301 "goa-mediator.c"
	}
}

static void
goa_mediator_class_init (GoaMediatorClass * klass,
                         gpointer klass_data)
{
#line 10 "../src/client/application/goa-mediator.vala"
	goa_mediator_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/client/application/goa-mediator.vala"
	g_type_class_adjust_private_offset (klass, &GoaMediator_private_offset);
#line 10 "../src/client/application/goa-mediator.vala"
	((GoaMediatorClass *) klass)->load_token = (void (*) (GoaMediator*, GearyAccountInformation*, GearyServiceInformation*, GCancellable*, GAsyncReadyCallback, gpointer)) goa_mediator_real_load_token;
#line 10 "../src/client/application/goa-mediator.vala"
	((GoaMediatorClass *) klass)->load_token_finish = (gboolean (*) (GoaMediator*, GAsyncResult*, GError**)) goa_mediator_real_load_token_finish;
#line 10 "../src/client/application/goa-mediator.vala"
	G_OBJECT_CLASS (klass)->finalize = goa_mediator_finalize;
#line 1319 "goa-mediator.c"
}

static void
goa_mediator_geary_credentials_mediator_interface_init (GearyCredentialsMediatorIface * iface,
                                                        gpointer iface_data)
{
#line 10 "../src/client/application/goa-mediator.vala"
	goa_mediator_geary_credentials_mediator_parent_iface = g_type_interface_peek_parent (iface);
#line 10 "../src/client/application/goa-mediator.vala"
	iface->load_token = (void (*) (GearyCredentialsMediator*, GearyAccountInformation*, GearyServiceInformation*, GCancellable*, GAsyncReadyCallback, gpointer)) goa_mediator_load_token;
#line 10 "../src/client/application/goa-mediator.vala"
	iface->load_token_finish = (gboolean (*) (GearyCredentialsMediator*, GAsyncResult*, GError**)) goa_mediator_load_token_finish;
#line 1332 "goa-mediator.c"
}

static void
goa_mediator_instance_init (GoaMediator * self,
                            gpointer klass)
{
#line 10 "../src/client/application/goa-mediator.vala"
	self->priv = goa_mediator_get_instance_private (self);
#line 1341 "goa-mediator.c"
}

static void
goa_mediator_finalize (GObject * obj)
{
	GoaMediator * self;
#line 10 "../src/client/application/goa-mediator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GOA_MEDIATOR, GoaMediator);
#line 13 "../src/client/application/goa-mediator.vala"
	_g_object_unref0 (self->priv->handle);
#line 10 "../src/client/application/goa-mediator.vala"
	G_OBJECT_CLASS (goa_mediator_parent_class)->finalize (obj);
#line 1354 "goa-mediator.c"
}

/** GNOME Online Accounts token adapter. */
GType
goa_mediator_get_type (void)
{
	static volatile gsize goa_mediator_type_id__volatile = 0;
	if (g_once_init_enter (&goa_mediator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GoaMediatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) goa_mediator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GoaMediator), 0, (GInstanceInitFunc) goa_mediator_instance_init, NULL };
		static const GInterfaceInfo geary_credentials_mediator_info = { (GInterfaceInitFunc) goa_mediator_geary_credentials_mediator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType goa_mediator_type_id;
		goa_mediator_type_id = g_type_register_static (G_TYPE_OBJECT, "GoaMediator", &g_define_type_info, 0);
		g_type_add_interface_static (goa_mediator_type_id, GEARY_TYPE_CREDENTIALS_MEDIATOR, &geary_credentials_mediator_info);
		GoaMediator_private_offset = g_type_add_instance_private (goa_mediator_type_id, sizeof (GoaMediatorPrivate));
		g_once_init_leave (&goa_mediator_type_id__volatile, goa_mediator_type_id);
	}
	return goa_mediator_type_id__volatile;
}

