/* icon-factory.c generated by valac 0.44.1, the Vala compiler
 * generated from icon-factory.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Singleton class to hold icons.*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>

#define TYPE_ICON_FACTORY (icon_factory_get_type ())
#define ICON_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_FACTORY, IconFactory))
#define ICON_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_FACTORY, IconFactoryClass))
#define IS_ICON_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_FACTORY))
#define IS_ICON_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_FACTORY))
#define ICON_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_FACTORY, IconFactoryClass))

typedef struct _IconFactory IconFactory;
typedef struct _IconFactoryClass IconFactoryClass;
typedef struct _IconFactoryPrivate IconFactoryPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _icon_factory_unref0(var) ((var == NULL) ? NULL : (var = (icon_factory_unref (var), NULL)))
typedef struct _ParamSpecIconFactory ParamSpecIconFactory;

struct _IconFactory {
	GTypeInstance parent_instance;
	volatile int ref_count;
	IconFactoryPrivate * priv;
};

struct _IconFactoryClass {
	GTypeClass parent_class;
	void (*finalize) (IconFactory *self);
};

struct _IconFactoryPrivate {
	GtkIconTheme* _icon_theme;
	GFile* icons_dir;
};

struct _ParamSpecIconFactory {
	GParamSpec parent_instance;
};

static gint IconFactory_private_offset;
static gpointer icon_factory_parent_class = NULL;
static IconFactory* icon_factory__instance;
static IconFactory* icon_factory__instance = NULL;

gpointer icon_factory_ref (gpointer instance);
void icon_factory_unref (gpointer instance);
GParamSpec* param_spec_icon_factory (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_icon_factory (GValue* value,
                             gpointer v_object);
void value_take_icon_factory (GValue* value,
                              gpointer v_object);
gpointer value_get_icon_factory (const GValue* value);
GType icon_factory_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IconFactory, icon_factory_unref)
#define ICON_FACTORY_ICON_TOOLBAR GTK_ICON_SIZE_LARGE_TOOLBAR
#define ICON_FACTORY_ICON_SIDEBAR GTK_ICON_SIZE_MENU
#define ICON_FACTORY_UNREAD_ICON_SIZE 16
#define ICON_FACTORY_STAR_ICON_SIZE 16
static IconFactory* icon_factory_new (void);
static IconFactory* icon_factory_construct (GType object_type);
GType geary_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyApplication, g_object_unref)
GearyApplication* geary_application_get_instance (void) G_GNUC_DEPRECATED;
GFile* geary_application_get_resource_directory (GearyApplication* self);
static void icon_factory_set_icon_theme (IconFactory* self,
                                  GtkIconTheme* value);
static GtkIconTheme* icon_factory_get_icon_theme (IconFactory* self);
void icon_factory_init (IconFactory* self);
static gint icon_factory_icon_size_to_pixels (IconFactory* self,
                                       GtkIconSize icon_size);
GIcon* icon_factory_get_theme_icon (IconFactory* self,
                                    const gchar* name);
GIcon* icon_factory_get_custom_icon (IconFactory* self,
                                     const gchar* name,
                                     GtkIconSize size);
static GdkPixbuf* icon_factory_get_missing_icon (IconFactory* self,
                                          gint size,
                                          GtkIconLookupFlags flags);
GtkIconInfo* icon_factory_lookup_icon (IconFactory* self,
                                       const gchar* icon_name,
                                       gint size,
                                       GtkIconLookupFlags flags);
static GdkPixbuf* icon_factory_aspect_scale_down_pixbuf (IconFactory* self,
                                                  GdkPixbuf* pixbuf,
                                                  gint size);
GdkPixbuf* icon_factory_load_symbolic (IconFactory* self,
                                       const gchar* icon_name,
                                       gint size,
                                       GtkStyleContext* style,
                                       GtkIconLookupFlags flags);
GdkPixbuf* icon_factory_load_symbolic_colored (IconFactory* self,
                                               const gchar* icon_name,
                                               gint size,
                                               GdkRGBA* color,
                                               GtkIconLookupFlags flags);
IconFactory* icon_factory_get_instance (void);
static void icon_factory_set_instance (IconFactory* value);
static void icon_factory_finalize (IconFactory * obj);

static inline gpointer
icon_factory_get_instance_private (IconFactory* self)
{
	return G_STRUCT_MEMBER_P (self, IconFactory_private_offset);
}

static IconFactory*
icon_factory_construct (GType object_type)
{
	IconFactory* self = NULL;
	GearyApplication* _tmp0_;
	GearyApplication* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GtkIconTheme* _tmp5_;
	GtkIconTheme* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 32 "../src/client/components/icon-factory.vala"
	self = (IconFactory*) g_type_create_instance (object_type);
#line 33 "../src/client/components/icon-factory.vala"
	_tmp0_ = geary_application_get_instance ();
#line 33 "../src/client/components/icon-factory.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/client/components/icon-factory.vala"
	_tmp2_ = geary_application_get_resource_directory (_tmp1_);
#line 33 "../src/client/components/icon-factory.vala"
	_tmp3_ = _tmp2_;
#line 33 "../src/client/components/icon-factory.vala"
	_tmp4_ = g_file_get_child (_tmp3_, "icons");
#line 33 "../src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->icons_dir);
#line 33 "../src/client/components/icon-factory.vala"
	self->priv->icons_dir = _tmp4_;
#line 33 "../src/client/components/icon-factory.vala"
	_g_object_unref0 (_tmp3_);
#line 34 "../src/client/components/icon-factory.vala"
	_tmp5_ = gtk_icon_theme_get_default ();
#line 34 "../src/client/components/icon-factory.vala"
	icon_factory_set_icon_theme (self, _tmp5_);
#line 35 "../src/client/components/icon-factory.vala"
	_tmp6_ = self->priv->_icon_theme;
#line 35 "../src/client/components/icon-factory.vala"
	_tmp7_ = self->priv->icons_dir;
#line 35 "../src/client/components/icon-factory.vala"
	_tmp8_ = g_file_get_path (_tmp7_);
#line 35 "../src/client/components/icon-factory.vala"
	_tmp9_ = _tmp8_;
#line 35 "../src/client/components/icon-factory.vala"
	gtk_icon_theme_append_search_path (_tmp6_, _tmp9_);
#line 35 "../src/client/components/icon-factory.vala"
	_g_free0 (_tmp9_);
#line 32 "../src/client/components/icon-factory.vala"
	return self;
#line 190 "icon-factory.c"
}

static IconFactory*
icon_factory_new (void)
{
#line 32 "../src/client/components/icon-factory.vala"
	return icon_factory_construct (TYPE_ICON_FACTORY);
#line 198 "icon-factory.c"
}

void
icon_factory_init (IconFactory* self)
{
#line 38 "../src/client/components/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 206 "icon-factory.c"
}

static gint
icon_factory_icon_size_to_pixels (IconFactory* self,
                                  GtkIconSize icon_size)
{
	gint result = 0;
#line 43 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), 0);
#line 44 "../src/client/components/icon-factory.vala"
	switch (icon_size) {
#line 44 "../src/client/components/icon-factory.vala"
		case ICON_FACTORY_ICON_SIDEBAR:
#line 220 "icon-factory.c"
		{
#line 46 "../src/client/components/icon-factory.vala"
			result = 16;
#line 46 "../src/client/components/icon-factory.vala"
			return result;
#line 226 "icon-factory.c"
		}
		default:
#line 44 "../src/client/components/icon-factory.vala"
		case ICON_FACTORY_ICON_TOOLBAR:
#line 231 "icon-factory.c"
		{
#line 50 "../src/client/components/icon-factory.vala"
			result = 24;
#line 50 "../src/client/components/icon-factory.vala"
			return result;
#line 237 "icon-factory.c"
		}
	}
}

GIcon*
icon_factory_get_theme_icon (IconFactory* self,
                             const gchar* name)
{
	GIcon* result = NULL;
	GThemedIcon* _tmp0_;
#line 54 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 54 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 55 "../src/client/components/icon-factory.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (name);
#line 55 "../src/client/components/icon-factory.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_icon_get_type (), GIcon);
#line 55 "../src/client/components/icon-factory.vala"
	return result;
#line 258 "icon-factory.c"
}

GIcon*
icon_factory_get_custom_icon (IconFactory* self,
                              const gchar* name,
                              GtkIconSize size)
{
	GIcon* result = NULL;
	gint pixels = 0;
	GFile* icon_file = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp14_;
	GFileIcon* _tmp15_;
#line 58 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 58 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 59 "../src/client/components/icon-factory.vala"
	pixels = icon_factory_icon_size_to_pixels (self, size);
#line 62 "../src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->icons_dir;
#line 62 "../src/client/components/icon-factory.vala"
	_tmp1_ = g_strdup_printf ("%dx%d", pixels, pixels);
#line 62 "../src/client/components/icon-factory.vala"
	_tmp2_ = _tmp1_;
#line 62 "../src/client/components/icon-factory.vala"
	_tmp3_ = g_file_get_child (_tmp0_, _tmp2_);
#line 62 "../src/client/components/icon-factory.vala"
	_tmp4_ = _tmp3_;
#line 62 "../src/client/components/icon-factory.vala"
	_tmp5_ = g_strdup_printf ("%s.svg", name);
#line 62 "../src/client/components/icon-factory.vala"
	_tmp6_ = _tmp5_;
#line 62 "../src/client/components/icon-factory.vala"
	_tmp7_ = g_file_get_child (_tmp4_, _tmp6_);
#line 62 "../src/client/components/icon-factory.vala"
	_tmp8_ = _tmp7_;
#line 62 "../src/client/components/icon-factory.vala"
	_g_free0 (_tmp6_);
#line 62 "../src/client/components/icon-factory.vala"
	_g_object_unref0 (_tmp4_);
#line 62 "../src/client/components/icon-factory.vala"
	_g_free0 (_tmp2_);
#line 62 "../src/client/components/icon-factory.vala"
	icon_file = _tmp8_;
#line 66 "../src/client/components/icon-factory.vala"
	_tmp9_ = icon_file;
#line 66 "../src/client/components/icon-factory.vala"
	if (!g_file_query_exists (_tmp9_, NULL)) {
#line 317 "icon-factory.c"
		GFile* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GFile* _tmp13_;
#line 67 "../src/client/components/icon-factory.vala"
		_tmp10_ = self->priv->icons_dir;
#line 67 "../src/client/components/icon-factory.vala"
		_tmp11_ = g_strdup_printf ("%s.svg", name);
#line 67 "../src/client/components/icon-factory.vala"
		_tmp12_ = _tmp11_;
#line 67 "../src/client/components/icon-factory.vala"
		_tmp13_ = g_file_get_child (_tmp10_, _tmp12_);
#line 67 "../src/client/components/icon-factory.vala"
		_g_object_unref0 (icon_file);
#line 67 "../src/client/components/icon-factory.vala"
		icon_file = _tmp13_;
#line 67 "../src/client/components/icon-factory.vala"
		_g_free0 (_tmp12_);
#line 336 "icon-factory.c"
	}
#line 69 "../src/client/components/icon-factory.vala"
	_tmp14_ = icon_file;
#line 69 "../src/client/components/icon-factory.vala"
	_tmp15_ = (GFileIcon*) g_file_icon_new (_tmp14_);
#line 69 "../src/client/components/icon-factory.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, g_icon_get_type (), GIcon);
#line 69 "../src/client/components/icon-factory.vala"
	_g_object_unref0 (icon_file);
#line 69 "../src/client/components/icon-factory.vala"
	return result;
#line 348 "icon-factory.c"
}

static GdkPixbuf*
icon_factory_get_missing_icon (IconFactory* self,
                               gint size,
                               GtkIconLookupFlags flags)
{
	GdkPixbuf* result = NULL;
	GError* _inner_error0_ = NULL;
#line 73 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 360 "icon-factory.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GtkIconTheme* _tmp1_;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 75 "../src/client/components/icon-factory.vala"
		_tmp1_ = self->priv->_icon_theme;
#line 75 "../src/client/components/icon-factory.vala"
		_tmp2_ = gtk_icon_theme_load_icon (_tmp1_, "image-missing", size, flags, &_inner_error0_);
#line 75 "../src/client/components/icon-factory.vala"
		_tmp0_ = _tmp2_;
#line 75 "../src/client/components/icon-factory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 374 "icon-factory.c"
			goto __catch110_g_error;
		}
#line 75 "../src/client/components/icon-factory.vala"
		_tmp3_ = _tmp0_;
#line 75 "../src/client/components/icon-factory.vala"
		_tmp0_ = NULL;
#line 75 "../src/client/components/icon-factory.vala"
		result = _tmp3_;
#line 75 "../src/client/components/icon-factory.vala"
		_g_object_unref0 (_tmp0_);
#line 75 "../src/client/components/icon-factory.vala"
		return result;
#line 387 "icon-factory.c"
	}
	goto __finally110;
	__catch110_g_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 74 "../src/client/components/icon-factory.vala"
		err = _inner_error0_;
#line 74 "../src/client/components/icon-factory.vala"
		_inner_error0_ = NULL;
#line 77 "../src/client/components/icon-factory.vala"
		_tmp4_ = err;
#line 77 "../src/client/components/icon-factory.vala"
		_tmp5_ = _tmp4_->message;
#line 77 "../src/client/components/icon-factory.vala"
		g_warning ("icon-factory.vala:77: Couldn't load image-missing icon: %s", _tmp5_);
#line 74 "../src/client/components/icon-factory.vala"
		_g_error_free0 (err);
#line 407 "icon-factory.c"
	}
	__finally110:
#line 74 "../src/client/components/icon-factory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/client/components/icon-factory.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 74 "../src/client/components/icon-factory.vala"
		g_clear_error (&_inner_error0_);
#line 74 "../src/client/components/icon-factory.vala"
		return NULL;
#line 418 "icon-factory.c"
	}
#line 81 "../src/client/components/icon-factory.vala"
	result = NULL;
#line 81 "../src/client/components/icon-factory.vala"
	return result;
#line 424 "icon-factory.c"
}

GtkIconInfo*
icon_factory_lookup_icon (IconFactory* self,
                          const gchar* icon_name,
                          gint size,
                          GtkIconLookupFlags flags)
{
	GtkIconInfo* result = NULL;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconInfo* _tmp1_;
	GtkIconInfo* _tmp2_;
#line 84 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 84 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 85 "../src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 85 "../src/client/components/icon-factory.vala"
	_tmp1_ = gtk_icon_theme_lookup_icon (_tmp0_, icon_name, size, flags);
#line 85 "../src/client/components/icon-factory.vala"
	icon_info = _tmp1_;
#line 86 "../src/client/components/icon-factory.vala"
	_tmp2_ = icon_info;
#line 86 "../src/client/components/icon-factory.vala"
	if (_tmp2_ == NULL) {
#line 452 "icon-factory.c"
		GtkIconTheme* _tmp3_;
		GtkIconInfo* _tmp4_;
#line 87 "../src/client/components/icon-factory.vala"
		_tmp3_ = self->priv->_icon_theme;
#line 87 "../src/client/components/icon-factory.vala"
		_tmp4_ = gtk_icon_theme_lookup_icon (_tmp3_, "text-x-generic-symbolic", size, flags);
#line 87 "../src/client/components/icon-factory.vala"
		_g_object_unref0 (icon_info);
#line 87 "../src/client/components/icon-factory.vala"
		icon_info = _tmp4_;
#line 463 "icon-factory.c"
	}
#line 89 "../src/client/components/icon-factory.vala"
	result = icon_info;
#line 89 "../src/client/components/icon-factory.vala"
	return result;
#line 469 "icon-factory.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 96 "../src/client/components/icon-factory.vala"
	return self ? g_object_ref (self) : NULL;
#line 477 "icon-factory.c"
}

static GdkPixbuf*
icon_factory_aspect_scale_down_pixbuf (IconFactory* self,
                                       GdkPixbuf* pixbuf,
                                       gint size)
{
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint scaled_width = 0;
	gint scaled_height = 0;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GdkPixbuf* _tmp18_;
#line 94 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 94 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 95 "../src/client/components/icon-factory.vala"
	_tmp1_ = gdk_pixbuf_get_width (pixbuf);
#line 95 "../src/client/components/icon-factory.vala"
	_tmp2_ = _tmp1_;
#line 95 "../src/client/components/icon-factory.vala"
	if (_tmp2_ <= size) {
#line 506 "icon-factory.c"
		gint _tmp3_;
		gint _tmp4_;
#line 95 "../src/client/components/icon-factory.vala"
		_tmp3_ = gdk_pixbuf_get_height (pixbuf);
#line 95 "../src/client/components/icon-factory.vala"
		_tmp4_ = _tmp3_;
#line 95 "../src/client/components/icon-factory.vala"
		_tmp0_ = _tmp4_ <= size;
#line 515 "icon-factory.c"
	} else {
#line 95 "../src/client/components/icon-factory.vala"
		_tmp0_ = FALSE;
#line 519 "icon-factory.c"
	}
#line 95 "../src/client/components/icon-factory.vala"
	if (_tmp0_) {
#line 523 "icon-factory.c"
		GdkPixbuf* _tmp5_;
#line 96 "../src/client/components/icon-factory.vala"
		_tmp5_ = _g_object_ref0 (pixbuf);
#line 96 "../src/client/components/icon-factory.vala"
		result = _tmp5_;
#line 96 "../src/client/components/icon-factory.vala"
		return result;
#line 531 "icon-factory.c"
	}
#line 99 "../src/client/components/icon-factory.vala"
	_tmp6_ = gdk_pixbuf_get_width (pixbuf);
#line 99 "../src/client/components/icon-factory.vala"
	_tmp7_ = _tmp6_;
#line 99 "../src/client/components/icon-factory.vala"
	_tmp8_ = gdk_pixbuf_get_height (pixbuf);
#line 99 "../src/client/components/icon-factory.vala"
	_tmp9_ = _tmp8_;
#line 99 "../src/client/components/icon-factory.vala"
	if (_tmp7_ >= _tmp9_) {
#line 543 "icon-factory.c"
		gdouble aspect = 0.0;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
#line 100 "../src/client/components/icon-factory.vala"
		_tmp10_ = gdk_pixbuf_get_width (pixbuf);
#line 100 "../src/client/components/icon-factory.vala"
		_tmp11_ = _tmp10_;
#line 100 "../src/client/components/icon-factory.vala"
		aspect = ((gdouble) size) / ((gdouble) _tmp11_);
#line 101 "../src/client/components/icon-factory.vala"
		scaled_width = size;
#line 102 "../src/client/components/icon-factory.vala"
		_tmp12_ = gdk_pixbuf_get_height (pixbuf);
#line 102 "../src/client/components/icon-factory.vala"
		_tmp13_ = _tmp12_;
#line 102 "../src/client/components/icon-factory.vala"
		scaled_height = (gint) round (((gdouble) _tmp13_) * aspect);
#line 563 "icon-factory.c"
	} else {
		gdouble aspect = 0.0;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
#line 104 "../src/client/components/icon-factory.vala"
		_tmp14_ = gdk_pixbuf_get_height (pixbuf);
#line 104 "../src/client/components/icon-factory.vala"
		_tmp15_ = _tmp14_;
#line 104 "../src/client/components/icon-factory.vala"
		aspect = ((gdouble) size) / ((gdouble) _tmp15_);
#line 105 "../src/client/components/icon-factory.vala"
		_tmp16_ = gdk_pixbuf_get_width (pixbuf);
#line 105 "../src/client/components/icon-factory.vala"
		_tmp17_ = _tmp16_;
#line 105 "../src/client/components/icon-factory.vala"
		scaled_width = (gint) round (((gdouble) _tmp17_) * aspect);
#line 106 "../src/client/components/icon-factory.vala"
		scaled_height = size;
#line 584 "icon-factory.c"
	}
#line 109 "../src/client/components/icon-factory.vala"
	_tmp18_ = gdk_pixbuf_scale_simple (pixbuf, scaled_width, scaled_height, GDK_INTERP_BILINEAR);
#line 109 "../src/client/components/icon-factory.vala"
	result = _tmp18_;
#line 109 "../src/client/components/icon-factory.vala"
	return result;
#line 592 "icon-factory.c"
}

GdkPixbuf*
icon_factory_load_symbolic (IconFactory* self,
                            const gchar* icon_name,
                            gint size,
                            GtkStyleContext* style,
                            GtkIconLookupFlags flags)
{
	GdkPixbuf* result = NULL;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconInfo* _tmp1_;
	GtkIconInfo* _tmp2_;
	GdkPixbuf* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 112 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 112 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 112 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (GTK_IS_STYLE_CONTEXT (style), NULL);
#line 114 "../src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 114 "../src/client/components/icon-factory.vala"
	_tmp1_ = gtk_icon_theme_lookup_icon (_tmp0_, icon_name, size, flags);
#line 114 "../src/client/components/icon-factory.vala"
	icon_info = _tmp1_;
#line 117 "../src/client/components/icon-factory.vala"
	_tmp2_ = icon_info;
#line 117 "../src/client/components/icon-factory.vala"
	if (_tmp2_ != NULL) {
#line 625 "icon-factory.c"
		{
			GdkPixbuf* _tmp3_ = NULL;
			GtkIconInfo* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 119 "../src/client/components/icon-factory.vala"
			_tmp4_ = icon_info;
#line 119 "../src/client/components/icon-factory.vala"
			_tmp5_ = gtk_icon_info_load_symbolic_for_context (_tmp4_, style, NULL, &_inner_error0_);
#line 119 "../src/client/components/icon-factory.vala"
			_tmp3_ = _tmp5_;
#line 119 "../src/client/components/icon-factory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 639 "icon-factory.c"
				goto __catch111_g_error;
			}
#line 119 "../src/client/components/icon-factory.vala"
			_tmp6_ = icon_factory_aspect_scale_down_pixbuf (self, _tmp3_, size);
#line 119 "../src/client/components/icon-factory.vala"
			result = _tmp6_;
#line 119 "../src/client/components/icon-factory.vala"
			_g_object_unref0 (_tmp3_);
#line 119 "../src/client/components/icon-factory.vala"
			_g_object_unref0 (icon_info);
#line 119 "../src/client/components/icon-factory.vala"
			return result;
#line 652 "icon-factory.c"
		}
		goto __finally111;
		__catch111_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
#line 118 "../src/client/components/icon-factory.vala"
			e = _inner_error0_;
#line 118 "../src/client/components/icon-factory.vala"
			_inner_error0_ = NULL;
#line 121 "../src/client/components/icon-factory.vala"
			_tmp7_ = e;
#line 121 "../src/client/components/icon-factory.vala"
			_tmp8_ = _tmp7_->message;
#line 121 "../src/client/components/icon-factory.vala"
			g_message ("icon-factory.vala:121: Couldn't load icon: %s", _tmp8_);
#line 118 "../src/client/components/icon-factory.vala"
			_g_error_free0 (e);
#line 672 "icon-factory.c"
		}
		__finally111:
#line 118 "../src/client/components/icon-factory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/client/components/icon-factory.vala"
			_g_object_unref0 (icon_info);
#line 118 "../src/client/components/icon-factory.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 118 "../src/client/components/icon-factory.vala"
			g_clear_error (&_inner_error0_);
#line 118 "../src/client/components/icon-factory.vala"
			return NULL;
#line 685 "icon-factory.c"
		}
	}
#line 126 "../src/client/components/icon-factory.vala"
	_tmp9_ = icon_factory_get_missing_icon (self, size, flags);
#line 126 "../src/client/components/icon-factory.vala"
	result = _tmp9_;
#line 126 "../src/client/components/icon-factory.vala"
	_g_object_unref0 (icon_info);
#line 126 "../src/client/components/icon-factory.vala"
	return result;
#line 696 "icon-factory.c"
}

/**
     * Loads a symbolic icon into a pixbuf, where the color-key has been switched to the provided
     * color.
     */
GdkPixbuf*
icon_factory_load_symbolic_colored (IconFactory* self,
                                    const gchar* icon_name,
                                    gint size,
                                    GdkRGBA* color,
                                    GtkIconLookupFlags flags)
{
	GdkPixbuf* result = NULL;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconInfo* _tmp1_;
	GtkIconInfo* _tmp2_;
	GdkPixbuf* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 133 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 133 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 133 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 135 "../src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 135 "../src/client/components/icon-factory.vala"
	_tmp1_ = gtk_icon_theme_lookup_icon (_tmp0_, icon_name, size, flags);
#line 135 "../src/client/components/icon-factory.vala"
	icon_info = _tmp1_;
#line 138 "../src/client/components/icon-factory.vala"
	_tmp2_ = icon_info;
#line 138 "../src/client/components/icon-factory.vala"
	if (_tmp2_ != NULL) {
#line 733 "icon-factory.c"
		{
			GdkPixbuf* _tmp3_ = NULL;
			GtkIconInfo* _tmp4_;
			GdkRGBA _tmp5_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 140 "../src/client/components/icon-factory.vala"
			_tmp4_ = icon_info;
#line 140 "../src/client/components/icon-factory.vala"
			_tmp5_ = *color;
#line 140 "../src/client/components/icon-factory.vala"
			_tmp6_ = gtk_icon_info_load_symbolic (_tmp4_, &_tmp5_, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 140 "../src/client/components/icon-factory.vala"
			_tmp3_ = _tmp6_;
#line 140 "../src/client/components/icon-factory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 750 "icon-factory.c"
				goto __catch112_g_error;
			}
#line 140 "../src/client/components/icon-factory.vala"
			_tmp7_ = icon_factory_aspect_scale_down_pixbuf (self, _tmp3_, size);
#line 140 "../src/client/components/icon-factory.vala"
			result = _tmp7_;
#line 140 "../src/client/components/icon-factory.vala"
			_g_object_unref0 (_tmp3_);
#line 140 "../src/client/components/icon-factory.vala"
			_g_object_unref0 (icon_info);
#line 140 "../src/client/components/icon-factory.vala"
			return result;
#line 763 "icon-factory.c"
		}
		goto __finally112;
		__catch112_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 139 "../src/client/components/icon-factory.vala"
			e = _inner_error0_;
#line 139 "../src/client/components/icon-factory.vala"
			_inner_error0_ = NULL;
#line 142 "../src/client/components/icon-factory.vala"
			_tmp8_ = e;
#line 142 "../src/client/components/icon-factory.vala"
			_tmp9_ = _tmp8_->message;
#line 142 "../src/client/components/icon-factory.vala"
			g_warning ("icon-factory.vala:142: Couldn't load icon: %s", _tmp9_);
#line 139 "../src/client/components/icon-factory.vala"
			_g_error_free0 (e);
#line 783 "icon-factory.c"
		}
		__finally112:
#line 139 "../src/client/components/icon-factory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../src/client/components/icon-factory.vala"
			_g_object_unref0 (icon_info);
#line 139 "../src/client/components/icon-factory.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 139 "../src/client/components/icon-factory.vala"
			g_clear_error (&_inner_error0_);
#line 139 "../src/client/components/icon-factory.vala"
			return NULL;
#line 796 "icon-factory.c"
		}
	}
#line 146 "../src/client/components/icon-factory.vala"
	_tmp10_ = icon_factory_get_missing_icon (self, size, flags);
#line 146 "../src/client/components/icon-factory.vala"
	result = _tmp10_;
#line 146 "../src/client/components/icon-factory.vala"
	_g_object_unref0 (icon_info);
#line 146 "../src/client/components/icon-factory.vala"
	return result;
#line 807 "icon-factory.c"
}

IconFactory*
icon_factory_get_instance (void)
{
	IconFactory* result;
	IconFactory* _tmp0_;
	IconFactory* _tmp2_;
#line 15 "../src/client/components/icon-factory.vala"
	_tmp0_ = icon_factory__instance;
#line 15 "../src/client/components/icon-factory.vala"
	if (_tmp0_ == NULL) {
#line 820 "icon-factory.c"
		IconFactory* _tmp1_;
#line 16 "../src/client/components/icon-factory.vala"
		_tmp1_ = icon_factory_new ();
#line 16 "../src/client/components/icon-factory.vala"
		_icon_factory_unref0 (icon_factory__instance);
#line 16 "../src/client/components/icon-factory.vala"
		icon_factory__instance = _tmp1_;
#line 828 "icon-factory.c"
	}
#line 18 "../src/client/components/icon-factory.vala"
	_tmp2_ = icon_factory__instance;
#line 18 "../src/client/components/icon-factory.vala"
	result = _tmp2_;
#line 18 "../src/client/components/icon-factory.vala"
	return result;
#line 836 "icon-factory.c"
}

static gpointer
_icon_factory_ref0 (gpointer self)
{
#line 21 "../src/client/components/icon-factory.vala"
	return self ? icon_factory_ref (self) : NULL;
#line 844 "icon-factory.c"
}

static void
icon_factory_set_instance (IconFactory* value)
{
	IconFactory* _tmp0_;
#line 21 "../src/client/components/icon-factory.vala"
	_tmp0_ = _icon_factory_ref0 (value);
#line 21 "../src/client/components/icon-factory.vala"
	_icon_factory_unref0 (icon_factory__instance);
#line 21 "../src/client/components/icon-factory.vala"
	icon_factory__instance = _tmp0_;
#line 857 "icon-factory.c"
}

static GtkIconTheme*
icon_factory_get_icon_theme (IconFactory* self)
{
	GtkIconTheme* result;
	GtkIconTheme* _tmp0_;
#line 27 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 27 "../src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 27 "../src/client/components/icon-factory.vala"
	result = _tmp0_;
#line 27 "../src/client/components/icon-factory.vala"
	return result;
#line 873 "icon-factory.c"
}

static void
icon_factory_set_icon_theme (IconFactory* self,
                             GtkIconTheme* value)
{
	GtkIconTheme* _tmp0_;
#line 27 "../src/client/components/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 27 "../src/client/components/icon-factory.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 27 "../src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->_icon_theme);
#line 27 "../src/client/components/icon-factory.vala"
	self->priv->_icon_theme = _tmp0_;
#line 889 "icon-factory.c"
}

static void
value_icon_factory_init (GValue* value)
{
#line 8 "../src/client/components/icon-factory.vala"
	value->data[0].v_pointer = NULL;
#line 897 "icon-factory.c"
}

static void
value_icon_factory_free_value (GValue* value)
{
#line 8 "../src/client/components/icon-factory.vala"
	if (value->data[0].v_pointer) {
#line 8 "../src/client/components/icon-factory.vala"
		icon_factory_unref (value->data[0].v_pointer);
#line 907 "icon-factory.c"
	}
}

static void
value_icon_factory_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 8 "../src/client/components/icon-factory.vala"
	if (src_value->data[0].v_pointer) {
#line 8 "../src/client/components/icon-factory.vala"
		dest_value->data[0].v_pointer = icon_factory_ref (src_value->data[0].v_pointer);
#line 919 "icon-factory.c"
	} else {
#line 8 "../src/client/components/icon-factory.vala"
		dest_value->data[0].v_pointer = NULL;
#line 923 "icon-factory.c"
	}
}

static gpointer
value_icon_factory_peek_pointer (const GValue* value)
{
#line 8 "../src/client/components/icon-factory.vala"
	return value->data[0].v_pointer;
#line 932 "icon-factory.c"
}

static gchar*
value_icon_factory_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 8 "../src/client/components/icon-factory.vala"
	if (collect_values[0].v_pointer) {
#line 943 "icon-factory.c"
		IconFactory * object;
		object = collect_values[0].v_pointer;
#line 8 "../src/client/components/icon-factory.vala"
		if (object->parent_instance.g_class == NULL) {
#line 8 "../src/client/components/icon-factory.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 950 "icon-factory.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 8 "../src/client/components/icon-factory.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 954 "icon-factory.c"
		}
#line 8 "../src/client/components/icon-factory.vala"
		value->data[0].v_pointer = icon_factory_ref (object);
#line 958 "icon-factory.c"
	} else {
#line 8 "../src/client/components/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 962 "icon-factory.c"
	}
#line 8 "../src/client/components/icon-factory.vala"
	return NULL;
#line 966 "icon-factory.c"
}

static gchar*
value_icon_factory_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	IconFactory ** object_p;
	object_p = collect_values[0].v_pointer;
#line 8 "../src/client/components/icon-factory.vala"
	if (!object_p) {
#line 8 "../src/client/components/icon-factory.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 981 "icon-factory.c"
	}
#line 8 "../src/client/components/icon-factory.vala"
	if (!value->data[0].v_pointer) {
#line 8 "../src/client/components/icon-factory.vala"
		*object_p = NULL;
#line 987 "icon-factory.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 8 "../src/client/components/icon-factory.vala"
		*object_p = value->data[0].v_pointer;
#line 991 "icon-factory.c"
	} else {
#line 8 "../src/client/components/icon-factory.vala"
		*object_p = icon_factory_ref (value->data[0].v_pointer);
#line 995 "icon-factory.c"
	}
#line 8 "../src/client/components/icon-factory.vala"
	return NULL;
#line 999 "icon-factory.c"
}

GParamSpec*
param_spec_icon_factory (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecIconFactory* spec;
#line 8 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ICON_FACTORY), NULL);
#line 8 "../src/client/components/icon-factory.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 8 "../src/client/components/icon-factory.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 8 "../src/client/components/icon-factory.vala"
	return G_PARAM_SPEC (spec);
#line 1018 "icon-factory.c"
}

gpointer
value_get_icon_factory (const GValue* value)
{
#line 8 "../src/client/components/icon-factory.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY), NULL);
#line 8 "../src/client/components/icon-factory.vala"
	return value->data[0].v_pointer;
#line 1028 "icon-factory.c"
}

void
value_set_icon_factory (GValue* value,
                        gpointer v_object)
{
	IconFactory * old;
#line 8 "../src/client/components/icon-factory.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY));
#line 8 "../src/client/components/icon-factory.vala"
	old = value->data[0].v_pointer;
#line 8 "../src/client/components/icon-factory.vala"
	if (v_object) {
#line 8 "../src/client/components/icon-factory.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_FACTORY));
#line 8 "../src/client/components/icon-factory.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "../src/client/components/icon-factory.vala"
		value->data[0].v_pointer = v_object;
#line 8 "../src/client/components/icon-factory.vala"
		icon_factory_ref (value->data[0].v_pointer);
#line 1050 "icon-factory.c"
	} else {
#line 8 "../src/client/components/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1054 "icon-factory.c"
	}
#line 8 "../src/client/components/icon-factory.vala"
	if (old) {
#line 8 "../src/client/components/icon-factory.vala"
		icon_factory_unref (old);
#line 1060 "icon-factory.c"
	}
}

void
value_take_icon_factory (GValue* value,
                         gpointer v_object)
{
	IconFactory * old;
#line 8 "../src/client/components/icon-factory.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY));
#line 8 "../src/client/components/icon-factory.vala"
	old = value->data[0].v_pointer;
#line 8 "../src/client/components/icon-factory.vala"
	if (v_object) {
#line 8 "../src/client/components/icon-factory.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_FACTORY));
#line 8 "../src/client/components/icon-factory.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "../src/client/components/icon-factory.vala"
		value->data[0].v_pointer = v_object;
#line 1081 "icon-factory.c"
	} else {
#line 8 "../src/client/components/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1085 "icon-factory.c"
	}
#line 8 "../src/client/components/icon-factory.vala"
	if (old) {
#line 8 "../src/client/components/icon-factory.vala"
		icon_factory_unref (old);
#line 1091 "icon-factory.c"
	}
}

static void
icon_factory_class_init (IconFactoryClass * klass,
                         gpointer klass_data)
{
#line 8 "../src/client/components/icon-factory.vala"
	icon_factory_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/client/components/icon-factory.vala"
	((IconFactoryClass *) klass)->finalize = icon_factory_finalize;
#line 8 "../src/client/components/icon-factory.vala"
	g_type_class_adjust_private_offset (klass, &IconFactory_private_offset);
#line 1105 "icon-factory.c"
}

static void
icon_factory_instance_init (IconFactory * self,
                            gpointer klass)
{
#line 8 "../src/client/components/icon-factory.vala"
	self->priv = icon_factory_get_instance_private (self);
#line 8 "../src/client/components/icon-factory.vala"
	self->ref_count = 1;
#line 1116 "icon-factory.c"
}

static void
icon_factory_finalize (IconFactory * obj)
{
	IconFactory * self;
#line 8 "../src/client/components/icon-factory.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_FACTORY, IconFactory);
#line 8 "../src/client/components/icon-factory.vala"
	g_signal_handlers_destroy (self);
#line 27 "../src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->_icon_theme);
#line 29 "../src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->icons_dir);
#line 1131 "icon-factory.c"
}

GType
icon_factory_get_type (void)
{
	static volatile gsize icon_factory_type_id__volatile = 0;
	if (g_once_init_enter (&icon_factory_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_icon_factory_init, value_icon_factory_free_value, value_icon_factory_copy_value, value_icon_factory_peek_pointer, "p", value_icon_factory_collect_value, "p", value_icon_factory_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (IconFactoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_factory_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconFactory), 0, (GInstanceInitFunc) icon_factory_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType icon_factory_type_id;
		icon_factory_type_id = g_type_register_fundamental (g_type_fundamental_next (), "IconFactory", &g_define_type_info, &g_define_type_fundamental_info, 0);
		IconFactory_private_offset = g_type_add_instance_private (icon_factory_type_id, sizeof (IconFactoryPrivate));
		g_once_init_leave (&icon_factory_type_id__volatile, icon_factory_type_id);
	}
	return icon_factory_type_id__volatile;
}

gpointer
icon_factory_ref (gpointer instance)
{
	IconFactory * self;
	self = instance;
#line 8 "../src/client/components/icon-factory.vala"
	g_atomic_int_inc (&self->ref_count);
#line 8 "../src/client/components/icon-factory.vala"
	return instance;
#line 1159 "icon-factory.c"
}

void
icon_factory_unref (gpointer instance)
{
	IconFactory * self;
	self = instance;
#line 8 "../src/client/components/icon-factory.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 8 "../src/client/components/icon-factory.vala"
		ICON_FACTORY_GET_CLASS (self)->finalize (self);
#line 8 "../src/client/components/icon-factory.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1173 "icon-factory.c"
	}
}

