/* main-toolbar.c generated by valac 0.44.1, the Vala compiler
 * generated from main-toolbar.vala, do not modify */

/* Copyright 2017 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Draws the main toolbar.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define TYPE_MAIN_TOOLBAR (main_toolbar_get_type ())
#define MAIN_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_TOOLBAR, MainToolbar))
#define MAIN_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_TOOLBAR, MainToolbarClass))
#define IS_MAIN_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_TOOLBAR))
#define IS_MAIN_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_TOOLBAR))
#define MAIN_TOOLBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_TOOLBAR, MainToolbarClass))

typedef struct _MainToolbar MainToolbar;
typedef struct _MainToolbarClass MainToolbarClass;
typedef struct _MainToolbarPrivate MainToolbarPrivate;

#define TYPE_FOLDER_POPOVER (folder_popover_get_type ())
#define FOLDER_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FOLDER_POPOVER, FolderPopover))
#define FOLDER_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FOLDER_POPOVER, FolderPopoverClass))
#define IS_FOLDER_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FOLDER_POPOVER))
#define IS_FOLDER_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FOLDER_POPOVER))
#define FOLDER_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FOLDER_POPOVER, FolderPopoverClass))

typedef struct _FolderPopover FolderPopover;
typedef struct _FolderPopoverClass FolderPopoverClass;
enum  {
	MAIN_TOOLBAR_0_PROPERTY,
	MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY,
	MAIN_TOOLBAR_ACCOUNT_PROPERTY,
	MAIN_TOOLBAR_FOLDER_PROPERTY,
	MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY,
	MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_LEFT_PROPERTY,
	MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_RIGHT_PROPERTY,
	MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY,
	MAIN_TOOLBAR_FIND_OPEN_PROPERTY,
	MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY,
	MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY,
	MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY,
	MAIN_TOOLBAR_SHOW_TRASH_BUTTON_PROPERTY,
	MAIN_TOOLBAR_UNDO_TOOLTIP_PROPERTY,
	MAIN_TOOLBAR_NUM_PROPERTIES
};
static GParamSpec* main_toolbar_properties[MAIN_TOOLBAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
typedef enum  {
	CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN = 0,
	CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY
} ConfigurationDesktopEnvironment;

#define CONFIGURATION_TYPE_DESKTOP_ENVIRONMENT (configuration_desktop_environment_get_type ())

struct _MainToolbar {
	GtkBox parent_instance;
	MainToolbarPrivate * priv;
	GtkMenuButton* copy_message_button;
	GtkMenuButton* move_message_button;
};

struct _MainToolbarClass {
	GtkBoxClass parent_class;
};

struct _MainToolbarPrivate {
	gint _left_pane_width;
	gchar* _account;
	gchar* _folder;
	gboolean _show_close_button;
	gboolean _show_close_button_left;
	gboolean _show_close_button_right;
	gboolean _search_open;
	gboolean _find_open;
	FolderPopover* _copy_folder_menu;
	FolderPopover* _move_folder_menu;
	gint _selected_conversations;
	gboolean _show_trash_button;
	GtkHeaderBar* folder_header;
	GtkToggleButton* search_conversations_button;
	GtkMenuButton* main_menu_button;
	GBinding* guest_header_binding;
	GtkHeaderBar* conversation_header;
	GtkMenuButton* mark_message_button;
	GtkButton* archive_button;
	GtkButton* trash_delete_button;
	GtkToggleButton* find_button;
	GtkButton* undo_button;
	GtkImage* trash_image;
	GtkImage* delete_image;
};

static gint MainToolbar_private_offset;
static gpointer main_toolbar_parent_class = NULL;

GType main_toolbar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainToolbar, g_object_unref)
GType folder_popover_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FolderPopover, g_object_unref)
FolderPopover* folder_popover_new (void);
FolderPopover* folder_popover_construct (GType object_type);
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_configuration (GValue* value,
                              gpointer v_object);
void value_take_configuration (GValue* value,
                               gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Configuration, configuration_unref)
MainToolbar* main_toolbar_new (Configuration* config);
MainToolbar* main_toolbar_construct (GType object_type,
                                     Configuration* config);
void configuration_bind (Configuration* self,
                         const gchar* key,
                         GObject* object,
                         const gchar* property,
                         GSettingsBindFlags flags);
#define CONFIGURATION_MESSAGES_PANE_POSITION_KEY "messages-pane-position"
static gboolean __lambda109_ (MainToolbar* self,
                       GBinding* binding,
                       GValue* source_value,
                       GValue* target_value);
gint main_toolbar_get_left_pane_width (MainToolbar* self);
static gboolean ___lambda109__gbinding_transform_func (GBinding* binding,
                                                GValue* from_value,
                                                GValue* to_value,
                                                gpointer self);
GType configuration_desktop_environment_get_type (void) G_GNUC_CONST;
ConfigurationDesktopEnvironment configuration_get_desktop_environment (Configuration* self);
static void __lambda110_ (MainToolbar* self);
static void main_toolbar_update_conversation_buttons (MainToolbar* self);
static void ___lambda110__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda111_ (MainToolbar* self);
static void ___lambda111__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
FolderPopover* main_toolbar_get_copy_folder_menu (MainToolbar* self);
FolderPopover* main_toolbar_get_move_folder_menu (MainToolbar* self);
static void main_toolbar_set_window_buttons (MainToolbar* self);
static void _main_toolbar_set_window_buttons_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void _main_toolbar_set_window_buttons_gtk_widget_realize (GtkWidget* _sender,
                                                          gpointer self);
void main_toolbar_set_conversation_header (MainToolbar* self,
                                           GtkHeaderBar* header);
void main_toolbar_remove_conversation_header (MainToolbar* self,
                                              GtkHeaderBar* header);
gboolean main_toolbar_get_show_close_button (MainToolbar* self);
static void main_toolbar_set_show_close_button_left (MainToolbar* self,
                                              gboolean value);
static void main_toolbar_set_show_close_button_right (MainToolbar* self,
                                               gboolean value);
gint main_toolbar_get_selected_conversations (MainToolbar* self);
gboolean main_toolbar_get_show_trash_button (MainToolbar* self);
#define GEARY_CONTROLLER_ACTION_TRASH_CONVERSATION "trash-conv"
#define GEARY_CONTROLLER_ACTION_DELETE_CONVERSATION "delete-conv"
void main_toolbar_set_left_pane_width (MainToolbar* self,
                                       gint value);
const gchar* main_toolbar_get_account (MainToolbar* self);
void main_toolbar_set_account (MainToolbar* self,
                               const gchar* value);
const gchar* main_toolbar_get_folder (MainToolbar* self);
void main_toolbar_set_folder (MainToolbar* self,
                              const gchar* value);
void main_toolbar_set_show_close_button (MainToolbar* self,
                                         gboolean value);
gboolean main_toolbar_get_show_close_button_left (MainToolbar* self);
gboolean main_toolbar_get_show_close_button_right (MainToolbar* self);
gboolean main_toolbar_get_search_open (MainToolbar* self);
void main_toolbar_set_search_open (MainToolbar* self,
                                   gboolean value);
gboolean main_toolbar_get_find_open (MainToolbar* self);
void main_toolbar_set_find_open (MainToolbar* self,
                                 gboolean value);
static void main_toolbar_set_copy_folder_menu (MainToolbar* self,
                                        FolderPopover* value);
static void main_toolbar_set_move_folder_menu (MainToolbar* self,
                                        FolderPopover* value);
void main_toolbar_set_selected_conversations (MainToolbar* self,
                                              gint value);
void main_toolbar_set_show_trash_button (MainToolbar* self,
                                         gboolean value);
gchar* main_toolbar_get_undo_tooltip (MainToolbar* self);
void main_toolbar_set_undo_tooltip (MainToolbar* self,
                                    const gchar* value);
static void main_toolbar_finalize (GObject * obj);
static void _vala_main_toolbar_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_main_toolbar_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
main_toolbar_get_instance_private (MainToolbar* self)
{
	return G_STRUCT_MEMBER_P (self, MainToolbar_private_offset);
}

static gboolean
__lambda109_ (MainToolbar* self,
              GBinding* binding,
              GValue* source_value,
              GValue* target_value)
{
	gboolean result = FALSE;
	gint _tmp0_;
	GValue _tmp1_ = {0};
#line 78 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (G_IS_BINDING (binding), FALSE);
#line 78 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (source_value != NULL, FALSE);
#line 78 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (target_value != NULL, FALSE);
#line 79 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->_left_pane_width;
#line 79 "../src/client/components/main-toolbar.vala"
	g_value_init (&_tmp1_, G_TYPE_INT);
#line 79 "../src/client/components/main-toolbar.vala"
	g_value_set_int (&_tmp1_, _tmp0_ + 6);
#line 79 "../src/client/components/main-toolbar.vala"
	G_IS_VALUE (target_value) ? (g_value_unset (target_value), NULL) : NULL;
#line 79 "../src/client/components/main-toolbar.vala"
	*target_value = _tmp1_;
#line 80 "../src/client/components/main-toolbar.vala"
	result = TRUE;
#line 80 "../src/client/components/main-toolbar.vala"
	return result;
#line 269 "main-toolbar.c"
}

static gboolean
___lambda109__gbinding_transform_func (GBinding* binding,
                                       GValue* from_value,
                                       GValue* to_value,
                                       gpointer self)
{
	gboolean result;
	result = __lambda109_ ((MainToolbar*) self, binding, from_value, to_value);
#line 77 "../src/client/components/main-toolbar.vala"
	return result;
#line 282 "main-toolbar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 94 "../src/client/components/main-toolbar.vala"
	return self ? g_object_ref (self) : NULL;
#line 290 "main-toolbar.c"
}

static void
__lambda110_ (MainToolbar* self)
{
#line 103 "../src/client/components/main-toolbar.vala"
	main_toolbar_update_conversation_buttons (self);
#line 298 "main-toolbar.c"
}

static void
___lambda110__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 103 "../src/client/components/main-toolbar.vala"
	__lambda110_ ((MainToolbar*) self);
#line 308 "main-toolbar.c"
}

static void
__lambda111_ (MainToolbar* self)
{
#line 104 "../src/client/components/main-toolbar.vala"
	main_toolbar_update_conversation_buttons (self);
#line 316 "main-toolbar.c"
}

static void
___lambda111__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 104 "../src/client/components/main-toolbar.vala"
	__lambda111_ ((MainToolbar*) self);
#line 326 "main-toolbar.c"
}

static void
_main_toolbar_set_window_buttons_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 112 "../src/client/components/main-toolbar.vala"
	main_toolbar_set_window_buttons ((MainToolbar*) self);
#line 336 "main-toolbar.c"
}

static void
_main_toolbar_set_window_buttons_gtk_widget_realize (GtkWidget* _sender,
                                                     gpointer self)
{
#line 113 "../src/client/components/main-toolbar.vala"
	main_toolbar_set_window_buttons ((MainToolbar*) self);
#line 345 "main-toolbar.c"
}

MainToolbar*
main_toolbar_construct (GType object_type,
                        Configuration* config)
{
	MainToolbar * self = NULL;
	GtkHeaderBar* _tmp0_;
	ConfigurationDesktopEnvironment _tmp1_;
	ConfigurationDesktopEnvironment _tmp2_;
	GtkHeaderBar* _tmp5_;
	GtkHeaderBar* _tmp6_;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp7_;
	GMenuModel* main_menu = NULL;
	GObject* _tmp8_;
	GMenuModel* _tmp9_;
	GMenuModel* mark_menu = NULL;
	GObject* _tmp10_;
	GMenuModel* _tmp11_;
	GtkMenuButton* _tmp12_;
	GtkPopover* _tmp13_;
	GtkPopover* _tmp14_;
	GtkToggleButton* _tmp15_;
	GtkMenuButton* _tmp16_;
	GtkPopover* _tmp17_;
	GtkPopover* _tmp18_;
	GtkMenuButton* _tmp19_;
	FolderPopover* _tmp20_;
	GtkMenuButton* _tmp21_;
	FolderPopover* _tmp22_;
	GtkToggleButton* _tmp23_;
	GtkSettings* _tmp24_;
#line 69 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_CONFIGURATION (config), NULL);
#line 69 "../src/client/components/main-toolbar.vala"
	self = (MainToolbar*) g_object_new (object_type, NULL);
#line 75 "../src/client/components/main-toolbar.vala"
	configuration_bind (config, CONFIGURATION_MESSAGES_PANE_POSITION_KEY, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "left-pane-width", G_SETTINGS_BIND_GET);
#line 77 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->folder_header;
#line 77 "../src/client/components/main-toolbar.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "left-pane-width", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, G_TYPE_OBJECT, GObject), "width-request", G_BINDING_SYNC_CREATE, (GClosure*) ((___lambda109__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda109__gbinding_transform_func, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 83 "../src/client/components/main-toolbar.vala"
	_tmp1_ = configuration_get_desktop_environment (config);
#line 83 "../src/client/components/main-toolbar.vala"
	_tmp2_ = _tmp1_;
#line 83 "../src/client/components/main-toolbar.vala"
	if (_tmp2_ != CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY) {
#line 395 "main-toolbar.c"
		GtkHeaderBar* _tmp3_;
		GtkHeaderBar* _tmp4_;
#line 84 "../src/client/components/main-toolbar.vala"
		_tmp3_ = self->priv->folder_header;
#line 84 "../src/client/components/main-toolbar.vala"
		g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "account", G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, G_TYPE_OBJECT, GObject), "title", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 85 "../src/client/components/main-toolbar.vala"
		_tmp4_ = self->priv->folder_header;
#line 85 "../src/client/components/main-toolbar.vala"
		g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "folder", G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, G_TYPE_OBJECT, GObject), "subtitle", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 406 "main-toolbar.c"
	}
#line 87 "../src/client/components/main-toolbar.vala"
	_tmp5_ = self->priv->folder_header;
#line 87 "../src/client/components/main-toolbar.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "show-close-button-left", G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, G_TYPE_OBJECT, GObject), "show-close-button", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 89 "../src/client/components/main-toolbar.vala"
	_tmp6_ = self->priv->conversation_header;
#line 89 "../src/client/components/main-toolbar.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "show-close-button-right", G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, G_TYPE_OBJECT, GObject), "show-close-button", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 93 "../src/client/components/main-toolbar.vala"
	_tmp7_ = gtk_builder_new_from_resource ("/org/gnome/Geary/main-toolbar-menus.ui");
#line 93 "../src/client/components/main-toolbar.vala"
	builder = _tmp7_;
#line 94 "../src/client/components/main-toolbar.vala"
	_tmp8_ = gtk_builder_get_object (builder, "main_menu");
#line 94 "../src/client/components/main-toolbar.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_menu_model_get_type (), GMenuModel));
#line 94 "../src/client/components/main-toolbar.vala"
	main_menu = _tmp9_;
#line 95 "../src/client/components/main-toolbar.vala"
	_tmp10_ = gtk_builder_get_object (builder, "mark_message_menu");
#line 95 "../src/client/components/main-toolbar.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, g_menu_model_get_type (), GMenuModel));
#line 95 "../src/client/components/main-toolbar.vala"
	mark_menu = _tmp11_;
#line 98 "../src/client/components/main-toolbar.vala"
	_tmp12_ = self->priv->main_menu_button;
#line 98 "../src/client/components/main-toolbar.vala"
	_tmp13_ = (GtkPopover*) gtk_popover_new_from_model (NULL, main_menu);
#line 98 "../src/client/components/main-toolbar.vala"
	g_object_ref_sink (_tmp13_);
#line 98 "../src/client/components/main-toolbar.vala"
	_tmp14_ = _tmp13_;
#line 98 "../src/client/components/main-toolbar.vala"
	gtk_menu_button_set_popover (_tmp12_, _tmp14_);
#line 98 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (_tmp14_);
#line 99 "../src/client/components/main-toolbar.vala"
	_tmp15_ = self->priv->search_conversations_button;
#line 99 "../src/client/components/main-toolbar.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "search-open", G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, G_TYPE_OBJECT, GObject), "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 103 "../src/client/components/main-toolbar.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::selected-conversations", (GCallback) ___lambda110__g_object_notify, self, 0);
#line 104 "../src/client/components/main-toolbar.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::show-trash-button", (GCallback) ___lambda111__g_object_notify, self, 0);
#line 105 "../src/client/components/main-toolbar.vala"
	_tmp16_ = self->priv->mark_message_button;
#line 105 "../src/client/components/main-toolbar.vala"
	_tmp17_ = (GtkPopover*) gtk_popover_new_from_model (NULL, mark_menu);
#line 105 "../src/client/components/main-toolbar.vala"
	g_object_ref_sink (_tmp17_);
#line 105 "../src/client/components/main-toolbar.vala"
	_tmp18_ = _tmp17_;
#line 105 "../src/client/components/main-toolbar.vala"
	gtk_menu_button_set_popover (_tmp16_, _tmp18_);
#line 105 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (_tmp18_);
#line 106 "../src/client/components/main-toolbar.vala"
	_tmp19_ = self->copy_message_button;
#line 106 "../src/client/components/main-toolbar.vala"
	_tmp20_ = self->priv->_copy_folder_menu;
#line 106 "../src/client/components/main-toolbar.vala"
	gtk_menu_button_set_popover (_tmp19_, G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_popover_get_type (), GtkPopover));
#line 107 "../src/client/components/main-toolbar.vala"
	_tmp21_ = self->move_message_button;
#line 107 "../src/client/components/main-toolbar.vala"
	_tmp22_ = self->priv->_move_folder_menu;
#line 107 "../src/client/components/main-toolbar.vala"
	gtk_menu_button_set_popover (_tmp21_, G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_popover_get_type (), GtkPopover));
#line 109 "../src/client/components/main-toolbar.vala"
	_tmp23_ = self->priv->find_button;
#line 109 "../src/client/components/main-toolbar.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "find-open", G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, G_TYPE_OBJECT, GObject), "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 112 "../src/client/components/main-toolbar.vala"
	_tmp24_ = gtk_settings_get_default ();
#line 112 "../src/client/components/main-toolbar.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, G_TYPE_OBJECT, GObject), "notify::gtk-decoration-layout", (GCallback) _main_toolbar_set_window_buttons_g_object_notify, self, 0);
#line 113 "../src/client/components/main-toolbar.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "realize", (GCallback) _main_toolbar_set_window_buttons_gtk_widget_realize, self, 0);
#line 69 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (mark_menu);
#line 69 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (main_menu);
#line 69 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (builder);
#line 69 "../src/client/components/main-toolbar.vala"
	return self;
#line 494 "main-toolbar.c"
}

MainToolbar*
main_toolbar_new (Configuration* config)
{
#line 69 "../src/client/components/main-toolbar.vala"
	return main_toolbar_construct (TYPE_MAIN_TOOLBAR, config);
#line 502 "main-toolbar.c"
}

void
main_toolbar_set_conversation_header (MainToolbar* self,
                                      GtkHeaderBar* header)
{
	GtkHeaderBar* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GBinding* _tmp3_;
	GBinding* _tmp4_;
	GtkHeaderBar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 116 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 116 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (GTK_IS_HEADER_BAR (header));
#line 117 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->conversation_header;
#line 117 "../src/client/components/main-toolbar.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 118 "../src/client/components/main-toolbar.vala"
	_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (header, gtk_widget_get_type (), GtkWidget));
#line 118 "../src/client/components/main-toolbar.vala"
	gtk_style_context_add_class (_tmp1_, "geary-titlebar");
#line 119 "../src/client/components/main-toolbar.vala"
	_tmp2_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (header, gtk_widget_get_type (), GtkWidget));
#line 119 "../src/client/components/main-toolbar.vala"
	gtk_style_context_add_class (_tmp2_, "geary-titlebar-right");
#line 120 "../src/client/components/main-toolbar.vala"
	_tmp3_ = g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "show-close-button-right", G_TYPE_CHECK_INSTANCE_CAST (header, G_TYPE_OBJECT, GObject), "show-close-button", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 120 "../src/client/components/main-toolbar.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 120 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->guest_header_binding);
#line 120 "../src/client/components/main-toolbar.vala"
	self->priv->guest_header_binding = _tmp4_;
#line 122 "../src/client/components/main-toolbar.vala"
	gtk_box_pack_start (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), G_TYPE_CHECK_INSTANCE_CAST (header, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
#line 123 "../src/client/components/main-toolbar.vala"
	_tmp5_ = self->priv->conversation_header;
#line 123 "../src/client/components/main-toolbar.vala"
	_tmp6_ = gtk_header_bar_get_decoration_layout (_tmp5_);
#line 123 "../src/client/components/main-toolbar.vala"
	_tmp7_ = _tmp6_;
#line 123 "../src/client/components/main-toolbar.vala"
	gtk_header_bar_set_decoration_layout (header, _tmp7_);
#line 551 "main-toolbar.c"
}

void
main_toolbar_remove_conversation_header (MainToolbar* self,
                                         GtkHeaderBar* header)
{
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GBinding* _tmp2_;
	GBinding* _tmp3_;
	GtkSettings* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkHeaderBar* _tmp8_;
#line 126 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 126 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (GTK_IS_HEADER_BAR (header));
#line 127 "../src/client/components/main-toolbar.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (header, gtk_widget_get_type (), GtkWidget));
#line 128 "../src/client/components/main-toolbar.vala"
	_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (header, gtk_widget_get_type (), GtkWidget));
#line 128 "../src/client/components/main-toolbar.vala"
	gtk_style_context_remove_class (_tmp0_, "geary-titlebar");
#line 129 "../src/client/components/main-toolbar.vala"
	_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (header, gtk_widget_get_type (), GtkWidget));
#line 129 "../src/client/components/main-toolbar.vala"
	gtk_style_context_remove_class (_tmp1_, "geary-titlebar-right");
#line 130 "../src/client/components/main-toolbar.vala"
	_tmp2_ = self->priv->guest_header_binding;
#line 130 "../src/client/components/main-toolbar.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 130 "../src/client/components/main-toolbar.vala"
	g_binding_unbind (_tmp3_);
#line 131 "../src/client/components/main-toolbar.vala"
	gtk_header_bar_set_show_close_button (header, FALSE);
#line 132 "../src/client/components/main-toolbar.vala"
	_tmp4_ = gtk_settings_get_default ();
#line 132 "../src/client/components/main-toolbar.vala"
	g_object_get (_tmp4_, "gtk-decoration-layout", &_tmp5_, NULL);
#line 132 "../src/client/components/main-toolbar.vala"
	_tmp6_ = _tmp5_;
#line 132 "../src/client/components/main-toolbar.vala"
	_tmp7_ = _tmp6_;
#line 132 "../src/client/components/main-toolbar.vala"
	gtk_header_bar_set_decoration_layout (header, _tmp7_);
#line 132 "../src/client/components/main-toolbar.vala"
	_g_free0 (_tmp7_);
#line 133 "../src/client/components/main-toolbar.vala"
	_tmp8_ = self->priv->conversation_header;
#line 133 "../src/client/components/main-toolbar.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 605 "main-toolbar.c"
}

static void
main_toolbar_set_window_buttons (MainToolbar* self)
{
	gchar** buttons = NULL;
	GtkSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint buttons_length1;
	gint _buttons_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GtkHeaderBar* _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkHeaderBar* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
#line 136 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 137 "../src/client/components/main-toolbar.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 137 "../src/client/components/main-toolbar.vala"
	g_object_get (_tmp0_, "gtk-decoration-layout", &_tmp1_, NULL);
#line 137 "../src/client/components/main-toolbar.vala"
	_tmp2_ = _tmp1_;
#line 137 "../src/client/components/main-toolbar.vala"
	_tmp3_ = _tmp2_;
#line 137 "../src/client/components/main-toolbar.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, ":", 0);
#line 137 "../src/client/components/main-toolbar.vala"
	_tmp6_ = _tmp5_;
#line 137 "../src/client/components/main-toolbar.vala"
	_tmp6__length1 = _vala_array_length (_tmp4_);
#line 137 "../src/client/components/main-toolbar.vala"
	_g_free0 (_tmp3_);
#line 137 "../src/client/components/main-toolbar.vala"
	buttons = _tmp6_;
#line 137 "../src/client/components/main-toolbar.vala"
	buttons_length1 = _tmp6__length1;
#line 137 "../src/client/components/main-toolbar.vala"
	_buttons_size_ = buttons_length1;
#line 138 "../src/client/components/main-toolbar.vala"
	_tmp7_ = buttons;
#line 138 "../src/client/components/main-toolbar.vala"
	_tmp7__length1 = buttons_length1;
#line 138 "../src/client/components/main-toolbar.vala"
	if (_tmp7__length1 != 2) {
#line 139 "../src/client/components/main-toolbar.vala"
		g_warning ("main-toolbar.vala:139: gtk_decoration_layout in unexpected format");
#line 140 "../src/client/components/main-toolbar.vala"
		buttons = (_vala_array_free (buttons, buttons_length1, (GDestroyNotify) g_free), NULL);
#line 140 "../src/client/components/main-toolbar.vala"
		return;
#line 674 "main-toolbar.c"
	}
#line 142 "../src/client/components/main-toolbar.vala"
	_tmp8_ = self->priv->_show_close_button;
#line 142 "../src/client/components/main-toolbar.vala"
	main_toolbar_set_show_close_button_left (self, _tmp8_);
#line 143 "../src/client/components/main-toolbar.vala"
	_tmp9_ = self->priv->_show_close_button;
#line 143 "../src/client/components/main-toolbar.vala"
	main_toolbar_set_show_close_button_right (self, _tmp9_);
#line 144 "../src/client/components/main-toolbar.vala"
	_tmp10_ = self->priv->folder_header;
#line 144 "../src/client/components/main-toolbar.vala"
	_tmp11_ = buttons;
#line 144 "../src/client/components/main-toolbar.vala"
	_tmp11__length1 = buttons_length1;
#line 144 "../src/client/components/main-toolbar.vala"
	_tmp12_ = _tmp11_[0];
#line 144 "../src/client/components/main-toolbar.vala"
	_tmp13_ = g_strconcat (_tmp12_, ":", NULL);
#line 144 "../src/client/components/main-toolbar.vala"
	_tmp14_ = _tmp13_;
#line 144 "../src/client/components/main-toolbar.vala"
	gtk_header_bar_set_decoration_layout (_tmp10_, _tmp14_);
#line 144 "../src/client/components/main-toolbar.vala"
	_g_free0 (_tmp14_);
#line 145 "../src/client/components/main-toolbar.vala"
	_tmp15_ = self->priv->conversation_header;
#line 145 "../src/client/components/main-toolbar.vala"
	_tmp16_ = buttons;
#line 145 "../src/client/components/main-toolbar.vala"
	_tmp16__length1 = buttons_length1;
#line 145 "../src/client/components/main-toolbar.vala"
	_tmp17_ = _tmp16_[1];
#line 145 "../src/client/components/main-toolbar.vala"
	_tmp18_ = g_strconcat (":", _tmp17_, NULL);
#line 145 "../src/client/components/main-toolbar.vala"
	_tmp19_ = _tmp18_;
#line 145 "../src/client/components/main-toolbar.vala"
	gtk_header_bar_set_decoration_layout (_tmp15_, _tmp19_);
#line 145 "../src/client/components/main-toolbar.vala"
	_g_free0 (_tmp19_);
#line 136 "../src/client/components/main-toolbar.vala"
	buttons = (_vala_array_free (buttons, buttons_length1, (GDestroyNotify) g_free), NULL);
#line 718 "main-toolbar.c"
}

static void
main_toolbar_update_conversation_buttons (MainToolbar* self)
{
	GtkMenuButton* _tmp0_;
	gint _tmp1_;
	GtkMenuButton* _tmp2_;
	gint _tmp3_;
	GtkMenuButton* _tmp4_;
	gint _tmp5_;
	GtkButton* _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_;
#line 149 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 150 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->mark_message_button;
#line 150 "../src/client/components/main-toolbar.vala"
	_tmp1_ = self->priv->_selected_conversations;
#line 150 "../src/client/components/main-toolbar.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), ngettext ("Mark conversation", "Mark conversations", (gulong) _tmp1_));
#line 155 "../src/client/components/main-toolbar.vala"
	_tmp2_ = self->copy_message_button;
#line 155 "../src/client/components/main-toolbar.vala"
	_tmp3_ = self->priv->_selected_conversations;
#line 155 "../src/client/components/main-toolbar.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), ngettext ("Add label to conversation", "Add label to conversations", (gulong) _tmp3_));
#line 160 "../src/client/components/main-toolbar.vala"
	_tmp4_ = self->move_message_button;
#line 160 "../src/client/components/main-toolbar.vala"
	_tmp5_ = self->priv->_selected_conversations;
#line 160 "../src/client/components/main-toolbar.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), ngettext ("Move conversation", "Move conversations", (gulong) _tmp5_));
#line 165 "../src/client/components/main-toolbar.vala"
	_tmp6_ = self->priv->archive_button;
#line 165 "../src/client/components/main-toolbar.vala"
	_tmp7_ = self->priv->_selected_conversations;
#line 165 "../src/client/components/main-toolbar.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), ngettext ("Archive conversation (A)", "Archive conversations (A)", (gulong) _tmp7_));
#line 171 "../src/client/components/main-toolbar.vala"
	_tmp8_ = self->priv->_show_trash_button;
#line 171 "../src/client/components/main-toolbar.vala"
	if (_tmp8_) {
#line 763 "main-toolbar.c"
		GtkButton* _tmp9_;
		GtkButton* _tmp10_;
		GtkImage* _tmp11_;
		GtkButton* _tmp12_;
		gint _tmp13_;
#line 172 "../src/client/components/main-toolbar.vala"
		_tmp9_ = self->priv->trash_delete_button;
#line 172 "../src/client/components/main-toolbar.vala"
		gtk_actionable_set_action_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_actionable_get_type (), GtkActionable), "win." GEARY_CONTROLLER_ACTION_TRASH_CONVERSATION);
#line 173 "../src/client/components/main-toolbar.vala"
		_tmp10_ = self->priv->trash_delete_button;
#line 173 "../src/client/components/main-toolbar.vala"
		_tmp11_ = self->priv->trash_image;
#line 173 "../src/client/components/main-toolbar.vala"
		gtk_button_set_image (_tmp10_, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
#line 174 "../src/client/components/main-toolbar.vala"
		_tmp12_ = self->priv->trash_delete_button;
#line 174 "../src/client/components/main-toolbar.vala"
		_tmp13_ = self->priv->_selected_conversations;
#line 174 "../src/client/components/main-toolbar.vala"
		gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget), ngettext ("Move conversation to Trash (Delete, Backspace)", "Move conversations to Trash (Delete, Backspace)", (gulong) _tmp13_));
#line 785 "main-toolbar.c"
	} else {
		GtkButton* _tmp14_;
		GtkButton* _tmp15_;
		GtkImage* _tmp16_;
		GtkButton* _tmp17_;
		gint _tmp18_;
#line 180 "../src/client/components/main-toolbar.vala"
		_tmp14_ = self->priv->trash_delete_button;
#line 180 "../src/client/components/main-toolbar.vala"
		gtk_actionable_set_action_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_actionable_get_type (), GtkActionable), "win." GEARY_CONTROLLER_ACTION_DELETE_CONVERSATION);
#line 181 "../src/client/components/main-toolbar.vala"
		_tmp15_ = self->priv->trash_delete_button;
#line 181 "../src/client/components/main-toolbar.vala"
		_tmp16_ = self->priv->delete_image;
#line 181 "../src/client/components/main-toolbar.vala"
		gtk_button_set_image (_tmp15_, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget));
#line 182 "../src/client/components/main-toolbar.vala"
		_tmp17_ = self->priv->trash_delete_button;
#line 182 "../src/client/components/main-toolbar.vala"
		_tmp18_ = self->priv->_selected_conversations;
#line 182 "../src/client/components/main-toolbar.vala"
		gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget), ngettext ("Delete conversation (Shift+Delete)", "Delete conversations (Shift+Delete)", (gulong) _tmp18_));
#line 808 "main-toolbar.c"
	}
}

gint
main_toolbar_get_left_pane_width (MainToolbar* self)
{
	gint result;
#line 11 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), 0);
#line 11 "../src/client/components/main-toolbar.vala"
	result = self->priv->_left_pane_width;
#line 11 "../src/client/components/main-toolbar.vala"
	return result;
#line 822 "main-toolbar.c"
}

void
main_toolbar_set_left_pane_width (MainToolbar* self,
                                  gint value)
{
#line 11 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 11 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_left_pane_width (self) != value) {
#line 11 "../src/client/components/main-toolbar.vala"
		self->priv->_left_pane_width = value;
#line 11 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY]);
#line 837 "main-toolbar.c"
	}
}

const gchar*
main_toolbar_get_account (MainToolbar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 13 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), NULL);
#line 13 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->_account;
#line 13 "../src/client/components/main-toolbar.vala"
	result = _tmp0_;
#line 13 "../src/client/components/main-toolbar.vala"
	return result;
#line 854 "main-toolbar.c"
}

void
main_toolbar_set_account (MainToolbar* self,
                          const gchar* value)
{
#line 13 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 13 "../src/client/components/main-toolbar.vala"
	if (g_strcmp0 (value, main_toolbar_get_account (self)) != 0) {
#line 865 "main-toolbar.c"
		gchar* _tmp0_;
#line 13 "../src/client/components/main-toolbar.vala"
		_tmp0_ = g_strdup (value);
#line 13 "../src/client/components/main-toolbar.vala"
		_g_free0 (self->priv->_account);
#line 13 "../src/client/components/main-toolbar.vala"
		self->priv->_account = _tmp0_;
#line 13 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_ACCOUNT_PROPERTY]);
#line 875 "main-toolbar.c"
	}
}

const gchar*
main_toolbar_get_folder (MainToolbar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 14 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), NULL);
#line 14 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->_folder;
#line 14 "../src/client/components/main-toolbar.vala"
	result = _tmp0_;
#line 14 "../src/client/components/main-toolbar.vala"
	return result;
#line 892 "main-toolbar.c"
}

void
main_toolbar_set_folder (MainToolbar* self,
                         const gchar* value)
{
#line 14 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 14 "../src/client/components/main-toolbar.vala"
	if (g_strcmp0 (value, main_toolbar_get_folder (self)) != 0) {
#line 903 "main-toolbar.c"
		gchar* _tmp0_;
#line 14 "../src/client/components/main-toolbar.vala"
		_tmp0_ = g_strdup (value);
#line 14 "../src/client/components/main-toolbar.vala"
		_g_free0 (self->priv->_folder);
#line 14 "../src/client/components/main-toolbar.vala"
		self->priv->_folder = _tmp0_;
#line 14 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_FOLDER_PROPERTY]);
#line 913 "main-toolbar.c"
	}
}

gboolean
main_toolbar_get_show_close_button (MainToolbar* self)
{
	gboolean result;
#line 16 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), FALSE);
#line 16 "../src/client/components/main-toolbar.vala"
	result = self->priv->_show_close_button;
#line 16 "../src/client/components/main-toolbar.vala"
	return result;
#line 927 "main-toolbar.c"
}

void
main_toolbar_set_show_close_button (MainToolbar* self,
                                    gboolean value)
{
#line 16 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 16 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_show_close_button (self) != value) {
#line 16 "../src/client/components/main-toolbar.vala"
		self->priv->_show_close_button = value;
#line 16 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY]);
#line 942 "main-toolbar.c"
	}
}

gboolean
main_toolbar_get_show_close_button_left (MainToolbar* self)
{
	gboolean result;
#line 17 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), FALSE);
#line 17 "../src/client/components/main-toolbar.vala"
	result = self->priv->_show_close_button_left;
#line 17 "../src/client/components/main-toolbar.vala"
	return result;
#line 956 "main-toolbar.c"
}

static void
main_toolbar_set_show_close_button_left (MainToolbar* self,
                                         gboolean value)
{
#line 17 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 17 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_show_close_button_left (self) != value) {
#line 17 "../src/client/components/main-toolbar.vala"
		self->priv->_show_close_button_left = value;
#line 17 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_LEFT_PROPERTY]);
#line 971 "main-toolbar.c"
	}
}

gboolean
main_toolbar_get_show_close_button_right (MainToolbar* self)
{
	gboolean result;
#line 18 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), FALSE);
#line 18 "../src/client/components/main-toolbar.vala"
	result = self->priv->_show_close_button_right;
#line 18 "../src/client/components/main-toolbar.vala"
	return result;
#line 985 "main-toolbar.c"
}

static void
main_toolbar_set_show_close_button_right (MainToolbar* self,
                                          gboolean value)
{
#line 18 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 18 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_show_close_button_right (self) != value) {
#line 18 "../src/client/components/main-toolbar.vala"
		self->priv->_show_close_button_right = value;
#line 18 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_RIGHT_PROPERTY]);
#line 1000 "main-toolbar.c"
	}
}

gboolean
main_toolbar_get_search_open (MainToolbar* self)
{
	gboolean result;
#line 20 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), FALSE);
#line 20 "../src/client/components/main-toolbar.vala"
	result = self->priv->_search_open;
#line 20 "../src/client/components/main-toolbar.vala"
	return result;
#line 1014 "main-toolbar.c"
}

void
main_toolbar_set_search_open (MainToolbar* self,
                              gboolean value)
{
#line 20 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 20 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_search_open (self) != value) {
#line 20 "../src/client/components/main-toolbar.vala"
		self->priv->_search_open = value;
#line 20 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY]);
#line 1029 "main-toolbar.c"
	}
}

gboolean
main_toolbar_get_find_open (MainToolbar* self)
{
	gboolean result;
#line 21 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), FALSE);
#line 21 "../src/client/components/main-toolbar.vala"
	result = self->priv->_find_open;
#line 21 "../src/client/components/main-toolbar.vala"
	return result;
#line 1043 "main-toolbar.c"
}

void
main_toolbar_set_find_open (MainToolbar* self,
                            gboolean value)
{
#line 21 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 21 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_find_open (self) != value) {
#line 21 "../src/client/components/main-toolbar.vala"
		self->priv->_find_open = value;
#line 21 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_FIND_OPEN_PROPERTY]);
#line 1058 "main-toolbar.c"
	}
}

FolderPopover*
main_toolbar_get_copy_folder_menu (MainToolbar* self)
{
	FolderPopover* result;
	FolderPopover* _tmp0_;
#line 23 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), NULL);
#line 23 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->_copy_folder_menu;
#line 23 "../src/client/components/main-toolbar.vala"
	result = _tmp0_;
#line 23 "../src/client/components/main-toolbar.vala"
	return result;
#line 1075 "main-toolbar.c"
}

static void
main_toolbar_set_copy_folder_menu (MainToolbar* self,
                                   FolderPopover* value)
{
#line 23 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 23 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_copy_folder_menu (self) != value) {
#line 1086 "main-toolbar.c"
		FolderPopover* _tmp0_;
#line 23 "../src/client/components/main-toolbar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/client/components/main-toolbar.vala"
		_g_object_unref0 (self->priv->_copy_folder_menu);
#line 23 "../src/client/components/main-toolbar.vala"
		self->priv->_copy_folder_menu = _tmp0_;
#line 23 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY]);
#line 1096 "main-toolbar.c"
	}
}

FolderPopover*
main_toolbar_get_move_folder_menu (MainToolbar* self)
{
	FolderPopover* result;
	FolderPopover* _tmp0_;
#line 24 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), NULL);
#line 24 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->_move_folder_menu;
#line 24 "../src/client/components/main-toolbar.vala"
	result = _tmp0_;
#line 24 "../src/client/components/main-toolbar.vala"
	return result;
#line 1113 "main-toolbar.c"
}

static void
main_toolbar_set_move_folder_menu (MainToolbar* self,
                                   FolderPopover* value)
{
#line 24 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 24 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_move_folder_menu (self) != value) {
#line 1124 "main-toolbar.c"
		FolderPopover* _tmp0_;
#line 24 "../src/client/components/main-toolbar.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/client/components/main-toolbar.vala"
		_g_object_unref0 (self->priv->_move_folder_menu);
#line 24 "../src/client/components/main-toolbar.vala"
		self->priv->_move_folder_menu = _tmp0_;
#line 24 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY]);
#line 1134 "main-toolbar.c"
	}
}

gint
main_toolbar_get_selected_conversations (MainToolbar* self)
{
	gint result;
#line 26 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), 0);
#line 26 "../src/client/components/main-toolbar.vala"
	result = self->priv->_selected_conversations;
#line 26 "../src/client/components/main-toolbar.vala"
	return result;
#line 1148 "main-toolbar.c"
}

void
main_toolbar_set_selected_conversations (MainToolbar* self,
                                         gint value)
{
#line 26 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 26 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_selected_conversations (self) != value) {
#line 26 "../src/client/components/main-toolbar.vala"
		self->priv->_selected_conversations = value;
#line 26 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY]);
#line 1163 "main-toolbar.c"
	}
}

gboolean
main_toolbar_get_show_trash_button (MainToolbar* self)
{
	gboolean result;
#line 28 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), FALSE);
#line 28 "../src/client/components/main-toolbar.vala"
	result = self->priv->_show_trash_button;
#line 28 "../src/client/components/main-toolbar.vala"
	return result;
#line 1177 "main-toolbar.c"
}

void
main_toolbar_set_show_trash_button (MainToolbar* self,
                                    gboolean value)
{
#line 28 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 28 "../src/client/components/main-toolbar.vala"
	if (main_toolbar_get_show_trash_button (self) != value) {
#line 28 "../src/client/components/main-toolbar.vala"
		self->priv->_show_trash_button = value;
#line 28 "../src/client/components/main-toolbar.vala"
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_SHOW_TRASH_BUTTON_PROPERTY]);
#line 1192 "main-toolbar.c"
	}
}

gchar*
main_toolbar_get_undo_tooltip (MainToolbar* self)
{
	gchar* result;
	GtkButton* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 31 "../src/client/components/main-toolbar.vala"
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), NULL);
#line 31 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->undo_button;
#line 31 "../src/client/components/main-toolbar.vala"
	_tmp1_ = gtk_widget_get_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 31 "../src/client/components/main-toolbar.vala"
	_tmp2_ = _tmp1_;
#line 31 "../src/client/components/main-toolbar.vala"
	result = _tmp2_;
#line 31 "../src/client/components/main-toolbar.vala"
	return result;
#line 1215 "main-toolbar.c"
}

void
main_toolbar_set_undo_tooltip (MainToolbar* self,
                               const gchar* value)
{
	GtkButton* _tmp0_;
#line 32 "../src/client/components/main-toolbar.vala"
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
#line 32 "../src/client/components/main-toolbar.vala"
	_tmp0_ = self->priv->undo_button;
#line 32 "../src/client/components/main-toolbar.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), value);
#line 32 "../src/client/components/main-toolbar.vala"
	g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_UNDO_TOOLTIP_PROPERTY]);
#line 1231 "main-toolbar.c"
}

static void
main_toolbar_class_init (MainToolbarClass * klass,
                         gpointer klass_data)
{
#line 9 "../src/client/components/main-toolbar.vala"
	main_toolbar_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/client/components/main-toolbar.vala"
	g_type_class_adjust_private_offset (klass, &MainToolbar_private_offset);
#line 9 "../src/client/components/main-toolbar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_main_toolbar_get_property;
#line 9 "../src/client/components/main-toolbar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_main_toolbar_set_property;
#line 9 "../src/client/components/main-toolbar.vala"
	G_OBJECT_CLASS (klass)->finalize = main_toolbar_finalize;
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY] = g_param_spec_int ("left-pane-width", "left-pane-width", "left-pane-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_ACCOUNT_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_ACCOUNT_PROPERTY] = g_param_spec_string ("account", "account", "account", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_FOLDER_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_FOLDER_PROPERTY] = g_param_spec_string ("folder", "folder", "folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY] = g_param_spec_boolean ("show-close-button", "show-close-button", "show-close-button", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_LEFT_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_LEFT_PROPERTY] = g_param_spec_boolean ("show-close-button-left", "show-close-button-left", "show-close-button-left", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_RIGHT_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_RIGHT_PROPERTY] = g_param_spec_boolean ("show-close-button-right", "show-close-button-right", "show-close-button-right", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY] = g_param_spec_boolean ("search-open", "search-open", "search-open", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_FIND_OPEN_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_FIND_OPEN_PROPERTY] = g_param_spec_boolean ("find-open", "find-open", "find-open", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY] = g_param_spec_object ("copy-folder-menu", "copy-folder-menu", "copy-folder-menu", TYPE_FOLDER_POPOVER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY] = g_param_spec_object ("move-folder-menu", "move-folder-menu", "move-folder-menu", TYPE_FOLDER_POPOVER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY] = g_param_spec_int ("selected-conversations", "selected-conversations", "selected-conversations", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_SHOW_TRASH_BUTTON_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_SHOW_TRASH_BUTTON_PROPERTY] = g_param_spec_boolean ("show-trash-button", "show-trash-button", "show-trash-button", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_UNDO_TOOLTIP_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_UNDO_TOOLTIP_PROPERTY] = g_param_spec_string ("undo-tooltip", "undo-tooltip", "undo-tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/main-toolbar.ui");
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "folder_header", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, folder_header));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_conversations_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, search_conversations_button));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_menu_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, main_menu_button));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_header", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, conversation_header));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mark_message_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, mark_message_button));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "copy_message_button", FALSE, G_STRUCT_OFFSET (MainToolbar, copy_message_button));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "move_message_button", FALSE, G_STRUCT_OFFSET (MainToolbar, move_message_button));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "archive_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, archive_button));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "trash_delete_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, trash_delete_button));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "find_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, find_button));
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "undo_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, undo_button));
#line 1298 "main-toolbar.c"
}

static void
main_toolbar_instance_init (MainToolbar * self,
                            gpointer klass)
{
	FolderPopover* _tmp0_;
	FolderPopover* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
#line 9 "../src/client/components/main-toolbar.vala"
	self->priv = main_toolbar_get_instance_private (self);
#line 16 "../src/client/components/main-toolbar.vala"
	self->priv->_show_close_button = FALSE;
#line 17 "../src/client/components/main-toolbar.vala"
	self->priv->_show_close_button_left = TRUE;
#line 18 "../src/client/components/main-toolbar.vala"
	self->priv->_show_close_button_right = TRUE;
#line 20 "../src/client/components/main-toolbar.vala"
	self->priv->_search_open = FALSE;
#line 21 "../src/client/components/main-toolbar.vala"
	self->priv->_find_open = FALSE;
#line 23 "../src/client/components/main-toolbar.vala"
	_tmp0_ = folder_popover_new ();
#line 23 "../src/client/components/main-toolbar.vala"
	g_object_ref_sink (_tmp0_);
#line 23 "../src/client/components/main-toolbar.vala"
	self->priv->_copy_folder_menu = _tmp0_;
#line 24 "../src/client/components/main-toolbar.vala"
	_tmp1_ = folder_popover_new ();
#line 24 "../src/client/components/main-toolbar.vala"
	g_object_ref_sink (_tmp1_);
#line 24 "../src/client/components/main-toolbar.vala"
	self->priv->_move_folder_menu = _tmp1_;
#line 28 "../src/client/components/main-toolbar.vala"
	self->priv->_show_trash_button = TRUE;
#line 65 "../src/client/components/main-toolbar.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("user-trash-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 65 "../src/client/components/main-toolbar.vala"
	g_object_ref_sink (_tmp2_);
#line 65 "../src/client/components/main-toolbar.vala"
	self->priv->trash_image = _tmp2_;
#line 66 "../src/client/components/main-toolbar.vala"
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-delete-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 66 "../src/client/components/main-toolbar.vala"
	g_object_ref_sink (_tmp3_);
#line 66 "../src/client/components/main-toolbar.vala"
	self->priv->delete_image = _tmp3_;
#line 9 "../src/client/components/main-toolbar.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1349 "main-toolbar.c"
}

static void
main_toolbar_finalize (GObject * obj)
{
	MainToolbar * self;
#line 9 "../src/client/components/main-toolbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_TOOLBAR, MainToolbar);
#line 13 "../src/client/components/main-toolbar.vala"
	_g_free0 (self->priv->_account);
#line 14 "../src/client/components/main-toolbar.vala"
	_g_free0 (self->priv->_folder);
#line 23 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->_copy_folder_menu);
#line 24 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->_move_folder_menu);
#line 37 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->folder_header);
#line 39 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->search_conversations_button);
#line 41 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->main_menu_button);
#line 42 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->guest_header_binding);
#line 46 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->conversation_header);
#line 48 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->mark_message_button);
#line 50 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->copy_message_button);
#line 52 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->move_message_button);
#line 54 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->archive_button);
#line 56 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->trash_delete_button);
#line 58 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->find_button);
#line 62 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->undo_button);
#line 65 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->trash_image);
#line 66 "../src/client/components/main-toolbar.vala"
	_g_object_unref0 (self->priv->delete_image);
#line 9 "../src/client/components/main-toolbar.vala"
	G_OBJECT_CLASS (main_toolbar_parent_class)->finalize (obj);
#line 1396 "main-toolbar.c"
}

GType
main_toolbar_get_type (void)
{
	static volatile gsize main_toolbar_type_id__volatile = 0;
	if (g_once_init_enter (&main_toolbar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MainToolbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_toolbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainToolbar), 0, (GInstanceInitFunc) main_toolbar_instance_init, NULL };
		GType main_toolbar_type_id;
		main_toolbar_type_id = g_type_register_static (gtk_box_get_type (), "MainToolbar", &g_define_type_info, 0);
		MainToolbar_private_offset = g_type_add_instance_private (main_toolbar_type_id, sizeof (MainToolbarPrivate));
		g_once_init_leave (&main_toolbar_type_id__volatile, main_toolbar_type_id);
	}
	return main_toolbar_type_id__volatile;
}

static void
_vala_main_toolbar_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	MainToolbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MAIN_TOOLBAR, MainToolbar);
#line 9 "../src/client/components/main-toolbar.vala"
	switch (property_id) {
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_int (value, main_toolbar_get_left_pane_width (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_ACCOUNT_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_string (value, main_toolbar_get_account (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_FOLDER_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_string (value, main_toolbar_get_folder (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_boolean (value, main_toolbar_get_show_close_button (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_LEFT_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_boolean (value, main_toolbar_get_show_close_button_left (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_RIGHT_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_boolean (value, main_toolbar_get_show_close_button_right (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_boolean (value, main_toolbar_get_search_open (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_FIND_OPEN_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_boolean (value, main_toolbar_get_find_open (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_object (value, main_toolbar_get_copy_folder_menu (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_object (value, main_toolbar_get_move_folder_menu (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_int (value, main_toolbar_get_selected_conversations (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SHOW_TRASH_BUTTON_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_set_boolean (value, main_toolbar_get_show_trash_button (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_UNDO_TOOLTIP_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		g_value_take_string (value, main_toolbar_get_undo_tooltip (self));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 1501 "main-toolbar.c"
		default:
#line 9 "../src/client/components/main-toolbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 1507 "main-toolbar.c"
	}
}

static void
_vala_main_toolbar_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	MainToolbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MAIN_TOOLBAR, MainToolbar);
#line 9 "../src/client/components/main-toolbar.vala"
	switch (property_id) {
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_left_pane_width (self, g_value_get_int (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_ACCOUNT_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_account (self, g_value_get_string (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_FOLDER_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_folder (self, g_value_get_string (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_show_close_button (self, g_value_get_boolean (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_LEFT_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_show_close_button_left (self, g_value_get_boolean (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_RIGHT_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_show_close_button_right (self, g_value_get_boolean (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_search_open (self, g_value_get_boolean (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_FIND_OPEN_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_find_open (self, g_value_get_boolean (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_copy_folder_menu (self, g_value_get_object (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_move_folder_menu (self, g_value_get_object (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_selected_conversations (self, g_value_get_int (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_SHOW_TRASH_BUTTON_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_show_trash_button (self, g_value_get_boolean (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 9 "../src/client/components/main-toolbar.vala"
		case MAIN_TOOLBAR_UNDO_TOOLTIP_PROPERTY:
#line 9 "../src/client/components/main-toolbar.vala"
		main_toolbar_set_undo_tooltip (self, g_value_get_string (value));
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 1599 "main-toolbar.c"
		default:
#line 9 "../src/client/components/main-toolbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/client/components/main-toolbar.vala"
		break;
#line 1605 "main-toolbar.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

