/* email-entry.c generated by valac 0.44.1, the Vala compiler
 * generated from email-entry.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* A custom entry for e-mail addresses*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "geary-engine.h"
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_EMAIL_ENTRY (email_entry_get_type ())
#define EMAIL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EMAIL_ENTRY, EmailEntry))
#define EMAIL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EMAIL_ENTRY, EmailEntryClass))
#define IS_EMAIL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EMAIL_ENTRY))
#define IS_EMAIL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EMAIL_ENTRY))
#define EMAIL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EMAIL_ENTRY, EmailEntryClass))

typedef struct _EmailEntry EmailEntry;
typedef struct _EmailEntryClass EmailEntryClass;
typedef struct _EmailEntryPrivate EmailEntryPrivate;

#define TYPE_COMPOSER_WIDGET (composer_widget_get_type ())
#define COMPOSER_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPOSER_WIDGET, ComposerWidget))
#define COMPOSER_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPOSER_WIDGET, ComposerWidgetClass))
#define IS_COMPOSER_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPOSER_WIDGET))
#define IS_COMPOSER_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPOSER_WIDGET))
#define COMPOSER_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPOSER_WIDGET, ComposerWidgetClass))

typedef struct _ComposerWidget ComposerWidget;
typedef struct _ComposerWidgetClass ComposerWidgetClass;
enum  {
	EMAIL_ENTRY_0_PROPERTY,
	EMAIL_ENTRY_VALID_PROPERTY,
	EMAIL_ENTRY_EMPTY_PROPERTY,
	EMAIL_ENTRY_ADDRESSES_PROPERTY,
	EMAIL_ENTRY_NUM_PROPERTIES
};
static GParamSpec* email_entry_properties[EMAIL_ENTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_CONTACT_ENTRY_COMPLETION (contact_entry_completion_get_type ())
#define CONTACT_ENTRY_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletion))
#define CONTACT_ENTRY_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletionClass))
#define IS_CONTACT_ENTRY_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTACT_ENTRY_COMPLETION))
#define IS_CONTACT_ENTRY_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTACT_ENTRY_COMPLETION))
#define CONTACT_ENTRY_COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletionClass))

typedef struct _ContactEntryCompletion ContactEntryCompletion;
typedef struct _ContactEntryCompletionClass ContactEntryCompletionClass;

struct _EmailEntry {
	GtkEntry parent_instance;
	EmailEntryPrivate * priv;
	gboolean modified;
};

struct _EmailEntryClass {
	GtkEntryClass parent_class;
};

struct _EmailEntryPrivate {
	gboolean _valid;
	gboolean _empty;
	GearyRFC822MailboxAddresses* _addresses;
	ComposerWidget* composer;
	gboolean updating;
};

static gint EmailEntry_private_offset;
static gpointer email_entry_parent_class = NULL;

GType email_entry_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EmailEntry, g_object_unref)
GType composer_widget_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComposerWidget, g_object_unref)
EmailEntry* email_entry_new (ComposerWidget* composer);
EmailEntry* email_entry_construct (GType object_type,
                                   ComposerWidget* composer);
static void email_entry_on_changed (EmailEntry* self);
static void _email_entry_on_changed_gtk_editable_changed (GtkEditable* _sender,
                                                   gpointer self);
static gboolean email_entry_on_key_press (EmailEntry* self,
                                   GtkWidget* widget,
                                   GdkEventKey* event);
static gboolean _email_entry_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                               GdkEventKey* event,
                                                               gpointer self);
static void __lambda29_ (EmailEntry* self);
static void email_entry_validate_addresses (EmailEntry* self);
GearyRFC822MailboxAddresses* email_entry_get_addresses (EmailEntry* self);
static void ___lambda29__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
GType contact_entry_completion_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactEntryCompletion, g_object_unref)
void contact_entry_completion_reset_selection (ContactEntryCompletion* self);
void email_entry_set_addresses (EmailEntry* self,
                                GearyRFC822MailboxAddresses* value);
void email_entry_set_valid (EmailEntry* self,
                            gboolean value);
void email_entry_set_empty (EmailEntry* self,
                            gboolean value);
void contact_entry_completion_trigger_selection (ContactEntryCompletion* self);
gboolean email_entry_get_valid (EmailEntry* self);
gboolean email_entry_get_empty (EmailEntry* self);
static void email_entry_finalize (GObject * obj);
static void _vala_email_entry_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_email_entry_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
email_entry_get_instance_private (EmailEntry* self)
{
	return G_STRUCT_MEMBER_P (self, EmailEntry_private_offset);
}

static void
_email_entry_on_changed_gtk_editable_changed (GtkEditable* _sender,
                                              gpointer self)
{
#line 24 "../src/client/composer/email-entry.vala"
	email_entry_on_changed ((EmailEntry*) self);
#line 138 "email-entry.c"
}

static gboolean
_email_entry_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                      GdkEventKey* event,
                                                      gpointer self)
{
	gboolean result;
	result = email_entry_on_key_press ((EmailEntry*) self, _sender, event);
#line 25 "../src/client/composer/email-entry.vala"
	return result;
#line 150 "email-entry.c"
}

static void
__lambda29_ (EmailEntry* self)
{
	gchar* _tmp0_ = NULL;
	GearyRFC822MailboxAddresses* _tmp1_;
#line 29 "../src/client/composer/email-entry.vala"
	email_entry_validate_addresses (self);
#line 30 "../src/client/composer/email-entry.vala"
	if (self->priv->updating) {
#line 31 "../src/client/composer/email-entry.vala"
		return;
#line 164 "email-entry.c"
	}
#line 33 "../src/client/composer/email-entry.vala"
	self->priv->updating = TRUE;
#line 34 "../src/client/composer/email-entry.vala"
	self->modified = TRUE;
#line 35 "../src/client/composer/email-entry.vala"
	_tmp1_ = self->priv->_addresses;
#line 35 "../src/client/composer/email-entry.vala"
	if (_tmp1_ == NULL) {
#line 174 "email-entry.c"
		gchar* _tmp2_;
#line 35 "../src/client/composer/email-entry.vala"
		_tmp2_ = g_strdup ("");
#line 35 "../src/client/composer/email-entry.vala"
		_g_free0 (_tmp0_);
#line 35 "../src/client/composer/email-entry.vala"
		_tmp0_ = _tmp2_;
#line 182 "email-entry.c"
	} else {
		GearyRFC822MailboxAddresses* _tmp3_;
		gchar* _tmp4_;
#line 35 "../src/client/composer/email-entry.vala"
		_tmp3_ = self->priv->_addresses;
#line 35 "../src/client/composer/email-entry.vala"
		_tmp4_ = geary_rf_c822_mailbox_addresses_to_full_display (_tmp3_);
#line 35 "../src/client/composer/email-entry.vala"
		_g_free0 (_tmp0_);
#line 35 "../src/client/composer/email-entry.vala"
		_tmp0_ = _tmp4_;
#line 194 "email-entry.c"
	}
#line 35 "../src/client/composer/email-entry.vala"
	gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry), _tmp0_);
#line 36 "../src/client/composer/email-entry.vala"
	self->priv->updating = FALSE;
#line 28 "../src/client/composer/email-entry.vala"
	_g_free0 (_tmp0_);
#line 202 "email-entry.c"
}

static void
___lambda29__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 28 "../src/client/composer/email-entry.vala"
	__lambda29_ ((EmailEntry*) self);
#line 212 "email-entry.c"
}

EmailEntry*
email_entry_construct (GType object_type,
                       ComposerWidget* composer)
{
	EmailEntry * self = NULL;
#line 23 "../src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_COMPOSER_WIDGET (composer), NULL);
#line 23 "../src/client/composer/email-entry.vala"
	self = (EmailEntry*) g_object_new (object_type, NULL);
#line 24 "../src/client/composer/email-entry.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_editable_get_type (), GtkEditable), "changed", (GCallback) _email_entry_on_changed_gtk_editable_changed, self, 0);
#line 25 "../src/client/composer/email-entry.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "key-press-event", (GCallback) _email_entry_on_key_press_gtk_widget_key_press_event, self, 0);
#line 26 "../src/client/composer/email-entry.vala"
	self->priv->composer = composer;
#line 28 "../src/client/composer/email-entry.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::addresses", (GCallback) ___lambda29__g_object_notify, self, 0);
#line 39 "../src/client/composer/email-entry.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 23 "../src/client/composer/email-entry.vala"
	return self;
#line 236 "email-entry.c"
}

EmailEntry*
email_entry_new (ComposerWidget* composer)
{
#line 23 "../src/client/composer/email-entry.vala"
	return email_entry_construct (TYPE_EMAIL_ENTRY, composer);
#line 244 "email-entry.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/client/composer/email-entry.vala"
	return self ? g_object_ref (self) : NULL;
#line 252 "email-entry.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 276 "email-entry.c"
}

static void
email_entry_on_changed (EmailEntry* self)
{
	ContactEntryCompletion* completion = NULL;
	GtkEntryCompletion* _tmp0_;
	ContactEntryCompletion* _tmp1_;
	ContactEntryCompletion* _tmp2_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GearyRFC822MailboxAddresses* _tmp11_;
	GearyRFC822MailboxAddresses* _tmp12_;
#line 42 "../src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 43 "../src/client/composer/email-entry.vala"
	if (self->priv->updating) {
#line 44 "../src/client/composer/email-entry.vala"
		return;
#line 301 "email-entry.c"
	}
#line 45 "../src/client/composer/email-entry.vala"
	self->modified = TRUE;
#line 47 "../src/client/composer/email-entry.vala"
	_tmp0_ = gtk_entry_get_completion (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 47 "../src/client/composer/email-entry.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_CONTACT_ENTRY_COMPLETION) ? ((ContactEntryCompletion*) _tmp0_) : NULL);
#line 47 "../src/client/composer/email-entry.vala"
	completion = _tmp1_;
#line 48 "../src/client/composer/email-entry.vala"
	_tmp2_ = completion;
#line 48 "../src/client/composer/email-entry.vala"
	if (_tmp2_ != NULL) {
#line 315 "email-entry.c"
		ContactEntryCompletion* _tmp3_;
#line 49 "../src/client/composer/email-entry.vala"
		_tmp3_ = completion;
#line 49 "../src/client/composer/email-entry.vala"
		contact_entry_completion_reset_selection (_tmp3_);
#line 321 "email-entry.c"
	}
#line 52 "../src/client/composer/email-entry.vala"
	_tmp4_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 52 "../src/client/composer/email-entry.vala"
	_tmp5_ = _tmp4_;
#line 52 "../src/client/composer/email-entry.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 52 "../src/client/composer/email-entry.vala"
	_tmp7_ = _tmp6_;
#line 52 "../src/client/composer/email-entry.vala"
	_tmp8_ = geary_string_is_empty (_tmp7_);
#line 52 "../src/client/composer/email-entry.vala"
	_g_free0 (_tmp7_);
#line 52 "../src/client/composer/email-entry.vala"
	if (_tmp8_) {
#line 53 "../src/client/composer/email-entry.vala"
		self->priv->updating = TRUE;
#line 54 "../src/client/composer/email-entry.vala"
		email_entry_set_addresses (self, NULL);
#line 55 "../src/client/composer/email-entry.vala"
		self->priv->updating = FALSE;
#line 56 "../src/client/composer/email-entry.vala"
		email_entry_set_valid (self, FALSE);
#line 57 "../src/client/composer/email-entry.vala"
		email_entry_set_empty (self, TRUE);
#line 58 "../src/client/composer/email-entry.vala"
		_g_object_unref0 (completion);
#line 58 "../src/client/composer/email-entry.vala"
		return;
#line 351 "email-entry.c"
	}
#line 61 "../src/client/composer/email-entry.vala"
	self->priv->updating = TRUE;
#line 62 "../src/client/composer/email-entry.vala"
	_tmp9_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 62 "../src/client/composer/email-entry.vala"
	_tmp10_ = _tmp9_;
#line 62 "../src/client/composer/email-entry.vala"
	_tmp11_ = geary_rf_c822_mailbox_addresses_new_from_rfc822_string (_tmp10_);
#line 62 "../src/client/composer/email-entry.vala"
	_tmp12_ = _tmp11_;
#line 62 "../src/client/composer/email-entry.vala"
	email_entry_set_addresses (self, _tmp12_);
#line 62 "../src/client/composer/email-entry.vala"
	_g_object_unref0 (_tmp12_);
#line 63 "../src/client/composer/email-entry.vala"
	self->priv->updating = FALSE;
#line 42 "../src/client/composer/email-entry.vala"
	_g_object_unref0 (completion);
#line 371 "email-entry.c"
}

static void
email_entry_validate_addresses (EmailEntry* self)
{
	gboolean _tmp0_ = FALSE;
	GearyRFC822MailboxAddresses* _tmp1_;
#line 66 "../src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 67 "../src/client/composer/email-entry.vala"
	_tmp1_ = self->priv->_addresses;
#line 67 "../src/client/composer/email-entry.vala"
	if (_tmp1_ == NULL) {
#line 67 "../src/client/composer/email-entry.vala"
		_tmp0_ = TRUE;
#line 387 "email-entry.c"
	} else {
		GearyRFC822MailboxAddresses* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 67 "../src/client/composer/email-entry.vala"
		_tmp2_ = self->priv->_addresses;
#line 67 "../src/client/composer/email-entry.vala"
		_tmp3_ = geary_rf_c822_mailbox_addresses_get_size (_tmp2_);
#line 67 "../src/client/composer/email-entry.vala"
		_tmp4_ = _tmp3_;
#line 67 "../src/client/composer/email-entry.vala"
		_tmp0_ = _tmp4_ == 0;
#line 400 "email-entry.c"
	}
#line 67 "../src/client/composer/email-entry.vala"
	if (_tmp0_) {
#line 68 "../src/client/composer/email-entry.vala"
		email_entry_set_valid (self, FALSE);
#line 69 "../src/client/composer/email-entry.vala"
		email_entry_set_empty (self, TRUE);
#line 70 "../src/client/composer/email-entry.vala"
		return;
#line 410 "email-entry.c"
	}
#line 72 "../src/client/composer/email-entry.vala"
	email_entry_set_empty (self, FALSE);
#line 414 "email-entry.c"
	{
		GearyRFC822MailboxAddresses* _address_list = NULL;
		GearyRFC822MailboxAddresses* _tmp5_;
		GearyRFC822MailboxAddresses* _tmp6_;
		gint _address_size = 0;
		GearyRFC822MailboxAddresses* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _address_index = 0;
#line 74 "../src/client/composer/email-entry.vala"
		_tmp5_ = self->priv->_addresses;
#line 74 "../src/client/composer/email-entry.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 74 "../src/client/composer/email-entry.vala"
		_address_list = _tmp6_;
#line 74 "../src/client/composer/email-entry.vala"
		_tmp7_ = _address_list;
#line 74 "../src/client/composer/email-entry.vala"
		_tmp8_ = geary_rf_c822_mailbox_addresses_get_size (_tmp7_);
#line 74 "../src/client/composer/email-entry.vala"
		_tmp9_ = _tmp8_;
#line 74 "../src/client/composer/email-entry.vala"
		_address_size = _tmp9_;
#line 74 "../src/client/composer/email-entry.vala"
		_address_index = -1;
#line 74 "../src/client/composer/email-entry.vala"
		while (TRUE) {
#line 442 "email-entry.c"
			GearyRFC822MailboxAddress* address = NULL;
			GearyRFC822MailboxAddresses* _tmp10_;
			GearyRFC822MailboxAddress* _tmp11_;
			GearyRFC822MailboxAddress* _tmp12_;
#line 74 "../src/client/composer/email-entry.vala"
			_address_index = _address_index + 1;
#line 74 "../src/client/composer/email-entry.vala"
			if (!(_address_index < _address_size)) {
#line 74 "../src/client/composer/email-entry.vala"
				break;
#line 453 "email-entry.c"
			}
#line 74 "../src/client/composer/email-entry.vala"
			_tmp10_ = _address_list;
#line 74 "../src/client/composer/email-entry.vala"
			_tmp11_ = geary_rf_c822_mailbox_addresses_get (_tmp10_, _address_index);
#line 74 "../src/client/composer/email-entry.vala"
			address = _tmp11_;
#line 75 "../src/client/composer/email-entry.vala"
			_tmp12_ = address;
#line 75 "../src/client/composer/email-entry.vala"
			if (!geary_rf_c822_mailbox_address_is_valid (_tmp12_)) {
#line 76 "../src/client/composer/email-entry.vala"
				email_entry_set_valid (self, FALSE);
#line 77 "../src/client/composer/email-entry.vala"
				_g_object_unref0 (address);
#line 77 "../src/client/composer/email-entry.vala"
				_g_object_unref0 (_address_list);
#line 77 "../src/client/composer/email-entry.vala"
				return;
#line 473 "email-entry.c"
			}
#line 74 "../src/client/composer/email-entry.vala"
			_g_object_unref0 (address);
#line 477 "email-entry.c"
		}
#line 74 "../src/client/composer/email-entry.vala"
		_g_object_unref0 (_address_list);
#line 481 "email-entry.c"
	}
#line 80 "../src/client/composer/email-entry.vala"
	email_entry_set_valid (self, TRUE);
#line 485 "email-entry.c"
}

static gboolean
email_entry_on_key_press (EmailEntry* self,
                          GtkWidget* widget,
                          GdkEventKey* event)
{
	gboolean result = FALSE;
#line 83 "../src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), FALSE);
#line 83 "../src/client/composer/email-entry.vala"
	g_return_val_if_fail (GTK_IS_WIDGET (widget), FALSE);
#line 83 "../src/client/composer/email-entry.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 84 "../src/client/composer/email-entry.vala"
	if (event->keyval == GDK_KEY_Tab) {
#line 502 "email-entry.c"
		GtkEntryCompletion* _tmp0_;
		ComposerWidget* _tmp1_;
#line 85 "../src/client/composer/email-entry.vala"
		_tmp0_ = gtk_entry_get_completion (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 85 "../src/client/composer/email-entry.vala"
		contact_entry_completion_trigger_selection (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletion));
#line 86 "../src/client/composer/email-entry.vala"
		_tmp1_ = self->priv->composer;
#line 86 "../src/client/composer/email-entry.vala"
		gtk_widget_child_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), GTK_DIR_TAB_FORWARD);
#line 87 "../src/client/composer/email-entry.vala"
		result = TRUE;
#line 87 "../src/client/composer/email-entry.vala"
		return result;
#line 517 "email-entry.c"
	}
#line 90 "../src/client/composer/email-entry.vala"
	result = FALSE;
#line 90 "../src/client/composer/email-entry.vala"
	return result;
#line 523 "email-entry.c"
}

gboolean
email_entry_get_valid (EmailEntry* self)
{
	gboolean result;
#line 10 "../src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), FALSE);
#line 10 "../src/client/composer/email-entry.vala"
	result = self->priv->_valid;
#line 10 "../src/client/composer/email-entry.vala"
	return result;
#line 536 "email-entry.c"
}

void
email_entry_set_valid (EmailEntry* self,
                       gboolean value)
{
#line 10 "../src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 10 "../src/client/composer/email-entry.vala"
	if (email_entry_get_valid (self) != value) {
#line 10 "../src/client/composer/email-entry.vala"
		self->priv->_valid = value;
#line 10 "../src/client/composer/email-entry.vala"
		g_object_notify_by_pspec ((GObject *) self, email_entry_properties[EMAIL_ENTRY_VALID_PROPERTY]);
#line 551 "email-entry.c"
	}
}

gboolean
email_entry_get_empty (EmailEntry* self)
{
	gboolean result;
#line 12 "../src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), FALSE);
#line 12 "../src/client/composer/email-entry.vala"
	result = self->priv->_empty;
#line 12 "../src/client/composer/email-entry.vala"
	return result;
#line 565 "email-entry.c"
}

void
email_entry_set_empty (EmailEntry* self,
                       gboolean value)
{
#line 12 "../src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 12 "../src/client/composer/email-entry.vala"
	if (email_entry_get_empty (self) != value) {
#line 12 "../src/client/composer/email-entry.vala"
		self->priv->_empty = value;
#line 12 "../src/client/composer/email-entry.vala"
		g_object_notify_by_pspec ((GObject *) self, email_entry_properties[EMAIL_ENTRY_EMPTY_PROPERTY]);
#line 580 "email-entry.c"
	}
}

GearyRFC822MailboxAddresses*
email_entry_get_addresses (EmailEntry* self)
{
	GearyRFC822MailboxAddresses* result;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 17 "../src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), NULL);
#line 17 "../src/client/composer/email-entry.vala"
	_tmp0_ = self->priv->_addresses;
#line 17 "../src/client/composer/email-entry.vala"
	result = _tmp0_;
#line 17 "../src/client/composer/email-entry.vala"
	return result;
#line 597 "email-entry.c"
}

void
email_entry_set_addresses (EmailEntry* self,
                           GearyRFC822MailboxAddresses* value)
{
#line 17 "../src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 17 "../src/client/composer/email-entry.vala"
	if (email_entry_get_addresses (self) != value) {
#line 608 "email-entry.c"
		GearyRFC822MailboxAddresses* _tmp0_;
#line 17 "../src/client/composer/email-entry.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 17 "../src/client/composer/email-entry.vala"
		_g_object_unref0 (self->priv->_addresses);
#line 17 "../src/client/composer/email-entry.vala"
		self->priv->_addresses = _tmp0_;
#line 17 "../src/client/composer/email-entry.vala"
		g_object_notify_by_pspec ((GObject *) self, email_entry_properties[EMAIL_ENTRY_ADDRESSES_PROPERTY]);
#line 618 "email-entry.c"
	}
}

static void
email_entry_class_init (EmailEntryClass * klass,
                        gpointer klass_data)
{
#line 8 "../src/client/composer/email-entry.vala"
	email_entry_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/client/composer/email-entry.vala"
	g_type_class_adjust_private_offset (klass, &EmailEntry_private_offset);
#line 8 "../src/client/composer/email-entry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_email_entry_get_property;
#line 8 "../src/client/composer/email-entry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_email_entry_set_property;
#line 8 "../src/client/composer/email-entry.vala"
	G_OBJECT_CLASS (klass)->finalize = email_entry_finalize;
#line 8 "../src/client/composer/email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EMAIL_ENTRY_VALID_PROPERTY, email_entry_properties[EMAIL_ENTRY_VALID_PROPERTY] = g_param_spec_boolean ("valid", "valid", "valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "../src/client/composer/email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EMAIL_ENTRY_EMPTY_PROPERTY, email_entry_properties[EMAIL_ENTRY_EMPTY_PROPERTY] = g_param_spec_boolean ("empty", "empty", "empty", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "../src/client/composer/email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EMAIL_ENTRY_ADDRESSES_PROPERTY, email_entry_properties[EMAIL_ENTRY_ADDRESSES_PROPERTY] = g_param_spec_object ("addresses", "addresses", "addresses", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 642 "email-entry.c"
}

static void
email_entry_instance_init (EmailEntry * self,
                           gpointer klass)
{
#line 8 "../src/client/composer/email-entry.vala"
	self->priv = email_entry_get_instance_private (self);
#line 10 "../src/client/composer/email-entry.vala"
	self->priv->_valid = FALSE;
#line 12 "../src/client/composer/email-entry.vala"
	self->priv->_empty = TRUE;
#line 14 "../src/client/composer/email-entry.vala"
	self->modified = FALSE;
#line 17 "../src/client/composer/email-entry.vala"
	self->priv->_addresses = NULL;
#line 21 "../src/client/composer/email-entry.vala"
	self->priv->updating = FALSE;
#line 661 "email-entry.c"
}

static void
email_entry_finalize (GObject * obj)
{
	EmailEntry * self;
#line 8 "../src/client/composer/email-entry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EMAIL_ENTRY, EmailEntry);
#line 17 "../src/client/composer/email-entry.vala"
	_g_object_unref0 (self->priv->_addresses);
#line 8 "../src/client/composer/email-entry.vala"
	G_OBJECT_CLASS (email_entry_parent_class)->finalize (obj);
#line 674 "email-entry.c"
}

GType
email_entry_get_type (void)
{
	static volatile gsize email_entry_type_id__volatile = 0;
	if (g_once_init_enter (&email_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EmailEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) email_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EmailEntry), 0, (GInstanceInitFunc) email_entry_instance_init, NULL };
		GType email_entry_type_id;
		email_entry_type_id = g_type_register_static (gtk_entry_get_type (), "EmailEntry", &g_define_type_info, 0);
		EmailEntry_private_offset = g_type_add_instance_private (email_entry_type_id, sizeof (EmailEntryPrivate));
		g_once_init_leave (&email_entry_type_id__volatile, email_entry_type_id);
	}
	return email_entry_type_id__volatile;
}

static void
_vala_email_entry_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	EmailEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EMAIL_ENTRY, EmailEntry);
#line 8 "../src/client/composer/email-entry.vala"
	switch (property_id) {
#line 8 "../src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_VALID_PROPERTY:
#line 8 "../src/client/composer/email-entry.vala"
		g_value_set_boolean (value, email_entry_get_valid (self));
#line 8 "../src/client/composer/email-entry.vala"
		break;
#line 8 "../src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_EMPTY_PROPERTY:
#line 8 "../src/client/composer/email-entry.vala"
		g_value_set_boolean (value, email_entry_get_empty (self));
#line 8 "../src/client/composer/email-entry.vala"
		break;
#line 8 "../src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_ADDRESSES_PROPERTY:
#line 8 "../src/client/composer/email-entry.vala"
		g_value_set_object (value, email_entry_get_addresses (self));
#line 8 "../src/client/composer/email-entry.vala"
		break;
#line 719 "email-entry.c"
		default:
#line 8 "../src/client/composer/email-entry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/client/composer/email-entry.vala"
		break;
#line 725 "email-entry.c"
	}
}

static void
_vala_email_entry_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	EmailEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EMAIL_ENTRY, EmailEntry);
#line 8 "../src/client/composer/email-entry.vala"
	switch (property_id) {
#line 8 "../src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_VALID_PROPERTY:
#line 8 "../src/client/composer/email-entry.vala"
		email_entry_set_valid (self, g_value_get_boolean (value));
#line 8 "../src/client/composer/email-entry.vala"
		break;
#line 8 "../src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_EMPTY_PROPERTY:
#line 8 "../src/client/composer/email-entry.vala"
		email_entry_set_empty (self, g_value_get_boolean (value));
#line 8 "../src/client/composer/email-entry.vala"
		break;
#line 8 "../src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_ADDRESSES_PROPERTY:
#line 8 "../src/client/composer/email-entry.vala"
		email_entry_set_addresses (self, g_value_get_object (value));
#line 8 "../src/client/composer/email-entry.vala"
		break;
#line 757 "email-entry.c"
		default:
#line 8 "../src/client/composer/email-entry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/client/composer/email-entry.vala"
		break;
#line 763 "email-entry.c"
	}
}

