/* attachment-dialog.c generated by valac 0.44.1, the Vala compiler
 * generated from attachment-dialog.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define TYPE_ATTACHMENT_DIALOG (attachment_dialog_get_type ())
#define ATTACHMENT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ATTACHMENT_DIALOG, AttachmentDialog))
#define ATTACHMENT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ATTACHMENT_DIALOG, AttachmentDialogClass))
#define IS_ATTACHMENT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ATTACHMENT_DIALOG))
#define IS_ATTACHMENT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ATTACHMENT_DIALOG))
#define ATTACHMENT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ATTACHMENT_DIALOG, AttachmentDialogClass))

typedef struct _AttachmentDialog AttachmentDialog;
typedef struct _AttachmentDialogClass AttachmentDialogClass;
typedef struct _AttachmentDialogPrivate AttachmentDialogPrivate;

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
enum  {
	ATTACHMENT_DIALOG_0_PROPERTY,
	ATTACHMENT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* attachment_dialog_properties[ATTACHMENT_DIALOG_NUM_PROPERTIES];
#define _configuration_unref0(var) ((var == NULL) ? NULL : (var = (configuration_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GdkPixbufFormat_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkPixbufFormat_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef gboolean (*AttachmentDialogAttacher) (GFile* attachment_file, gboolean alert_errors, gpointer user_data);

struct _AttachmentDialog {
	GObject parent_instance;
	AttachmentDialogPrivate * priv;
};

struct _AttachmentDialogClass {
	GObjectClass parent_class;
};

struct _AttachmentDialogPrivate {
	Configuration* config;
	GtkFileChooserNative* chooser;
	GtkImage* preview_image;
};

static gint AttachmentDialog_private_offset;
static gpointer attachment_dialog_parent_class = NULL;

GType attachment_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AttachmentDialog, g_object_unref)
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_configuration (GValue* value,
                              gpointer v_object);
void value_take_configuration (GValue* value,
                               gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Configuration, configuration_unref)
#define ATTACHMENT_DIALOG_PREVIEW_SIZE 180
#define ATTACHMENT_DIALOG_PREVIEW_PADDING 3
AttachmentDialog* attachment_dialog_new (GtkWindow* parent,
                                         Configuration* config);
AttachmentDialog* attachment_dialog_construct (GType object_type,
                                               GtkWindow* parent,
                                               Configuration* config);
#define STOCK__CANCEL _ ("_Cancel")
static void attachment_dialog_on_update_preview (AttachmentDialog* self);
static void _attachment_dialog_on_update_preview_gtk_file_chooser_update_preview (GtkFileChooser* _sender,
                                                                           gpointer self);
void attachment_dialog_add_filter (AttachmentDialog* self,
                                   GtkFileFilter* filter);
GSList* attachment_dialog_get_files (AttachmentDialog* self);
gint attachment_dialog_run (AttachmentDialog* self);
void attachment_dialog_hide (AttachmentDialog* self);
void attachment_dialog_destroy (AttachmentDialog* self);
static GdkPixbufFormat* _vala_GdkPixbufFormat_copy (GdkPixbufFormat* self);
static void _vala_GdkPixbufFormat_free (GdkPixbufFormat* self);
static void attachment_dialog_finalize (GObject * obj);

static inline gpointer
attachment_dialog_get_instance_private (AttachmentDialog* self)
{
	return G_STRUCT_MEMBER_P (self, AttachmentDialog_private_offset);
}

static gpointer
_configuration_ref0 (gpointer self)
{
#line 24 "../src/client/dialogs/attachment-dialog.vala"
	return self ? configuration_ref (self) : NULL;
#line 118 "attachment-dialog.c"
}

static void
_attachment_dialog_on_update_preview_gtk_file_chooser_update_preview (GtkFileChooser* _sender,
                                                                      gpointer self)
{
#line 35 "../src/client/dialogs/attachment-dialog.vala"
	attachment_dialog_on_update_preview ((AttachmentDialog*) self);
#line 127 "attachment-dialog.c"
}

AttachmentDialog*
attachment_dialog_construct (GType object_type,
                             GtkWindow* parent,
                             Configuration* config)
{
	AttachmentDialog * self = NULL;
	Configuration* _tmp0_;
	GtkFileChooserNative* _tmp1_;
	GtkFileChooserNative* _tmp2_;
	GtkFileChooserNative* _tmp3_;
	GtkFileChooserNative* _tmp4_;
	GtkImage* _tmp5_;
	GtkFileChooserNative* _tmp6_;
	GtkFileChooserNative* _tmp7_;
#line 23 "../src/client/dialogs/attachment-dialog.vala"
	g_return_val_if_fail ((parent == NULL) || GTK_IS_WINDOW (parent), NULL);
#line 23 "../src/client/dialogs/attachment-dialog.vala"
	g_return_val_if_fail (IS_CONFIGURATION (config), NULL);
#line 23 "../src/client/dialogs/attachment-dialog.vala"
	self = (AttachmentDialog*) g_object_new (object_type, NULL);
#line 24 "../src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = _configuration_ref0 (config);
#line 24 "../src/client/dialogs/attachment-dialog.vala"
	_configuration_unref0 (self->priv->config);
#line 24 "../src/client/dialogs/attachment-dialog.vala"
	self->priv->config = _tmp0_;
#line 25 "../src/client/dialogs/attachment-dialog.vala"
	_tmp1_ = gtk_file_chooser_native_new (_ ("Choose a file"), parent, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("_Attach"), STOCK__CANCEL);
#line 25 "../src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (self->priv->chooser);
#line 25 "../src/client/dialogs/attachment-dialog.vala"
	self->priv->chooser = _tmp1_;
#line 27 "../src/client/dialogs/attachment-dialog.vala"
	_tmp2_ = self->priv->chooser;
#line 27 "../src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_local_only (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_file_chooser_get_type (), GtkFileChooser), FALSE);
#line 28 "../src/client/dialogs/attachment-dialog.vala"
	_tmp3_ = self->priv->chooser;
#line 28 "../src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_select_multiple (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_file_chooser_get_type (), GtkFileChooser), TRUE);
#line 32 "../src/client/dialogs/attachment-dialog.vala"
	_tmp4_ = self->priv->chooser;
#line 32 "../src/client/dialogs/attachment-dialog.vala"
	_tmp5_ = self->priv->preview_image;
#line 32 "../src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_preview_widget (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_file_chooser_get_type (), GtkFileChooser), G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget));
#line 33 "../src/client/dialogs/attachment-dialog.vala"
	_tmp6_ = self->priv->chooser;
#line 33 "../src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_use_preview_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_file_chooser_get_type (), GtkFileChooser), FALSE);
#line 35 "../src/client/dialogs/attachment-dialog.vala"
	_tmp7_ = self->priv->chooser;
#line 35 "../src/client/dialogs/attachment-dialog.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_file_chooser_get_type (), GtkFileChooser), "update-preview", (GCallback) _attachment_dialog_on_update_preview_gtk_file_chooser_update_preview, self, 0);
#line 23 "../src/client/dialogs/attachment-dialog.vala"
	return self;
#line 186 "attachment-dialog.c"
}

AttachmentDialog*
attachment_dialog_new (GtkWindow* parent,
                       Configuration* config)
{
#line 23 "../src/client/dialogs/attachment-dialog.vala"
	return attachment_dialog_construct (TYPE_ATTACHMENT_DIALOG, parent, config);
#line 195 "attachment-dialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/client/dialogs/attachment-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 203 "attachment-dialog.c"
}

void
attachment_dialog_add_filter (AttachmentDialog* self,
                              GtkFileFilter* filter)
{
	GtkFileChooserNative* _tmp0_;
	GtkFileFilter* _tmp1_;
#line 38 "../src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (IS_ATTACHMENT_DIALOG (self));
#line 38 "../src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (GTK_IS_FILE_FILTER (filter));
#line 39 "../src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 39 "../src/client/dialogs/attachment-dialog.vala"
	_tmp1_ = _g_object_ref0 (filter);
#line 39 "../src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_add_filter (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_file_chooser_get_type (), GtkFileChooser), _tmp1_);
#line 38 "../src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (filter);
#line 224 "attachment-dialog.c"
}

GSList*
attachment_dialog_get_files (AttachmentDialog* self)
{
	GSList* result = NULL;
	GtkFileChooserNative* _tmp0_;
	GSList* _tmp1_;
#line 42 "../src/client/dialogs/attachment-dialog.vala"
	g_return_val_if_fail (IS_ATTACHMENT_DIALOG (self), NULL);
#line 43 "../src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 43 "../src/client/dialogs/attachment-dialog.vala"
	_tmp1_ = gtk_file_chooser_get_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_file_chooser_get_type (), GtkFileChooser));
#line 43 "../src/client/dialogs/attachment-dialog.vala"
	result = _tmp1_;
#line 43 "../src/client/dialogs/attachment-dialog.vala"
	return result;
#line 243 "attachment-dialog.c"
}

gint
attachment_dialog_run (AttachmentDialog* self)
{
	gint result = 0;
	GtkFileChooserNative* _tmp0_;
#line 46 "../src/client/dialogs/attachment-dialog.vala"
	g_return_val_if_fail (IS_ATTACHMENT_DIALOG (self), 0);
#line 47 "../src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 47 "../src/client/dialogs/attachment-dialog.vala"
	result = gtk_native_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_native_dialog_get_type (), GtkNativeDialog));
#line 47 "../src/client/dialogs/attachment-dialog.vala"
	return result;
#line 259 "attachment-dialog.c"
}

void
attachment_dialog_hide (AttachmentDialog* self)
{
	GtkFileChooserNative* _tmp0_;
#line 50 "../src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (IS_ATTACHMENT_DIALOG (self));
#line 51 "../src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 51 "../src/client/dialogs/attachment-dialog.vala"
	gtk_native_dialog_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_native_dialog_get_type (), GtkNativeDialog));
#line 272 "attachment-dialog.c"
}

void
attachment_dialog_destroy (AttachmentDialog* self)
{
	GtkFileChooserNative* _tmp0_;
#line 54 "../src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (IS_ATTACHMENT_DIALOG (self));
#line 55 "../src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 55 "../src/client/dialogs/attachment-dialog.vala"
	gtk_native_dialog_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_native_dialog_get_type (), GtkNativeDialog));
#line 285 "attachment-dialog.c"
}

static GdkPixbufFormat*
_vala_GdkPixbufFormat_copy (GdkPixbufFormat* self)
{
#line 68 "../src/client/dialogs/attachment-dialog.vala"
	return g_boxed_copy (gdk_pixbuf_format_get_type (), self);
#line 293 "attachment-dialog.c"
}

static gpointer
__vala_GdkPixbufFormat_copy0 (gpointer self)
{
#line 68 "../src/client/dialogs/attachment-dialog.vala"
	return self ? _vala_GdkPixbufFormat_copy (self) : NULL;
#line 301 "attachment-dialog.c"
}

static void
_vala_GdkPixbufFormat_free (GdkPixbufFormat* self)
{
#line 72 "../src/client/dialogs/attachment-dialog.vala"
	g_boxed_free (gdk_pixbuf_format_get_type (), self);
#line 309 "attachment-dialog.c"
}

static void
attachment_dialog_on_update_preview (AttachmentDialog* self)
{
	gchar* filename = NULL;
	GtkFileChooserNative* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint width = 0;
	gint height = 0;
	GdkPixbufFormat* format = NULL;
	const gchar* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GdkPixbufFormat* _tmp7_;
	GdkPixbufFormat* _tmp8_;
	GdkPixbufFormat* _tmp9_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp18_;
	GdkPixbuf* _tmp19_;
	gint extra_space = 0;
	GdkPixbuf* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint smaller_half = 0;
	gint larger_half = 0;
	GtkImage* _tmp23_;
	GtkImage* _tmp24_;
	GtkImage* _tmp25_;
	GdkPixbuf* _tmp26_;
	GtkFileChooserNative* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 58 "../src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (IS_ATTACHMENT_DIALOG (self));
#line 59 "../src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 59 "../src/client/dialogs/attachment-dialog.vala"
	_tmp1_ = gtk_file_chooser_get_preview_filename (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_file_chooser_get_type (), GtkFileChooser));
#line 59 "../src/client/dialogs/attachment-dialog.vala"
	filename = _tmp1_;
#line 60 "../src/client/dialogs/attachment-dialog.vala"
	_tmp2_ = filename;
#line 60 "../src/client/dialogs/attachment-dialog.vala"
	if (_tmp2_ == NULL) {
#line 356 "attachment-dialog.c"
		GtkFileChooserNative* _tmp3_;
#line 61 "../src/client/dialogs/attachment-dialog.vala"
		_tmp3_ = self->priv->chooser;
#line 61 "../src/client/dialogs/attachment-dialog.vala"
		gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_file_chooser_get_type (), GtkFileChooser), FALSE);
#line 62 "../src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 62 "../src/client/dialogs/attachment-dialog.vala"
		return;
#line 366 "attachment-dialog.c"
	}
#line 66 "../src/client/dialogs/attachment-dialog.vala"
	width = 0;
#line 67 "../src/client/dialogs/attachment-dialog.vala"
	height = 0;
#line 68 "../src/client/dialogs/attachment-dialog.vala"
	_tmp4_ = filename;
#line 68 "../src/client/dialogs/attachment-dialog.vala"
	_tmp7_ = gdk_pixbuf_get_file_info (_tmp4_, &_tmp5_, &_tmp6_);
#line 68 "../src/client/dialogs/attachment-dialog.vala"
	width = _tmp5_;
#line 68 "../src/client/dialogs/attachment-dialog.vala"
	height = _tmp6_;
#line 68 "../src/client/dialogs/attachment-dialog.vala"
	_tmp8_ = __vala_GdkPixbufFormat_copy0 (_tmp7_);
#line 68 "../src/client/dialogs/attachment-dialog.vala"
	format = _tmp8_;
#line 70 "../src/client/dialogs/attachment-dialog.vala"
	_tmp9_ = format;
#line 70 "../src/client/dialogs/attachment-dialog.vala"
	if (_tmp9_ == NULL) {
#line 388 "attachment-dialog.c"
		GtkFileChooserNative* _tmp10_;
#line 71 "../src/client/dialogs/attachment-dialog.vala"
		_tmp10_ = self->priv->chooser;
#line 71 "../src/client/dialogs/attachment-dialog.vala"
		gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_file_chooser_get_type (), GtkFileChooser), FALSE);
#line 72 "../src/client/dialogs/attachment-dialog.vala"
		__vala_GdkPixbufFormat_free0 (format);
#line 72 "../src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 72 "../src/client/dialogs/attachment-dialog.vala"
		return;
#line 400 "attachment-dialog.c"
	}
	{
		GdkPixbuf* _tmp11_ = NULL;
		const gchar* _tmp12_;
		GdkPixbuf* _tmp13_;
		GdkPixbuf* _tmp14_;
#line 78 "../src/client/dialogs/attachment-dialog.vala"
		_tmp12_ = filename;
#line 78 "../src/client/dialogs/attachment-dialog.vala"
		_tmp13_ = gdk_pixbuf_new_from_file_at_scale (_tmp12_, ATTACHMENT_DIALOG_PREVIEW_SIZE, ATTACHMENT_DIALOG_PREVIEW_SIZE, TRUE, &_inner_error0_);
#line 78 "../src/client/dialogs/attachment-dialog.vala"
		_tmp11_ = _tmp13_;
#line 78 "../src/client/dialogs/attachment-dialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 415 "attachment-dialog.c"
			goto __catch166_g_error;
		}
#line 78 "../src/client/dialogs/attachment-dialog.vala"
		_tmp14_ = _tmp11_;
#line 78 "../src/client/dialogs/attachment-dialog.vala"
		_tmp11_ = NULL;
#line 78 "../src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (pixbuf);
#line 78 "../src/client/dialogs/attachment-dialog.vala"
		pixbuf = _tmp14_;
#line 77 "../src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (_tmp11_);
#line 428 "attachment-dialog.c"
	}
	goto __finally166;
	__catch166_g_error:
	{
		GError* e = NULL;
		GtkFileChooserNative* _tmp15_;
#line 77 "../src/client/dialogs/attachment-dialog.vala"
		e = _inner_error0_;
#line 77 "../src/client/dialogs/attachment-dialog.vala"
		_inner_error0_ = NULL;
#line 80 "../src/client/dialogs/attachment-dialog.vala"
		_tmp15_ = self->priv->chooser;
#line 80 "../src/client/dialogs/attachment-dialog.vala"
		gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_file_chooser_get_type (), GtkFileChooser), FALSE);
#line 81 "../src/client/dialogs/attachment-dialog.vala"
		_g_error_free0 (e);
#line 81 "../src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (pixbuf);
#line 81 "../src/client/dialogs/attachment-dialog.vala"
		__vala_GdkPixbufFormat_free0 (format);
#line 81 "../src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 81 "../src/client/dialogs/attachment-dialog.vala"
		return;
#line 453 "attachment-dialog.c"
	}
	__finally166:
#line 77 "../src/client/dialogs/attachment-dialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (pixbuf);
#line 77 "../src/client/dialogs/attachment-dialog.vala"
		__vala_GdkPixbufFormat_free0 (format);
#line 77 "../src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 77 "../src/client/dialogs/attachment-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../src/client/dialogs/attachment-dialog.vala"
		g_clear_error (&_inner_error0_);
#line 77 "../src/client/dialogs/attachment-dialog.vala"
		return;
#line 470 "attachment-dialog.c"
	}
#line 84 "../src/client/dialogs/attachment-dialog.vala"
	_tmp16_ = pixbuf;
#line 84 "../src/client/dialogs/attachment-dialog.vala"
	if (_tmp16_ == NULL) {
#line 476 "attachment-dialog.c"
		GtkFileChooserNative* _tmp17_;
#line 85 "../src/client/dialogs/attachment-dialog.vala"
		_tmp17_ = self->priv->chooser;
#line 85 "../src/client/dialogs/attachment-dialog.vala"
		gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_file_chooser_get_type (), GtkFileChooser), FALSE);
#line 86 "../src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (pixbuf);
#line 86 "../src/client/dialogs/attachment-dialog.vala"
		__vala_GdkPixbufFormat_free0 (format);
#line 86 "../src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 86 "../src/client/dialogs/attachment-dialog.vala"
		return;
#line 490 "attachment-dialog.c"
	}
#line 89 "../src/client/dialogs/attachment-dialog.vala"
	_tmp18_ = pixbuf;
#line 89 "../src/client/dialogs/attachment-dialog.vala"
	_tmp19_ = gdk_pixbuf_apply_embedded_orientation (_tmp18_);
#line 89 "../src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (pixbuf);
#line 89 "../src/client/dialogs/attachment-dialog.vala"
	pixbuf = _tmp19_;
#line 92 "../src/client/dialogs/attachment-dialog.vala"
	_tmp20_ = pixbuf;
#line 92 "../src/client/dialogs/attachment-dialog.vala"
	_tmp21_ = gdk_pixbuf_get_width (_tmp20_);
#line 92 "../src/client/dialogs/attachment-dialog.vala"
	_tmp22_ = _tmp21_;
#line 92 "../src/client/dialogs/attachment-dialog.vala"
	extra_space = ATTACHMENT_DIALOG_PREVIEW_SIZE - _tmp22_;
#line 93 "../src/client/dialogs/attachment-dialog.vala"
	smaller_half = extra_space / 2;
#line 94 "../src/client/dialogs/attachment-dialog.vala"
	larger_half = extra_space - smaller_half;
#line 97 "../src/client/dialogs/attachment-dialog.vala"
	_tmp23_ = self->priv->preview_image;
#line 97 "../src/client/dialogs/attachment-dialog.vala"
	gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget), ATTACHMENT_DIALOG_PREVIEW_PADDING + smaller_half);
#line 98 "../src/client/dialogs/attachment-dialog.vala"
	_tmp24_ = self->priv->preview_image;
#line 98 "../src/client/dialogs/attachment-dialog.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_widget_get_type (), GtkWidget), ATTACHMENT_DIALOG_PREVIEW_PADDING + larger_half);
#line 101 "../src/client/dialogs/attachment-dialog.vala"
	_tmp25_ = self->priv->preview_image;
#line 101 "../src/client/dialogs/attachment-dialog.vala"
	_tmp26_ = pixbuf;
#line 101 "../src/client/dialogs/attachment-dialog.vala"
	gtk_image_set_from_pixbuf (_tmp25_, _tmp26_);
#line 102 "../src/client/dialogs/attachment-dialog.vala"
	_tmp27_ = self->priv->chooser;
#line 102 "../src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_file_chooser_get_type (), GtkFileChooser), TRUE);
#line 58 "../src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (pixbuf);
#line 58 "../src/client/dialogs/attachment-dialog.vala"
	__vala_GdkPixbufFormat_free0 (format);
#line 58 "../src/client/dialogs/attachment-dialog.vala"
	_g_free0 (filename);
#line 536 "attachment-dialog.c"
}

static void
attachment_dialog_class_init (AttachmentDialogClass * klass,
                              gpointer klass_data)
{
#line 10 "../src/client/dialogs/attachment-dialog.vala"
	attachment_dialog_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/client/dialogs/attachment-dialog.vala"
	g_type_class_adjust_private_offset (klass, &AttachmentDialog_private_offset);
#line 10 "../src/client/dialogs/attachment-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = attachment_dialog_finalize;
#line 549 "attachment-dialog.c"
}

static void
attachment_dialog_instance_init (AttachmentDialog * self,
                                 gpointer klass)
{
	GtkImage* _tmp0_;
#line 10 "../src/client/dialogs/attachment-dialog.vala"
	self->priv = attachment_dialog_get_instance_private (self);
#line 17 "../src/client/dialogs/attachment-dialog.vala"
	self->priv->chooser = NULL;
#line 19 "../src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = (GtkImage*) gtk_image_new ();
#line 19 "../src/client/dialogs/attachment-dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 19 "../src/client/dialogs/attachment-dialog.vala"
	self->priv->preview_image = _tmp0_;
#line 567 "attachment-dialog.c"
}

static void
attachment_dialog_finalize (GObject * obj)
{
	AttachmentDialog * self;
#line 10 "../src/client/dialogs/attachment-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ATTACHMENT_DIALOG, AttachmentDialog);
#line 15 "../src/client/dialogs/attachment-dialog.vala"
	_configuration_unref0 (self->priv->config);
#line 17 "../src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (self->priv->chooser);
#line 19 "../src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (self->priv->preview_image);
#line 10 "../src/client/dialogs/attachment-dialog.vala"
	G_OBJECT_CLASS (attachment_dialog_parent_class)->finalize (obj);
#line 584 "attachment-dialog.c"
}

/**
 * A FileChooser-like object for choosing attachments for a message.
 */
GType
attachment_dialog_get_type (void)
{
	static volatile gsize attachment_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&attachment_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AttachmentDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) attachment_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AttachmentDialog), 0, (GInstanceInitFunc) attachment_dialog_instance_init, NULL };
		GType attachment_dialog_type_id;
		attachment_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "AttachmentDialog", &g_define_type_info, 0);
		AttachmentDialog_private_offset = g_type_add_instance_private (attachment_dialog_type_id, sizeof (AttachmentDialogPrivate));
		g_once_init_leave (&attachment_dialog_type_id__volatile, attachment_dialog_type_id);
	}
	return attachment_dialog_type_id__volatile;
}

