/* in-app-notification.c generated by valac 0.44.1, the Vala compiler
 * generated from in-app-notification.vala, do not modify */

/* Copyright 2017 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_IN_APP_NOTIFICATION (in_app_notification_get_type ())
#define IN_APP_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IN_APP_NOTIFICATION, InAppNotification))
#define IN_APP_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IN_APP_NOTIFICATION, InAppNotificationClass))
#define IS_IN_APP_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IN_APP_NOTIFICATION))
#define IS_IN_APP_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IN_APP_NOTIFICATION))
#define IN_APP_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IN_APP_NOTIFICATION, InAppNotificationClass))

typedef struct _InAppNotification InAppNotification;
typedef struct _InAppNotificationClass InAppNotificationClass;
typedef struct _InAppNotificationPrivate InAppNotificationPrivate;
enum  {
	IN_APP_NOTIFICATION_0_PROPERTY,
	IN_APP_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* in_app_notification_properties[IN_APP_NOTIFICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _InAppNotification {
	GtkRevealer parent_instance;
	InAppNotificationPrivate * priv;
};

struct _InAppNotificationClass {
	GtkRevealerClass parent_class;
};

struct _InAppNotificationPrivate {
	GtkLabel* message_label;
	GtkButton* action_button;
};

static gint InAppNotification_private_offset;
static gpointer in_app_notification_parent_class = NULL;

GType in_app_notification_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (InAppNotification, g_object_unref)
#define IN_APP_NOTIFICATION_DEFAULT_KEEPALIVE ((guint) 5)
InAppNotification* in_app_notification_new (const gchar* message,
                                            guint keepalive);
InAppNotification* in_app_notification_construct (GType object_type,
                                                  const gchar* message,
                                                  guint keepalive);
static gboolean __lambda120_ (InAppNotification* self);
void in_app_notification_close (InAppNotification* self);
static gboolean ___lambda120__gsource_func (gpointer self);
void in_app_notification_set_button (InAppNotification* self,
                                     const gchar* label,
                                     const gchar* action_name);
static void in_app_notification_real_show (GtkWidget* base);
static void _in_app_notification_close_gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self);
static void in_app_notification_on_child_revealed (InAppNotification* self,
                                            GObject* src,
                                            GParamSpec* p);
static void _in_app_notification_on_child_revealed_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void in_app_notification_finalize (GObject * obj);

static inline gpointer
in_app_notification_get_instance_private (InAppNotification* self)
{
	return G_STRUCT_MEMBER_P (self, InAppNotification_private_offset);
}

/**
     * Creates an in-app notification.
     *
     * @param message The messag that should be displayed.
     * @param keepalive The amount of seconds that the notification should stay visible.
     */
static gboolean
__lambda120_ (InAppNotification* self)
{
	gboolean result = FALSE;
#line 34 "../src/client/notification/in-app-notification.vala"
	in_app_notification_close (self);
#line 34 "../src/client/notification/in-app-notification.vala"
	result = FALSE;
#line 34 "../src/client/notification/in-app-notification.vala"
	return result;
#line 98 "in-app-notification.c"
}

static gboolean
___lambda120__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda120_ ((InAppNotification*) self);
#line 34 "../src/client/notification/in-app-notification.vala"
	return result;
#line 108 "in-app-notification.c"
}

InAppNotification*
in_app_notification_construct (GType object_type,
                               const gchar* message,
                               guint keepalive)
{
	InAppNotification * self = NULL;
	GtkLabel* _tmp0_;
#line 29 "../src/client/notification/in-app-notification.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 29 "../src/client/notification/in-app-notification.vala"
	self = (InAppNotification*) g_object_new (object_type, NULL);
#line 30 "../src/client/notification/in-app-notification.vala"
	gtk_revealer_set_transition_type (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_revealer_get_type (), GtkRevealer), GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 31 "../src/client/notification/in-app-notification.vala"
	_tmp0_ = self->priv->message_label;
#line 31 "../src/client/notification/in-app-notification.vala"
	gtk_label_set_label (_tmp0_, message);
#line 34 "../src/client/notification/in-app-notification.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, keepalive, ___lambda120__gsource_func, g_object_ref (self), g_object_unref);
#line 29 "../src/client/notification/in-app-notification.vala"
	return self;
#line 132 "in-app-notification.c"
}

InAppNotification*
in_app_notification_new (const gchar* message,
                         guint keepalive)
{
#line 29 "../src/client/notification/in-app-notification.vala"
	return in_app_notification_construct (TYPE_IN_APP_NOTIFICATION, message, keepalive);
#line 141 "in-app-notification.c"
}

/**
     * Sets a button for the notification.
     */
void
in_app_notification_set_button (InAppNotification* self,
                                const gchar* label,
                                const gchar* action_name)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
#line 40 "../src/client/notification/in-app-notification.vala"
	g_return_if_fail (IS_IN_APP_NOTIFICATION (self));
#line 40 "../src/client/notification/in-app-notification.vala"
	g_return_if_fail (label != NULL);
#line 40 "../src/client/notification/in-app-notification.vala"
	g_return_if_fail (action_name != NULL);
#line 41 "../src/client/notification/in-app-notification.vala"
	_tmp0_ = self->priv->action_button;
#line 41 "../src/client/notification/in-app-notification.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 42 "../src/client/notification/in-app-notification.vala"
	_tmp1_ = self->priv->action_button;
#line 42 "../src/client/notification/in-app-notification.vala"
	gtk_button_set_label (_tmp1_, label);
#line 43 "../src/client/notification/in-app-notification.vala"
	_tmp2_ = self->priv->action_button;
#line 43 "../src/client/notification/in-app-notification.vala"
	gtk_actionable_set_action_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_actionable_get_type (), GtkActionable), action_name);
#line 173 "in-app-notification.c"
}

static void
in_app_notification_real_show (GtkWidget* base)
{
	InAppNotification * self;
#line 46 "../src/client/notification/in-app-notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_IN_APP_NOTIFICATION, InAppNotification);
#line 47 "../src/client/notification/in-app-notification.vala"
	GTK_WIDGET_CLASS (in_app_notification_parent_class)->show (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_revealer_get_type (), GtkRevealer), gtk_widget_get_type (), GtkWidget));
#line 48 "../src/client/notification/in-app-notification.vala"
	gtk_revealer_set_reveal_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_revealer_get_type (), GtkRevealer), TRUE);
#line 186 "in-app-notification.c"
}

/**
     * Closes the in-app notification.
     */
void
in_app_notification_close (InAppNotification* self)
{
#line 55 "../src/client/notification/in-app-notification.vala"
	g_return_if_fail (IS_IN_APP_NOTIFICATION (self));
#line 57 "../src/client/notification/in-app-notification.vala"
	gtk_revealer_set_reveal_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_revealer_get_type (), GtkRevealer), FALSE);
#line 199 "in-app-notification.c"
}

static void
_in_app_notification_close_gtk_button_clicked (GtkButton* _sender,
                                               gpointer self)
{
#line 13 "../src/client/notification/in-app-notification.vala"
	in_app_notification_close ((InAppNotification*) self);
#line 208 "in-app-notification.c"
}

static void
in_app_notification_on_child_revealed (InAppNotification* self,
                                       GObject* src,
                                       GParamSpec* p)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 62 "../src/client/notification/in-app-notification.vala"
	g_return_if_fail (IS_IN_APP_NOTIFICATION (self));
#line 62 "../src/client/notification/in-app-notification.vala"
	g_return_if_fail (G_IS_OBJECT (src));
#line 62 "../src/client/notification/in-app-notification.vala"
	g_return_if_fail (G_IS_PARAM_SPEC (p));
#line 63 "../src/client/notification/in-app-notification.vala"
	_tmp0_ = gtk_revealer_get_child_revealed (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_revealer_get_type (), GtkRevealer));
#line 63 "../src/client/notification/in-app-notification.vala"
	_tmp1_ = _tmp0_;
#line 63 "../src/client/notification/in-app-notification.vala"
	if (!_tmp1_) {
#line 64 "../src/client/notification/in-app-notification.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 232 "in-app-notification.c"
	}
}

static void
_in_app_notification_on_child_revealed_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 13 "../src/client/notification/in-app-notification.vala"
	in_app_notification_on_child_revealed ((InAppNotification*) self, _sender, pspec);
#line 243 "in-app-notification.c"
}

static void
in_app_notification_class_init (InAppNotificationClass * klass,
                                gpointer klass_data)
{
#line 13 "../src/client/notification/in-app-notification.vala"
	in_app_notification_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/client/notification/in-app-notification.vala"
	g_type_class_adjust_private_offset (klass, &InAppNotification_private_offset);
#line 13 "../src/client/notification/in-app-notification.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) in_app_notification_real_show;
#line 13 "../src/client/notification/in-app-notification.vala"
	G_OBJECT_CLASS (klass)->finalize = in_app_notification_finalize;
#line 13 "../src/client/notification/in-app-notification.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/in-app-notification.ui");
#line 13 "../src/client/notification/in-app-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "message_label", FALSE, InAppNotification_private_offset + G_STRUCT_OFFSET (InAppNotificationPrivate, message_label));
#line 13 "../src/client/notification/in-app-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "action_button", FALSE, InAppNotification_private_offset + G_STRUCT_OFFSET (InAppNotificationPrivate, action_button));
#line 13 "../src/client/notification/in-app-notification.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "close", G_CALLBACK(_in_app_notification_close_gtk_button_clicked));
#line 13 "../src/client/notification/in-app-notification.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_child_revealed", G_CALLBACK(_in_app_notification_on_child_revealed_g_object_notify));
#line 268 "in-app-notification.c"
}

static void
in_app_notification_instance_init (InAppNotification * self,
                                   gpointer klass)
{
#line 13 "../src/client/notification/in-app-notification.vala"
	self->priv = in_app_notification_get_instance_private (self);
#line 13 "../src/client/notification/in-app-notification.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 279 "in-app-notification.c"
}

static void
in_app_notification_finalize (GObject * obj)
{
	InAppNotification * self;
#line 13 "../src/client/notification/in-app-notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IN_APP_NOTIFICATION, InAppNotification);
#line 19 "../src/client/notification/in-app-notification.vala"
	_g_object_unref0 (self->priv->message_label);
#line 21 "../src/client/notification/in-app-notification.vala"
	_g_object_unref0 (self->priv->action_button);
#line 13 "../src/client/notification/in-app-notification.vala"
	G_OBJECT_CLASS (in_app_notification_parent_class)->finalize (obj);
#line 294 "in-app-notification.c"
}

/**
 * Represents an in-app notification.
 *
 * Following the GNOME HIG, it should only contain a label and maybe a button.
 */
GType
in_app_notification_get_type (void)
{
	static volatile gsize in_app_notification_type_id__volatile = 0;
	if (g_once_init_enter (&in_app_notification_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (InAppNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) in_app_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (InAppNotification), 0, (GInstanceInitFunc) in_app_notification_instance_init, NULL };
		GType in_app_notification_type_id;
		in_app_notification_type_id = g_type_register_static (gtk_revealer_get_type (), "InAppNotification", &g_define_type_info, 0);
		InAppNotification_private_offset = g_type_add_instance_private (in_app_notification_type_id, sizeof (InAppNotificationPrivate));
		g_once_init_leave (&in_app_notification_type_id__volatile, in_app_notification_type_id);
	}
	return in_app_notification_type_id__volatile;
}

