/* util-avatar.c generated by valac 0.44.1, the Vala compiler
 * generated from util-avatar.vala, do not modify */

/*
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>

#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

GdkPixbuf* util_avatar_generate_user_picture (const gchar* name,
                                              gint size);
void util_avatar_get_color_for_name (const gchar* name,
                                     GdkRGBA* result);
gchar* util_avatar_extract_initials_from_name (const gchar* name);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
GdkPixbuf* util_avatar_round_image (GdkPixbuf* source);

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 37 "../src/client/util/util-avatar.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 43 "util-avatar.c"
}

GdkPixbuf*
util_avatar_generate_user_picture (const gchar* name,
                                   gint size)
{
	GdkPixbuf* result = NULL;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	GdkRGBA color = {0};
	GdkRGBA _tmp4_ = {0};
	cairo_t* _tmp5_;
	GdkRGBA _tmp6_;
	GdkRGBA _tmp7_;
	GdkRGBA _tmp8_;
	cairo_t* _tmp9_;
	gchar* initials = NULL;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	cairo_surface_t* _tmp29_;
	GdkPixbuf* _tmp30_;
#line 15 "../src/client/util/util-avatar.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 16 "../src/client/util/util-avatar.vala"
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, size, size);
#line 16 "../src/client/util/util-avatar.vala"
	surface = _tmp0_;
#line 19 "../src/client/util/util-avatar.vala"
	_tmp1_ = surface;
#line 19 "../src/client/util/util-avatar.vala"
	_tmp2_ = cairo_create (_tmp1_);
#line 19 "../src/client/util/util-avatar.vala"
	cr = _tmp2_;
#line 20 "../src/client/util/util-avatar.vala"
	_tmp3_ = cr;
#line 20 "../src/client/util/util-avatar.vala"
	cairo_rectangle (_tmp3_, (gdouble) 0, (gdouble) 0, (gdouble) size, (gdouble) size);
#line 23 "../src/client/util/util-avatar.vala"
	util_avatar_get_color_for_name (name, &_tmp4_);
#line 23 "../src/client/util/util-avatar.vala"
	color = _tmp4_;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp5_ = cr;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp6_ = color;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp7_ = color;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp8_ = color;
#line 24 "../src/client/util/util-avatar.vala"
	cairo_set_source_rgb (_tmp5_, _tmp6_.red / 255.0, _tmp7_.green / 255.0, _tmp8_.blue / 255.0);
#line 27 "../src/client/util/util-avatar.vala"
	_tmp9_ = cr;
#line 27 "../src/client/util/util-avatar.vala"
	cairo_fill (_tmp9_);
#line 30 "../src/client/util/util-avatar.vala"
	_tmp10_ = util_avatar_extract_initials_from_name (name);
#line 30 "../src/client/util/util-avatar.vala"
	initials = _tmp10_;
#line 31 "../src/client/util/util-avatar.vala"
	_tmp11_ = initials;
#line 31 "../src/client/util/util-avatar.vala"
	if (_tmp11_ != NULL) {
#line 111 "util-avatar.c"
		gchar* font = NULL;
		gchar* _tmp12_;
		cairo_t* _tmp13_;
		PangoLayout* layout = NULL;
		cairo_t* _tmp14_;
		PangoLayout* _tmp15_;
		PangoLayout* _tmp16_;
		const gchar* _tmp17_;
		PangoLayout* _tmp18_;
		const gchar* _tmp19_;
		PangoFontDescription* _tmp20_;
		PangoFontDescription* _tmp21_;
		gint width = 0;
		gint height = 0;
		PangoLayout* _tmp22_;
		gint _tmp23_ = 0;
		gint _tmp24_ = 0;
		cairo_t* _tmp25_;
		cairo_t* _tmp26_;
		cairo_t* _tmp27_;
		PangoLayout* _tmp28_;
#line 32 "../src/client/util/util-avatar.vala"
		_tmp12_ = g_strdup_printf ("Sans %d", (gint) ceil (size / 2.5));
#line 32 "../src/client/util/util-avatar.vala"
		font = _tmp12_;
#line 34 "../src/client/util/util-avatar.vala"
		_tmp13_ = cr;
#line 34 "../src/client/util/util-avatar.vala"
		cairo_set_source_rgb (_tmp13_, 1.0, 1.0, 1.0);
#line 35 "../src/client/util/util-avatar.vala"
		_tmp14_ = cr;
#line 35 "../src/client/util/util-avatar.vala"
		_tmp15_ = pango_cairo_create_layout (_tmp14_);
#line 35 "../src/client/util/util-avatar.vala"
		layout = _tmp15_;
#line 36 "../src/client/util/util-avatar.vala"
		_tmp16_ = layout;
#line 36 "../src/client/util/util-avatar.vala"
		_tmp17_ = initials;
#line 36 "../src/client/util/util-avatar.vala"
		pango_layout_set_text (_tmp16_, _tmp17_, -1);
#line 37 "../src/client/util/util-avatar.vala"
		_tmp18_ = layout;
#line 37 "../src/client/util/util-avatar.vala"
		_tmp19_ = font;
#line 37 "../src/client/util/util-avatar.vala"
		_tmp20_ = pango_font_description_from_string (_tmp19_);
#line 37 "../src/client/util/util-avatar.vala"
		_tmp21_ = _tmp20_;
#line 37 "../src/client/util/util-avatar.vala"
		pango_layout_set_font_description (_tmp18_, _tmp21_);
#line 37 "../src/client/util/util-avatar.vala"
		__vala_PangoFontDescription_free0 (_tmp21_);
#line 40 "../src/client/util/util-avatar.vala"
		_tmp22_ = layout;
#line 40 "../src/client/util/util-avatar.vala"
		pango_layout_get_size (_tmp22_, &_tmp23_, &_tmp24_);
#line 40 "../src/client/util/util-avatar.vala"
		width = _tmp23_;
#line 40 "../src/client/util/util-avatar.vala"
		height = _tmp24_;
#line 41 "../src/client/util/util-avatar.vala"
		_tmp25_ = cr;
#line 41 "../src/client/util/util-avatar.vala"
		cairo_translate (_tmp25_, (gdouble) (size / 2), (gdouble) (size / 2));
#line 42 "../src/client/util/util-avatar.vala"
		_tmp26_ = cr;
#line 42 "../src/client/util/util-avatar.vala"
		cairo_move_to (_tmp26_, (-(((gdouble) width) / PANGO_SCALE)) / 2, (-(((gdouble) height) / PANGO_SCALE)) / 2);
#line 46 "../src/client/util/util-avatar.vala"
		_tmp27_ = cr;
#line 46 "../src/client/util/util-avatar.vala"
		_tmp28_ = layout;
#line 46 "../src/client/util/util-avatar.vala"
		pango_cairo_show_layout (_tmp27_, _tmp28_);
#line 31 "../src/client/util/util-avatar.vala"
		_g_object_unref0 (layout);
#line 31 "../src/client/util/util-avatar.vala"
		_g_free0 (font);
#line 191 "util-avatar.c"
	}
#line 49 "../src/client/util/util-avatar.vala"
	_tmp29_ = surface;
#line 49 "../src/client/util/util-avatar.vala"
	_tmp30_ = gdk_pixbuf_get_from_surface (_tmp29_, 0, 0, size, size);
#line 49 "../src/client/util/util-avatar.vala"
	result = _tmp30_;
#line 49 "../src/client/util/util-avatar.vala"
	_g_free0 (initials);
#line 49 "../src/client/util/util-avatar.vala"
	_cairo_destroy0 (cr);
#line 49 "../src/client/util/util-avatar.vala"
	_cairo_surface_destroy0 (surface);
#line 49 "../src/client/util/util-avatar.vala"
	return result;
#line 207 "util-avatar.c"
}

GdkPixbuf*
util_avatar_round_image (GdkPixbuf* source)
{
	GdkPixbuf* result = NULL;
	gint size = 0;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_t* _tmp3_;
	GdkPixbuf* _tmp4_;
#line 54 "../src/client/util/util-avatar.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (source), NULL);
#line 55 "../src/client/util/util-avatar.vala"
	_tmp0_ = gdk_pixbuf_get_width (source);
#line 55 "../src/client/util/util-avatar.vala"
	_tmp1_ = _tmp0_;
#line 55 "../src/client/util/util-avatar.vala"
	size = _tmp1_;
#line 56 "../src/client/util/util-avatar.vala"
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, size, size);
#line 56 "../src/client/util/util-avatar.vala"
	surface = _tmp2_;
#line 59 "../src/client/util/util-avatar.vala"
	_tmp3_ = cairo_create (surface);
#line 59 "../src/client/util/util-avatar.vala"
	cr = _tmp3_;
#line 62 "../src/client/util/util-avatar.vala"
	cairo_arc (cr, (gdouble) (size / 2), (gdouble) (size / 2), (gdouble) (size / 2), (gdouble) 0, 2 * G_PI);
#line 63 "../src/client/util/util-avatar.vala"
	cairo_clip (cr);
#line 64 "../src/client/util/util-avatar.vala"
	cairo_new_path (cr);
#line 66 "../src/client/util/util-avatar.vala"
	gdk_cairo_set_source_pixbuf (cr, source, (gdouble) 0, (gdouble) 0);
#line 67 "../src/client/util/util-avatar.vala"
	cairo_paint (cr);
#line 69 "../src/client/util/util-avatar.vala"
	_tmp4_ = gdk_pixbuf_get_from_surface (surface, 0, 0, size, size);
#line 69 "../src/client/util/util-avatar.vala"
	result = _tmp4_;
#line 69 "../src/client/util/util-avatar.vala"
	_cairo_destroy0 (cr);
#line 69 "../src/client/util/util-avatar.vala"
	_cairo_surface_destroy0 (surface);
#line 69 "../src/client/util/util-avatar.vala"
	return result;
#line 258 "util-avatar.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 282 "util-avatar.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1199 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 298 "util-avatar.c"
		gchar* _tmp0_;
#line 1202 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1203 "glib-2.0.vapi"
		result = TRUE;
#line 1203 "glib-2.0.vapi"
		if (c) {
#line 1203 "glib-2.0.vapi"
			*c = _vala_c;
#line 310 "util-avatar.c"
		}
#line 1203 "glib-2.0.vapi"
		return result;
#line 314 "util-avatar.c"
	} else {
#line 1205 "glib-2.0.vapi"
		result = FALSE;
#line 1205 "glib-2.0.vapi"
		if (c) {
#line 1205 "glib-2.0.vapi"
			*c = _vala_c;
#line 322 "util-avatar.c"
		}
#line 1205 "glib-2.0.vapi"
		return result;
#line 326 "util-avatar.c"
	}
#line 1199 "glib-2.0.vapi"
	if (c) {
#line 1199 "glib-2.0.vapi"
		*c = _vala_c;
#line 332 "util-avatar.c"
	}
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1111 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1112 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1112 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1114 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1114 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 355 "util-avatar.c"
		gchar* _tmp2_;
#line 1115 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1115 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1115 "glib-2.0.vapi"
		return result;
#line 363 "util-avatar.c"
	} else {
#line 1117 "glib-2.0.vapi"
		result = -1;
#line 1117 "glib-2.0.vapi"
		return result;
#line 369 "util-avatar.c"
	}
}

static guint8*
g_string_get_data (GString* self,
                   gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 5000 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5001 "glib-2.0.vapi"
	_tmp0_ = self->str;
#line 5001 "glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 5001 "glib-2.0.vapi"
	res_length1 = -1;
#line 5001 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 5002 "glib-2.0.vapi"
	res_length1 = (gint) self->len;
#line 5003 "glib-2.0.vapi"
	_tmp1_ = res;
#line 5003 "glib-2.0.vapi"
	_tmp1__length1 = res_length1;
#line 5003 "glib-2.0.vapi"
	_tmp2_ = _tmp1_;
#line 5003 "glib-2.0.vapi"
	_tmp2__length1 = _tmp1__length1;
#line 5003 "glib-2.0.vapi"
	if (result_length1) {
#line 5003 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 410 "util-avatar.c"
	}
#line 5003 "glib-2.0.vapi"
	result = _tmp2_;
#line 5003 "glib-2.0.vapi"
	return result;
#line 416 "util-avatar.c"
}

gchar*
util_avatar_extract_initials_from_name (const gchar* name)
{
	gchar* result = NULL;
	gchar* normalized = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* initials = NULL;
	const gchar* _tmp6_;
#line 74 "../src/client/util/util-avatar.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 75 "../src/client/util/util-avatar.vala"
	_tmp0_ = string_strip (name);
#line 75 "../src/client/util/util-avatar.vala"
	_tmp1_ = _tmp0_;
#line 75 "../src/client/util/util-avatar.vala"
	_tmp2_ = g_utf8_strup (_tmp1_, (gssize) -1);
#line 75 "../src/client/util/util-avatar.vala"
	_tmp3_ = _tmp2_;
#line 75 "../src/client/util/util-avatar.vala"
	_tmp4_ = g_utf8_normalize (_tmp3_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 75 "../src/client/util/util-avatar.vala"
	_tmp5_ = _tmp4_;
#line 75 "../src/client/util/util-avatar.vala"
	_g_free0 (_tmp3_);
#line 75 "../src/client/util/util-avatar.vala"
	_g_free0 (_tmp1_);
#line 75 "../src/client/util/util-avatar.vala"
	normalized = _tmp5_;
#line 76 "../src/client/util/util-avatar.vala"
	initials = NULL;
#line 77 "../src/client/util/util-avatar.vala"
	_tmp6_ = normalized;
#line 77 "../src/client/util/util-avatar.vala"
	if (g_strcmp0 (_tmp6_, "") != 0) {
#line 458 "util-avatar.c"
		GString* buf = NULL;
		GString* _tmp7_;
		gunichar c = 0U;
		gint index = 0;
		const gchar* _tmp14_;
		GString* _tmp21_;
		guint8* _tmp22_;
		gint _tmp22__length1;
		guint8* _tmp23_;
		gint _tmp23__length1;
#line 78 "../src/client/util/util-avatar.vala"
		_tmp7_ = g_string_new ("");
#line 78 "../src/client/util/util-avatar.vala"
		buf = _tmp7_;
#line 79 "../src/client/util/util-avatar.vala"
		c = (gunichar) 0;
#line 80 "../src/client/util/util-avatar.vala"
		index = 0;
#line 477 "util-avatar.c"
		{
			gint i = 0;
#line 83 "../src/client/util/util-avatar.vala"
			i = 0;
#line 482 "util-avatar.c"
			{
				gboolean _tmp8_ = FALSE;
#line 83 "../src/client/util/util-avatar.vala"
				_tmp8_ = TRUE;
#line 83 "../src/client/util/util-avatar.vala"
				while (TRUE) {
#line 489 "util-avatar.c"
					const gchar* _tmp10_;
					gunichar _tmp11_ = 0U;
					gboolean _tmp12_;
#line 83 "../src/client/util/util-avatar.vala"
					if (!_tmp8_) {
#line 495 "util-avatar.c"
						gint _tmp9_;
#line 83 "../src/client/util/util-avatar.vala"
						_tmp9_ = i;
#line 83 "../src/client/util/util-avatar.vala"
						i = _tmp9_ + 1;
#line 501 "util-avatar.c"
					}
#line 83 "../src/client/util/util-avatar.vala"
					_tmp8_ = FALSE;
#line 83 "../src/client/util/util-avatar.vala"
					_tmp10_ = normalized;
#line 83 "../src/client/util/util-avatar.vala"
					_tmp12_ = string_get_next_char (_tmp10_, &index, &_tmp11_);
#line 83 "../src/client/util/util-avatar.vala"
					c = _tmp11_;
#line 83 "../src/client/util/util-avatar.vala"
					if (!_tmp12_) {
#line 83 "../src/client/util/util-avatar.vala"
						break;
#line 515 "util-avatar.c"
					}
#line 84 "../src/client/util/util-avatar.vala"
					if (g_unichar_isalnum (c)) {
#line 519 "util-avatar.c"
						GString* _tmp13_;
#line 85 "../src/client/util/util-avatar.vala"
						_tmp13_ = buf;
#line 85 "../src/client/util/util-avatar.vala"
						g_string_append_unichar (_tmp13_, c);
#line 86 "../src/client/util/util-avatar.vala"
						break;
#line 527 "util-avatar.c"
					}
				}
			}
		}
#line 91 "../src/client/util/util-avatar.vala"
		_tmp14_ = normalized;
#line 91 "../src/client/util/util-avatar.vala"
		index = string_last_index_of_char (_tmp14_, (gunichar) ' ', 0);
#line 536 "util-avatar.c"
		{
			gint i = 0;
#line 92 "../src/client/util/util-avatar.vala"
			i = 0;
#line 541 "util-avatar.c"
			{
				gboolean _tmp15_ = FALSE;
#line 92 "../src/client/util/util-avatar.vala"
				_tmp15_ = TRUE;
#line 92 "../src/client/util/util-avatar.vala"
				while (TRUE) {
#line 548 "util-avatar.c"
					const gchar* _tmp17_;
					gunichar _tmp18_ = 0U;
					gboolean _tmp19_;
#line 92 "../src/client/util/util-avatar.vala"
					if (!_tmp15_) {
#line 554 "util-avatar.c"
						gint _tmp16_;
#line 92 "../src/client/util/util-avatar.vala"
						_tmp16_ = i;
#line 92 "../src/client/util/util-avatar.vala"
						i = _tmp16_ + 1;
#line 560 "util-avatar.c"
					}
#line 92 "../src/client/util/util-avatar.vala"
					_tmp15_ = FALSE;
#line 92 "../src/client/util/util-avatar.vala"
					_tmp17_ = normalized;
#line 92 "../src/client/util/util-avatar.vala"
					_tmp19_ = string_get_next_char (_tmp17_, &index, &_tmp18_);
#line 92 "../src/client/util/util-avatar.vala"
					c = _tmp18_;
#line 92 "../src/client/util/util-avatar.vala"
					if (!_tmp19_) {
#line 92 "../src/client/util/util-avatar.vala"
						break;
#line 574 "util-avatar.c"
					}
#line 93 "../src/client/util/util-avatar.vala"
					if (g_unichar_isalnum (c)) {
#line 578 "util-avatar.c"
						GString* _tmp20_;
#line 94 "../src/client/util/util-avatar.vala"
						_tmp20_ = buf;
#line 94 "../src/client/util/util-avatar.vala"
						g_string_append_unichar (_tmp20_, c);
#line 95 "../src/client/util/util-avatar.vala"
						break;
#line 586 "util-avatar.c"
					}
				}
			}
		}
#line 99 "../src/client/util/util-avatar.vala"
		_tmp21_ = buf;
#line 99 "../src/client/util/util-avatar.vala"
		_tmp22_ = g_string_get_data (_tmp21_, &_tmp22__length1);
#line 99 "../src/client/util/util-avatar.vala"
		_tmp23_ = _tmp22_;
#line 99 "../src/client/util/util-avatar.vala"
		_tmp23__length1 = _tmp22__length1;
#line 99 "../src/client/util/util-avatar.vala"
		if (_tmp23__length1 > 0) {
#line 601 "util-avatar.c"
			GString* _tmp24_;
			guint8* _tmp25_;
			gint _tmp25__length1;
			guint8* _tmp26_;
			gint _tmp26__length1;
			gchar* _tmp27_;
#line 100 "../src/client/util/util-avatar.vala"
			_tmp24_ = buf;
#line 100 "../src/client/util/util-avatar.vala"
			_tmp25_ = g_string_get_data (_tmp24_, &_tmp25__length1);
#line 100 "../src/client/util/util-avatar.vala"
			_tmp26_ = _tmp25_;
#line 100 "../src/client/util/util-avatar.vala"
			_tmp26__length1 = _tmp25__length1;
#line 100 "../src/client/util/util-avatar.vala"
			_tmp27_ = g_strdup ((const gchar*) _tmp26_);
#line 100 "../src/client/util/util-avatar.vala"
			_g_free0 (initials);
#line 100 "../src/client/util/util-avatar.vala"
			initials = _tmp27_;
#line 622 "util-avatar.c"
		}
#line 77 "../src/client/util/util-avatar.vala"
		_g_string_free0 (buf);
#line 626 "util-avatar.c"
	}
#line 103 "../src/client/util/util-avatar.vala"
	result = initials;
#line 103 "../src/client/util/util-avatar.vala"
	_g_free0 (normalized);
#line 103 "../src/client/util/util-avatar.vala"
	return result;
#line 634 "util-avatar.c"
}

void
util_avatar_get_color_for_name (const gchar* name,
                                GdkRGBA* result)
{
#line 109 "../src/client/util/util-avatar.vala"
	static const gdouble GNOME_COLOR_PALETTE[28][3] = {{(gdouble) 98, (gdouble) 160, (gdouble) 234}, {(gdouble) 53, (gdouble) 132, (gdouble) 228}, {(gdouble) 28, (gdouble) 113, (gdouble) 216}, {(gdouble) 26, (gdouble) 95, (gdouble) 180}, {(gdouble) 87, (gdouble) 227, (gdouble) 137}, {(gdouble) 51, (gdouble) 209, (gdouble) 122}, {(gdouble) 46, (gdouble) 194, (gdouble) 126}, {(gdouble) 38, (gdouble) 162, (gdouble) 105}, {(gdouble) 248, (gdouble) 228, (gdouble) 92}, {(gdouble) 246, (gdouble) 211, (gdouble) 45}, {(gdouble) 245, (gdouble) 194, (gdouble) 17}, {(gdouble) 229, (gdouble) 165, (gdouble) 10}, {(gdouble) 255, (gdouble) 163, (gdouble) 72}, {(gdouble) 255, (gdouble) 120, (gdouble) 0}, {(gdouble) 230, (gdouble) 97, (gdouble) 0}, {(gdouble) 198, (gdouble) 70, (gdouble) 0}, {(gdouble) 237, (gdouble) 51, (gdouble) 59}, {(gdouble) 224, (gdouble) 27, (gdouble) 36}, {(gdouble) 192, (gdouble) 28, (gdouble) 40}, {(gdouble) 165, (gdouble) 29, (gdouble) 45}, {(gdouble) 192, (gdouble) 97, (gdouble) 203}, {(gdouble) 163, (gdouble) 71, (gdouble) 186}, {(gdouble) 129, (gdouble) 61, (gdouble) 156}, {(gdouble) 97, (gdouble) 53, (gdouble) 131}, {(gdouble) 181, (gdouble) 131, (gdouble) 90}, {(gdouble) 152, (gdouble) 106, (gdouble) 68}, {(gdouble) 134, (gdouble) 94, (gdouble) 60}, {(gdouble) 99, (gdouble) 69, (gdouble) 44}};
#line 643 "util-avatar.c"
	GdkRGBA color = {0};
	GdkRGBA _tmp0_ = {0};
	guint hash = 0U;
	guint number_of_colors = 0U;
	guint idx = 0U;
	gint _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
#line 107 "../src/client/util/util-avatar.vala"
	g_return_if_fail (name != NULL);
#line 140 "../src/client/util/util-avatar.vala"
	_tmp0_.red = (gdouble) 255;
#line 140 "../src/client/util/util-avatar.vala"
	_tmp0_.green = (gdouble) 255;
#line 140 "../src/client/util/util-avatar.vala"
	_tmp0_.blue = (gdouble) 255;
#line 140 "../src/client/util/util-avatar.vala"
	_tmp0_.alpha = 1.0;
#line 140 "../src/client/util/util-avatar.vala"
	color = _tmp0_;
#line 145 "../src/client/util/util-avatar.vala"
	if (g_strcmp0 (name, "") == 0) {
#line 146 "../src/client/util/util-avatar.vala"
		*result = color;
#line 146 "../src/client/util/util-avatar.vala"
		return;
#line 671 "util-avatar.c"
	}
#line 149 "../src/client/util/util-avatar.vala"
	hash = g_str_hash (name);
#line 150 "../src/client/util/util-avatar.vala"
	_tmp1_ = G_N_ELEMENTS (GNOME_COLOR_PALETTE);
#line 150 "../src/client/util/util-avatar.vala"
	number_of_colors = (guint) _tmp1_;
#line 151 "../src/client/util/util-avatar.vala"
	idx = hash % number_of_colors;
#line 153 "../src/client/util/util-avatar.vala"
	_tmp2_ = (*GNOME_COLOR_PALETTE)[(idx * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 0];
#line 153 "../src/client/util/util-avatar.vala"
	color.red = _tmp2_;
#line 154 "../src/client/util/util-avatar.vala"
	_tmp3_ = (*GNOME_COLOR_PALETTE)[(idx * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 1];
#line 154 "../src/client/util/util-avatar.vala"
	color.green = _tmp3_;
#line 155 "../src/client/util/util-avatar.vala"
	_tmp4_ = (*GNOME_COLOR_PALETTE)[(idx * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 2];
#line 155 "../src/client/util/util-avatar.vala"
	color.blue = _tmp4_;
#line 157 "../src/client/util/util-avatar.vala"
	*result = color;
#line 157 "../src/client/util/util-avatar.vala"
	return;
#line 697 "util-avatar.c"
}

