/* util-date.c generated by valac 0.44.1, the Vala compiler
 * generated from util-date.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <math.h>
#include <float.h>

typedef enum  {
	DATE_CLOCK_FORMAT_TWELVE_HOURS,
	DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS,
	DATE_CLOCK_FORMAT_LOCALE_DEFAULT,
	DATE_CLOCK_FORMAT_TOTAL
} DateClockFormat;

#define DATE_TYPE_CLOCK_FORMAT (date_clock_format_get_type ())
typedef enum  {
	DATE_COARSE_DATE_NOW,
	DATE_COARSE_DATE_MINUTES,
	DATE_COARSE_DATE_HOURS,
	DATE_COARSE_DATE_TODAY,
	DATE_COARSE_DATE_YESTERDAY,
	DATE_COARSE_DATE_THIS_WEEK,
	DATE_COARSE_DATE_THIS_YEAR,
	DATE_COARSE_DATE_YEARS,
	DATE_COARSE_DATE_FUTURE
} DateCoarseDate;

#define DATE_TYPE_COARSE_DATE (date_coarse_date_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

extern gint date_init_count;
gint date_init_count = 0;
extern gchar** date_xlat_pretty_dates;
extern gint date_xlat_pretty_dates_length1;
gchar** date_xlat_pretty_dates = NULL;
gint date_xlat_pretty_dates_length1 = 0;
static gint _date_xlat_pretty_dates_size_ = 0;
extern gchar** date_xlat_pretty_verbose_dates;
extern gint date_xlat_pretty_verbose_dates_length1;
gchar** date_xlat_pretty_verbose_dates = NULL;
gint date_xlat_pretty_verbose_dates_length1 = 0;
static gint _date_xlat_pretty_verbose_dates_size_ = 0;
extern gchar* date_xlat_same_year;
gchar* date_xlat_same_year = NULL;
extern gchar* date_xlat_diff_year;
gchar* date_xlat_diff_year = NULL;

GType date_clock_format_get_type (void) G_GNUC_CONST;
gint date_clock_format_to_index (DateClockFormat self);
GType date_coarse_date_get_type (void) G_GNUC_CONST;
void date_init (void);
void date_terminate (void);
gboolean date_same_day (GDateTime* a,
                        GDateTime* b);
DateCoarseDate date_as_coarse_date (GDateTime* datetime,
                                    GDateTime* now,
                                    GTimeSpan diff);
gchar* date_pretty_print_coarse (DateCoarseDate coarse_date,
                                 DateClockFormat clock_format,
                                 GDateTime* datetime,
                                 GTimeSpan diff);
gchar* date_pretty_print (GDateTime* datetime,
                          DateClockFormat clock_format);
gchar* date_pretty_print_verbose (GDateTime* datetime,
                                  DateClockFormat clock_format);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

gint
date_clock_format_to_index (DateClockFormat self)
{
	gint result = 0;
#line 18 "../src/client/util/util-date.vala"
	result = CLAMP ((gint) self, 0, (gint) (DATE_CLOCK_FORMAT_TOTAL - 1));
#line 18 "../src/client/util/util-date.vala"
	return result;
#line 94 "util-date.c"
}

GType
date_clock_format_get_type (void)
{
	static volatile gsize date_clock_format_type_id__volatile = 0;
	if (g_once_init_enter (&date_clock_format_type_id__volatile)) {
		static const GEnumValue values[] = {{DATE_CLOCK_FORMAT_TWELVE_HOURS, "DATE_CLOCK_FORMAT_TWELVE_HOURS", "twelve-hours"}, {DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS, "DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS", "twenty-four-hours"}, {DATE_CLOCK_FORMAT_LOCALE_DEFAULT, "DATE_CLOCK_FORMAT_LOCALE_DEFAULT", "locale-default"}, {DATE_CLOCK_FORMAT_TOTAL, "DATE_CLOCK_FORMAT_TOTAL", "total"}, {0, NULL, NULL}};
		GType date_clock_format_type_id;
		date_clock_format_type_id = g_enum_register_static ("DateClockFormat", values);
		g_once_init_leave (&date_clock_format_type_id__volatile, date_clock_format_type_id);
	}
	return date_clock_format_type_id__volatile;
}

GType
date_coarse_date_get_type (void)
{
	static volatile gsize date_coarse_date_type_id__volatile = 0;
	if (g_once_init_enter (&date_coarse_date_type_id__volatile)) {
		static const GEnumValue values[] = {{DATE_COARSE_DATE_NOW, "DATE_COARSE_DATE_NOW", "now"}, {DATE_COARSE_DATE_MINUTES, "DATE_COARSE_DATE_MINUTES", "minutes"}, {DATE_COARSE_DATE_HOURS, "DATE_COARSE_DATE_HOURS", "hours"}, {DATE_COARSE_DATE_TODAY, "DATE_COARSE_DATE_TODAY", "today"}, {DATE_COARSE_DATE_YESTERDAY, "DATE_COARSE_DATE_YESTERDAY", "yesterday"}, {DATE_COARSE_DATE_THIS_WEEK, "DATE_COARSE_DATE_THIS_WEEK", "this-week"}, {DATE_COARSE_DATE_THIS_YEAR, "DATE_COARSE_DATE_THIS_YEAR", "this-year"}, {DATE_COARSE_DATE_YEARS, "DATE_COARSE_DATE_YEARS", "years"}, {DATE_COARSE_DATE_FUTURE, "DATE_COARSE_DATE_FUTURE", "future"}, {0, NULL, NULL}};
		GType date_coarse_date_type_id;
		date_coarse_date_type_id = g_enum_register_static ("DateCoarseDate", values);
		g_once_init_leave (&date_coarse_date_type_id__volatile, date_coarse_date_type_id);
	}
	return date_coarse_date_type_id__volatile;
}

void
date_init (void)
{
	gint _tmp0_;
	gchar* messages_locale = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* time_locale = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* language_env = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp28_;
#line 42 "../src/client/util/util-date.vala"
	_tmp0_ = date_init_count;
#line 42 "../src/client/util/util-date.vala"
	date_init_count = _tmp0_ + 1;
#line 42 "../src/client/util/util-date.vala"
	if (_tmp0_ != 0) {
#line 43 "../src/client/util/util-date.vala"
		return;
#line 170 "util-date.c"
	}
#line 52 "../src/client/util/util-date.vala"
	_tmp1_ = setlocale (LC_MESSAGES, NULL);
#line 52 "../src/client/util/util-date.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 52 "../src/client/util/util-date.vala"
	messages_locale = _tmp2_;
#line 53 "../src/client/util/util-date.vala"
	_tmp3_ = setlocale (LC_TIME, NULL);
#line 53 "../src/client/util/util-date.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 53 "../src/client/util/util-date.vala"
	time_locale = _tmp4_;
#line 56 "../src/client/util/util-date.vala"
	_tmp5_ = g_getenv ("LANGUAGE");
#line 56 "../src/client/util/util-date.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 56 "../src/client/util/util-date.vala"
	language_env = _tmp6_;
#line 57 "../src/client/util/util-date.vala"
	_tmp7_ = language_env;
#line 57 "../src/client/util/util-date.vala"
	if (_tmp7_ != NULL) {
#line 58 "../src/client/util/util-date.vala"
		g_unsetenv ("LANGUAGE");
#line 196 "util-date.c"
	}
#line 62 "../src/client/util/util-date.vala"
	_tmp8_ = time_locale;
#line 62 "../src/client/util/util-date.vala"
	if (_tmp8_ != NULL) {
#line 202 "util-date.c"
		const gchar* _tmp9_;
#line 63 "../src/client/util/util-date.vala"
		_tmp9_ = time_locale;
#line 63 "../src/client/util/util-date.vala"
		setlocale (LC_MESSAGES, _tmp9_);
#line 208 "util-date.c"
	}
#line 65 "../src/client/util/util-date.vala"
	_tmp10_ = g_new0 (gchar*, DATE_CLOCK_FORMAT_TOTAL + 1);
#line 65 "../src/client/util/util-date.vala"
	date_xlat_pretty_dates = (_vala_array_free (date_xlat_pretty_dates, date_xlat_pretty_dates_length1, (GDestroyNotify) g_free), NULL);
#line 65 "../src/client/util/util-date.vala"
	date_xlat_pretty_dates = _tmp10_;
#line 65 "../src/client/util/util-date.vala"
	date_xlat_pretty_dates_length1 = DATE_CLOCK_FORMAT_TOTAL;
#line 65 "../src/client/util/util-date.vala"
	_date_xlat_pretty_dates_size_ = date_xlat_pretty_dates_length1;
#line 68 "../src/client/util/util-date.vala"
	_tmp11_ = date_xlat_pretty_dates;
#line 68 "../src/client/util/util-date.vala"
	_tmp11__length1 = date_xlat_pretty_dates_length1;
#line 68 "../src/client/util/util-date.vala"
	_tmp12_ = g_strdup (_ ("%l:%M %P"));
#line 68 "../src/client/util/util-date.vala"
	_g_free0 (_tmp11_[DATE_CLOCK_FORMAT_TWELVE_HOURS]);
#line 68 "../src/client/util/util-date.vala"
	_tmp11_[DATE_CLOCK_FORMAT_TWELVE_HOURS] = _tmp12_;
#line 71 "../src/client/util/util-date.vala"
	_tmp13_ = date_xlat_pretty_dates;
#line 71 "../src/client/util/util-date.vala"
	_tmp13__length1 = date_xlat_pretty_dates_length1;
#line 71 "../src/client/util/util-date.vala"
	_tmp14_ = g_strdup (_ ("%H:%M"));
#line 71 "../src/client/util/util-date.vala"
	_g_free0 (_tmp13_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS]);
#line 71 "../src/client/util/util-date.vala"
	_tmp13_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS] = _tmp14_;
#line 74 "../src/client/util/util-date.vala"
	_tmp15_ = date_xlat_pretty_dates;
#line 74 "../src/client/util/util-date.vala"
	_tmp15__length1 = date_xlat_pretty_dates_length1;
#line 74 "../src/client/util/util-date.vala"
	_tmp16_ = g_strdup (C_ ("Default clock format", "%l:%M %P"));
#line 74 "../src/client/util/util-date.vala"
	_g_free0 (_tmp15_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT]);
#line 74 "../src/client/util/util-date.vala"
	_tmp15_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT] = _tmp16_;
#line 78 "../src/client/util/util-date.vala"
	_tmp17_ = g_strdup (_ ("%b %-e"));
#line 78 "../src/client/util/util-date.vala"
	_g_free0 (date_xlat_same_year);
#line 78 "../src/client/util/util-date.vala"
	date_xlat_same_year = _tmp17_;
#line 83 "../src/client/util/util-date.vala"
	_tmp18_ = g_strdup (_ ("%x"));
#line 83 "../src/client/util/util-date.vala"
	_g_free0 (date_xlat_diff_year);
#line 83 "../src/client/util/util-date.vala"
	date_xlat_diff_year = _tmp18_;
#line 85 "../src/client/util/util-date.vala"
	_tmp19_ = g_new0 (gchar*, DATE_CLOCK_FORMAT_TOTAL + 1);
#line 85 "../src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates = (_vala_array_free (date_xlat_pretty_verbose_dates, date_xlat_pretty_verbose_dates_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates = _tmp19_;
#line 85 "../src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates_length1 = DATE_CLOCK_FORMAT_TOTAL;
#line 85 "../src/client/util/util-date.vala"
	_date_xlat_pretty_verbose_dates_size_ = date_xlat_pretty_verbose_dates_length1;
#line 88 "../src/client/util/util-date.vala"
	_tmp20_ = date_xlat_pretty_verbose_dates;
#line 88 "../src/client/util/util-date.vala"
	_tmp20__length1 = date_xlat_pretty_verbose_dates_length1;
#line 88 "../src/client/util/util-date.vala"
	_tmp21_ = g_strdup (_ ("%B %-e, %Y %-l:%M %P"));
#line 88 "../src/client/util/util-date.vala"
	_g_free0 (_tmp20_[DATE_CLOCK_FORMAT_TWELVE_HOURS]);
#line 88 "../src/client/util/util-date.vala"
	_tmp20_[DATE_CLOCK_FORMAT_TWELVE_HOURS] = _tmp21_;
#line 91 "../src/client/util/util-date.vala"
	_tmp22_ = date_xlat_pretty_verbose_dates;
#line 91 "../src/client/util/util-date.vala"
	_tmp22__length1 = date_xlat_pretty_verbose_dates_length1;
#line 91 "../src/client/util/util-date.vala"
	_tmp23_ = g_strdup (_ ("%B %-e, %Y %-H:%M"));
#line 91 "../src/client/util/util-date.vala"
	_g_free0 (_tmp22_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS]);
#line 91 "../src/client/util/util-date.vala"
	_tmp22_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS] = _tmp23_;
#line 94 "../src/client/util/util-date.vala"
	_tmp24_ = date_xlat_pretty_verbose_dates;
#line 94 "../src/client/util/util-date.vala"
	_tmp24__length1 = date_xlat_pretty_verbose_dates_length1;
#line 94 "../src/client/util/util-date.vala"
	_tmp25_ = g_strdup (C_ ("Default full date", "%B %-e, %Y %-l:%M %P"));
#line 94 "../src/client/util/util-date.vala"
	_g_free0 (_tmp24_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT]);
#line 94 "../src/client/util/util-date.vala"
	_tmp24_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT] = _tmp25_;
#line 97 "../src/client/util/util-date.vala"
	_tmp26_ = messages_locale;
#line 97 "../src/client/util/util-date.vala"
	if (_tmp26_ != NULL) {
#line 306 "util-date.c"
		const gchar* _tmp27_;
#line 98 "../src/client/util/util-date.vala"
		_tmp27_ = messages_locale;
#line 98 "../src/client/util/util-date.vala"
		setlocale (LC_MESSAGES, _tmp27_);
#line 312 "util-date.c"
	}
#line 99 "../src/client/util/util-date.vala"
	_tmp28_ = language_env;
#line 99 "../src/client/util/util-date.vala"
	if (_tmp28_ != NULL) {
#line 318 "util-date.c"
		const gchar* _tmp29_;
#line 100 "../src/client/util/util-date.vala"
		_tmp29_ = language_env;
#line 100 "../src/client/util/util-date.vala"
		g_setenv ("LANGUAGE", _tmp29_, TRUE);
#line 324 "util-date.c"
	}
#line 41 "../src/client/util/util-date.vala"
	_g_free0 (language_env);
#line 41 "../src/client/util/util-date.vala"
	_g_free0 (time_locale);
#line 41 "../src/client/util/util-date.vala"
	_g_free0 (messages_locale);
#line 332 "util-date.c"
}

void
date_terminate (void)
{
#line 105 "../src/client/util/util-date.vala"
	date_init_count = date_init_count - 1;
#line 105 "../src/client/util/util-date.vala"
	if (date_init_count != 0) {
#line 106 "../src/client/util/util-date.vala"
		return;
#line 344 "util-date.c"
	}
#line 108 "../src/client/util/util-date.vala"
	date_xlat_pretty_dates = (_vala_array_free (date_xlat_pretty_dates, date_xlat_pretty_dates_length1, (GDestroyNotify) g_free), NULL);
#line 108 "../src/client/util/util-date.vala"
	date_xlat_pretty_dates = NULL;
#line 108 "../src/client/util/util-date.vala"
	date_xlat_pretty_dates_length1 = 0;
#line 108 "../src/client/util/util-date.vala"
	_date_xlat_pretty_dates_size_ = date_xlat_pretty_dates_length1;
#line 109 "../src/client/util/util-date.vala"
	_g_free0 (date_xlat_same_year);
#line 109 "../src/client/util/util-date.vala"
	date_xlat_same_year = NULL;
#line 110 "../src/client/util/util-date.vala"
	_g_free0 (date_xlat_diff_year);
#line 110 "../src/client/util/util-date.vala"
	date_xlat_diff_year = NULL;
#line 111 "../src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates = (_vala_array_free (date_xlat_pretty_verbose_dates, date_xlat_pretty_verbose_dates_length1, (GDestroyNotify) g_free), NULL);
#line 111 "../src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates = NULL;
#line 111 "../src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates_length1 = 0;
#line 111 "../src/client/util/util-date.vala"
	_date_xlat_pretty_verbose_dates_size_ = date_xlat_pretty_verbose_dates_length1;
#line 370 "util-date.c"
}

gboolean
date_same_day (GDateTime* a,
               GDateTime* b)
{
	gboolean result = FALSE;
	gint year1 = 0;
	gint month1 = 0;
	gint day1 = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint year2 = 0;
	gint month2 = 0;
	gint day2 = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 114 "../src/client/util/util-date.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 114 "../src/client/util/util-date.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 116 "../src/client/util/util-date.vala"
	g_date_time_get_ymd (a, &_tmp0_, &_tmp1_, &_tmp2_);
#line 116 "../src/client/util/util-date.vala"
	year1 = _tmp0_;
#line 116 "../src/client/util/util-date.vala"
	month1 = _tmp1_;
#line 116 "../src/client/util/util-date.vala"
	day1 = _tmp2_;
#line 119 "../src/client/util/util-date.vala"
	g_date_time_get_ymd (b, &_tmp3_, &_tmp4_, &_tmp5_);
#line 119 "../src/client/util/util-date.vala"
	year2 = _tmp3_;
#line 119 "../src/client/util/util-date.vala"
	month2 = _tmp4_;
#line 119 "../src/client/util/util-date.vala"
	day2 = _tmp5_;
#line 121 "../src/client/util/util-date.vala"
	if (year1 == year2) {
#line 121 "../src/client/util/util-date.vala"
		_tmp7_ = month1 == month2;
#line 416 "util-date.c"
	} else {
#line 121 "../src/client/util/util-date.vala"
		_tmp7_ = FALSE;
#line 420 "util-date.c"
	}
#line 121 "../src/client/util/util-date.vala"
	if (_tmp7_) {
#line 121 "../src/client/util/util-date.vala"
		_tmp6_ = day1 == day2;
#line 426 "util-date.c"
	} else {
#line 121 "../src/client/util/util-date.vala"
		_tmp6_ = FALSE;
#line 430 "util-date.c"
	}
#line 121 "../src/client/util/util-date.vala"
	result = _tmp6_;
#line 121 "../src/client/util/util-date.vala"
	return result;
#line 436 "util-date.c"
}

DateCoarseDate
date_as_coarse_date (GDateTime* datetime,
                     GDateTime* now,
                     GTimeSpan diff)
{
	DateCoarseDate result = 0;
#line 126 "../src/client/util/util-date.vala"
	g_return_val_if_fail (datetime != NULL, 0);
#line 126 "../src/client/util/util-date.vala"
	g_return_val_if_fail (now != NULL, 0);
#line 127 "../src/client/util/util-date.vala"
	if (date_same_day (datetime, now)) {
#line 128 "../src/client/util/util-date.vala"
		if (diff < G_TIME_SPAN_MINUTE) {
#line 129 "../src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_NOW;
#line 129 "../src/client/util/util-date.vala"
			return result;
#line 457 "util-date.c"
		}
#line 131 "../src/client/util/util-date.vala"
		if (diff < G_TIME_SPAN_HOUR) {
#line 132 "../src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_MINUTES;
#line 132 "../src/client/util/util-date.vala"
			return result;
#line 465 "util-date.c"
		}
#line 134 "../src/client/util/util-date.vala"
		if (diff < (12 * G_TIME_SPAN_HOUR)) {
#line 135 "../src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_HOURS;
#line 135 "../src/client/util/util-date.vala"
			return result;
#line 473 "util-date.c"
		}
#line 137 "../src/client/util/util-date.vala"
		result = DATE_COARSE_DATE_TODAY;
#line 137 "../src/client/util/util-date.vala"
		return result;
#line 479 "util-date.c"
	} else {
		GDateTime* temp = NULL;
		GDateTime* _tmp0_;
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GDateTime* _tmp4_;
#line 139 "../src/client/util/util-date.vala"
		if (g_date_time_compare (datetime, now) > 0) {
#line 140 "../src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_FUTURE;
#line 140 "../src/client/util/util-date.vala"
			return result;
#line 493 "util-date.c"
		}
#line 143 "../src/client/util/util-date.vala"
		_tmp0_ = g_date_time_add_days (datetime, 1);
#line 143 "../src/client/util/util-date.vala"
		_g_date_time_unref0 (temp);
#line 143 "../src/client/util/util-date.vala"
		temp = _tmp0_;
#line 144 "../src/client/util/util-date.vala"
		_tmp1_ = temp;
#line 144 "../src/client/util/util-date.vala"
		if (date_same_day (_tmp1_, now)) {
#line 145 "../src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_YESTERDAY;
#line 145 "../src/client/util/util-date.vala"
			_g_date_time_unref0 (temp);
#line 145 "../src/client/util/util-date.vala"
			return result;
#line 511 "util-date.c"
		}
#line 147 "../src/client/util/util-date.vala"
		_tmp2_ = g_date_time_add_days (datetime, 6);
#line 147 "../src/client/util/util-date.vala"
		_g_date_time_unref0 (temp);
#line 147 "../src/client/util/util-date.vala"
		temp = _tmp2_;
#line 148 "../src/client/util/util-date.vala"
		_tmp4_ = temp;
#line 148 "../src/client/util/util-date.vala"
		if (date_same_day (_tmp4_, now)) {
#line 148 "../src/client/util/util-date.vala"
			_tmp3_ = TRUE;
#line 525 "util-date.c"
		} else {
			GDateTime* _tmp5_;
#line 148 "../src/client/util/util-date.vala"
			_tmp5_ = temp;
#line 148 "../src/client/util/util-date.vala"
			_tmp3_ = g_date_time_compare (_tmp5_, now) >= 0;
#line 532 "util-date.c"
		}
#line 148 "../src/client/util/util-date.vala"
		if (_tmp3_) {
#line 149 "../src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_THIS_WEEK;
#line 149 "../src/client/util/util-date.vala"
			_g_date_time_unref0 (temp);
#line 149 "../src/client/util/util-date.vala"
			return result;
#line 542 "util-date.c"
		}
#line 151 "../src/client/util/util-date.vala"
		if (g_date_time_get_year (datetime) == g_date_time_get_year (now)) {
#line 152 "../src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_THIS_YEAR;
#line 152 "../src/client/util/util-date.vala"
			_g_date_time_unref0 (temp);
#line 152 "../src/client/util/util-date.vala"
			return result;
#line 552 "util-date.c"
		} else {
#line 154 "../src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_YEARS;
#line 154 "../src/client/util/util-date.vala"
			_g_date_time_unref0 (temp);
#line 154 "../src/client/util/util-date.vala"
			return result;
#line 560 "util-date.c"
		}
#line 127 "../src/client/util/util-date.vala"
		_g_date_time_unref0 (temp);
#line 564 "util-date.c"
	}
}

gchar*
date_pretty_print_coarse (DateCoarseDate coarse_date,
                          DateClockFormat clock_format,
                          GDateTime* datetime,
                          GTimeSpan diff)
{
	gchar* result = NULL;
	gchar* fmt = NULL;
	const gchar* _tmp12_;
	gchar* _tmp13_;
#line 160 "../src/client/util/util-date.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 162 "../src/client/util/util-date.vala"
	switch (coarse_date) {
#line 162 "../src/client/util/util-date.vala"
		case DATE_COARSE_DATE_NOW:
#line 584 "util-date.c"
		{
			gchar* _tmp0_;
#line 164 "../src/client/util/util-date.vala"
			_tmp0_ = g_strdup (_ ("Now"));
#line 164 "../src/client/util/util-date.vala"
			result = _tmp0_;
#line 164 "../src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 164 "../src/client/util/util-date.vala"
			return result;
#line 595 "util-date.c"
		}
#line 162 "../src/client/util/util-date.vala"
		case DATE_COARSE_DATE_MINUTES:
#line 599 "util-date.c"
		{
			gchar* _tmp1_;
#line 167 "../src/client/util/util-date.vala"
			_tmp1_ = g_strdup_printf (ngettext ("%dm ago", "%dm ago", (gulong) (diff / G_TIME_SPAN_MINUTE)), (gint) (diff / G_TIME_SPAN_MINUTE));
#line 167 "../src/client/util/util-date.vala"
			result = _tmp1_;
#line 167 "../src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 167 "../src/client/util/util-date.vala"
			return result;
#line 610 "util-date.c"
		}
#line 162 "../src/client/util/util-date.vala"
		case DATE_COARSE_DATE_HOURS:
#line 614 "util-date.c"
		{
			gint rounded = 0;
			gchar* _tmp2_;
#line 170 "../src/client/util/util-date.vala"
			rounded = (gint) round (((gdouble) diff) / G_TIME_SPAN_HOUR);
#line 171 "../src/client/util/util-date.vala"
			_tmp2_ = g_strdup_printf (ngettext ("%dh ago", "%dh ago", (gulong) rounded), rounded);
#line 171 "../src/client/util/util-date.vala"
			result = _tmp2_;
#line 171 "../src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 171 "../src/client/util/util-date.vala"
			return result;
#line 628 "util-date.c"
		}
#line 162 "../src/client/util/util-date.vala"
		case DATE_COARSE_DATE_TODAY:
#line 632 "util-date.c"
		{
			gchar** _tmp3_;
			gint _tmp3__length1;
			const gchar* _tmp4_;
			gchar* _tmp5_;
#line 174 "../src/client/util/util-date.vala"
			_tmp3_ = date_xlat_pretty_dates;
#line 174 "../src/client/util/util-date.vala"
			_tmp3__length1 = date_xlat_pretty_dates_length1;
#line 174 "../src/client/util/util-date.vala"
			_tmp4_ = _tmp3_[date_clock_format_to_index (clock_format)];
#line 174 "../src/client/util/util-date.vala"
			_tmp5_ = g_strdup (_tmp4_);
#line 174 "../src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 174 "../src/client/util/util-date.vala"
			fmt = _tmp5_;
#line 175 "../src/client/util/util-date.vala"
			break;
#line 652 "util-date.c"
		}
#line 162 "../src/client/util/util-date.vala"
		case DATE_COARSE_DATE_YESTERDAY:
#line 656 "util-date.c"
		{
			gchar* _tmp6_;
#line 178 "../src/client/util/util-date.vala"
			_tmp6_ = g_strdup (_ ("Yesterday"));
#line 178 "../src/client/util/util-date.vala"
			result = _tmp6_;
#line 178 "../src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 178 "../src/client/util/util-date.vala"
			return result;
#line 667 "util-date.c"
		}
#line 162 "../src/client/util/util-date.vala"
		case DATE_COARSE_DATE_THIS_WEEK:
#line 671 "util-date.c"
		{
			gchar* _tmp7_;
#line 183 "../src/client/util/util-date.vala"
			_tmp7_ = g_strdup (_ ("%A"));
#line 183 "../src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 183 "../src/client/util/util-date.vala"
			fmt = _tmp7_;
#line 184 "../src/client/util/util-date.vala"
			break;
#line 682 "util-date.c"
		}
#line 162 "../src/client/util/util-date.vala"
		case DATE_COARSE_DATE_THIS_YEAR:
#line 686 "util-date.c"
		{
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 187 "../src/client/util/util-date.vala"
			_tmp8_ = date_xlat_same_year;
#line 187 "../src/client/util/util-date.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 187 "../src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 187 "../src/client/util/util-date.vala"
			fmt = _tmp9_;
#line 188 "../src/client/util/util-date.vala"
			break;
#line 700 "util-date.c"
		}
		default:
#line 162 "../src/client/util/util-date.vala"
		case DATE_COARSE_DATE_YEARS:
#line 162 "../src/client/util/util-date.vala"
		case DATE_COARSE_DATE_FUTURE:
#line 707 "util-date.c"
		{
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 193 "../src/client/util/util-date.vala"
			_tmp10_ = date_xlat_diff_year;
#line 193 "../src/client/util/util-date.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 193 "../src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 193 "../src/client/util/util-date.vala"
			fmt = _tmp11_;
#line 194 "../src/client/util/util-date.vala"
			break;
#line 721 "util-date.c"
		}
	}
#line 197 "../src/client/util/util-date.vala"
	_tmp12_ = fmt;
#line 197 "../src/client/util/util-date.vala"
	_tmp13_ = g_date_time_format (datetime, _tmp12_);
#line 197 "../src/client/util/util-date.vala"
	result = _tmp13_;
#line 197 "../src/client/util/util-date.vala"
	_g_free0 (fmt);
#line 197 "../src/client/util/util-date.vala"
	return result;
#line 734 "util-date.c"
}

gchar*
date_pretty_print (GDateTime* datetime,
                   DateClockFormat clock_format)
{
	gchar* result = NULL;
	GDateTime* to_local = NULL;
	GDateTime* _tmp0_;
	GDateTime* now = NULL;
	GDateTime* _tmp1_;
	GTimeSpan diff = 0LL;
	gchar* _tmp2_;
#line 200 "../src/client/util/util-date.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 201 "../src/client/util/util-date.vala"
	_tmp0_ = g_date_time_to_local (datetime);
#line 201 "../src/client/util/util-date.vala"
	to_local = _tmp0_;
#line 202 "../src/client/util/util-date.vala"
	_tmp1_ = g_date_time_new_now_local ();
#line 202 "../src/client/util/util-date.vala"
	now = _tmp1_;
#line 203 "../src/client/util/util-date.vala"
	diff = g_date_time_difference (now, to_local);
#line 205 "../src/client/util/util-date.vala"
	_tmp2_ = date_pretty_print_coarse (date_as_coarse_date (to_local, now, diff), clock_format, to_local, diff);
#line 205 "../src/client/util/util-date.vala"
	result = _tmp2_;
#line 205 "../src/client/util/util-date.vala"
	_g_date_time_unref0 (now);
#line 205 "../src/client/util/util-date.vala"
	_g_date_time_unref0 (to_local);
#line 205 "../src/client/util/util-date.vala"
	return result;
#line 770 "util-date.c"
}

gchar*
date_pretty_print_verbose (GDateTime* datetime,
                           DateClockFormat clock_format)
{
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 208 "../src/client/util/util-date.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 209 "../src/client/util/util-date.vala"
	_tmp0_ = date_xlat_pretty_verbose_dates;
#line 209 "../src/client/util/util-date.vala"
	_tmp0__length1 = date_xlat_pretty_verbose_dates_length1;
#line 209 "../src/client/util/util-date.vala"
	_tmp1_ = _tmp0_[date_clock_format_to_index (clock_format)];
#line 209 "../src/client/util/util-date.vala"
	_tmp2_ = g_date_time_format (datetime, _tmp1_);
#line 209 "../src/client/util/util-date.vala"
	result = _tmp2_;
#line 209 "../src/client/util/util-date.vala"
	return result;
#line 796 "util-date.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
#line 8 "../src/client/notification/libnotify.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 806 "util-date.c"
		int i;
#line 8 "../src/client/notification/libnotify.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 8 "../src/client/notification/libnotify.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 8 "../src/client/notification/libnotify.vala"
				destroy_func (((gpointer*) array)[i]);
#line 814 "util-date.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
#line 8 "../src/client/notification/libnotify.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 8 "../src/client/notification/libnotify.vala"
	g_free (array);
#line 829 "util-date.c"
}

