/* util-email.c generated by valac 0.44.1, the Vala compiler
 * generated from util-email.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

gint util_email_compare_conversation_ascending (GearyAppConversation* a,
                                                GearyAppConversation* b);
gint util_email_compare_conversation_descending (GearyAppConversation* a,
                                                 GearyAppConversation* b);
gchar* util_email_strip_subject_prefixes (GearyEmail* email);
GearyRFC822MailboxAddress* util_email_get_primary_originator (GearyEmailHeaderSet* email);
gchar* util_email_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

gint
util_email_compare_conversation_ascending (GearyAppConversation* a,
                                           GearyAppConversation* b)
{
	gint result = 0;
	GearyEmail* a_latest = NULL;
	GearyEmail* _tmp0_;
	GearyEmail* b_latest = NULL;
	GearyEmail* _tmp1_;
	GearyEmail* _tmp2_;
	GearyEmail* _tmp6_;
	GearyEmail* _tmp7_;
#line 9 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (a), 0);
#line 9 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (b), 0);
#line 11 "../src/client/util/util-email.vala"
	_tmp0_ = geary_app_conversation_get_latest_recv_email (a, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
#line 11 "../src/client/util/util-email.vala"
	a_latest = _tmp0_;
#line 14 "../src/client/util/util-email.vala"
	_tmp1_ = geary_app_conversation_get_latest_recv_email (b, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
#line 14 "../src/client/util/util-email.vala"
	b_latest = _tmp1_;
#line 18 "../src/client/util/util-email.vala"
	_tmp2_ = a_latest;
#line 18 "../src/client/util/util-email.vala"
	if (_tmp2_ == NULL) {
#line 63 "util-email.c"
		gint _tmp3_ = 0;
		GearyEmail* _tmp4_;
#line 19 "../src/client/util/util-email.vala"
		_tmp4_ = b_latest;
#line 19 "../src/client/util/util-email.vala"
		if (_tmp4_ == NULL) {
#line 19 "../src/client/util/util-email.vala"
			_tmp3_ = 0;
#line 72 "util-email.c"
		} else {
#line 19 "../src/client/util/util-email.vala"
			_tmp3_ = -1;
#line 76 "util-email.c"
		}
#line 19 "../src/client/util/util-email.vala"
		result = _tmp3_;
#line 19 "../src/client/util/util-email.vala"
		_g_object_unref0 (b_latest);
#line 19 "../src/client/util/util-email.vala"
		_g_object_unref0 (a_latest);
#line 19 "../src/client/util/util-email.vala"
		return result;
#line 86 "util-email.c"
	} else {
		GearyEmail* _tmp5_;
#line 20 "../src/client/util/util-email.vala"
		_tmp5_ = b_latest;
#line 20 "../src/client/util/util-email.vala"
		if (_tmp5_ == NULL) {
#line 21 "../src/client/util/util-email.vala"
			result = 1;
#line 21 "../src/client/util/util-email.vala"
			_g_object_unref0 (b_latest);
#line 21 "../src/client/util/util-email.vala"
			_g_object_unref0 (a_latest);
#line 21 "../src/client/util/util-email.vala"
			return result;
#line 101 "util-email.c"
		}
	}
#line 27 "../src/client/util/util-email.vala"
	_tmp6_ = a_latest;
#line 27 "../src/client/util/util-email.vala"
	_tmp7_ = b_latest;
#line 27 "../src/client/util/util-email.vala"
	result = geary_email_compare_recv_date_ascending (_tmp6_, _tmp7_);
#line 27 "../src/client/util/util-email.vala"
	_g_object_unref0 (b_latest);
#line 27 "../src/client/util/util-email.vala"
	_g_object_unref0 (a_latest);
#line 27 "../src/client/util/util-email.vala"
	return result;
#line 116 "util-email.c"
}

gint
util_email_compare_conversation_descending (GearyAppConversation* a,
                                            GearyAppConversation* b)
{
	gint result = 0;
#line 30 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (a), 0);
#line 30 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (b), 0);
#line 32 "../src/client/util/util-email.vala"
	result = util_email_compare_conversation_ascending (b, a);
#line 32 "../src/client/util/util-email.vala"
	return result;
#line 132 "util-email.c"
}

/** Returns the stripped subject line, or a placeholder if none. */
gchar*
util_email_strip_subject_prefixes (GearyEmail* email)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	GearyRFC822Subject* _tmp1_;
	GearyRFC822Subject* _tmp2_;
	gchar* cleaned = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp10_;
#line 36 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (email), NULL);
#line 37 "../src/client/util/util-email.vala"
	_tmp1_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 37 "../src/client/util/util-email.vala"
	_tmp2_ = _tmp1_;
#line 37 "../src/client/util/util-email.vala"
	if (_tmp2_ != NULL) {
#line 156 "util-email.c"
		GearyRFC822Subject* _tmp3_;
		GearyRFC822Subject* _tmp4_;
		gchar* _tmp5_;
#line 37 "../src/client/util/util-email.vala"
		_tmp3_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 37 "../src/client/util/util-email.vala"
		_tmp4_ = _tmp3_;
#line 37 "../src/client/util/util-email.vala"
		_tmp5_ = geary_rf_c822_subject_strip_prefixes (_tmp4_);
#line 37 "../src/client/util/util-email.vala"
		_g_free0 (_tmp0_);
#line 37 "../src/client/util/util-email.vala"
		_tmp0_ = _tmp5_;
#line 170 "util-email.c"
	} else {
#line 37 "../src/client/util/util-email.vala"
		_g_free0 (_tmp0_);
#line 37 "../src/client/util/util-email.vala"
		_tmp0_ = NULL;
#line 176 "util-email.c"
	}
#line 37 "../src/client/util/util-email.vala"
	_tmp6_ = g_strdup (_tmp0_);
#line 37 "../src/client/util/util-email.vala"
	cleaned = _tmp6_;
#line 38 "../src/client/util/util-email.vala"
	_tmp8_ = cleaned;
#line 38 "../src/client/util/util-email.vala"
	if (!geary_string_is_empty (_tmp8_)) {
#line 186 "util-email.c"
		const gchar* _tmp9_;
#line 38 "../src/client/util/util-email.vala"
		_tmp9_ = cleaned;
#line 38 "../src/client/util/util-email.vala"
		_tmp7_ = _tmp9_;
#line 192 "util-email.c"
	} else {
#line 38 "../src/client/util/util-email.vala"
		_tmp7_ = _ ("(no subject)");
#line 196 "util-email.c"
	}
#line 38 "../src/client/util/util-email.vala"
	_tmp10_ = g_strdup (_tmp7_);
#line 38 "../src/client/util/util-email.vala"
	result = _tmp10_;
#line 38 "../src/client/util/util-email.vala"
	_g_free0 (cleaned);
#line 38 "../src/client/util/util-email.vala"
	_g_free0 (_tmp0_);
#line 38 "../src/client/util/util-email.vala"
	return result;
#line 208 "util-email.c"
}

/**
     * Returns a mailbox for the primary originator of an email.
     *
     * RFC 822 allows multiple and absent From header values, and
     * software such as Mailman and GitLab will mangle the names in
     * From mailboxes. This provides a canonical means to obtain a
     * mailbox (that is, name and email address) for the first
     * originator, and with the mailbox's name having been fixed up
     * where possible.
     *
     * The first From mailbox is used and de-mangled if found, if not
     * the Sender mailbox is used if present, else the first Reply-To
     * mailbox is used.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 60 "../src/client/util/util-email.vala"
	return self ? g_object_ref (self) : NULL;
#line 230 "util-email.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 249 "util-email.c"
}

GearyRFC822MailboxAddress*
util_email_get_primary_originator (GearyEmailHeaderSet* email)
{
	GearyRFC822MailboxAddress* result = NULL;
	GearyRFC822MailboxAddress* primary = NULL;
	gboolean _tmp0_ = FALSE;
	GearyRFC822MailboxAddresses* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
#line 55 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL_HEADER_SET (email), NULL);
#line 57 "../src/client/util/util-email.vala"
	primary = NULL;
#line 58 "../src/client/util/util-email.vala"
	_tmp1_ = geary_email_header_set_get_from (email);
#line 58 "../src/client/util/util-email.vala"
	_tmp2_ = _tmp1_;
#line 58 "../src/client/util/util-email.vala"
	if (_tmp2_ != NULL) {
#line 270 "util-email.c"
		GearyRFC822MailboxAddresses* _tmp3_;
		GearyRFC822MailboxAddresses* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 58 "../src/client/util/util-email.vala"
		_tmp3_ = geary_email_header_set_get_from (email);
#line 58 "../src/client/util/util-email.vala"
		_tmp4_ = _tmp3_;
#line 58 "../src/client/util/util-email.vala"
		_tmp5_ = geary_rf_c822_mailbox_addresses_get_size (_tmp4_);
#line 58 "../src/client/util/util-email.vala"
		_tmp6_ = _tmp5_;
#line 58 "../src/client/util/util-email.vala"
		_tmp0_ = _tmp6_ > 0;
#line 285 "util-email.c"
	} else {
#line 58 "../src/client/util/util-email.vala"
		_tmp0_ = FALSE;
#line 289 "util-email.c"
	}
#line 58 "../src/client/util/util-email.vala"
	if (_tmp0_) {
#line 293 "util-email.c"
		GearyRFC822MailboxAddresses* from = NULL;
		GearyRFC822MailboxAddresses* _tmp7_;
		GearyRFC822MailboxAddresses* _tmp8_;
		GearyRFC822MailboxAddresses* _tmp9_;
		gchar* from_name = NULL;
		gchar* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp12_;
		GearyRFC822MailboxAddresses* reply_to = NULL;
		GearyRFC822MailboxAddresses* _tmp23_;
		GearyRFC822MailboxAddresses* _tmp24_;
		GearyRFC822MailboxAddresses* _tmp25_;
		GearyRFC822MailboxAddress* primary_reply_to = NULL;
		gchar* reply_to_name = NULL;
		gchar* _tmp26_;
		gboolean _tmp27_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp28_;
#line 77 "../src/client/util/util-email.vala"
		static const char VIA[] = " via ";
#line 313 "util-email.c"
		gboolean _tmp39_ = FALSE;
		const gchar* _tmp40_;
#line 60 "../src/client/util/util-email.vala"
		_tmp7_ = geary_email_header_set_get_from (email);
#line 60 "../src/client/util/util-email.vala"
		_tmp8_ = _tmp7_;
#line 60 "../src/client/util/util-email.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 60 "../src/client/util/util-email.vala"
		from = _tmp9_;
#line 62 "../src/client/util/util-email.vala"
		_tmp10_ = g_strdup ("");
#line 62 "../src/client/util/util-email.vala"
		from_name = _tmp10_;
#line 63 "../src/client/util/util-email.vala"
		_tmp12_ = from;
#line 63 "../src/client/util/util-email.vala"
		if (_tmp12_ != NULL) {
#line 332 "util-email.c"
			GearyRFC822MailboxAddresses* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 63 "../src/client/util/util-email.vala"
			_tmp13_ = from;
#line 63 "../src/client/util/util-email.vala"
			_tmp14_ = geary_rf_c822_mailbox_addresses_get_size (_tmp13_);
#line 63 "../src/client/util/util-email.vala"
			_tmp15_ = _tmp14_;
#line 63 "../src/client/util/util-email.vala"
			_tmp11_ = _tmp15_ > 0;
#line 344 "util-email.c"
		} else {
#line 63 "../src/client/util/util-email.vala"
			_tmp11_ = FALSE;
#line 348 "util-email.c"
		}
#line 63 "../src/client/util/util-email.vala"
		if (_tmp11_) {
#line 352 "util-email.c"
			GearyRFC822MailboxAddresses* _tmp16_;
			GearyRFC822MailboxAddress* _tmp17_;
			const gchar* _tmp18_ = NULL;
			GearyRFC822MailboxAddress* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 64 "../src/client/util/util-email.vala"
			_tmp16_ = from;
#line 64 "../src/client/util/util-email.vala"
			_tmp17_ = geary_rf_c822_mailbox_addresses_get (_tmp16_, 0);
#line 64 "../src/client/util/util-email.vala"
			_g_object_unref0 (primary);
#line 64 "../src/client/util/util-email.vala"
			primary = _tmp17_;
#line 65 "../src/client/util/util-email.vala"
			_tmp19_ = primary;
#line 65 "../src/client/util/util-email.vala"
			_tmp20_ = geary_rf_c822_mailbox_address_get_name (_tmp19_);
#line 65 "../src/client/util/util-email.vala"
			_tmp21_ = _tmp20_;
#line 65 "../src/client/util/util-email.vala"
			_tmp18_ = _tmp21_;
#line 65 "../src/client/util/util-email.vala"
			if (_tmp18_ == NULL) {
#line 65 "../src/client/util/util-email.vala"
				_tmp18_ = "";
#line 380 "util-email.c"
			}
#line 65 "../src/client/util/util-email.vala"
			_tmp22_ = g_strdup (_tmp18_);
#line 65 "../src/client/util/util-email.vala"
			_g_free0 (from_name);
#line 65 "../src/client/util/util-email.vala"
			from_name = _tmp22_;
#line 388 "util-email.c"
		}
#line 68 "../src/client/util/util-email.vala"
		_tmp23_ = geary_email_header_set_get_reply_to (email);
#line 68 "../src/client/util/util-email.vala"
		_tmp24_ = _tmp23_;
#line 68 "../src/client/util/util-email.vala"
		_tmp25_ = _g_object_ref0 (_tmp24_);
#line 68 "../src/client/util/util-email.vala"
		reply_to = _tmp25_;
#line 69 "../src/client/util/util-email.vala"
		primary_reply_to = NULL;
#line 70 "../src/client/util/util-email.vala"
		_tmp26_ = g_strdup ("");
#line 70 "../src/client/util/util-email.vala"
		reply_to_name = _tmp26_;
#line 71 "../src/client/util/util-email.vala"
		_tmp28_ = reply_to;
#line 71 "../src/client/util/util-email.vala"
		if (_tmp28_ != NULL) {
#line 408 "util-email.c"
			GearyRFC822MailboxAddresses* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
#line 71 "../src/client/util/util-email.vala"
			_tmp29_ = reply_to;
#line 71 "../src/client/util/util-email.vala"
			_tmp30_ = geary_rf_c822_mailbox_addresses_get_size (_tmp29_);
#line 71 "../src/client/util/util-email.vala"
			_tmp31_ = _tmp30_;
#line 71 "../src/client/util/util-email.vala"
			_tmp27_ = _tmp31_ > 0;
#line 420 "util-email.c"
		} else {
#line 71 "../src/client/util/util-email.vala"
			_tmp27_ = FALSE;
#line 424 "util-email.c"
		}
#line 71 "../src/client/util/util-email.vala"
		if (_tmp27_) {
#line 428 "util-email.c"
			GearyRFC822MailboxAddresses* _tmp32_;
			GearyRFC822MailboxAddress* _tmp33_;
			const gchar* _tmp34_ = NULL;
			GearyRFC822MailboxAddress* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
#line 72 "../src/client/util/util-email.vala"
			_tmp32_ = reply_to;
#line 72 "../src/client/util/util-email.vala"
			_tmp33_ = geary_rf_c822_mailbox_addresses_get (_tmp32_, 0);
#line 72 "../src/client/util/util-email.vala"
			_g_object_unref0 (primary_reply_to);
#line 72 "../src/client/util/util-email.vala"
			primary_reply_to = _tmp33_;
#line 73 "../src/client/util/util-email.vala"
			_tmp35_ = primary_reply_to;
#line 73 "../src/client/util/util-email.vala"
			_tmp36_ = geary_rf_c822_mailbox_address_get_name (_tmp35_);
#line 73 "../src/client/util/util-email.vala"
			_tmp37_ = _tmp36_;
#line 73 "../src/client/util/util-email.vala"
			_tmp34_ = _tmp37_;
#line 73 "../src/client/util/util-email.vala"
			if (_tmp34_ == NULL) {
#line 73 "../src/client/util/util-email.vala"
				_tmp34_ = "";
#line 456 "util-email.c"
			}
#line 73 "../src/client/util/util-email.vala"
			_tmp38_ = g_strdup (_tmp34_);
#line 73 "../src/client/util/util-email.vala"
			_g_free0 (reply_to_name);
#line 73 "../src/client/util/util-email.vala"
			reply_to_name = _tmp38_;
#line 464 "util-email.c"
		}
#line 79 "../src/client/util/util-email.vala"
		_tmp40_ = reply_to_name;
#line 79 "../src/client/util/util-email.vala"
		if (g_strcmp0 (_tmp40_, "") != 0) {
#line 470 "util-email.c"
			const gchar* _tmp41_;
			const gchar* _tmp42_;
#line 79 "../src/client/util/util-email.vala"
			_tmp41_ = from_name;
#line 79 "../src/client/util/util-email.vala"
			_tmp42_ = reply_to_name;
#line 79 "../src/client/util/util-email.vala"
			_tmp39_ = g_str_has_prefix (_tmp41_, _tmp42_);
#line 479 "util-email.c"
		} else {
#line 79 "../src/client/util/util-email.vala"
			_tmp39_ = FALSE;
#line 483 "util-email.c"
		}
#line 79 "../src/client/util/util-email.vala"
		if (_tmp39_) {
#line 487 "util-email.c"
			GearyRFC822MailboxAddress* _tmp43_;
			GearyRFC822MailboxAddress* _tmp44_;
#line 82 "../src/client/util/util-email.vala"
			_tmp43_ = primary_reply_to;
#line 82 "../src/client/util/util-email.vala"
			_tmp44_ = _g_object_ref0 (_tmp43_);
#line 82 "../src/client/util/util-email.vala"
			_g_object_unref0 (primary);
#line 82 "../src/client/util/util-email.vala"
			primary = _tmp44_;
#line 498 "util-email.c"
		} else {
			const gchar* _tmp45_;
#line 83 "../src/client/util/util-email.vala"
			_tmp45_ = from_name;
#line 83 "../src/client/util/util-email.vala"
			if (string_contains (_tmp45_, VIA)) {
#line 505 "util-email.c"
				const gchar* _tmp46_;
				gchar** _tmp47_;
				gchar** _tmp48_;
				gchar** _tmp49_;
				gint _tmp49__length1;
				const gchar* _tmp50_;
				GearyRFC822MailboxAddress* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				GearyRFC822MailboxAddress* _tmp54_;
#line 87 "../src/client/util/util-email.vala"
				_tmp46_ = from_name;
#line 87 "../src/client/util/util-email.vala"
				_tmp48_ = _tmp47_ = g_strsplit (_tmp46_, VIA, 2);
#line 87 "../src/client/util/util-email.vala"
				_tmp49_ = _tmp48_;
#line 87 "../src/client/util/util-email.vala"
				_tmp49__length1 = _vala_array_length (_tmp47_);
#line 87 "../src/client/util/util-email.vala"
				_tmp50_ = _tmp49_[0];
#line 87 "../src/client/util/util-email.vala"
				_tmp51_ = primary;
#line 87 "../src/client/util/util-email.vala"
				_tmp52_ = geary_rf_c822_mailbox_address_get_address (_tmp51_);
#line 87 "../src/client/util/util-email.vala"
				_tmp53_ = _tmp52_;
#line 87 "../src/client/util/util-email.vala"
				_tmp54_ = geary_rf_c822_mailbox_address_new (_tmp50_, _tmp53_);
#line 87 "../src/client/util/util-email.vala"
				_g_object_unref0 (primary);
#line 87 "../src/client/util/util-email.vala"
				primary = _tmp54_;
#line 87 "../src/client/util/util-email.vala"
				_tmp49_ = (_vala_array_free (_tmp49_, _tmp49__length1, (GDestroyNotify) g_free), NULL);
#line 540 "util-email.c"
			}
		}
#line 58 "../src/client/util/util-email.vala"
		_g_free0 (reply_to_name);
#line 58 "../src/client/util/util-email.vala"
		_g_object_unref0 (primary_reply_to);
#line 58 "../src/client/util/util-email.vala"
		_g_object_unref0 (reply_to);
#line 58 "../src/client/util/util-email.vala"
		_g_free0 (from_name);
#line 58 "../src/client/util/util-email.vala"
		_g_object_unref0 (from);
#line 553 "util-email.c"
	} else {
		GearyRFC822MailboxAddress* _tmp55_;
		GearyRFC822MailboxAddress* _tmp56_;
#line 91 "../src/client/util/util-email.vala"
		_tmp55_ = geary_email_header_set_get_sender (email);
#line 91 "../src/client/util/util-email.vala"
		_tmp56_ = _tmp55_;
#line 91 "../src/client/util/util-email.vala"
		if (_tmp56_ != NULL) {
#line 563 "util-email.c"
			GearyRFC822MailboxAddress* _tmp57_;
			GearyRFC822MailboxAddress* _tmp58_;
			GearyRFC822MailboxAddress* _tmp59_;
#line 92 "../src/client/util/util-email.vala"
			_tmp57_ = geary_email_header_set_get_sender (email);
#line 92 "../src/client/util/util-email.vala"
			_tmp58_ = _tmp57_;
#line 92 "../src/client/util/util-email.vala"
			_tmp59_ = _g_object_ref0 (_tmp58_);
#line 92 "../src/client/util/util-email.vala"
			_g_object_unref0 (primary);
#line 92 "../src/client/util/util-email.vala"
			primary = _tmp59_;
#line 577 "util-email.c"
		} else {
			gboolean _tmp60_ = FALSE;
			GearyRFC822MailboxAddresses* _tmp61_;
			GearyRFC822MailboxAddresses* _tmp62_;
#line 93 "../src/client/util/util-email.vala"
			_tmp61_ = geary_email_header_set_get_reply_to (email);
#line 93 "../src/client/util/util-email.vala"
			_tmp62_ = _tmp61_;
#line 93 "../src/client/util/util-email.vala"
			if (_tmp62_ != NULL) {
#line 588 "util-email.c"
				GearyRFC822MailboxAddresses* _tmp63_;
				GearyRFC822MailboxAddresses* _tmp64_;
				gint _tmp65_;
				gint _tmp66_;
#line 93 "../src/client/util/util-email.vala"
				_tmp63_ = geary_email_header_set_get_reply_to (email);
#line 93 "../src/client/util/util-email.vala"
				_tmp64_ = _tmp63_;
#line 93 "../src/client/util/util-email.vala"
				_tmp65_ = geary_rf_c822_mailbox_addresses_get_size (_tmp64_);
#line 93 "../src/client/util/util-email.vala"
				_tmp66_ = _tmp65_;
#line 93 "../src/client/util/util-email.vala"
				_tmp60_ = _tmp66_ > 0;
#line 603 "util-email.c"
			} else {
#line 93 "../src/client/util/util-email.vala"
				_tmp60_ = FALSE;
#line 607 "util-email.c"
			}
#line 93 "../src/client/util/util-email.vala"
			if (_tmp60_) {
#line 611 "util-email.c"
				GearyRFC822MailboxAddresses* _tmp67_;
				GearyRFC822MailboxAddresses* _tmp68_;
				GearyRFC822MailboxAddress* _tmp69_;
#line 94 "../src/client/util/util-email.vala"
				_tmp67_ = geary_email_header_set_get_reply_to (email);
#line 94 "../src/client/util/util-email.vala"
				_tmp68_ = _tmp67_;
#line 94 "../src/client/util/util-email.vala"
				_tmp69_ = geary_rf_c822_mailbox_addresses_get (_tmp68_, 0);
#line 94 "../src/client/util/util-email.vala"
				_g_object_unref0 (primary);
#line 94 "../src/client/util/util-email.vala"
				primary = _tmp69_;
#line 625 "util-email.c"
			}
		}
	}
#line 97 "../src/client/util/util-email.vala"
	result = primary;
#line 97 "../src/client/util/util-email.vala"
	return result;
#line 633 "util-email.c"
}

/**
     * Returns a shortened recipient list suitable for display.
     *
     * This is useful in case there are a lot of recipients, or there
     * is little room for the display.
     *
     * @return a string containing at least the first mailbox
     * serialised by {@link MailboxAddress.to_short_display}, if the
     * list contains more mailboxes then an indication of how many
     * additional are present.
     */
gchar*
util_email_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* first_recipient = NULL;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	const gchar* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gchar* _tmp14_;
#line 111 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESSES (mailboxes), NULL);
#line 112 "../src/client/util/util-email.vala"
	_tmp0_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 112 "../src/client/util/util-email.vala"
	_tmp1_ = _tmp0_;
#line 112 "../src/client/util/util-email.vala"
	if (_tmp1_ == 0) {
#line 674 "util-email.c"
		gchar* _tmp2_;
#line 116 "../src/client/util/util-email.vala"
		_tmp2_ = g_strdup (_ ("(No recipients)"));
#line 116 "../src/client/util/util-email.vala"
		result = _tmp2_;
#line 116 "../src/client/util/util-email.vala"
		return result;
#line 682 "util-email.c"
	}
#line 120 "../src/client/util/util-email.vala"
	_tmp3_ = geary_rf_c822_mailbox_addresses_get (mailboxes, 0);
#line 120 "../src/client/util/util-email.vala"
	_tmp4_ = _tmp3_;
#line 120 "../src/client/util/util-email.vala"
	_tmp5_ = geary_rf_c822_mailbox_address_to_short_display (_tmp4_);
#line 120 "../src/client/util/util-email.vala"
	_tmp6_ = _tmp5_;
#line 120 "../src/client/util/util-email.vala"
	_g_object_unref0 (_tmp4_);
#line 120 "../src/client/util/util-email.vala"
	first_recipient = _tmp6_;
#line 121 "../src/client/util/util-email.vala"
	_tmp7_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 121 "../src/client/util/util-email.vala"
	_tmp8_ = _tmp7_;
#line 121 "../src/client/util/util-email.vala"
	if (_tmp8_ == 1) {
#line 122 "../src/client/util/util-email.vala"
		result = first_recipient;
#line 122 "../src/client/util/util-email.vala"
		return result;
#line 706 "util-email.c"
	}
#line 129 "../src/client/util/util-email.vala"
	_tmp9_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 129 "../src/client/util/util-email.vala"
	_tmp10_ = _tmp9_;
#line 129 "../src/client/util/util-email.vala"
	_tmp11_ = first_recipient;
#line 129 "../src/client/util/util-email.vala"
	_tmp12_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 129 "../src/client/util/util-email.vala"
	_tmp13_ = _tmp12_;
#line 129 "../src/client/util/util-email.vala"
	_tmp14_ = g_strdup_printf (ngettext ("%s and %d other", "%s and %d others", (gulong) (_tmp10_ - 1)), _tmp11_, _tmp13_ - 1);
#line 129 "../src/client/util/util-email.vala"
	result = _tmp14_;
#line 129 "../src/client/util/util-email.vala"
	_g_free0 (first_recipient);
#line 129 "../src/client/util/util-email.vala"
	return result;
#line 726 "util-email.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
#line 8 "../src/client/notification/libnotify.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 736 "util-email.c"
		int i;
#line 8 "../src/client/notification/libnotify.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 8 "../src/client/notification/libnotify.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 8 "../src/client/notification/libnotify.vala"
				destroy_func (((gpointer*) array)[i]);
#line 744 "util-email.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
#line 8 "../src/client/notification/libnotify.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 8 "../src/client/notification/libnotify.vala"
	g_free (array);
#line 759 "util-email.c"
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
#line 8 "../src/client/notification/libnotify.vala"
	if (array) {
#line 8 "../src/client/notification/libnotify.vala"
		while (((gpointer*) array)[length]) {
#line 8 "../src/client/notification/libnotify.vala"
			length++;
#line 773 "util-email.c"
		}
	}
#line 8 "../src/client/notification/libnotify.vala"
	return length;
#line 778 "util-email.c"
}

