/* util-gtk.c generated by valac 0.44.1, the Vala compiler
 * generated from util-gtk.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
typedef void (*GtkUtilMenuForeachFunc) (const gchar* label, const gchar* action_name, GVariant* target, GMenu* section, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

void gtk_util_set_source_color_from_string (cairo_t* ctx,
                                            const gchar* spec);
gboolean gtk_util_close_button_at_end (void);
void gtk_util_menu_foreach (GMenu* menu,
                            GtkUtilMenuForeachFunc foreach_func,
                            gpointer foreach_func_target);
gint gtk_util_get_border_box_height (GtkWidget* widget);

/**
 * Given an HTML-style color spec, parses the color and sets it to the source RGB of the Cairo context.
 * (Borrowed from Shotwell.)
 */
void
gtk_util_set_source_color_from_string (cairo_t* ctx,
                                       const gchar* spec)
{
	GdkRGBA rgba = {0};
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
#line 13 "../src/client/util/util-gtk.vala"
	g_return_if_fail (ctx != NULL);
#line 13 "../src/client/util/util-gtk.vala"
	g_return_if_fail (spec != NULL);
#line 14 "../src/client/util/util-gtk.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 15 "../src/client/util/util-gtk.vala"
	if (!gdk_rgba_parse (&rgba, spec)) {
#line 16 "../src/client/util/util-gtk.vala"
		g_error ("util-gtk.vala:16: Can't parse color %s", spec);
#line 54 "util-gtk.c"
	}
#line 17 "../src/client/util/util-gtk.vala"
	_tmp0_ = rgba;
#line 17 "../src/client/util/util-gtk.vala"
	_tmp1_ = rgba;
#line 17 "../src/client/util/util-gtk.vala"
	_tmp2_ = rgba;
#line 17 "../src/client/util/util-gtk.vala"
	cairo_set_source_rgb (ctx, _tmp0_.red, _tmp1_.green, _tmp2_.blue);
#line 64 "util-gtk.c"
}

/**
 * Returns whether the close button is at the end of the headerbar.
 */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 91 "util-gtk.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 99 "util-gtk.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 105 "util-gtk.c"
	}
}

gboolean
gtk_util_close_button_at_end (void)
{
	gboolean result = FALSE;
	gchar* layout = NULL;
	GtkSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean at_end = FALSE;
	const gchar* _tmp3_;
#line 24 "../src/client/util/util-gtk.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 24 "../src/client/util/util-gtk.vala"
	g_object_get (_tmp0_, "gtk-decoration-layout", &_tmp1_, NULL);
#line 24 "../src/client/util/util-gtk.vala"
	_tmp2_ = _tmp1_;
#line 24 "../src/client/util/util-gtk.vala"
	layout = _tmp2_;
#line 25 "../src/client/util/util-gtk.vala"
	at_end = FALSE;
#line 28 "../src/client/util/util-gtk.vala"
	_tmp3_ = layout;
#line 28 "../src/client/util/util-gtk.vala"
	if (_tmp3_ != NULL) {
#line 133 "util-gtk.c"
		gint colon_ind = 0;
		const gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 29 "../src/client/util/util-gtk.vala"
		_tmp4_ = layout;
#line 29 "../src/client/util/util-gtk.vala"
		colon_ind = string_index_of (_tmp4_, ":", 0);
#line 30 "../src/client/util/util-gtk.vala"
		if (colon_ind >= 0) {
#line 143 "util-gtk.c"
			const gchar* _tmp6_;
#line 30 "../src/client/util/util-gtk.vala"
			_tmp6_ = layout;
#line 30 "../src/client/util/util-gtk.vala"
			_tmp5_ = string_index_of (_tmp6_, "close", colon_ind) >= 0;
#line 149 "util-gtk.c"
		} else {
#line 30 "../src/client/util/util-gtk.vala"
			_tmp5_ = FALSE;
#line 153 "util-gtk.c"
		}
#line 30 "../src/client/util/util-gtk.vala"
		at_end = _tmp5_;
#line 157 "util-gtk.c"
	}
#line 32 "../src/client/util/util-gtk.vala"
	result = at_end;
#line 32 "../src/client/util/util-gtk.vala"
	_g_free0 (layout);
#line 32 "../src/client/util/util-gtk.vala"
	return result;
#line 165 "util-gtk.c"
}

/**
 * Allows iterating over a GMenu, without having to handle MenuItems
 * @param menu - The menu to iterate over
 * @param foreach_func - The function which will be called on the attributes of menu's children
 */
void
gtk_util_menu_foreach (GMenu* menu,
                       GtkUtilMenuForeachFunc foreach_func,
                       gpointer foreach_func_target)
{
#line 40 "../src/client/util/util-gtk.vala"
	g_return_if_fail (G_IS_MENU (menu));
#line 180 "util-gtk.c"
	{
		gint i = 0;
#line 41 "../src/client/util/util-gtk.vala"
		i = 0;
#line 185 "util-gtk.c"
		{
			gboolean _tmp0_ = FALSE;
#line 41 "../src/client/util/util-gtk.vala"
			_tmp0_ = TRUE;
#line 41 "../src/client/util/util-gtk.vala"
			while (TRUE) {
#line 192 "util-gtk.c"
				GVariant* label = NULL;
				const GVariantType* _tmp2_;
				GVariant* _tmp3_;
				GVariant* action_name = NULL;
				const GVariantType* _tmp4_;
				GVariant* _tmp5_;
				GVariant* action_target = NULL;
				const GVariantType* _tmp6_;
				GVariant* _tmp7_;
				GMenu* section = NULL;
				GMenuModel* _tmp8_;
				const gchar* _tmp9_ = NULL;
				GVariant* _tmp10_;
				const gchar* _tmp13_ = NULL;
				GVariant* _tmp14_;
				GVariant* _tmp17_;
				GMenu* _tmp18_;
#line 41 "../src/client/util/util-gtk.vala"
				if (!_tmp0_) {
#line 212 "util-gtk.c"
					gint _tmp1_;
#line 41 "../src/client/util/util-gtk.vala"
					_tmp1_ = i;
#line 41 "../src/client/util/util-gtk.vala"
					i = _tmp1_ + 1;
#line 218 "util-gtk.c"
				}
#line 41 "../src/client/util/util-gtk.vala"
				_tmp0_ = FALSE;
#line 41 "../src/client/util/util-gtk.vala"
				if (!(i < g_menu_model_get_n_items (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel)))) {
#line 41 "../src/client/util/util-gtk.vala"
					break;
#line 226 "util-gtk.c"
				}
#line 43 "../src/client/util/util-gtk.vala"
				_tmp2_ = G_VARIANT_TYPE_STRING;
#line 43 "../src/client/util/util-gtk.vala"
				_tmp3_ = g_menu_model_get_item_attribute_value (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_ATTRIBUTE_LABEL, _tmp2_);
#line 43 "../src/client/util/util-gtk.vala"
				label = _tmp3_;
#line 44 "../src/client/util/util-gtk.vala"
				_tmp4_ = G_VARIANT_TYPE_STRING;
#line 44 "../src/client/util/util-gtk.vala"
				_tmp5_ = g_menu_model_get_item_attribute_value (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_ATTRIBUTE_ACTION, _tmp4_);
#line 44 "../src/client/util/util-gtk.vala"
				action_name = _tmp5_;
#line 45 "../src/client/util/util-gtk.vala"
				_tmp6_ = G_VARIANT_TYPE_STRING;
#line 45 "../src/client/util/util-gtk.vala"
				_tmp7_ = g_menu_model_get_item_attribute_value (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_ATTRIBUTE_TARGET, _tmp6_);
#line 45 "../src/client/util/util-gtk.vala"
				action_target = _tmp7_;
#line 48 "../src/client/util/util-gtk.vala"
				_tmp8_ = g_menu_model_get_item_link (G_TYPE_CHECK_INSTANCE_CAST (menu, g_menu_model_get_type (), GMenuModel), i, G_MENU_LINK_SECTION);
#line 48 "../src/client/util/util-gtk.vala"
				section = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_menu_get_type (), GMenu);
#line 51 "../src/client/util/util-gtk.vala"
				_tmp10_ = label;
#line 51 "../src/client/util/util-gtk.vala"
				if (_tmp10_ != NULL) {
#line 254 "util-gtk.c"
					GVariant* _tmp11_;
					const gchar* _tmp12_;
#line 51 "../src/client/util/util-gtk.vala"
					_tmp11_ = label;
#line 51 "../src/client/util/util-gtk.vala"
					_tmp12_ = g_variant_get_string (_tmp11_, NULL);
#line 51 "../src/client/util/util-gtk.vala"
					_tmp9_ = _tmp12_;
#line 263 "util-gtk.c"
				} else {
#line 51 "../src/client/util/util-gtk.vala"
					_tmp9_ = NULL;
#line 267 "util-gtk.c"
				}
#line 52 "../src/client/util/util-gtk.vala"
				_tmp14_ = action_name;
#line 52 "../src/client/util/util-gtk.vala"
				if (_tmp14_ != NULL) {
#line 273 "util-gtk.c"
					GVariant* _tmp15_;
					const gchar* _tmp16_;
#line 52 "../src/client/util/util-gtk.vala"
					_tmp15_ = action_name;
#line 52 "../src/client/util/util-gtk.vala"
					_tmp16_ = g_variant_get_string (_tmp15_, NULL);
#line 52 "../src/client/util/util-gtk.vala"
					_tmp13_ = _tmp16_;
#line 282 "util-gtk.c"
				} else {
#line 52 "../src/client/util/util-gtk.vala"
					_tmp13_ = NULL;
#line 286 "util-gtk.c"
				}
#line 51 "../src/client/util/util-gtk.vala"
				_tmp17_ = action_target;
#line 51 "../src/client/util/util-gtk.vala"
				_tmp18_ = section;
#line 51 "../src/client/util/util-gtk.vala"
				foreach_func (_tmp9_, _tmp13_, _tmp17_, _tmp18_, foreach_func_target);
#line 41 "../src/client/util/util-gtk.vala"
				_g_object_unref0 (section);
#line 41 "../src/client/util/util-gtk.vala"
				_g_variant_unref0 (action_target);
#line 41 "../src/client/util/util-gtk.vala"
				_g_variant_unref0 (action_name);
#line 41 "../src/client/util/util-gtk.vala"
				_g_variant_unref0 (label);
#line 302 "util-gtk.c"
			}
		}
	}
}

/**
 * Returns the CSS border box height for a widget.
 *
 * This adjusts the GTK widget's allocated height to exclude extra
 * space added by the CSS margin property, if any.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 75 "../src/client/util/util-gtk.vala"
	return self ? g_object_ref (self) : NULL;
#line 319 "util-gtk.c"
}

inline gint
gtk_util_get_border_box_height (GtkWidget* widget)
{
	gint result = 0;
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags flags = 0U;
	GtkBorder margin = {0};
	GtkBorder _tmp2_ = {0};
	GtkBorder _tmp3_;
	GtkBorder _tmp4_;
#line 74 "../src/client/util/util-gtk.vala"
	g_return_val_if_fail (GTK_IS_WIDGET (widget), 0);
#line 75 "../src/client/util/util-gtk.vala"
	_tmp0_ = gtk_widget_get_style_context (widget);
#line 75 "../src/client/util/util-gtk.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 75 "../src/client/util/util-gtk.vala"
	style = _tmp1_;
#line 76 "../src/client/util/util-gtk.vala"
	flags = gtk_style_context_get_state (style);
#line 77 "../src/client/util/util-gtk.vala"
	gtk_style_context_get_margin (style, flags, &_tmp2_);
#line 77 "../src/client/util/util-gtk.vala"
	margin = _tmp2_;
#line 79 "../src/client/util/util-gtk.vala"
	_tmp3_ = margin;
#line 79 "../src/client/util/util-gtk.vala"
	_tmp4_ = margin;
#line 79 "../src/client/util/util-gtk.vala"
	result = (gtk_widget_get_allocated_height (widget) - _tmp3_.top) - _tmp4_.bottom;
#line 79 "../src/client/util/util-gtk.vala"
	_g_object_unref0 (style);
#line 79 "../src/client/util/util-gtk.vala"
	return result;
#line 358 "util-gtk.c"
}

