/* util-migrate.c generated by valac 0.44.1, the Vala compiler
 * generated from util-migrate.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include "geary-engine.h"

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define MIGRATE_GROUP "AccountInformation"
#define MIGRATE_PRIMARY_EMAIL_KEY "primary_email"
#define ACCOUNTS_MANAGER_SETTINGS_FILENAME "geary.ini"
#define MIGRATE_SETTINGS_FILENAME ACCOUNTS_MANAGER_SETTINGS_FILENAME
#define MIGRATE_MIGRATED_FILENAME ".config_migrated"
void migrate_xdg_config_dir (GFile* user_data_dir,
                             GFile* user_config_dir,
                             GError** error);
#define MIGRATE_OLD_APP_ID "org.yorba.geary"
#define MIGRATE_MIGRATED_CONFIG_KEY "migrated-config"
void migrate_old_app_config (GSettings* newSettings,
                             const gchar* old_app_id);
#define GEARY_APPLICATION_GSETTINGS_DIR _GSETTINGS_DIR
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

/**
     * Migrates geary.ini to the XDG configuration directory with the account's email address
     *
     * This function iterates through all the account directories in $XDG_DATA_DIR and copies over
     * geary.ini to ~/.config/geary/<account>/geary.ini. Note that it leaves the
     * original file untouched.
     * It also appends a "primary_email" key to the new configuration file to reliaby keep
     * track of the user's email address.
     */
static gpointer
_g_error_copy0 (gpointer self)
{
#line 34 "../src/client/util/util-migrate.vala"
	return self ? g_error_copy (self) : NULL;
#line 63 "util-migrate.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1502 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1502 "glib-2.0.vapi"
	res_length1 = -1;
#line 1502 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1503 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1503 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1503 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1504 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1504 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1504 "glib-2.0.vapi"
	_tmp3_ = _tmp2_;
#line 1504 "glib-2.0.vapi"
	_tmp3__length1 = _tmp2__length1;
#line 1504 "glib-2.0.vapi"
	if (result_length1) {
#line 1504 "glib-2.0.vapi"
		*result_length1 = _tmp3__length1;
#line 106 "util-migrate.c"
	}
#line 1504 "glib-2.0.vapi"
	result = _tmp3_;
#line 1504 "glib-2.0.vapi"
	return result;
#line 112 "util-migrate.c"
}

void
migrate_xdg_config_dir (GFile* user_data_dir,
                        GFile* user_config_dir,
                        GError** error)
{
	GFile* new_config_dir = NULL;
	GFile* old_data_dir = NULL;
	GFile* new_config_file = NULL;
	GFile* old_config_file = NULL;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp3_ = NULL;
	GFileEnumerator* _tmp4_;
	GFileEnumerator* _tmp5_;
	GFileInfo* info = NULL;
	gchar* email = NULL;
	GFile* is_migrated = NULL;
	GError* _inner_error0_ = NULL;
#line 22 "../src/client/util/util-migrate.vala"
	g_return_if_fail (G_IS_FILE (user_data_dir));
#line 22 "../src/client/util/util-migrate.vala"
	g_return_if_fail (G_IS_FILE (user_config_dir));
#line 136 "util-migrate.c"
	{
#line 30 "../src/client/util/util-migrate.vala"
		g_file_make_directory_with_parents (user_config_dir, NULL, &_inner_error0_);
#line 30 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "util-migrate.c"
			goto __catch173_g_error;
		}
	}
	goto __finally173;
	__catch173_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
#line 29 "../src/client/util/util-migrate.vala"
		err = _inner_error0_;
#line 29 "../src/client/util/util-migrate.vala"
		_inner_error0_ = NULL;
#line 33 "../src/client/util/util-migrate.vala"
		_tmp0_ = err;
#line 33 "../src/client/util/util-migrate.vala"
		if (!g_error_matches (_tmp0_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 159 "util-migrate.c"
			GError* _tmp1_;
			GError* _tmp2_;
#line 34 "../src/client/util/util-migrate.vala"
			_tmp1_ = err;
#line 34 "../src/client/util/util-migrate.vala"
			_tmp2_ = _g_error_copy0 (_tmp1_);
#line 34 "../src/client/util/util-migrate.vala"
			_inner_error0_ = _tmp2_;
#line 34 "../src/client/util/util-migrate.vala"
			_g_error_free0 (err);
#line 170 "util-migrate.c"
			goto __finally173;
		}
#line 29 "../src/client/util/util-migrate.vala"
		_g_error_free0 (err);
#line 175 "util-migrate.c"
	}
	__finally173:
#line 29 "../src/client/util/util-migrate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29 "../src/client/util/util-migrate.vala"
		g_propagate_error (error, _inner_error0_);
#line 29 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 29 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 29 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 29 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 29 "../src/client/util/util-migrate.vala"
		return;
#line 192 "util-migrate.c"
	}
#line 38 "../src/client/util/util-migrate.vala"
	if (!g_file_query_exists (user_data_dir, NULL)) {
#line 39 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 39 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 39 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 39 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 39 "../src/client/util/util-migrate.vala"
		return;
#line 206 "util-migrate.c"
	}
#line 42 "../src/client/util/util-migrate.vala"
	_tmp4_ = g_file_enumerate_children (user_data_dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 42 "../src/client/util/util-migrate.vala"
	_tmp3_ = _tmp4_;
#line 42 "../src/client/util/util-migrate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 42 "../src/client/util/util-migrate.vala"
		g_propagate_error (error, _inner_error0_);
#line 42 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (enumerator);
#line 42 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 42 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 42 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 42 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 42 "../src/client/util/util-migrate.vala"
		return;
#line 228 "util-migrate.c"
	}
#line 42 "../src/client/util/util-migrate.vala"
	_tmp5_ = _tmp3_;
#line 42 "../src/client/util/util-migrate.vala"
	_tmp3_ = NULL;
#line 42 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (enumerator);
#line 42 "../src/client/util/util-migrate.vala"
	enumerator = _tmp5_;
#line 48 "../src/client/util/util-migrate.vala"
	while (TRUE) {
#line 240 "util-migrate.c"
		GFileInfo* _tmp6_ = NULL;
		GFileEnumerator* _tmp7_;
		GFileInfo* _tmp8_;
		GFileInfo* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		GFile* _tmp17_;
		const gchar* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp30_;
		GFile* _tmp31_;
		GFile* _tmp32_;
		GKeyFile* key_file = NULL;
		GKeyFile* _tmp38_;
		GKeyFile* _tmp46_;
		const gchar* _tmp47_;
		gchar* data = NULL;
		GKeyFile* _tmp48_;
		gchar* _tmp49_;
		GFile* _tmp55_;
		GFileOutputStream* _tmp56_;
		GFileOutputStream* _tmp57_;
#line 48 "../src/client/util/util-migrate.vala"
		_tmp7_ = enumerator;
#line 48 "../src/client/util/util-migrate.vala"
		_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error0_);
#line 48 "../src/client/util/util-migrate.vala"
		_tmp6_ = _tmp8_;
#line 48 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 48 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 48 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 48 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 48 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 48 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 48 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 48 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 48 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 48 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 48 "../src/client/util/util-migrate.vala"
			return;
#line 305 "util-migrate.c"
		}
#line 48 "../src/client/util/util-migrate.vala"
		_tmp9_ = _tmp6_;
#line 48 "../src/client/util/util-migrate.vala"
		_tmp6_ = NULL;
#line 48 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (info);
#line 48 "../src/client/util/util-migrate.vala"
		info = _tmp9_;
#line 48 "../src/client/util/util-migrate.vala"
		_tmp10_ = info;
#line 48 "../src/client/util/util-migrate.vala"
		if (!(_tmp10_ != NULL)) {
#line 48 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 48 "../src/client/util/util-migrate.vala"
			break;
#line 323 "util-migrate.c"
		}
#line 49 "../src/client/util/util-migrate.vala"
		_tmp11_ = info;
#line 49 "../src/client/util/util-migrate.vala"
		if (g_file_info_get_file_type (_tmp11_) != G_FILE_TYPE_DIRECTORY) {
#line 50 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 50 "../src/client/util/util-migrate.vala"
			continue;
#line 333 "util-migrate.c"
		}
#line 52 "../src/client/util/util-migrate.vala"
		_tmp12_ = info;
#line 52 "../src/client/util/util-migrate.vala"
		_tmp13_ = g_file_info_get_name (_tmp12_);
#line 52 "../src/client/util/util-migrate.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 52 "../src/client/util/util-migrate.vala"
		_g_free0 (email);
#line 52 "../src/client/util/util-migrate.vala"
		email = _tmp14_;
#line 55 "../src/client/util/util-migrate.vala"
		_tmp15_ = email;
#line 55 "../src/client/util/util-migrate.vala"
		if (!geary_rf_c822_mailbox_address_is_valid_address (_tmp15_)) {
#line 56 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 56 "../src/client/util/util-migrate.vala"
			continue;
#line 353 "util-migrate.c"
		}
#line 58 "../src/client/util/util-migrate.vala"
		_tmp16_ = email;
#line 58 "../src/client/util/util-migrate.vala"
		_tmp17_ = g_file_get_child (user_data_dir, _tmp16_);
#line 58 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_data_dir);
#line 58 "../src/client/util/util-migrate.vala"
		old_data_dir = _tmp17_;
#line 59 "../src/client/util/util-migrate.vala"
		_tmp18_ = email;
#line 59 "../src/client/util/util-migrate.vala"
		_tmp19_ = g_file_get_child (user_config_dir, _tmp18_);
#line 59 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_dir);
#line 59 "../src/client/util/util-migrate.vala"
		new_config_dir = _tmp19_;
#line 62 "../src/client/util/util-migrate.vala"
		_tmp20_ = old_data_dir;
#line 62 "../src/client/util/util-migrate.vala"
		_tmp21_ = g_file_get_child (_tmp20_, MIGRATE_SETTINGS_FILENAME);
#line 62 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (old_config_file);
#line 62 "../src/client/util/util-migrate.vala"
		old_config_file = _tmp21_;
#line 63 "../src/client/util/util-migrate.vala"
		_tmp22_ = old_config_file;
#line 63 "../src/client/util/util-migrate.vala"
		if (!g_file_query_exists (_tmp22_, NULL)) {
#line 64 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 64 "../src/client/util/util-migrate.vala"
			continue;
#line 387 "util-migrate.c"
		}
#line 67 "../src/client/util/util-migrate.vala"
		_tmp23_ = old_data_dir;
#line 67 "../src/client/util/util-migrate.vala"
		_tmp24_ = g_file_get_child (_tmp23_, MIGRATE_MIGRATED_FILENAME);
#line 67 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (is_migrated);
#line 67 "../src/client/util/util-migrate.vala"
		is_migrated = _tmp24_;
#line 68 "../src/client/util/util-migrate.vala"
		_tmp25_ = is_migrated;
#line 68 "../src/client/util/util-migrate.vala"
		if (g_file_query_exists (_tmp25_, NULL)) {
#line 69 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 69 "../src/client/util/util-migrate.vala"
			continue;
#line 405 "util-migrate.c"
		}
#line 71 "../src/client/util/util-migrate.vala"
		_tmp26_ = new_config_dir;
#line 71 "../src/client/util/util-migrate.vala"
		if (!g_file_query_exists (_tmp26_, NULL)) {
#line 411 "util-migrate.c"
			{
				GFile* _tmp27_;
#line 73 "../src/client/util/util-migrate.vala"
				_tmp27_ = new_config_dir;
#line 73 "../src/client/util/util-migrate.vala"
				g_file_make_directory_with_parents (_tmp27_, NULL, &_inner_error0_);
#line 73 "../src/client/util/util-migrate.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 420 "util-migrate.c"
					goto __catch174_g_error;
				}
			}
			goto __finally174;
			__catch174_g_error:
			{
				GError* e = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 72 "../src/client/util/util-migrate.vala"
				e = _inner_error0_;
#line 72 "../src/client/util/util-migrate.vala"
				_inner_error0_ = NULL;
#line 75 "../src/client/util/util-migrate.vala"
				_tmp28_ = e;
#line 75 "../src/client/util/util-migrate.vala"
				_tmp29_ = _tmp28_->message;
#line 75 "../src/client/util/util-migrate.vala"
				g_debug ("util-migrate.vala:75: Cannot make directory, %s", _tmp29_);
#line 76 "../src/client/util/util-migrate.vala"
				_g_error_free0 (e);
#line 76 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp6_);
#line 76 "../src/client/util/util-migrate.vala"
				continue;
#line 446 "util-migrate.c"
			}
			__finally174:
#line 72 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "../src/client/util/util-migrate.vala"
				g_propagate_error (error, _inner_error0_);
#line 72 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp6_);
#line 72 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (is_migrated);
#line 72 "../src/client/util/util-migrate.vala"
				_g_free0 (email);
#line 72 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (info);
#line 72 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (_tmp3_);
#line 72 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (enumerator);
#line 72 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (old_config_file);
#line 72 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (new_config_file);
#line 72 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (old_data_dir);
#line 72 "../src/client/util/util-migrate.vala"
				_g_object_unref0 (new_config_dir);
#line 72 "../src/client/util/util-migrate.vala"
				return;
#line 475 "util-migrate.c"
			}
		}
#line 80 "../src/client/util/util-migrate.vala"
		_tmp30_ = new_config_dir;
#line 80 "../src/client/util/util-migrate.vala"
		_tmp31_ = g_file_get_child (_tmp30_, MIGRATE_SETTINGS_FILENAME);
#line 80 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (new_config_file);
#line 80 "../src/client/util/util-migrate.vala"
		new_config_file = _tmp31_;
#line 81 "../src/client/util/util-migrate.vala"
		_tmp32_ = new_config_file;
#line 81 "../src/client/util/util-migrate.vala"
		if (g_file_query_exists (_tmp32_, NULL)) {
#line 82 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 82 "../src/client/util/util-migrate.vala"
			continue;
#line 494 "util-migrate.c"
		}
		{
			GFile* _tmp33_;
			GFile* _tmp34_;
#line 85 "../src/client/util/util-migrate.vala"
			_tmp33_ = old_config_file;
#line 85 "../src/client/util/util-migrate.vala"
			_tmp34_ = new_config_file;
#line 85 "../src/client/util/util-migrate.vala"
			g_file_copy (_tmp33_, _tmp34_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 85 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 507 "util-migrate.c"
				goto __catch175_g_error;
			}
		}
		goto __finally175;
		__catch175_g_error:
		{
			GError* err = NULL;
			GFile* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
#line 84 "../src/client/util/util-migrate.vala"
			err = _inner_error0_;
#line 84 "../src/client/util/util-migrate.vala"
			_inner_error0_ = NULL;
#line 87 "../src/client/util/util-migrate.vala"
			_tmp35_ = new_config_dir;
#line 87 "../src/client/util/util-migrate.vala"
			_tmp36_ = g_file_get_path (_tmp35_);
#line 87 "../src/client/util/util-migrate.vala"
			_tmp37_ = _tmp36_;
#line 87 "../src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:87: Error copying over to %s", _tmp37_);
#line 87 "../src/client/util/util-migrate.vala"
			_g_free0 (_tmp37_);
#line 88 "../src/client/util/util-migrate.vala"
			_g_error_free0 (err);
#line 88 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 88 "../src/client/util/util-migrate.vala"
			continue;
#line 538 "util-migrate.c"
		}
		__finally175:
#line 84 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 84 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 84 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 84 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 84 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 84 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 84 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 84 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 84 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 84 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 84 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 84 "../src/client/util/util-migrate.vala"
			return;
#line 567 "util-migrate.c"
		}
#line 90 "../src/client/util/util-migrate.vala"
		_tmp38_ = g_key_file_new ();
#line 90 "../src/client/util/util-migrate.vala"
		key_file = _tmp38_;
#line 573 "util-migrate.c"
		{
			GKeyFile* _tmp39_;
			GFile* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
#line 92 "../src/client/util/util-migrate.vala"
			_tmp39_ = key_file;
#line 92 "../src/client/util/util-migrate.vala"
			_tmp40_ = new_config_file;
#line 92 "../src/client/util/util-migrate.vala"
			_tmp41_ = g_file_get_path (_tmp40_);
#line 92 "../src/client/util/util-migrate.vala"
			_tmp42_ = _tmp41_;
#line 92 "../src/client/util/util-migrate.vala"
			g_key_file_load_from_file (_tmp39_, _tmp42_, G_KEY_FILE_NONE, &_inner_error0_);
#line 92 "../src/client/util/util-migrate.vala"
			_g_free0 (_tmp42_);
#line 92 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 593 "util-migrate.c"
				goto __catch176_g_error;
			}
		}
		goto __finally176;
		__catch176_g_error:
		{
			GError* err = NULL;
			GFile* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
#line 91 "../src/client/util/util-migrate.vala"
			err = _inner_error0_;
#line 91 "../src/client/util/util-migrate.vala"
			_inner_error0_ = NULL;
#line 94 "../src/client/util/util-migrate.vala"
			_tmp43_ = new_config_file;
#line 94 "../src/client/util/util-migrate.vala"
			_tmp44_ = g_file_get_path (_tmp43_);
#line 94 "../src/client/util/util-migrate.vala"
			_tmp45_ = _tmp44_;
#line 94 "../src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:94: Error opening %s", _tmp45_);
#line 94 "../src/client/util/util-migrate.vala"
			_g_free0 (_tmp45_);
#line 95 "../src/client/util/util-migrate.vala"
			_g_error_free0 (err);
#line 95 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 95 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 95 "../src/client/util/util-migrate.vala"
			continue;
#line 626 "util-migrate.c"
		}
		__finally176:
#line 91 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 91 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 91 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 91 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 91 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 91 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 91 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 91 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 91 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 91 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 91 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 91 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 91 "../src/client/util/util-migrate.vala"
			return;
#line 657 "util-migrate.c"
		}
#line 99 "../src/client/util/util-migrate.vala"
		_tmp46_ = key_file;
#line 99 "../src/client/util/util-migrate.vala"
		_tmp47_ = email;
#line 99 "../src/client/util/util-migrate.vala"
		g_key_file_set_value (_tmp46_, MIGRATE_GROUP, MIGRATE_PRIMARY_EMAIL_KEY, _tmp47_);
#line 100 "../src/client/util/util-migrate.vala"
		_tmp48_ = key_file;
#line 100 "../src/client/util/util-migrate.vala"
		_tmp49_ = g_key_file_to_data (_tmp48_, NULL, NULL);
#line 100 "../src/client/util/util-migrate.vala"
		data = _tmp49_;
#line 671 "util-migrate.c"
		{
			GFile* _tmp50_;
			const gchar* _tmp51_;
			guint8* _tmp52_;
			gint _tmp52__length1;
			guint8* _tmp53_;
			gint _tmp53__length1;
#line 102 "../src/client/util/util-migrate.vala"
			_tmp50_ = new_config_file;
#line 102 "../src/client/util/util-migrate.vala"
			_tmp51_ = data;
#line 102 "../src/client/util/util-migrate.vala"
			_tmp52_ = string_get_data (_tmp51_, &_tmp52__length1);
#line 102 "../src/client/util/util-migrate.vala"
			_tmp53_ = _tmp52_;
#line 102 "../src/client/util/util-migrate.vala"
			_tmp53__length1 = _tmp52__length1;
#line 102 "../src/client/util/util-migrate.vala"
			g_file_replace_contents (_tmp50_, _tmp53_, (gsize) _tmp53__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 102 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 693 "util-migrate.c"
				goto __catch177_g_error;
			}
		}
		goto __finally177;
		__catch177_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp54_;
#line 101 "../src/client/util/util-migrate.vala"
			e = _inner_error0_;
#line 101 "../src/client/util/util-migrate.vala"
			_inner_error0_ = NULL;
#line 105 "../src/client/util/util-migrate.vala"
			_tmp54_ = email;
#line 105 "../src/client/util/util-migrate.vala"
			g_debug ("util-migrate.vala:105: Error writing email %s to config file", _tmp54_);
#line 106 "../src/client/util/util-migrate.vala"
			_g_error_free0 (e);
#line 106 "../src/client/util/util-migrate.vala"
			_g_free0 (data);
#line 106 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 106 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 106 "../src/client/util/util-migrate.vala"
			continue;
#line 720 "util-migrate.c"
		}
		__finally177:
#line 101 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 101 "../src/client/util/util-migrate.vala"
			_g_free0 (data);
#line 101 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 101 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 101 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 101 "../src/client/util/util-migrate.vala"
			return;
#line 753 "util-migrate.c"
		}
#line 108 "../src/client/util/util-migrate.vala"
		_tmp55_ = is_migrated;
#line 108 "../src/client/util/util-migrate.vala"
		_tmp56_ = g_file_create (_tmp55_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
#line 108 "../src/client/util/util-migrate.vala"
		_tmp57_ = _tmp56_;
#line 108 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (_tmp57_);
#line 108 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../src/client/util/util-migrate.vala"
			g_propagate_error (error, _inner_error0_);
#line 108 "../src/client/util/util-migrate.vala"
			_g_free0 (data);
#line 108 "../src/client/util/util-migrate.vala"
			_g_key_file_unref0 (key_file);
#line 108 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp6_);
#line 108 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (is_migrated);
#line 108 "../src/client/util/util-migrate.vala"
			_g_free0 (email);
#line 108 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (info);
#line 108 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (_tmp3_);
#line 108 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (enumerator);
#line 108 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_config_file);
#line 108 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_file);
#line 108 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (old_data_dir);
#line 108 "../src/client/util/util-migrate.vala"
			_g_object_unref0 (new_config_dir);
#line 108 "../src/client/util/util-migrate.vala"
			return;
#line 793 "util-migrate.c"
		}
#line 48 "../src/client/util/util-migrate.vala"
		_g_free0 (data);
#line 48 "../src/client/util/util-migrate.vala"
		_g_key_file_unref0 (key_file);
#line 48 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (_tmp6_);
#line 801 "util-migrate.c"
	}
#line 22 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (is_migrated);
#line 22 "../src/client/util/util-migrate.vala"
	_g_free0 (email);
#line 22 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (info);
#line 22 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (_tmp3_);
#line 22 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (enumerator);
#line 22 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (old_config_file);
#line 22 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (new_config_file);
#line 22 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (old_data_dir);
#line 22 "../src/client/util/util-migrate.vala"
	_g_object_unref0 (new_config_dir);
#line 821 "util-migrate.c"
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
#line 116 "../src/client/util/util-migrate.vala"
	return self ? g_settings_schema_source_ref (self) : NULL;
#line 829 "util-migrate.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
#line 134 "../src/client/util/util-migrate.vala"
	for (i = 0; i < stack_length; i++) {
#line 134 "../src/client/util/util-migrate.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 134 "../src/client/util/util-migrate.vala"
			return TRUE;
#line 844 "util-migrate.c"
		}
	}
#line 134 "../src/client/util/util-migrate.vala"
	return FALSE;
#line 849 "util-migrate.c"
}

void
migrate_old_app_config (GSettings* newSettings,
                        const gchar* old_app_id)
{
	GSettingsSchemaSource* schemaSource = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchemaSource* _tmp1_;
	GSettingsSchema* oldSettingsSchema = NULL;
	GSettingsSchemaSource* _tmp5_;
	GSettingsSchema* _tmp6_;
	GSettingsSchema* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 115 "../src/client/util/util-migrate.vala"
	g_return_if_fail (G_IS_SETTINGS (newSettings));
#line 115 "../src/client/util/util-migrate.vala"
	g_return_if_fail (old_app_id != NULL);
#line 116 "../src/client/util/util-migrate.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 116 "../src/client/util/util-migrate.vala"
	_tmp1_ = _g_settings_schema_source_ref0 (_tmp0_);
#line 116 "../src/client/util/util-migrate.vala"
	schemaSource = _tmp1_;
#line 117 "../src/client/util/util-migrate.vala"
	if (GEARY_APPLICATION_GSETTINGS_DIR != NULL) {
#line 876 "util-migrate.c"
		{
			GSettingsSchemaSource* _tmp2_ = NULL;
			GSettingsSchemaSource* _tmp3_;
			GSettingsSchemaSource* _tmp4_;
#line 119 "../src/client/util/util-migrate.vala"
			_tmp3_ = g_settings_schema_source_new_from_directory (GEARY_APPLICATION_GSETTINGS_DIR, NULL, FALSE, &_inner_error0_);
#line 119 "../src/client/util/util-migrate.vala"
			_tmp2_ = _tmp3_;
#line 119 "../src/client/util/util-migrate.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 887 "util-migrate.c"
				goto __catch178_g_error;
			}
#line 119 "../src/client/util/util-migrate.vala"
			_tmp4_ = _tmp2_;
#line 119 "../src/client/util/util-migrate.vala"
			_tmp2_ = NULL;
#line 119 "../src/client/util/util-migrate.vala"
			_g_settings_schema_source_unref0 (schemaSource);
#line 119 "../src/client/util/util-migrate.vala"
			schemaSource = _tmp4_;
#line 118 "../src/client/util/util-migrate.vala"
			_g_settings_schema_source_unref0 (_tmp2_);
#line 900 "util-migrate.c"
		}
		goto __finally178;
		__catch178_g_error:
		{
			GError* e = NULL;
#line 118 "../src/client/util/util-migrate.vala"
			e = _inner_error0_;
#line 118 "../src/client/util/util-migrate.vala"
			_inner_error0_ = NULL;
#line 118 "../src/client/util/util-migrate.vala"
			_g_error_free0 (e);
#line 912 "util-migrate.c"
		}
		__finally178:
#line 118 "../src/client/util/util-migrate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 118 "../src/client/util/util-migrate.vala"
			_g_settings_schema_source_unref0 (schemaSource);
#line 118 "../src/client/util/util-migrate.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 118 "../src/client/util/util-migrate.vala"
			g_clear_error (&_inner_error0_);
#line 118 "../src/client/util/util-migrate.vala"
			return;
#line 925 "util-migrate.c"
		}
	}
#line 124 "../src/client/util/util-migrate.vala"
	_tmp5_ = schemaSource;
#line 124 "../src/client/util/util-migrate.vala"
	_tmp6_ = g_settings_schema_source_lookup (_tmp5_, old_app_id, FALSE);
#line 124 "../src/client/util/util-migrate.vala"
	oldSettingsSchema = _tmp6_;
#line 126 "../src/client/util/util-migrate.vala"
	if (g_settings_get_boolean (newSettings, MIGRATE_MIGRATED_CONFIG_KEY)) {
#line 127 "../src/client/util/util-migrate.vala"
		_g_settings_schema_unref0 (oldSettingsSchema);
#line 127 "../src/client/util/util-migrate.vala"
		_g_settings_schema_source_unref0 (schemaSource);
#line 127 "../src/client/util/util-migrate.vala"
		return;
#line 942 "util-migrate.c"
	}
#line 129 "../src/client/util/util-migrate.vala"
	_tmp7_ = oldSettingsSchema;
#line 129 "../src/client/util/util-migrate.vala"
	if (_tmp7_ != NULL) {
#line 948 "util-migrate.c"
		GSettings* oldSettings = NULL;
		GSettingsSchema* _tmp8_;
		GSettings* _tmp9_;
		gchar** oldKeys = NULL;
		GSettings* _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint oldKeys_length1;
		gint _oldKeys_size_;
		gchar** _tmp13_;
		gchar** _tmp14_;
#line 130 "../src/client/util/util-migrate.vala"
		_tmp8_ = oldSettingsSchema;
#line 130 "../src/client/util/util-migrate.vala"
		_tmp9_ = g_settings_new_full (_tmp8_, NULL, NULL);
#line 130 "../src/client/util/util-migrate.vala"
		oldSettings = _tmp9_;
#line 132 "../src/client/util/util-migrate.vala"
		_tmp10_ = oldSettings;
#line 132 "../src/client/util/util-migrate.vala"
		_tmp12_ = _tmp11_ = g_settings_list_keys (_tmp10_);
#line 132 "../src/client/util/util-migrate.vala"
		oldKeys = _tmp12_;
#line 132 "../src/client/util/util-migrate.vala"
		oldKeys_length1 = _vala_array_length (_tmp11_);
#line 132 "../src/client/util/util-migrate.vala"
		_oldKeys_size_ = oldKeys_length1;
#line 133 "../src/client/util/util-migrate.vala"
		_tmp14_ = _tmp13_ = g_settings_list_keys (newSettings);
#line 978 "util-migrate.c"
		{
			gchar** key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 133 "../src/client/util/util-migrate.vala"
			key_collection = _tmp14_;
#line 133 "../src/client/util/util-migrate.vala"
			key_collection_length1 = _vala_array_length (_tmp13_);
#line 133 "../src/client/util/util-migrate.vala"
			for (key_it = 0; key_it < _vala_array_length (_tmp13_); key_it = key_it + 1) {
#line 990 "util-migrate.c"
				gchar* _tmp15_;
				gchar* key = NULL;
#line 133 "../src/client/util/util-migrate.vala"
				_tmp15_ = g_strdup (key_collection[key_it]);
#line 133 "../src/client/util/util-migrate.vala"
				key = _tmp15_;
#line 997 "util-migrate.c"
				{
					const gchar* _tmp16_;
					gchar** _tmp17_;
					gint _tmp17__length1;
#line 134 "../src/client/util/util-migrate.vala"
					_tmp16_ = key;
#line 134 "../src/client/util/util-migrate.vala"
					_tmp17_ = oldKeys;
#line 134 "../src/client/util/util-migrate.vala"
					_tmp17__length1 = oldKeys_length1;
#line 134 "../src/client/util/util-migrate.vala"
					if (_vala_string_array_contains (_tmp17_, _tmp17__length1, _tmp16_)) {
#line 1010 "util-migrate.c"
						const gchar* _tmp18_;
						GSettings* _tmp19_;
						const gchar* _tmp20_;
						GVariant* _tmp21_;
						GVariant* _tmp22_;
#line 135 "../src/client/util/util-migrate.vala"
						_tmp18_ = key;
#line 135 "../src/client/util/util-migrate.vala"
						_tmp19_ = oldSettings;
#line 135 "../src/client/util/util-migrate.vala"
						_tmp20_ = key;
#line 135 "../src/client/util/util-migrate.vala"
						_tmp21_ = g_settings_get_value (_tmp19_, _tmp20_);
#line 135 "../src/client/util/util-migrate.vala"
						_tmp22_ = _tmp21_;
#line 135 "../src/client/util/util-migrate.vala"
						g_settings_set_value (newSettings, _tmp18_, _tmp22_);
#line 135 "../src/client/util/util-migrate.vala"
						_g_variant_unref0 (_tmp22_);
#line 1030 "util-migrate.c"
					}
#line 133 "../src/client/util/util-migrate.vala"
					_g_free0 (key);
#line 1034 "util-migrate.c"
				}
			}
#line 133 "../src/client/util/util-migrate.vala"
			key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1039 "util-migrate.c"
		}
#line 129 "../src/client/util/util-migrate.vala"
		oldKeys = (_vala_array_free (oldKeys, oldKeys_length1, (GDestroyNotify) g_free), NULL);
#line 129 "../src/client/util/util-migrate.vala"
		_g_object_unref0 (oldSettings);
#line 1045 "util-migrate.c"
	}
#line 138 "../src/client/util/util-migrate.vala"
	g_settings_set_boolean (newSettings, MIGRATE_MIGRATED_CONFIG_KEY, TRUE);
#line 115 "../src/client/util/util-migrate.vala"
	_g_settings_schema_unref0 (oldSettingsSchema);
#line 115 "../src/client/util/util-migrate.vala"
	_g_settings_schema_source_unref0 (schemaSource);
#line 1053 "util-migrate.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
#line 8 "../src/client/notification/libnotify.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1063 "util-migrate.c"
		int i;
#line 8 "../src/client/notification/libnotify.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 8 "../src/client/notification/libnotify.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 8 "../src/client/notification/libnotify.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1071 "util-migrate.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
#line 8 "../src/client/notification/libnotify.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 8 "../src/client/notification/libnotify.vala"
	g_free (array);
#line 1086 "util-migrate.c"
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
#line 8 "../src/client/notification/libnotify.vala"
	if (array) {
#line 8 "../src/client/notification/libnotify.vala"
		while (((gpointer*) array)[length]) {
#line 8 "../src/client/notification/libnotify.vala"
			length++;
#line 1100 "util-migrate.c"
		}
	}
#line 8 "../src/client/notification/libnotify.vala"
	return length;
#line 1105 "util-migrate.c"
}

