/* util-webkit.c generated by valac 0.44.1, the Vala compiler
 * generated from util-webkit.vala, do not modify */

/*
 * Copyright 2017 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <webkit2/webkit2.h>
#include <glib.h>
#include "geary-engine.h"
#include <JavaScriptCore/JavaScript.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))

gboolean web_kit_util_to_bool (WebKitJavascriptResult* _result_,
                               GError** error);
gdouble web_kit_util_to_number (WebKitJavascriptResult* _result_,
                                GError** error);
gchar* web_kit_util_to_string (WebKitJavascriptResult* _result_,
                               GError** error);
gchar* web_kit_util_as_string (WebKitJavascriptResult* _result_,
                               GError** error);
struct OpaqueJSValue* web_kit_util_to_object (WebKitJavascriptResult* _result_,
                                              GError** error);

/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as a `bool`.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `Boolean`.
     */
gboolean
web_kit_util_to_bool (WebKitJavascriptResult* _result_,
                      GError** error)
{
	gboolean result = FALSE;
	struct OpaqueJSContext* context = NULL;
	struct OpaqueJSContext* _tmp0_;
	const struct OpaqueJSValue* value = NULL;
	const struct OpaqueJSValue* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	struct OpaqueJSContext* _tmp3_;
	const struct OpaqueJSValue* _tmp7_;
	struct OpaqueJSContext* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 19 "../src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, FALSE);
#line 21 "../src/client/util/util-webkit.vala"
	_tmp0_ = webkit_javascript_result_get_global_context (_result_);
#line 21 "../src/client/util/util-webkit.vala"
	context = _tmp0_;
#line 22 "../src/client/util/util-webkit.vala"
	_tmp1_ = webkit_javascript_result_get_value (_result_);
#line 22 "../src/client/util/util-webkit.vala"
	value = _tmp1_;
#line 23 "../src/client/util/util-webkit.vala"
	_tmp2_ = value;
#line 23 "../src/client/util/util-webkit.vala"
	_tmp3_ = context;
#line 23 "../src/client/util/util-webkit.vala"
	if (!JSValueIsBoolean ((const struct OpaqueJSContext*) _tmp3_, _tmp2_)) {
#line 72 "util-webkit.c"
		GError* _tmp4_;
#line 24 "../src/client/util/util-webkit.vala"
		_tmp4_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Result is not a JS Boolean object");
#line 24 "../src/client/util/util-webkit.vala"
		_inner_error0_ = _tmp4_;
#line 24 "../src/client/util/util-webkit.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 80 "util-webkit.c"
			gboolean _tmp5_ = FALSE;
#line 24 "../src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error0_);
#line 24 "../src/client/util/util-webkit.vala"
			return _tmp5_;
#line 86 "util-webkit.c"
		} else {
			gboolean _tmp6_ = FALSE;
#line 24 "../src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 24 "../src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error0_);
#line 24 "../src/client/util/util-webkit.vala"
			return _tmp6_;
#line 95 "util-webkit.c"
		}
	}
#line 26 "../src/client/util/util-webkit.vala"
	_tmp7_ = value;
#line 26 "../src/client/util/util-webkit.vala"
	_tmp8_ = context;
#line 26 "../src/client/util/util-webkit.vala"
	result = JSValueToBoolean ((const struct OpaqueJSContext*) _tmp8_, _tmp7_);
#line 26 "../src/client/util/util-webkit.vala"
	return result;
#line 106 "util-webkit.c"
}

/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as a `double`.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `Number`.
     */
inline gdouble
web_kit_util_to_number (WebKitJavascriptResult* _result_,
                        GError** error)
{
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	struct OpaqueJSContext* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 35 "../src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, 0.0);
#line 37 "../src/client/util/util-webkit.vala"
	_tmp1_ = webkit_javascript_result_get_global_context (_result_);
#line 37 "../src/client/util/util-webkit.vala"
	_tmp2_ = webkit_javascript_result_get_value (_result_);
#line 37 "../src/client/util/util-webkit.vala"
	_tmp0_ = geary_js_to_number ((const struct OpaqueJSContext*) _tmp1_, _tmp2_, &_inner_error0_);
#line 37 "../src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37 "../src/client/util/util-webkit.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 136 "util-webkit.c"
			gdouble _tmp3_ = -1.0;
#line 37 "../src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error0_);
#line 37 "../src/client/util/util-webkit.vala"
			return _tmp3_;
#line 142 "util-webkit.c"
		} else {
			gdouble _tmp4_ = -1.0;
#line 37 "../src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "../src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error0_);
#line 37 "../src/client/util/util-webkit.vala"
			return _tmp4_;
#line 151 "util-webkit.c"
		}
	}
#line 37 "../src/client/util/util-webkit.vala"
	result = _tmp0_;
#line 37 "../src/client/util/util-webkit.vala"
	return result;
#line 158 "util-webkit.c"
}

/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as a Vala {@link string}.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `String`.
     */
inline gchar*
web_kit_util_to_string (WebKitJavascriptResult* _result_,
                        GError** error)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	struct OpaqueJSContext* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 47 "../src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, NULL);
#line 49 "../src/client/util/util-webkit.vala"
	_tmp1_ = webkit_javascript_result_get_global_context (_result_);
#line 49 "../src/client/util/util-webkit.vala"
	_tmp2_ = webkit_javascript_result_get_value (_result_);
#line 49 "../src/client/util/util-webkit.vala"
	_tmp3_ = geary_js_to_string ((const struct OpaqueJSContext*) _tmp1_, _tmp2_, &_inner_error0_);
#line 49 "../src/client/util/util-webkit.vala"
	_tmp0_ = _tmp3_;
#line 49 "../src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 49 "../src/client/util/util-webkit.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 49 "../src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error0_);
#line 49 "../src/client/util/util-webkit.vala"
			return NULL;
#line 196 "util-webkit.c"
		} else {
#line 49 "../src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 49 "../src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error0_);
#line 49 "../src/client/util/util-webkit.vala"
			return NULL;
#line 204 "util-webkit.c"
		}
	}
#line 49 "../src/client/util/util-webkit.vala"
	_tmp4_ = _tmp0_;
#line 49 "../src/client/util/util-webkit.vala"
	_tmp0_ = NULL;
#line 49 "../src/client/util/util-webkit.vala"
	result = _tmp4_;
#line 49 "../src/client/util/util-webkit.vala"
	_g_free0 (_tmp0_);
#line 49 "../src/client/util/util-webkit.vala"
	return result;
#line 217 "util-webkit.c"
}

/**
     * Converts a WebKit {@link WebKit.JavascriptResult} to a {@link string}.
     *
     * Unlike the other `get_foo_result` methods, this will coax the
     * result to a string, effectively by calling the JavaScript
     * `toString()` method on it, and returning that value.
     */
gchar*
web_kit_util_as_string (WebKitJavascriptResult* _result_,
                        GError** error)
{
	gchar* result = NULL;
	struct OpaqueJSContext* context = NULL;
	struct OpaqueJSContext* _tmp0_;
	const struct OpaqueJSValue* js_str_value = NULL;
	const struct OpaqueJSValue* _tmp1_;
	const struct OpaqueJSValue* err = NULL;
	struct OpaqueJSString* js_str = NULL;
	const struct OpaqueJSValue* _tmp2_ = NULL;
	struct OpaqueJSString* _tmp3_;
	const struct OpaqueJSValue* _tmp4_;
	gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 60 "../src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, NULL);
#line 62 "../src/client/util/util-webkit.vala"
	_tmp0_ = webkit_javascript_result_get_global_context (_result_);
#line 62 "../src/client/util/util-webkit.vala"
	context = _tmp0_;
#line 63 "../src/client/util/util-webkit.vala"
	_tmp1_ = webkit_javascript_result_get_value (_result_);
#line 63 "../src/client/util/util-webkit.vala"
	js_str_value = _tmp1_;
#line 64 "../src/client/util/util-webkit.vala"
	err = NULL;
#line 65 "../src/client/util/util-webkit.vala"
	_tmp3_ = JSValueToStringCopy ((const struct OpaqueJSContext*) context, js_str_value, &_tmp2_);
#line 65 "../src/client/util/util-webkit.vala"
	_0 (err);
#line 65 "../src/client/util/util-webkit.vala"
	err = _tmp2_;
#line 65 "../src/client/util/util-webkit.vala"
	js_str = _tmp3_;
#line 66 "../src/client/util/util-webkit.vala"
	_tmp4_ = err;
#line 66 "../src/client/util/util-webkit.vala"
	geary_js_check_exception ((const struct OpaqueJSContext*) context, _tmp4_, &_inner_error0_);
#line 66 "../src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 66 "../src/client/util/util-webkit.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 66 "../src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error0_);
#line 66 "../src/client/util/util-webkit.vala"
			_JSStringRelease0 (js_str);
#line 66 "../src/client/util/util-webkit.vala"
			_0 (err);
#line 66 "../src/client/util/util-webkit.vala"
			return NULL;
#line 279 "util-webkit.c"
		} else {
#line 66 "../src/client/util/util-webkit.vala"
			_JSStringRelease0 (js_str);
#line 66 "../src/client/util/util-webkit.vala"
			_0 (err);
#line 66 "../src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 66 "../src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error0_);
#line 66 "../src/client/util/util-webkit.vala"
			return NULL;
#line 291 "util-webkit.c"
		}
	}
#line 67 "../src/client/util/util-webkit.vala"
	_tmp5_ = geary_js_to_native_string (js_str);
#line 67 "../src/client/util/util-webkit.vala"
	result = _tmp5_;
#line 67 "../src/client/util/util-webkit.vala"
	_JSStringRelease0 (js_str);
#line 67 "../src/client/util/util-webkit.vala"
	_0 (err);
#line 67 "../src/client/util/util-webkit.vala"
	return result;
#line 304 "util-webkit.c"
}

/**
     * Returns a WebKit {@link WebKit.JavascriptResult} as an Object.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * result is not a JavaScript `Object`.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
struct OpaqueJSValue*
web_kit_util_to_object (WebKitJavascriptResult* _result_,
                        GError** error)
{
	struct OpaqueJSValue* result = NULL;
	struct OpaqueJSValue* _tmp0_ = NULL;
	struct OpaqueJSContext* _tmp1_;
	const struct OpaqueJSValue* _tmp2_;
	struct OpaqueJSValue* _tmp3_;
	struct OpaqueJSValue* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 79 "../src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, NULL);
#line 81 "../src/client/util/util-webkit.vala"
	_tmp1_ = webkit_javascript_result_get_global_context (_result_);
#line 81 "../src/client/util/util-webkit.vala"
	_tmp2_ = webkit_javascript_result_get_value (_result_);
#line 81 "../src/client/util/util-webkit.vala"
	_tmp3_ = geary_js_to_object ((const struct OpaqueJSContext*) _tmp1_, _tmp2_, &_inner_error0_);
#line 81 "../src/client/util/util-webkit.vala"
	_tmp0_ = _tmp3_;
#line 81 "../src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/client/util/util-webkit.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 81 "../src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error0_);
#line 81 "../src/client/util/util-webkit.vala"
			return NULL;
#line 345 "util-webkit.c"
		} else {
#line 81 "../src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error0_);
#line 81 "../src/client/util/util-webkit.vala"
			return NULL;
#line 353 "util-webkit.c"
		}
	}
#line 81 "../src/client/util/util-webkit.vala"
	_tmp4_ = _tmp0_;
#line 81 "../src/client/util/util-webkit.vala"
	_tmp0_ = NULL;
#line 81 "../src/client/util/util-webkit.vala"
	result = _tmp4_;
#line 81 "../src/client/util/util-webkit.vala"
	_0 (_tmp0_);
#line 81 "../src/client/util/util-webkit.vala"
	return result;
#line 366 "util-webkit.c"
}

