/* geary-credentials.c generated by valac 0.44.1, the Vala compiler
 * generated from geary-credentials.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define GEARY_TYPE_BASE_INTERFACE (geary_base_interface_get_type ())
#define GEARY_BASE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface))
#define GEARY_IS_BASE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_INTERFACE))
#define GEARY_BASE_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_TYPE_BASE_INTERFACE, GearyBaseInterfaceIface))

typedef struct _GearyBaseInterface GearyBaseInterface;
typedef struct _GearyBaseInterfaceIface GearyBaseInterfaceIface;

#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;
typedef struct _GearyBaseObjectPrivate GearyBaseObjectPrivate;

#define GEARY_TYPE_CREDENTIALS (geary_credentials_get_type ())
#define GEARY_CREDENTIALS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_CREDENTIALS, GearyCredentials))
#define GEARY_CREDENTIALS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_CREDENTIALS, GearyCredentialsClass))
#define GEARY_IS_CREDENTIALS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_CREDENTIALS))
#define GEARY_IS_CREDENTIALS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_CREDENTIALS))
#define GEARY_CREDENTIALS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_CREDENTIALS, GearyCredentialsClass))

typedef struct _GearyCredentials GearyCredentials;
typedef struct _GearyCredentialsClass GearyCredentialsClass;
typedef struct _GearyCredentialsPrivate GearyCredentialsPrivate;
typedef enum  {
	GEARY_CREDENTIALS_METHOD_PASSWORD,
	GEARY_CREDENTIALS_METHOD_OAUTH2
} GearyCredentialsMethod;

#define GEARY_CREDENTIALS_TYPE_METHOD (geary_credentials_method_get_type ())
enum  {
	GEARY_CREDENTIALS_0_PROPERTY,
	GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY,
	GEARY_CREDENTIALS_USER_PROPERTY,
	GEARY_CREDENTIALS_TOKEN_PROPERTY,
	GEARY_CREDENTIALS_NUM_PROPERTIES
};
static GParamSpec* geary_credentials_properties[GEARY_CREDENTIALS_NUM_PROPERTIES];
typedef enum  {
	GEARY_CREDENTIALS_REQUIREMENT_NONE,
	GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING,
	GEARY_CREDENTIALS_REQUIREMENT_CUSTOM
} GearyCredentialsRequirement;

#define GEARY_CREDENTIALS_TYPE_REQUIREMENT (geary_credentials_requirement_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GearyBaseInterfaceIface {
	GTypeInterface parent_iface;
};

struct _GearyBaseObject {
	GObject parent_instance;
	GearyBaseObjectPrivate * priv;
};

struct _GearyBaseObjectClass {
	GObjectClass parent_class;
};

struct _GearyCredentials {
	GearyBaseObject parent_instance;
	GearyCredentialsPrivate * priv;
};

struct _GearyCredentialsClass {
	GearyBaseObjectClass parent_class;
};

struct _GearyCredentialsPrivate {
	GearyCredentialsMethod _supported_method;
	gchar* _user;
	gchar* _token;
};

typedef enum  {
	GEARY_ENGINE_ERROR_OPEN_REQUIRED,
	GEARY_ENGINE_ERROR_ALREADY_OPEN,
	GEARY_ENGINE_ERROR_ALREADY_EXISTS,
	GEARY_ENGINE_ERROR_ALREADY_CLOSED,
	GEARY_ENGINE_ERROR_CLOSE_REQUIRED,
	GEARY_ENGINE_ERROR_NOT_FOUND,
	GEARY_ENGINE_ERROR_BAD_PARAMETERS,
	GEARY_ENGINE_ERROR_INCOMPLETE_MESSAGE,
	GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE,
	GEARY_ENGINE_ERROR_CORRUPT,
	GEARY_ENGINE_ERROR_PERMISSIONS,
	GEARY_ENGINE_ERROR_VERSION,
	GEARY_ENGINE_ERROR_UNSUPPORTED
} GearyEngineError;
#define GEARY_ENGINE_ERROR geary_engine_error_quark ()

static gint GearyCredentials_private_offset;
static gpointer geary_credentials_parent_class = NULL;
static GeeHashableIface * geary_credentials_gee_hashable_parent_iface = NULL;

GType geary_base_interface_get_type (void) G_GNUC_CONST;
GType geary_base_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyBaseObject, g_object_unref)
GType geary_credentials_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyCredentials, g_object_unref)
GType geary_credentials_method_get_type (void) G_GNUC_CONST;
gchar* geary_credentials_method_to_string (GearyCredentialsMethod self);
GearyCredentialsMethod geary_credentials_method_from_string (const gchar* str,
                                                             GError** error);
GType geary_credentials_requirement_get_type (void) G_GNUC_CONST;
GQuark geary_engine_error_quark (void);
GearyCredentialsRequirement geary_credentials_requirement_for_value (const gchar* value,
                                                                     GError** error);
gpointer geary_object_utils_from_enum_nick (GType e_type,
                                            GBoxedCopyFunc e_dup_func,
                                            GDestroyNotify e_destroy_func,
                                            GType type,
                                            const gchar* nick,
                                            GError** error);
gchar* geary_credentials_requirement_to_value (GearyCredentialsRequirement self);
gchar* geary_object_utils_to_enum_nick (GType e_type,
                                        GBoxedCopyFunc e_dup_func,
                                        GDestroyNotify e_destroy_func,
                                        GType type,
                                        gconstpointer value);
GearyCredentials* geary_credentials_new (GearyCredentialsMethod supported_method,
                                         const gchar* user,
                                         const gchar* token);
GearyCredentials* geary_credentials_construct (GType object_type,
                                               GearyCredentialsMethod supported_method,
                                               const gchar* user,
                                               const gchar* token);
GearyBaseObject* geary_base_object_construct (GType object_type);
static void geary_credentials_set_supported_method (GearyCredentials* self,
                                             GearyCredentialsMethod value);
static void geary_credentials_set_user (GearyCredentials* self,
                                 const gchar* value);
static void geary_credentials_set_token (GearyCredentials* self,
                                  const gchar* value);
gboolean geary_credentials_is_complete (GearyCredentials* self);
const gchar* geary_credentials_get_token (GearyCredentials* self);
GearyCredentials* geary_credentials_copy_with_user (GearyCredentials* self,
                                                    const gchar* user);
GearyCredentialsMethod geary_credentials_get_supported_method (GearyCredentials* self);
GearyCredentials* geary_credentials_copy_with_token (GearyCredentials* self,
                                                     const gchar* token);
const gchar* geary_credentials_get_user (GearyCredentials* self);
GearyCredentials* geary_credentials_copy (GearyCredentials* self);
gchar* geary_credentials_to_string (GearyCredentials* self);
static gboolean geary_credentials_real_equal_to (GeeHashable* base,
                                          GearyCredentials* c);
static guint geary_credentials_real_hash (GeeHashable* base);
static void geary_credentials_finalize (GObject * obj);
static void _vala_geary_credentials_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_geary_credentials_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
geary_credentials_get_instance_private (GearyCredentials* self)
{
	return G_STRUCT_MEMBER_P (self, GearyCredentials_private_offset);
}

gchar*
geary_credentials_method_to_string (GearyCredentialsMethod self)
{
	gchar* result = NULL;
#line 44 "../src/engine/api/geary-credentials.vala"
	switch (self) {
#line 44 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_METHOD_PASSWORD:
#line 196 "geary-credentials.c"
		{
			gchar* _tmp0_;
#line 46 "../src/engine/api/geary-credentials.vala"
			_tmp0_ = g_strdup ("password");
#line 46 "../src/engine/api/geary-credentials.vala"
			result = _tmp0_;
#line 46 "../src/engine/api/geary-credentials.vala"
			return result;
#line 205 "geary-credentials.c"
		}
#line 44 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_METHOD_OAUTH2:
#line 209 "geary-credentials.c"
		{
			gchar* _tmp1_;
#line 49 "../src/engine/api/geary-credentials.vala"
			_tmp1_ = g_strdup ("oauth2");
#line 49 "../src/engine/api/geary-credentials.vala"
			result = _tmp1_;
#line 49 "../src/engine/api/geary-credentials.vala"
			return result;
#line 218 "geary-credentials.c"
		}
		default:
		{
#line 52 "../src/engine/api/geary-credentials.vala"
			g_assert_not_reached ();
#line 224 "geary-credentials.c"
		}
	}
}

GearyCredentialsMethod
geary_credentials_method_from_string (const gchar* str,
                                      GError** error)
{
	GearyCredentialsMethod result = 0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 57 "../src/engine/api/geary-credentials.vala"
	static GQuark _tmp1_label0 = 0;
#line 57 "../src/engine/api/geary-credentials.vala"
	static GQuark _tmp1_label1 = 0;
#line 240 "geary-credentials.c"
	GError* _inner_error0_ = NULL;
#line 56 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 57 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = str;
#line 57 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 57 "../src/engine/api/geary-credentials.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("password")))) {
#line 57 "../src/engine/api/geary-credentials.vala"
		switch (0) {
#line 252 "geary-credentials.c"
			default:
			{
#line 59 "../src/engine/api/geary-credentials.vala"
				result = GEARY_CREDENTIALS_METHOD_PASSWORD;
#line 59 "../src/engine/api/geary-credentials.vala"
				return result;
#line 259 "geary-credentials.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("oauth2")))) {
#line 57 "../src/engine/api/geary-credentials.vala"
		switch (0) {
#line 265 "geary-credentials.c"
			default:
			{
#line 62 "../src/engine/api/geary-credentials.vala"
				result = GEARY_CREDENTIALS_METHOD_OAUTH2;
#line 62 "../src/engine/api/geary-credentials.vala"
				return result;
#line 272 "geary-credentials.c"
			}
		}
	} else {
#line 57 "../src/engine/api/geary-credentials.vala"
		switch (0) {
#line 278 "geary-credentials.c"
			default:
			{
				GError* _tmp3_;
#line 65 "../src/engine/api/geary-credentials.vala"
				_tmp3_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, "Unknown credentials method type: %s", str);
#line 65 "../src/engine/api/geary-credentials.vala"
				_inner_error0_ = _tmp3_;
#line 65 "../src/engine/api/geary-credentials.vala"
				g_propagate_error (error, _inner_error0_);
#line 65 "../src/engine/api/geary-credentials.vala"
				return 0;
#line 290 "geary-credentials.c"
			}
		}
	}
}

/**
     * Authentication methods supported by the Engine.
     */
GType
geary_credentials_method_get_type (void)
{
	static volatile gsize geary_credentials_method_type_id__volatile = 0;
	if (g_once_init_enter (&geary_credentials_method_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_CREDENTIALS_METHOD_PASSWORD, "GEARY_CREDENTIALS_METHOD_PASSWORD", "password"}, {GEARY_CREDENTIALS_METHOD_OAUTH2, "GEARY_CREDENTIALS_METHOD_OAUTH2", "oauth2"}, {0, NULL, NULL}};
		GType geary_credentials_method_type_id;
		geary_credentials_method_type_id = g_enum_register_static ("GearyCredentialsMethod", values);
		g_once_init_leave (&geary_credentials_method_type_id__volatile, geary_credentials_method_type_id);
	}
	return geary_credentials_method_type_id__volatile;
}

GearyCredentialsRequirement
geary_credentials_requirement_for_value (const gchar* value,
                                         GError** error)
{
	GearyCredentialsRequirement result = 0;
	GearyCredentialsRequirement _tmp0_ = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	GearyCredentialsRequirement _tmp4_;
	GError* _inner_error0_ = NULL;
#line 84 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = g_ascii_strdown (value, (gssize) -1);
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = _tmp1_;
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = geary_object_utils_from_enum_nick (GEARY_CREDENTIALS_TYPE_REQUIREMENT, NULL, NULL, GEARY_CREDENTIALS_TYPE_REQUIREMENT, _tmp2_, &_inner_error0_);
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp4_ = (GearyCredentialsRequirement) ((gintptr) _tmp3_);
#line 86 "../src/engine/api/geary-credentials.vala"
	_g_free0 (_tmp2_);
#line 86 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = _tmp4_;
#line 86 "../src/engine/api/geary-credentials.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../src/engine/api/geary-credentials.vala"
		if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 86 "../src/engine/api/geary-credentials.vala"
			g_propagate_error (error, _inner_error0_);
#line 86 "../src/engine/api/geary-credentials.vala"
			return 0;
#line 345 "geary-credentials.c"
		} else {
#line 86 "../src/engine/api/geary-credentials.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 86 "../src/engine/api/geary-credentials.vala"
			g_clear_error (&_inner_error0_);
#line 86 "../src/engine/api/geary-credentials.vala"
			return 0;
#line 353 "geary-credentials.c"
		}
	}
#line 86 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 86 "../src/engine/api/geary-credentials.vala"
	return result;
#line 360 "geary-credentials.c"
}

gchar*
geary_credentials_requirement_to_value (GearyCredentialsRequirement self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 92 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (GEARY_CREDENTIALS_TYPE_REQUIREMENT, NULL, NULL, GEARY_CREDENTIALS_TYPE_REQUIREMENT, (gpointer) ((gintptr) self));
#line 92 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 92 "../src/engine/api/geary-credentials.vala"
	return result;
#line 374 "geary-credentials.c"
}

/** The requirements for a service's credentials. */
GType
geary_credentials_requirement_get_type (void)
{
	static volatile gsize geary_credentials_requirement_type_id__volatile = 0;
	if (g_once_init_enter (&geary_credentials_requirement_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_CREDENTIALS_REQUIREMENT_NONE, "GEARY_CREDENTIALS_REQUIREMENT_NONE", "none"}, {GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING, "GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING", "use-incoming"}, {GEARY_CREDENTIALS_REQUIREMENT_CUSTOM, "GEARY_CREDENTIALS_REQUIREMENT_CUSTOM", "custom"}, {0, NULL, NULL}};
		GType geary_credentials_requirement_type_id;
		geary_credentials_requirement_type_id = g_enum_register_static ("GearyCredentialsRequirement", values);
		g_once_init_leave (&geary_credentials_requirement_type_id__volatile, geary_credentials_requirement_type_id);
	}
	return geary_credentials_requirement_type_id__volatile;
}

GearyCredentials*
geary_credentials_construct (GType object_type,
                             GearyCredentialsMethod supported_method,
                             const gchar* user,
                             const gchar* token)
{
	GearyCredentials * self = NULL;
#line 104 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 104 "../src/engine/api/geary-credentials.vala"
	self = (GearyCredentials*) geary_base_object_construct (object_type);
#line 105 "../src/engine/api/geary-credentials.vala"
	geary_credentials_set_supported_method (self, supported_method);
#line 106 "../src/engine/api/geary-credentials.vala"
	geary_credentials_set_user (self, user);
#line 107 "../src/engine/api/geary-credentials.vala"
	geary_credentials_set_token (self, token);
#line 104 "../src/engine/api/geary-credentials.vala"
	return self;
#line 410 "geary-credentials.c"
}

GearyCredentials*
geary_credentials_new (GearyCredentialsMethod supported_method,
                       const gchar* user,
                       const gchar* token)
{
#line 104 "../src/engine/api/geary-credentials.vala"
	return geary_credentials_construct (GEARY_TYPE_CREDENTIALS, supported_method, user, token);
#line 420 "geary-credentials.c"
}

/** Determines if a token has been provided. */
gboolean
geary_credentials_is_complete (GearyCredentials* self)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
#line 111 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), FALSE);
#line 112 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_token;
#line 112 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_ != NULL;
#line 112 "../src/engine/api/geary-credentials.vala"
	return result;
#line 437 "geary-credentials.c"
}

GearyCredentials*
geary_credentials_copy_with_user (GearyCredentials* self,
                                  const gchar* user)
{
	GearyCredentials* result = NULL;
	GearyCredentialsMethod _tmp0_;
	const gchar* _tmp1_;
	GearyCredentials* _tmp2_;
#line 115 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 115 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 116 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_supported_method;
#line 116 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_token;
#line 116 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = geary_credentials_new (_tmp0_, user, _tmp1_);
#line 116 "../src/engine/api/geary-credentials.vala"
	result = _tmp2_;
#line 116 "../src/engine/api/geary-credentials.vala"
	return result;
#line 462 "geary-credentials.c"
}

GearyCredentials*
geary_credentials_copy_with_token (GearyCredentials* self,
                                   const gchar* token)
{
	GearyCredentials* result = NULL;
	GearyCredentialsMethod _tmp0_;
	const gchar* _tmp1_;
	GearyCredentials* _tmp2_;
#line 119 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 120 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_supported_method;
#line 120 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_user;
#line 120 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = geary_credentials_new (_tmp0_, _tmp1_, token);
#line 120 "../src/engine/api/geary-credentials.vala"
	result = _tmp2_;
#line 120 "../src/engine/api/geary-credentials.vala"
	return result;
#line 485 "geary-credentials.c"
}

GearyCredentials*
geary_credentials_copy (GearyCredentials* self)
{
	GearyCredentials* result = NULL;
	GearyCredentialsMethod _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GearyCredentials* _tmp3_;
#line 123 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 124 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_supported_method;
#line 124 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_user;
#line 124 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = self->priv->_token;
#line 124 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = geary_credentials_new (_tmp0_, _tmp1_, _tmp2_);
#line 124 "../src/engine/api/geary-credentials.vala"
	result = _tmp3_;
#line 124 "../src/engine/api/geary-credentials.vala"
	return result;
#line 510 "geary-credentials.c"
}

gchar*
geary_credentials_to_string (GearyCredentials* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	GearyCredentialsMethod _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 127 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_user;
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_supported_method;
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = geary_credentials_method_to_string (_tmp1_);
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = _tmp2_;
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp4_ = g_strdup_printf ("%s:%s", _tmp0_, _tmp3_);
#line 128 "../src/engine/api/geary-credentials.vala"
	_tmp5_ = _tmp4_;
#line 128 "../src/engine/api/geary-credentials.vala"
	_g_free0 (_tmp3_);
#line 128 "../src/engine/api/geary-credentials.vala"
	result = _tmp5_;
#line 128 "../src/engine/api/geary-credentials.vala"
	return result;
#line 543 "geary-credentials.c"
}

static gboolean
geary_credentials_real_equal_to (GeeHashable* base,
                                 GearyCredentials* c)
{
	GearyCredentials * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GearyCredentialsMethod _tmp2_;
	GearyCredentialsMethod _tmp3_;
#line 131 "../src/engine/api/geary-credentials.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 131 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (c), FALSE);
#line 132 "../src/engine/api/geary-credentials.vala"
	if (self == c) {
#line 133 "../src/engine/api/geary-credentials.vala"
		result = TRUE;
#line 133 "../src/engine/api/geary-credentials.vala"
		return result;
#line 566 "geary-credentials.c"
	}
#line 136 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = self->priv->_supported_method;
#line 136 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = c->priv->_supported_method;
#line 136 "../src/engine/api/geary-credentials.vala"
	if (_tmp2_ == _tmp3_) {
#line 574 "geary-credentials.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 137 "../src/engine/api/geary-credentials.vala"
		_tmp4_ = self->priv->_user;
#line 137 "../src/engine/api/geary-credentials.vala"
		_tmp5_ = c->priv->_user;
#line 137 "../src/engine/api/geary-credentials.vala"
		_tmp1_ = g_strcmp0 (_tmp4_, _tmp5_) == 0;
#line 583 "geary-credentials.c"
	} else {
#line 136 "../src/engine/api/geary-credentials.vala"
		_tmp1_ = FALSE;
#line 587 "geary-credentials.c"
	}
#line 136 "../src/engine/api/geary-credentials.vala"
	if (_tmp1_) {
#line 591 "geary-credentials.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 138 "../src/engine/api/geary-credentials.vala"
		_tmp6_ = self->priv->_token;
#line 138 "../src/engine/api/geary-credentials.vala"
		_tmp7_ = c->priv->_token;
#line 138 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = g_strcmp0 (_tmp6_, _tmp7_) == 0;
#line 600 "geary-credentials.c"
	} else {
#line 136 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = FALSE;
#line 604 "geary-credentials.c"
	}
#line 135 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 135 "../src/engine/api/geary-credentials.vala"
	return result;
#line 610 "geary-credentials.c"
}

static guint
geary_credentials_real_hash (GeeHashable* base)
{
	GearyCredentials * self;
	guint result = 0U;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	GearyCredentialsMethod _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	guint _tmp6_;
#line 142 "../src/engine/api/geary-credentials.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 144 "../src/engine/api/geary-credentials.vala"
	_tmp1_ = self->priv->_token;
#line 144 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = _tmp1_;
#line 144 "../src/engine/api/geary-credentials.vala"
	if (_tmp0_ == NULL) {
#line 144 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = "";
#line 635 "geary-credentials.c"
	}
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp2_ = self->priv->_supported_method;
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp3_ = self->priv->_user;
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp4_ = g_strdup_printf ("%d%s%s", (gint) _tmp2_, _tmp3_, _tmp0_);
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp5_ = _tmp4_;
#line 143 "../src/engine/api/geary-credentials.vala"
	_tmp6_ = g_str_hash (_tmp5_);
#line 143 "../src/engine/api/geary-credentials.vala"
	_g_free0 (_tmp5_);
#line 143 "../src/engine/api/geary-credentials.vala"
	result = _tmp6_;
#line 143 "../src/engine/api/geary-credentials.vala"
	return result;
#line 653 "geary-credentials.c"
}

GearyCredentialsMethod
geary_credentials_get_supported_method (GearyCredentials* self)
{
	GearyCredentialsMethod result;
	GearyCredentialsMethod _tmp0_;
#line 100 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), 0);
#line 100 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_supported_method;
#line 100 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 100 "../src/engine/api/geary-credentials.vala"
	return result;
#line 669 "geary-credentials.c"
}

static void
geary_credentials_set_supported_method (GearyCredentials* self,
                                        GearyCredentialsMethod value)
{
#line 100 "../src/engine/api/geary-credentials.vala"
	g_return_if_fail (GEARY_IS_CREDENTIALS (self));
#line 100 "../src/engine/api/geary-credentials.vala"
	if (geary_credentials_get_supported_method (self) != value) {
#line 100 "../src/engine/api/geary-credentials.vala"
		self->priv->_supported_method = value;
#line 100 "../src/engine/api/geary-credentials.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_credentials_properties[GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY]);
#line 684 "geary-credentials.c"
	}
}

const gchar*
geary_credentials_get_user (GearyCredentials* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 101 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 101 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_user;
#line 101 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 101 "../src/engine/api/geary-credentials.vala"
	return result;
#line 701 "geary-credentials.c"
}

static void
geary_credentials_set_user (GearyCredentials* self,
                            const gchar* value)
{
#line 101 "../src/engine/api/geary-credentials.vala"
	g_return_if_fail (GEARY_IS_CREDENTIALS (self));
#line 101 "../src/engine/api/geary-credentials.vala"
	if (g_strcmp0 (value, geary_credentials_get_user (self)) != 0) {
#line 712 "geary-credentials.c"
		gchar* _tmp0_;
#line 101 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = g_strdup (value);
#line 101 "../src/engine/api/geary-credentials.vala"
		_g_free0 (self->priv->_user);
#line 101 "../src/engine/api/geary-credentials.vala"
		self->priv->_user = _tmp0_;
#line 101 "../src/engine/api/geary-credentials.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_credentials_properties[GEARY_CREDENTIALS_USER_PROPERTY]);
#line 722 "geary-credentials.c"
	}
}

const gchar*
geary_credentials_get_token (GearyCredentials* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 102 "../src/engine/api/geary-credentials.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS (self), NULL);
#line 102 "../src/engine/api/geary-credentials.vala"
	_tmp0_ = self->priv->_token;
#line 102 "../src/engine/api/geary-credentials.vala"
	result = _tmp0_;
#line 102 "../src/engine/api/geary-credentials.vala"
	return result;
#line 739 "geary-credentials.c"
}

static void
geary_credentials_set_token (GearyCredentials* self,
                             const gchar* value)
{
#line 102 "../src/engine/api/geary-credentials.vala"
	g_return_if_fail (GEARY_IS_CREDENTIALS (self));
#line 102 "../src/engine/api/geary-credentials.vala"
	if (g_strcmp0 (value, geary_credentials_get_token (self)) != 0) {
#line 750 "geary-credentials.c"
		gchar* _tmp0_;
#line 102 "../src/engine/api/geary-credentials.vala"
		_tmp0_ = g_strdup (value);
#line 102 "../src/engine/api/geary-credentials.vala"
		_g_free0 (self->priv->_token);
#line 102 "../src/engine/api/geary-credentials.vala"
		self->priv->_token = _tmp0_;
#line 102 "../src/engine/api/geary-credentials.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_credentials_properties[GEARY_CREDENTIALS_TOKEN_PROPERTY]);
#line 760 "geary-credentials.c"
	}
}

static void
geary_credentials_class_init (GearyCredentialsClass * klass,
                              gpointer klass_data)
{
#line 28 "../src/engine/api/geary-credentials.vala"
	geary_credentials_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/engine/api/geary-credentials.vala"
	g_type_class_adjust_private_offset (klass, &GearyCredentials_private_offset);
#line 28 "../src/engine/api/geary-credentials.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_credentials_get_property;
#line 28 "../src/engine/api/geary-credentials.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_credentials_set_property;
#line 28 "../src/engine/api/geary-credentials.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_credentials_finalize;
#line 28 "../src/engine/api/geary-credentials.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY, geary_credentials_properties[GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY] = g_param_spec_enum ("supported-method", "supported-method", "supported-method", GEARY_CREDENTIALS_TYPE_METHOD, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/engine/api/geary-credentials.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CREDENTIALS_USER_PROPERTY, geary_credentials_properties[GEARY_CREDENTIALS_USER_PROPERTY] = g_param_spec_string ("user", "user", "user", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/engine/api/geary-credentials.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_CREDENTIALS_TOKEN_PROPERTY, geary_credentials_properties[GEARY_CREDENTIALS_TOKEN_PROPERTY] = g_param_spec_string ("token", "token", "token", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 784 "geary-credentials.c"
}

static void
geary_credentials_gee_hashable_interface_init (GeeHashableIface * iface,
                                               gpointer iface_data)
{
#line 28 "../src/engine/api/geary-credentials.vala"
	geary_credentials_gee_hashable_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "../src/engine/api/geary-credentials.vala"
	iface->equal_to = (gboolean (*) (GeeHashable*, gconstpointer)) geary_credentials_real_equal_to;
#line 28 "../src/engine/api/geary-credentials.vala"
	iface->hash = (guint (*) (GeeHashable*)) geary_credentials_real_hash;
#line 797 "geary-credentials.c"
}

static void
geary_credentials_instance_init (GearyCredentials * self,
                                 gpointer klass)
{
#line 28 "../src/engine/api/geary-credentials.vala"
	self->priv = geary_credentials_get_instance_private (self);
#line 806 "geary-credentials.c"
}

static void
geary_credentials_finalize (GObject * obj)
{
	GearyCredentials * self;
#line 28 "../src/engine/api/geary-credentials.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 101 "../src/engine/api/geary-credentials.vala"
	_g_free0 (self->priv->_user);
#line 102 "../src/engine/api/geary-credentials.vala"
	_g_free0 (self->priv->_token);
#line 28 "../src/engine/api/geary-credentials.vala"
	G_OBJECT_CLASS (geary_credentials_parent_class)->finalize (obj);
#line 821 "geary-credentials.c"
}

/**
 * Credentials provide a user's access details for authentication.
 *
 * The {@link user} property specifies the user's log in name, and the
 * {@link token} property is a shared secret between the user and a
 * service. For password-based schemes, this would be a password.

 * The token property may be null. This indicates the Credentials are
 * incomplete and need further information (i.e. prompt user for
 * username, fetch password from keyring, etc.). The token may be a
 * non-null zero-length string; this is considered valid and
 * is_complete() will return true in this case.
 *
 * Note that Geary will hold Credentials in memory for the long-term,
 * usually the duration of the application.  This is because network
 * resources often have to be connected (or reconnected) to in the
 * background and asking the user to reauthenticate each time is
 * deemed inconvenient.
 */
GType
geary_credentials_get_type (void)
{
	static volatile gsize geary_credentials_type_id__volatile = 0;
	if (g_once_init_enter (&geary_credentials_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyCredentialsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_credentials_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyCredentials), 0, (GInstanceInitFunc) geary_credentials_instance_init, NULL };
		static const GInterfaceInfo gee_hashable_info = { (GInterfaceInitFunc) geary_credentials_gee_hashable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType geary_credentials_type_id;
		geary_credentials_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyCredentials", &g_define_type_info, 0);
		g_type_add_interface_static (geary_credentials_type_id, GEE_TYPE_HASHABLE, &gee_hashable_info);
		GearyCredentials_private_offset = g_type_add_instance_private (geary_credentials_type_id, sizeof (GearyCredentialsPrivate));
		g_once_init_leave (&geary_credentials_type_id__volatile, geary_credentials_type_id);
	}
	return geary_credentials_type_id__volatile;
}

static void
_vala_geary_credentials_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GearyCredentials * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 28 "../src/engine/api/geary-credentials.vala"
	switch (property_id) {
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		g_value_set_enum (value, geary_credentials_get_supported_method (self));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_USER_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		g_value_set_string (value, geary_credentials_get_user (self));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_TOKEN_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		g_value_set_string (value, geary_credentials_get_token (self));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 887 "geary-credentials.c"
		default:
#line 28 "../src/engine/api/geary-credentials.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 893 "geary-credentials.c"
	}
}

static void
_vala_geary_credentials_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	GearyCredentials * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_CREDENTIALS, GearyCredentials);
#line 28 "../src/engine/api/geary-credentials.vala"
	switch (property_id) {
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_SUPPORTED_METHOD_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		geary_credentials_set_supported_method (self, g_value_get_enum (value));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_USER_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		geary_credentials_set_user (self, g_value_get_string (value));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 28 "../src/engine/api/geary-credentials.vala"
		case GEARY_CREDENTIALS_TOKEN_PROPERTY:
#line 28 "../src/engine/api/geary-credentials.vala"
		geary_credentials_set_token (self, g_value_get_string (value));
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 925 "geary-credentials.c"
		default:
#line 28 "../src/engine/api/geary-credentials.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/engine/api/geary-credentials.vala"
		break;
#line 931 "geary-credentials.c"
	}
}

