/* geary-logging.c generated by valac 0.44.1, the Vala compiler
 * generated from geary-logging.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#define _XOPEN_SOURCE

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>

typedef enum  {
	GEARY_LOGGING_FLAG_NONE = 0,
	GEARY_LOGGING_FLAG_NETWORK = 1 << 0,
	GEARY_LOGGING_FLAG_SERIALIZER = 1 << 1,
	GEARY_LOGGING_FLAG_REPLAY = 1 << 2,
	GEARY_LOGGING_FLAG_CONVERSATIONS = 1 << 3,
	GEARY_LOGGING_FLAG_PERIODIC = 1 << 4,
	GEARY_LOGGING_FLAG_SQL = 1 << 5,
	GEARY_LOGGING_FLAG_FOLDER_NORMALIZATION = 1 << 6,
	GEARY_LOGGING_FLAG_DESERIALIZER = 1 << 7
} GearyLoggingFlag;

#define GEARY_LOGGING_TYPE_FLAG (geary_logging_flag_get_type ())
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

extern gint geary_logging_init_count;
gint geary_logging_init_count = 0;
extern GearyLoggingFlag geary_logging_logging_flags;
GearyLoggingFlag geary_logging_logging_flags = GEARY_LOGGING_FLAG_NONE;
extern FILE* geary_logging_stream;
FILE* geary_logging_stream = NULL;
extern GTimer* geary_logging_entry_timer;
GTimer* geary_logging_entry_timer = NULL;

#define GEARY_LOGGING_DOMAIN "Geary"
GType geary_logging_flag_get_type (void) G_GNUC_CONST;
gboolean geary_logging_flag_is_all_set (GearyLoggingFlag self,
                                        GearyLoggingFlag flags);
gboolean geary_logging_flag_is_any_set (GearyLoggingFlag self,
                                        GearyLoggingFlag flags);
void geary_logging_init (void);
void geary_logging_set_flags (GearyLoggingFlag flags);
void geary_logging_enable_flags (GearyLoggingFlag flags);
void geary_logging_disable_flags (GearyLoggingFlag flags);
GearyLoggingFlag geary_logging_get_flags (void);
gboolean geary_logging_are_all_flags_set (GearyLoggingFlag flags);
void geary_logging_error (GearyLoggingFlag flags,
                          const gchar* fmt,
                          ...) G_GNUC_PRINTF(2,3);
void geary_logging_critical (GearyLoggingFlag flags,
                             const gchar* fmt,
                             ...) G_GNUC_PRINTF(2,3);
void geary_logging_warning (GearyLoggingFlag flags,
                            const gchar* fmt,
                            ...) G_GNUC_PRINTF(2,3);
void geary_logging_message (GearyLoggingFlag flags,
                            const gchar* fmt,
                            ...) G_GNUC_PRINTF(2,3);
void geary_logging_debug (GearyLoggingFlag flags,
                          const gchar* fmt,
                          ...) G_GNUC_PRINTF(2,3);
void geary_logging_log_to (FILE* stream);
void geary_logging_default_handler (const gchar* domain,
                                    GLogLevelFlags log_levels,
                                    const gchar* message);
gchar* geary_logging_to_prefix (GLogLevelFlags level);

inline gboolean
geary_logging_flag_is_all_set (GearyLoggingFlag self,
                               GearyLoggingFlag flags)
{
	gboolean result = FALSE;
#line 31 "../src/engine/api/geary-logging.vala"
	result = (flags & self) == flags;
#line 31 "../src/engine/api/geary-logging.vala"
	return result;
#line 88 "geary-logging.c"
}

inline gboolean
geary_logging_flag_is_any_set (GearyLoggingFlag self,
                               GearyLoggingFlag flags)
{
	gboolean result = FALSE;
#line 35 "../src/engine/api/geary-logging.vala"
	result = (flags & self) != 0;
#line 35 "../src/engine/api/geary-logging.vala"
	return result;
#line 100 "geary-logging.c"
}

GType
geary_logging_flag_get_type (void)
{
	static volatile gsize geary_logging_flag_type_id__volatile = 0;
	if (g_once_init_enter (&geary_logging_flag_type_id__volatile)) {
		static const GFlagsValue values[] = {{GEARY_LOGGING_FLAG_NONE, "GEARY_LOGGING_FLAG_NONE", "none"}, {GEARY_LOGGING_FLAG_NETWORK, "GEARY_LOGGING_FLAG_NETWORK", "network"}, {GEARY_LOGGING_FLAG_SERIALIZER, "GEARY_LOGGING_FLAG_SERIALIZER", "serializer"}, {GEARY_LOGGING_FLAG_REPLAY, "GEARY_LOGGING_FLAG_REPLAY", "replay"}, {GEARY_LOGGING_FLAG_CONVERSATIONS, "GEARY_LOGGING_FLAG_CONVERSATIONS", "conversations"}, {GEARY_LOGGING_FLAG_PERIODIC, "GEARY_LOGGING_FLAG_PERIODIC", "periodic"}, {GEARY_LOGGING_FLAG_SQL, "GEARY_LOGGING_FLAG_SQL", "sql"}, {GEARY_LOGGING_FLAG_FOLDER_NORMALIZATION, "GEARY_LOGGING_FLAG_FOLDER_NORMALIZATION", "folder-normalization"}, {GEARY_LOGGING_FLAG_DESERIALIZER, "GEARY_LOGGING_FLAG_DESERIALIZER", "deserializer"}, {0, NULL, NULL}};
		GType geary_logging_flag_type_id;
		geary_logging_flag_type_id = g_flags_register_static ("GearyLoggingFlag", values);
		g_once_init_leave (&geary_logging_flag_type_id__volatile, geary_logging_flag_type_id);
	}
	return geary_logging_flag_type_id__volatile;
}

/**
 * Must be called before ''any'' call to the Logging namespace.
 *
 * This will be initialized by the Engine when it's opened, but applications may want to set up
 * logging before that, in which case, call this directly.
 */
void
geary_logging_init (void)
{
	gint _tmp0_;
	GTimer* _tmp1_;
#line 51 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_init_count;
#line 51 "../src/engine/api/geary-logging.vala"
	geary_logging_init_count = _tmp0_ + 1;
#line 51 "../src/engine/api/geary-logging.vala"
	if (_tmp0_ != 0) {
#line 52 "../src/engine/api/geary-logging.vala"
		return;
#line 135 "geary-logging.c"
	}
#line 53 "../src/engine/api/geary-logging.vala"
	_tmp1_ = g_timer_new ();
#line 53 "../src/engine/api/geary-logging.vala"
	_g_timer_destroy0 (geary_logging_entry_timer);
#line 53 "../src/engine/api/geary-logging.vala"
	geary_logging_entry_timer = _tmp1_;
#line 143 "geary-logging.c"
}

/**
 * Replaces the current logging flags with flags.  Use Geary.Logging.Flag.NONE to clear all
 * logging flags.
 */
void
geary_logging_set_flags (GearyLoggingFlag flags)
{
#line 61 "../src/engine/api/geary-logging.vala"
	geary_logging_logging_flags = flags;
#line 155 "geary-logging.c"
}

/**
 * Adds the supplied flags to the current logging flags without disturbing the others.
 */
void
geary_logging_enable_flags (GearyLoggingFlag flags)
{
	GearyLoggingFlag _tmp0_;
#line 68 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_logging_flags;
#line 68 "../src/engine/api/geary-logging.vala"
	geary_logging_logging_flags = _tmp0_ | flags;
#line 169 "geary-logging.c"
}

/**
 * Removes the supplied flags from the current logging flags without disturbing the others.
 */
void
geary_logging_disable_flags (GearyLoggingFlag flags)
{
	GearyLoggingFlag _tmp0_;
#line 75 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_logging_flags;
#line 75 "../src/engine/api/geary-logging.vala"
	geary_logging_logging_flags = _tmp0_ & (~flags);
#line 183 "geary-logging.c"
}

/**
 * Returns the current logging flags.
 */
GearyLoggingFlag
geary_logging_get_flags (void)
{
	GearyLoggingFlag result = 0U;
	GearyLoggingFlag _tmp0_;
#line 82 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_logging_flags;
#line 82 "../src/engine/api/geary-logging.vala"
	result = _tmp0_;
#line 82 "../src/engine/api/geary-logging.vala"
	return result;
#line 200 "geary-logging.c"
}

/**
 * Returns true if all the flag(s) are set.
 */
inline gboolean
geary_logging_are_all_flags_set (GearyLoggingFlag flags)
{
	gboolean result = FALSE;
	GearyLoggingFlag _tmp0_;
#line 89 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_logging_flags;
#line 89 "../src/engine/api/geary-logging.vala"
	result = geary_logging_flag_is_all_set (_tmp0_, flags);
#line 89 "../src/engine/api/geary-logging.vala"
	return result;
#line 217 "geary-logging.c"
}

inline void
geary_logging_error (GearyLoggingFlag flags,
                     const gchar* fmt,
                     ...)
{
	GearyLoggingFlag _tmp0_;
#line 93 "../src/engine/api/geary-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 94 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_logging_flags;
#line 94 "../src/engine/api/geary-logging.vala"
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
#line 232 "geary-logging.c"
		va_list _tmp1_ = {0};
#line 95 "../src/engine/api/geary-logging.vala"
		va_start (_tmp1_, fmt);
#line 95 "../src/engine/api/geary-logging.vala"
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_ERROR, fmt, _tmp1_);
#line 95 "../src/engine/api/geary-logging.vala"
		va_end (_tmp1_);
#line 240 "geary-logging.c"
	}
}

inline void
geary_logging_critical (GearyLoggingFlag flags,
                        const gchar* fmt,
                        ...)
{
	GearyLoggingFlag _tmp0_;
#line 99 "../src/engine/api/geary-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 100 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_logging_flags;
#line 100 "../src/engine/api/geary-logging.vala"
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
#line 256 "geary-logging.c"
		va_list _tmp1_ = {0};
#line 101 "../src/engine/api/geary-logging.vala"
		va_start (_tmp1_, fmt);
#line 101 "../src/engine/api/geary-logging.vala"
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_CRITICAL, fmt, _tmp1_);
#line 101 "../src/engine/api/geary-logging.vala"
		va_end (_tmp1_);
#line 264 "geary-logging.c"
	}
}

inline void
geary_logging_warning (GearyLoggingFlag flags,
                       const gchar* fmt,
                       ...)
{
	GearyLoggingFlag _tmp0_;
#line 105 "../src/engine/api/geary-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 106 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_logging_flags;
#line 106 "../src/engine/api/geary-logging.vala"
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
#line 280 "geary-logging.c"
		va_list _tmp1_ = {0};
#line 107 "../src/engine/api/geary-logging.vala"
		va_start (_tmp1_, fmt);
#line 107 "../src/engine/api/geary-logging.vala"
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_WARNING, fmt, _tmp1_);
#line 107 "../src/engine/api/geary-logging.vala"
		va_end (_tmp1_);
#line 288 "geary-logging.c"
	}
}

inline void
geary_logging_message (GearyLoggingFlag flags,
                       const gchar* fmt,
                       ...)
{
	GearyLoggingFlag _tmp0_;
#line 111 "../src/engine/api/geary-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 112 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_logging_flags;
#line 112 "../src/engine/api/geary-logging.vala"
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
#line 304 "geary-logging.c"
		va_list _tmp1_ = {0};
#line 113 "../src/engine/api/geary-logging.vala"
		va_start (_tmp1_, fmt);
#line 113 "../src/engine/api/geary-logging.vala"
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_MESSAGE, fmt, _tmp1_);
#line 113 "../src/engine/api/geary-logging.vala"
		va_end (_tmp1_);
#line 312 "geary-logging.c"
	}
}

inline void
geary_logging_debug (GearyLoggingFlag flags,
                     const gchar* fmt,
                     ...)
{
	GearyLoggingFlag _tmp0_;
#line 117 "../src/engine/api/geary-logging.vala"
	g_return_if_fail (fmt != NULL);
#line 118 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_logging_flags;
#line 118 "../src/engine/api/geary-logging.vala"
	if (geary_logging_flag_is_any_set (_tmp0_, flags)) {
#line 328 "geary-logging.c"
		va_list _tmp1_ = {0};
#line 119 "../src/engine/api/geary-logging.vala"
		va_start (_tmp1_, fmt);
#line 119 "../src/engine/api/geary-logging.vala"
		g_logv (GEARY_LOGGING_DOMAIN, G_LOG_LEVEL_DEBUG, fmt, _tmp1_);
#line 119 "../src/engine/api/geary-logging.vala"
		va_end (_tmp1_);
#line 336 "geary-logging.c"
	}
}

/**
 * Registers a FileStream to receive all log output from the Engine, be it via the specialized
 * Logging calls (which use the topic-based {@link Flag} or GLib's standard issue
 * debug/message/error/etc. calls ... thus, calling this will also affect the Engine user's calls
 * to those functions.
 *
 * If stream is null, no logging occurs.  This is default.
 */
void
geary_logging_log_to (FILE* stream)
{
#line 132 "../src/engine/api/geary-logging.vala"
	geary_logging_stream = stream;
#line 353 "geary-logging.c"
}

static void
g_time_local (time_t time,
              struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
#line 2944 "glib-2.0.vapi"
	localtime_r (&time, &_tmp0_);
#line 2944 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 2945 "glib-2.0.vapi"
	*result = _result_;
#line 2945 "glib-2.0.vapi"
	return;
#line 370 "geary-logging.c"
}

void
geary_logging_default_handler (const gchar* domain,
                               GLogLevelFlags log_levels,
                               const gchar* message)
{
	FILE* out = NULL;
	FILE* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	FILE* _tmp4_;
#line 135 "../src/engine/api/geary-logging.vala"
	g_return_if_fail (message != NULL);
#line 138 "../src/engine/api/geary-logging.vala"
	_tmp0_ = geary_logging_stream;
#line 138 "../src/engine/api/geary-logging.vala"
	out = _tmp0_;
#line 139 "../src/engine/api/geary-logging.vala"
	_tmp4_ = out;
#line 139 "../src/engine/api/geary-logging.vala"
	if (_tmp4_ != NULL) {
#line 139 "../src/engine/api/geary-logging.vala"
		_tmp3_ = TRUE;
#line 396 "geary-logging.c"
	} else {
#line 140 "../src/engine/api/geary-logging.vala"
		_tmp3_ = (G_LOG_LEVEL_WARNING & log_levels) > 0;
#line 400 "geary-logging.c"
	}
#line 139 "../src/engine/api/geary-logging.vala"
	if (_tmp3_) {
#line 139 "../src/engine/api/geary-logging.vala"
		_tmp2_ = TRUE;
#line 406 "geary-logging.c"
	} else {
#line 141 "../src/engine/api/geary-logging.vala"
		_tmp2_ = (G_LOG_LEVEL_CRITICAL & log_levels) > 0;
#line 410 "geary-logging.c"
	}
#line 139 "../src/engine/api/geary-logging.vala"
	if (_tmp2_) {
#line 139 "../src/engine/api/geary-logging.vala"
		_tmp1_ = TRUE;
#line 416 "geary-logging.c"
	} else {
#line 142 "../src/engine/api/geary-logging.vala"
		_tmp1_ = (G_LOG_LEVEL_ERROR & log_levels) > 0;
#line 420 "geary-logging.c"
	}
#line 139 "../src/engine/api/geary-logging.vala"
	if (_tmp1_) {
#line 424 "geary-logging.c"
		FILE* _tmp5_;
		struct tm tm = {0};
		time_t _tmp7_;
		struct tm _tmp8_ = {0};
		const gchar* _tmp9_ = NULL;
		FILE* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		struct tm _tmp13_;
		struct tm _tmp14_;
		struct tm _tmp15_;
		GTimer* _tmp16_;
		GTimer* _tmp17_;
#line 144 "../src/engine/api/geary-logging.vala"
		_tmp5_ = out;
#line 144 "../src/engine/api/geary-logging.vala"
		if (_tmp5_ == NULL) {
#line 442 "geary-logging.c"
			FILE* _tmp6_;
#line 145 "../src/engine/api/geary-logging.vala"
			_tmp6_ = stderr;
#line 145 "../src/engine/api/geary-logging.vala"
			out = _tmp6_;
#line 448 "geary-logging.c"
		}
#line 148 "../src/engine/api/geary-logging.vala"
		_tmp7_ = time (NULL);
#line 148 "../src/engine/api/geary-logging.vala"
		g_time_local (_tmp7_, &_tmp8_);
#line 148 "../src/engine/api/geary-logging.vala"
		tm = _tmp8_;
#line 154 "../src/engine/api/geary-logging.vala"
		_tmp9_ = domain;
#line 154 "../src/engine/api/geary-logging.vala"
		if (_tmp9_ == NULL) {
#line 154 "../src/engine/api/geary-logging.vala"
			_tmp9_ = "default";
#line 462 "geary-logging.c"
		}
#line 149 "../src/engine/api/geary-logging.vala"
		_tmp10_ = out;
#line 149 "../src/engine/api/geary-logging.vala"
		_tmp11_ = geary_logging_to_prefix (log_levels);
#line 149 "../src/engine/api/geary-logging.vala"
		_tmp12_ = _tmp11_;
#line 149 "../src/engine/api/geary-logging.vala"
		_tmp13_ = tm;
#line 149 "../src/engine/api/geary-logging.vala"
		_tmp14_ = tm;
#line 149 "../src/engine/api/geary-logging.vala"
		_tmp15_ = tm;
#line 149 "../src/engine/api/geary-logging.vala"
		_tmp16_ = geary_logging_entry_timer;
#line 149 "../src/engine/api/geary-logging.vala"
		fprintf (_tmp10_, "%s %02d:%02d:%02d %lf %s: %s\n", _tmp12_, _tmp13_.tm_hour, _tmp14_.tm_min, _tmp15_.tm_sec, g_timer_elapsed (_tmp16_, NULL), _tmp9_, message);
#line 149 "../src/engine/api/geary-logging.vala"
		_g_free0 (_tmp12_);
#line 158 "../src/engine/api/geary-logging.vala"
		_tmp17_ = geary_logging_entry_timer;
#line 158 "../src/engine/api/geary-logging.vala"
		g_timer_start (_tmp17_);
#line 486 "geary-logging.c"
	}
}

inline gchar*
geary_logging_to_prefix (GLogLevelFlags level)
{
	gchar* result = NULL;
#line 163 "../src/engine/api/geary-logging.vala"
	switch (level) {
#line 163 "../src/engine/api/geary-logging.vala"
		case G_LOG_LEVEL_ERROR:
#line 498 "geary-logging.c"
		{
			gchar* _tmp0_;
#line 165 "../src/engine/api/geary-logging.vala"
			_tmp0_ = g_strdup ("![err]");
#line 165 "../src/engine/api/geary-logging.vala"
			result = _tmp0_;
#line 165 "../src/engine/api/geary-logging.vala"
			return result;
#line 507 "geary-logging.c"
		}
#line 163 "../src/engine/api/geary-logging.vala"
		case G_LOG_LEVEL_CRITICAL:
#line 511 "geary-logging.c"
		{
			gchar* _tmp1_;
#line 168 "../src/engine/api/geary-logging.vala"
			_tmp1_ = g_strdup ("![crt]");
#line 168 "../src/engine/api/geary-logging.vala"
			result = _tmp1_;
#line 168 "../src/engine/api/geary-logging.vala"
			return result;
#line 520 "geary-logging.c"
		}
#line 163 "../src/engine/api/geary-logging.vala"
		case G_LOG_LEVEL_WARNING:
#line 524 "geary-logging.c"
		{
			gchar* _tmp2_;
#line 171 "../src/engine/api/geary-logging.vala"
			_tmp2_ = g_strdup ("*[wrn]");
#line 171 "../src/engine/api/geary-logging.vala"
			result = _tmp2_;
#line 171 "../src/engine/api/geary-logging.vala"
			return result;
#line 533 "geary-logging.c"
		}
#line 163 "../src/engine/api/geary-logging.vala"
		case G_LOG_LEVEL_MESSAGE:
#line 537 "geary-logging.c"
		{
			gchar* _tmp3_;
#line 174 "../src/engine/api/geary-logging.vala"
			_tmp3_ = g_strdup (" [msg]");
#line 174 "../src/engine/api/geary-logging.vala"
			result = _tmp3_;
#line 174 "../src/engine/api/geary-logging.vala"
			return result;
#line 546 "geary-logging.c"
		}
#line 163 "../src/engine/api/geary-logging.vala"
		case G_LOG_LEVEL_INFO:
#line 550 "geary-logging.c"
		{
			gchar* _tmp4_;
#line 177 "../src/engine/api/geary-logging.vala"
			_tmp4_ = g_strdup (" [inf]");
#line 177 "../src/engine/api/geary-logging.vala"
			result = _tmp4_;
#line 177 "../src/engine/api/geary-logging.vala"
			return result;
#line 559 "geary-logging.c"
		}
#line 163 "../src/engine/api/geary-logging.vala"
		case G_LOG_LEVEL_DEBUG:
#line 563 "geary-logging.c"
		{
			gchar* _tmp5_;
#line 180 "../src/engine/api/geary-logging.vala"
			_tmp5_ = g_strdup (" [deb]");
#line 180 "../src/engine/api/geary-logging.vala"
			result = _tmp5_;
#line 180 "../src/engine/api/geary-logging.vala"
			return result;
#line 572 "geary-logging.c"
		}
#line 163 "../src/engine/api/geary-logging.vala"
		case G_LOG_LEVEL_MASK:
#line 576 "geary-logging.c"
		{
			gchar* _tmp6_;
#line 183 "../src/engine/api/geary-logging.vala"
			_tmp6_ = g_strdup ("![***]");
#line 183 "../src/engine/api/geary-logging.vala"
			result = _tmp6_;
#line 183 "../src/engine/api/geary-logging.vala"
			return result;
#line 585 "geary-logging.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 186 "../src/engine/api/geary-logging.vala"
			_tmp7_ = g_strdup ("![???]");
#line 186 "../src/engine/api/geary-logging.vala"
			result = _tmp7_;
#line 186 "../src/engine/api/geary-logging.vala"
			return result;
#line 596 "geary-logging.c"
		}
	}
}

