/* geary-service-information.c generated by valac 0.44.1, the Vala compiler
 * generated from geary-service-information.vala, do not modify */

/*
 * Copyright 2017 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>

typedef enum  {
	GEARY_PROTOCOL_IMAP,
	GEARY_PROTOCOL_SMTP
} GearyProtocol;

#define GEARY_TYPE_PROTOCOL (geary_protocol_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	GEARY_TLS_NEGOTIATION_METHOD_NONE,
	GEARY_TLS_NEGOTIATION_METHOD_START_TLS,
	GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT
} GearyTlsNegotiationMethod;

#define GEARY_TYPE_TLS_NEGOTIATION_METHOD (geary_tls_negotiation_method_get_type ())

#define GEARY_TYPE_SERVICE_INFORMATION (geary_service_information_get_type ())
#define GEARY_SERVICE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformation))
#define GEARY_SERVICE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformationClass))
#define GEARY_IS_SERVICE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SERVICE_INFORMATION))
#define GEARY_IS_SERVICE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SERVICE_INFORMATION))
#define GEARY_SERVICE_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformationClass))

typedef struct _GearyServiceInformation GearyServiceInformation;
typedef struct _GearyServiceInformationClass GearyServiceInformationClass;
typedef struct _GearyServiceInformationPrivate GearyServiceInformationPrivate;
typedef enum  {
	GEARY_CREDENTIALS_REQUIREMENT_NONE,
	GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING,
	GEARY_CREDENTIALS_REQUIREMENT_CUSTOM
} GearyCredentialsRequirement;

#define GEARY_CREDENTIALS_TYPE_REQUIREMENT (geary_credentials_requirement_get_type ())

#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;

#define GEARY_TYPE_CREDENTIALS (geary_credentials_get_type ())
#define GEARY_CREDENTIALS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_CREDENTIALS, GearyCredentials))
#define GEARY_CREDENTIALS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_CREDENTIALS, GearyCredentialsClass))
#define GEARY_IS_CREDENTIALS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_CREDENTIALS))
#define GEARY_IS_CREDENTIALS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_CREDENTIALS))
#define GEARY_CREDENTIALS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_CREDENTIALS, GearyCredentialsClass))

typedef struct _GearyCredentials GearyCredentials;
typedef struct _GearyCredentialsClass GearyCredentialsClass;
enum  {
	GEARY_SERVICE_INFORMATION_0_PROPERTY,
	GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY,
	GEARY_SERVICE_INFORMATION_HOST_PROPERTY,
	GEARY_SERVICE_INFORMATION_PORT_PROPERTY,
	GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY,
	GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY,
	GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY,
	GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY,
	GEARY_SERVICE_INFORMATION_NUM_PROPERTIES
};
static GParamSpec* geary_service_information_properties[GEARY_SERVICE_INFORMATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	GEARY_SERVICE_PROVIDER_GMAIL,
	GEARY_SERVICE_PROVIDER_YAHOO,
	GEARY_SERVICE_PROVIDER_OUTLOOK,
	GEARY_SERVICE_PROVIDER_OTHER
} GearyServiceProvider;

#define GEARY_TYPE_SERVICE_PROVIDER (geary_service_provider_get_type ())

typedef enum  {
	GEARY_ENGINE_ERROR_OPEN_REQUIRED,
	GEARY_ENGINE_ERROR_ALREADY_OPEN,
	GEARY_ENGINE_ERROR_ALREADY_EXISTS,
	GEARY_ENGINE_ERROR_ALREADY_CLOSED,
	GEARY_ENGINE_ERROR_CLOSE_REQUIRED,
	GEARY_ENGINE_ERROR_NOT_FOUND,
	GEARY_ENGINE_ERROR_BAD_PARAMETERS,
	GEARY_ENGINE_ERROR_INCOMPLETE_MESSAGE,
	GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE,
	GEARY_ENGINE_ERROR_CORRUPT,
	GEARY_ENGINE_ERROR_PERMISSIONS,
	GEARY_ENGINE_ERROR_VERSION,
	GEARY_ENGINE_ERROR_UNSUPPORTED
} GearyEngineError;
#define GEARY_ENGINE_ERROR geary_engine_error_quark ()
struct _GearyServiceInformation {
	GObject parent_instance;
	GearyServiceInformationPrivate * priv;
};

struct _GearyServiceInformationClass {
	GObjectClass parent_class;
};

struct _GearyServiceInformationPrivate {
	GearyProtocol _protocol;
	gchar* _host;
	guint16 _port;
	GearyTlsNegotiationMethod _transport_security;
	GearyCredentialsRequirement _credentials_requirement;
	GearyCredentials* _credentials;
	gboolean _remember_password;
};

static gint GearyServiceInformation_private_offset;
static gpointer geary_service_information_parent_class = NULL;

GType geary_protocol_get_type (void) G_GNUC_CONST;
GQuark geary_engine_error_quark (void);
GearyProtocol geary_protocol_for_value (const gchar* value,
                                        GError** error);
gpointer geary_object_utils_from_enum_nick (GType e_type,
                                            GBoxedCopyFunc e_dup_func,
                                            GDestroyNotify e_destroy_func,
                                            GType type,
                                            const gchar* nick,
                                            GError** error);
gchar* geary_protocol_to_value (GearyProtocol self);
gchar* geary_object_utils_to_enum_nick (GType e_type,
                                        GBoxedCopyFunc e_dup_func,
                                        GDestroyNotify e_destroy_func,
                                        GType type,
                                        gconstpointer value);
#define GEARY_SMTP_SMTP_PORT ((guint16) 25)
#define GEARY_SMTP_SUBMISSION_PORT ((guint16) 587)
#define GEARY_SMTP_SUBMISSION_TLS_PORT ((guint16) 465)
#define GEARY_IMAP_IMAP_PORT ((guint16) 143)
#define GEARY_IMAP_IMAP_TLS_PORT ((guint16) 993)
GType geary_tls_negotiation_method_get_type (void) G_GNUC_CONST;
GearyTlsNegotiationMethod geary_tls_negotiation_method_for_value (const gchar* value,
                                                                  GError** error);
gchar* geary_tls_negotiation_method_to_value (GearyTlsNegotiationMethod self);
GType geary_service_information_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyServiceInformation, g_object_unref)
GType geary_credentials_requirement_get_type (void) G_GNUC_CONST;
GType geary_base_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyBaseObject, g_object_unref)
GType geary_credentials_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyCredentials, g_object_unref)
GType geary_service_provider_get_type (void) G_GNUC_CONST;
GearyServiceInformation* geary_service_information_new (GearyProtocol proto,
                                                        GearyServiceProvider provider);
GearyServiceInformation* geary_service_information_construct (GType object_type,
                                                              GearyProtocol proto,
                                                              GearyServiceProvider provider);
static void geary_service_information_set_protocol (GearyServiceInformation* self,
                                             GearyProtocol value);
void geary_service_information_set_transport_security (GearyServiceInformation* self,
                                                       GearyTlsNegotiationMethod value);
void geary_service_information_set_credentials_requirement (GearyServiceInformation* self,
                                                            GearyCredentialsRequirement value);
void geary_service_provider_set_service_defaults (GearyServiceProvider self,
                                                  GearyServiceInformation* service);
GearyServiceInformation* geary_service_information_new_copy (GearyServiceInformation* other);
GearyServiceInformation* geary_service_information_construct_copy (GType object_type,
                                                                   GearyServiceInformation* other);
GearyProtocol geary_service_information_get_protocol (GearyServiceInformation* self);
const gchar* geary_service_information_get_host (GearyServiceInformation* self);
void geary_service_information_set_host (GearyServiceInformation* self,
                                         const gchar* value);
guint16 geary_service_information_get_port (GearyServiceInformation* self);
void geary_service_information_set_port (GearyServiceInformation* self,
                                         guint16 value);
GearyTlsNegotiationMethod geary_service_information_get_transport_security (GearyServiceInformation* self);
GearyCredentials* geary_service_information_get_credentials (GearyServiceInformation* self);
GearyCredentials* geary_credentials_copy (GearyCredentials* self);
void geary_service_information_set_credentials (GearyServiceInformation* self,
                                                GearyCredentials* value);
GearyCredentialsRequirement geary_service_information_get_credentials_requirement (GearyServiceInformation* self);
gboolean geary_service_information_get_remember_password (GearyServiceInformation* self);
void geary_service_information_set_remember_password (GearyServiceInformation* self,
                                                      gboolean value);
guint16 geary_service_information_get_default_port (GearyServiceInformation* self);
gboolean geary_service_information_equal_to (GearyServiceInformation* self,
                                             GearyServiceInformation* other);
static void geary_service_information_finalize (GObject * obj);
static void _vala_geary_service_information_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_geary_service_information_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

GearyProtocol
geary_protocol_for_value (const gchar* value,
                          GError** error)
{
	GearyProtocol result = 0;
	GearyProtocol _tmp0_ = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	GearyProtocol _tmp4_;
	GError* _inner_error0_ = NULL;
#line 16 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp1_ = g_ascii_strdown (value, (gssize) -1);
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp2_ = _tmp1_;
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp3_ = geary_object_utils_from_enum_nick (GEARY_TYPE_PROTOCOL, NULL, NULL, GEARY_TYPE_PROTOCOL, _tmp2_, &_inner_error0_);
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp4_ = (GearyProtocol) ((gintptr) _tmp3_);
#line 18 "../src/engine/api/geary-service-information.vala"
	_g_free0 (_tmp2_);
#line 18 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = _tmp4_;
#line 18 "../src/engine/api/geary-service-information.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18 "../src/engine/api/geary-service-information.vala"
		if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 18 "../src/engine/api/geary-service-information.vala"
			g_propagate_error (error, _inner_error0_);
#line 18 "../src/engine/api/geary-service-information.vala"
			return 0;
#line 241 "geary-service-information.c"
		} else {
#line 18 "../src/engine/api/geary-service-information.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 18 "../src/engine/api/geary-service-information.vala"
			g_clear_error (&_inner_error0_);
#line 18 "../src/engine/api/geary-service-information.vala"
			return 0;
#line 249 "geary-service-information.c"
		}
	}
#line 18 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 18 "../src/engine/api/geary-service-information.vala"
	return result;
#line 256 "geary-service-information.c"
}

gchar*
geary_protocol_to_value (GearyProtocol self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 24 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (GEARY_TYPE_PROTOCOL, NULL, NULL, GEARY_TYPE_PROTOCOL, (gpointer) ((gintptr) self));
#line 24 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 24 "../src/engine/api/geary-service-information.vala"
	return result;
#line 270 "geary-service-information.c"
}

/**
 * The network protocols supported by the engine for email services.
 */
GType
geary_protocol_get_type (void)
{
	static volatile gsize geary_protocol_type_id__volatile = 0;
	if (g_once_init_enter (&geary_protocol_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_PROTOCOL_IMAP, "GEARY_PROTOCOL_IMAP", "imap"}, {GEARY_PROTOCOL_SMTP, "GEARY_PROTOCOL_SMTP", "smtp"}, {0, NULL, NULL}};
		GType geary_protocol_type_id;
		geary_protocol_type_id = g_enum_register_static ("GearyProtocol", values);
		g_once_init_leave (&geary_protocol_type_id__volatile, geary_protocol_type_id);
	}
	return geary_protocol_type_id__volatile;
}

GearyTlsNegotiationMethod
geary_tls_negotiation_method_for_value (const gchar* value,
                                        GError** error)
{
	GearyTlsNegotiationMethod result = 0;
	GearyTlsNegotiationMethod _tmp0_ = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	GearyTlsNegotiationMethod _tmp4_;
	GError* _inner_error0_ = NULL;
#line 66 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp1_ = g_ascii_strdown (value, (gssize) -1);
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp2_ = _tmp1_;
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp3_ = geary_object_utils_from_enum_nick (GEARY_TYPE_TLS_NEGOTIATION_METHOD, NULL, NULL, GEARY_TYPE_TLS_NEGOTIATION_METHOD, _tmp2_, &_inner_error0_);
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp4_ = (GearyTlsNegotiationMethod) ((gintptr) _tmp3_);
#line 68 "../src/engine/api/geary-service-information.vala"
	_g_free0 (_tmp2_);
#line 68 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = _tmp4_;
#line 68 "../src/engine/api/geary-service-information.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/engine/api/geary-service-information.vala"
		if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
#line 68 "../src/engine/api/geary-service-information.vala"
			g_propagate_error (error, _inner_error0_);
#line 68 "../src/engine/api/geary-service-information.vala"
			return 0;
#line 322 "geary-service-information.c"
		} else {
#line 68 "../src/engine/api/geary-service-information.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 68 "../src/engine/api/geary-service-information.vala"
			g_clear_error (&_inner_error0_);
#line 68 "../src/engine/api/geary-service-information.vala"
			return 0;
#line 330 "geary-service-information.c"
		}
	}
#line 68 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 68 "../src/engine/api/geary-service-information.vala"
	return result;
#line 337 "geary-service-information.c"
}

gchar*
geary_tls_negotiation_method_to_value (GearyTlsNegotiationMethod self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 74 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (GEARY_TYPE_TLS_NEGOTIATION_METHOD, NULL, NULL, GEARY_TYPE_TLS_NEGOTIATION_METHOD, (gpointer) ((gintptr) self));
#line 74 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 74 "../src/engine/api/geary-service-information.vala"
	return result;
#line 351 "geary-service-information.c"
}

/** The method used to negotiate a TLS session, if any. */
GType
geary_tls_negotiation_method_get_type (void)
{
	static volatile gsize geary_tls_negotiation_method_type_id__volatile = 0;
	if (g_once_init_enter (&geary_tls_negotiation_method_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_TLS_NEGOTIATION_METHOD_NONE, "GEARY_TLS_NEGOTIATION_METHOD_NONE", "none"}, {GEARY_TLS_NEGOTIATION_METHOD_START_TLS, "GEARY_TLS_NEGOTIATION_METHOD_START_TLS", "start-tls"}, {GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT, "GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT", "transport"}, {0, NULL, NULL}};
		GType geary_tls_negotiation_method_type_id;
		geary_tls_negotiation_method_type_id = g_enum_register_static ("GearyTlsNegotiationMethod", values);
		g_once_init_leave (&geary_tls_negotiation_method_type_id__volatile, geary_tls_negotiation_method_type_id);
	}
	return geary_tls_negotiation_method_type_id__volatile;
}

static inline gpointer
geary_service_information_get_instance_private (GearyServiceInformation* self)
{
	return G_STRUCT_MEMBER_P (self, GearyServiceInformation_private_offset);
}

/**
     * Constructs a new configuration for a specific service.
     */
GearyServiceInformation*
geary_service_information_construct (GType object_type,
                                     GearyProtocol proto,
                                     GearyServiceProvider provider)
{
	GearyServiceInformation * self = NULL;
	GearyTlsNegotiationMethod _tmp0_ = 0;
	GearyCredentialsRequirement _tmp1_ = 0;
#line 119 "../src/engine/api/geary-service-information.vala"
	self = (GearyServiceInformation*) g_object_new (object_type, NULL);
#line 120 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_protocol (self, proto);
#line 123 "../src/engine/api/geary-service-information.vala"
	if (proto == GEARY_PROTOCOL_SMTP) {
#line 124 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = GEARY_TLS_NEGOTIATION_METHOD_START_TLS;
#line 393 "geary-service-information.c"
	} else {
#line 125 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT;
#line 397 "geary-service-information.c"
	}
#line 123 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_transport_security (self, _tmp0_);
#line 126 "../src/engine/api/geary-service-information.vala"
	if (proto == GEARY_PROTOCOL_SMTP) {
#line 127 "../src/engine/api/geary-service-information.vala"
		_tmp1_ = GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING;
#line 405 "geary-service-information.c"
	} else {
#line 128 "../src/engine/api/geary-service-information.vala"
		_tmp1_ = GEARY_CREDENTIALS_REQUIREMENT_CUSTOM;
#line 409 "geary-service-information.c"
	}
#line 126 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_credentials_requirement (self, _tmp1_);
#line 130 "../src/engine/api/geary-service-information.vala"
	geary_service_provider_set_service_defaults (provider, self);
#line 119 "../src/engine/api/geary-service-information.vala"
	return self;
#line 417 "geary-service-information.c"
}

GearyServiceInformation*
geary_service_information_new (GearyProtocol proto,
                               GearyServiceProvider provider)
{
#line 119 "../src/engine/api/geary-service-information.vala"
	return geary_service_information_construct (GEARY_TYPE_SERVICE_INFORMATION, proto, provider);
#line 426 "geary-service-information.c"
}

/**
     * Constructs a copy of the given service configuration.
     */
GearyServiceInformation*
geary_service_information_construct_copy (GType object_type,
                                          GearyServiceInformation* other)
{
	GearyServiceInformation * self = NULL;
	GearyProtocol _tmp0_;
	const gchar* _tmp1_;
	guint16 _tmp2_;
	GearyTlsNegotiationMethod _tmp3_;
	GearyCredentials* _tmp4_ = NULL;
	GearyCredentials* _tmp5_;
	GearyCredentialsRequirement _tmp8_;
	gboolean _tmp9_;
#line 136 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (other), NULL);
#line 138 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = other->priv->_protocol;
#line 138 "../src/engine/api/geary-service-information.vala"
	self = (GearyServiceInformation*) geary_service_information_construct (object_type, _tmp0_, GEARY_SERVICE_PROVIDER_OTHER);
#line 139 "../src/engine/api/geary-service-information.vala"
	_tmp1_ = other->priv->_host;
#line 139 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_host (self, _tmp1_);
#line 140 "../src/engine/api/geary-service-information.vala"
	_tmp2_ = other->priv->_port;
#line 140 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_port (self, _tmp2_);
#line 141 "../src/engine/api/geary-service-information.vala"
	_tmp3_ = other->priv->_transport_security;
#line 141 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_transport_security (self, _tmp3_);
#line 143 "../src/engine/api/geary-service-information.vala"
	_tmp5_ = other->priv->_credentials;
#line 143 "../src/engine/api/geary-service-information.vala"
	if (_tmp5_ != NULL) {
#line 467 "geary-service-information.c"
		GearyCredentials* _tmp6_;
		GearyCredentials* _tmp7_;
#line 143 "../src/engine/api/geary-service-information.vala"
		_tmp6_ = other->priv->_credentials;
#line 143 "../src/engine/api/geary-service-information.vala"
		_tmp7_ = geary_credentials_copy (_tmp6_);
#line 143 "../src/engine/api/geary-service-information.vala"
		_g_object_unref0 (_tmp4_);
#line 143 "../src/engine/api/geary-service-information.vala"
		_tmp4_ = _tmp7_;
#line 478 "geary-service-information.c"
	} else {
#line 143 "../src/engine/api/geary-service-information.vala"
		_g_object_unref0 (_tmp4_);
#line 143 "../src/engine/api/geary-service-information.vala"
		_tmp4_ = NULL;
#line 484 "geary-service-information.c"
	}
#line 142 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_credentials (self, _tmp4_);
#line 145 "../src/engine/api/geary-service-information.vala"
	_tmp8_ = other->priv->_credentials_requirement;
#line 145 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_credentials_requirement (self, _tmp8_);
#line 146 "../src/engine/api/geary-service-information.vala"
	_tmp9_ = other->priv->_remember_password;
#line 146 "../src/engine/api/geary-service-information.vala"
	geary_service_information_set_remember_password (self, _tmp9_);
#line 136 "../src/engine/api/geary-service-information.vala"
	_g_object_unref0 (_tmp4_);
#line 136 "../src/engine/api/geary-service-information.vala"
	return self;
#line 500 "geary-service-information.c"
}

GearyServiceInformation*
geary_service_information_new_copy (GearyServiceInformation* other)
{
#line 136 "../src/engine/api/geary-service-information.vala"
	return geary_service_information_construct_copy (GEARY_TYPE_SERVICE_INFORMATION, other);
#line 508 "geary-service-information.c"
}

/**
     * Returns the default port for this service type and settings.
     */
guint16
geary_service_information_get_default_port (GearyServiceInformation* self)
{
	guint16 result = 0U;
	guint16 port = 0U;
	GearyProtocol _tmp0_;
#line 153 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0U);
#line 154 "../src/engine/api/geary-service-information.vala"
	port = (guint16) 0;
#line 156 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = self->priv->_protocol;
#line 156 "../src/engine/api/geary-service-information.vala"
	switch (_tmp0_) {
#line 156 "../src/engine/api/geary-service-information.vala"
		case GEARY_PROTOCOL_IMAP:
#line 530 "geary-service-information.c"
		{
			guint16 _tmp1_ = 0U;
			GearyTlsNegotiationMethod _tmp2_;
#line 158 "../src/engine/api/geary-service-information.vala"
			_tmp2_ = self->priv->_transport_security;
#line 158 "../src/engine/api/geary-service-information.vala"
			if (_tmp2_ == GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT) {
#line 159 "../src/engine/api/geary-service-information.vala"
				_tmp1_ = GEARY_IMAP_IMAP_TLS_PORT;
#line 540 "geary-service-information.c"
			} else {
#line 160 "../src/engine/api/geary-service-information.vala"
				_tmp1_ = GEARY_IMAP_IMAP_PORT;
#line 544 "geary-service-information.c"
			}
#line 158 "../src/engine/api/geary-service-information.vala"
			port = _tmp1_;
#line 161 "../src/engine/api/geary-service-information.vala"
			break;
#line 550 "geary-service-information.c"
		}
#line 156 "../src/engine/api/geary-service-information.vala"
		case GEARY_PROTOCOL_SMTP:
#line 554 "geary-service-information.c"
		{
			GearyTlsNegotiationMethod _tmp3_;
#line 164 "../src/engine/api/geary-service-information.vala"
			_tmp3_ = self->priv->_transport_security;
#line 164 "../src/engine/api/geary-service-information.vala"
			if (_tmp3_ == GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT) {
#line 165 "../src/engine/api/geary-service-information.vala"
				port = GEARY_SMTP_SUBMISSION_TLS_PORT;
#line 563 "geary-service-information.c"
			} else {
				GearyCredentialsRequirement _tmp4_;
#line 166 "../src/engine/api/geary-service-information.vala"
				_tmp4_ = self->priv->_credentials_requirement;
#line 166 "../src/engine/api/geary-service-information.vala"
				if (_tmp4_ == GEARY_CREDENTIALS_REQUIREMENT_NONE) {
#line 168 "../src/engine/api/geary-service-information.vala"
					port = GEARY_SMTP_SMTP_PORT;
#line 572 "geary-service-information.c"
				} else {
#line 170 "../src/engine/api/geary-service-information.vala"
					port = GEARY_SMTP_SUBMISSION_PORT;
#line 576 "geary-service-information.c"
				}
			}
#line 172 "../src/engine/api/geary-service-information.vala"
			break;
#line 581 "geary-service-information.c"
		}
		default:
#line 156 "../src/engine/api/geary-service-information.vala"
		break;
#line 586 "geary-service-information.c"
	}
#line 175 "../src/engine/api/geary-service-information.vala"
	result = port;
#line 175 "../src/engine/api/geary-service-information.vala"
	return result;
#line 592 "geary-service-information.c"
}

/**
     * Returns true if another object is equal to this one.
     */
gboolean
geary_service_information_equal_to (GearyServiceInformation* self,
                                    GearyServiceInformation* other)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 181 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), FALSE);
#line 181 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (other), FALSE);
#line 183 "../src/engine/api/geary-service-information.vala"
	if (self == other) {
#line 183 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = TRUE;
#line 612 "geary-service-information.c"
	} else {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 184 "../src/engine/api/geary-service-information.vala"
		_tmp6_ = self->priv->_host;
#line 184 "../src/engine/api/geary-service-information.vala"
		_tmp7_ = other->priv->_host;
#line 184 "../src/engine/api/geary-service-information.vala"
		if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 627 "geary-service-information.c"
			guint16 _tmp8_;
			guint16 _tmp9_;
#line 185 "../src/engine/api/geary-service-information.vala"
			_tmp8_ = self->priv->_port;
#line 185 "../src/engine/api/geary-service-information.vala"
			_tmp9_ = other->priv->_port;
#line 185 "../src/engine/api/geary-service-information.vala"
			_tmp5_ = _tmp8_ == _tmp9_;
#line 636 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp5_ = FALSE;
#line 640 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		if (_tmp5_) {
#line 644 "geary-service-information.c"
			GearyTlsNegotiationMethod _tmp10_;
			GearyTlsNegotiationMethod _tmp11_;
#line 186 "../src/engine/api/geary-service-information.vala"
			_tmp10_ = self->priv->_transport_security;
#line 186 "../src/engine/api/geary-service-information.vala"
			_tmp11_ = other->priv->_transport_security;
#line 186 "../src/engine/api/geary-service-information.vala"
			_tmp4_ = _tmp10_ == _tmp11_;
#line 653 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp4_ = FALSE;
#line 657 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		if (_tmp4_) {
#line 661 "geary-service-information.c"
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
			GearyCredentials* _tmp14_;
#line 187 "../src/engine/api/geary-service-information.vala"
			_tmp14_ = self->priv->_credentials;
#line 187 "../src/engine/api/geary-service-information.vala"
			if (_tmp14_ == NULL) {
#line 669 "geary-service-information.c"
				GearyCredentials* _tmp15_;
#line 187 "../src/engine/api/geary-service-information.vala"
				_tmp15_ = other->priv->_credentials;
#line 187 "../src/engine/api/geary-service-information.vala"
				_tmp13_ = _tmp15_ == NULL;
#line 675 "geary-service-information.c"
			} else {
#line 187 "../src/engine/api/geary-service-information.vala"
				_tmp13_ = FALSE;
#line 679 "geary-service-information.c"
			}
#line 187 "../src/engine/api/geary-service-information.vala"
			if (_tmp13_) {
#line 187 "../src/engine/api/geary-service-information.vala"
				_tmp12_ = TRUE;
#line 685 "geary-service-information.c"
			} else {
				gboolean _tmp16_ = FALSE;
				gboolean _tmp17_ = FALSE;
				GearyCredentials* _tmp18_;
#line 188 "../src/engine/api/geary-service-information.vala"
				_tmp18_ = self->priv->_credentials;
#line 188 "../src/engine/api/geary-service-information.vala"
				if (_tmp18_ != NULL) {
#line 694 "geary-service-information.c"
					GearyCredentials* _tmp19_;
#line 188 "../src/engine/api/geary-service-information.vala"
					_tmp19_ = other->priv->_credentials;
#line 188 "../src/engine/api/geary-service-information.vala"
					_tmp17_ = _tmp19_ != NULL;
#line 700 "geary-service-information.c"
				} else {
#line 188 "../src/engine/api/geary-service-information.vala"
					_tmp17_ = FALSE;
#line 704 "geary-service-information.c"
				}
#line 188 "../src/engine/api/geary-service-information.vala"
				if (_tmp17_) {
#line 708 "geary-service-information.c"
					GearyCredentials* _tmp20_;
					GearyCredentials* _tmp21_;
#line 189 "../src/engine/api/geary-service-information.vala"
					_tmp20_ = self->priv->_credentials;
#line 189 "../src/engine/api/geary-service-information.vala"
					_tmp21_ = other->priv->_credentials;
#line 189 "../src/engine/api/geary-service-information.vala"
					_tmp16_ = gee_hashable_equal_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_HASHABLE, GeeHashable), _tmp21_);
#line 717 "geary-service-information.c"
				} else {
#line 188 "../src/engine/api/geary-service-information.vala"
					_tmp16_ = FALSE;
#line 721 "geary-service-information.c"
				}
#line 188 "../src/engine/api/geary-service-information.vala"
				_tmp12_ = _tmp16_;
#line 725 "geary-service-information.c"
			}
#line 187 "../src/engine/api/geary-service-information.vala"
			_tmp3_ = _tmp12_;
#line 729 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp3_ = FALSE;
#line 733 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		if (_tmp3_) {
#line 737 "geary-service-information.c"
			GearyCredentialsRequirement _tmp22_;
			GearyCredentialsRequirement _tmp23_;
#line 190 "../src/engine/api/geary-service-information.vala"
			_tmp22_ = self->priv->_credentials_requirement;
#line 190 "../src/engine/api/geary-service-information.vala"
			_tmp23_ = other->priv->_credentials_requirement;
#line 190 "../src/engine/api/geary-service-information.vala"
			_tmp2_ = _tmp22_ == _tmp23_;
#line 746 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp2_ = FALSE;
#line 750 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		if (_tmp2_) {
#line 754 "geary-service-information.c"
			gboolean _tmp24_;
			gboolean _tmp25_;
#line 191 "../src/engine/api/geary-service-information.vala"
			_tmp24_ = self->priv->_remember_password;
#line 191 "../src/engine/api/geary-service-information.vala"
			_tmp25_ = other->priv->_remember_password;
#line 191 "../src/engine/api/geary-service-information.vala"
			_tmp1_ = _tmp24_ == _tmp25_;
#line 763 "geary-service-information.c"
		} else {
#line 184 "../src/engine/api/geary-service-information.vala"
			_tmp1_ = FALSE;
#line 767 "geary-service-information.c"
		}
#line 184 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = _tmp1_;
#line 771 "geary-service-information.c"
	}
#line 182 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 182 "../src/engine/api/geary-service-information.vala"
	return result;
#line 777 "geary-service-information.c"
}

GearyProtocol
geary_service_information_get_protocol (GearyServiceInformation* self)
{
	GearyProtocol result;
	GearyProtocol _tmp0_;
#line 89 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0);
#line 89 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = self->priv->_protocol;
#line 89 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 89 "../src/engine/api/geary-service-information.vala"
	return result;
#line 793 "geary-service-information.c"
}

static void
geary_service_information_set_protocol (GearyServiceInformation* self,
                                        GearyProtocol value)
{
#line 89 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 89 "../src/engine/api/geary-service-information.vala"
	if (geary_service_information_get_protocol (self) != value) {
#line 89 "../src/engine/api/geary-service-information.vala"
		self->priv->_protocol = value;
#line 89 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY]);
#line 808 "geary-service-information.c"
	}
}

const gchar*
geary_service_information_get_host (GearyServiceInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 92 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), NULL);
#line 92 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = self->priv->_host;
#line 92 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 92 "../src/engine/api/geary-service-information.vala"
	return result;
#line 825 "geary-service-information.c"
}

void
geary_service_information_set_host (GearyServiceInformation* self,
                                    const gchar* value)
{
#line 92 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 92 "../src/engine/api/geary-service-information.vala"
	if (g_strcmp0 (value, geary_service_information_get_host (self)) != 0) {
#line 836 "geary-service-information.c"
		gchar* _tmp0_;
#line 92 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = g_strdup (value);
#line 92 "../src/engine/api/geary-service-information.vala"
		_g_free0 (self->priv->_host);
#line 92 "../src/engine/api/geary-service-information.vala"
		self->priv->_host = _tmp0_;
#line 92 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_HOST_PROPERTY]);
#line 846 "geary-service-information.c"
	}
}

guint16
geary_service_information_get_port (GearyServiceInformation* self)
{
	guint16 result;
#line 95 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0U);
#line 95 "../src/engine/api/geary-service-information.vala"
	result = self->priv->_port;
#line 95 "../src/engine/api/geary-service-information.vala"
	return result;
#line 860 "geary-service-information.c"
}

void
geary_service_information_set_port (GearyServiceInformation* self,
                                    guint16 value)
{
#line 95 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 95 "../src/engine/api/geary-service-information.vala"
	if (geary_service_information_get_port (self) != value) {
#line 95 "../src/engine/api/geary-service-information.vala"
		self->priv->_port = value;
#line 95 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_PORT_PROPERTY]);
#line 875 "geary-service-information.c"
	}
}

GearyTlsNegotiationMethod
geary_service_information_get_transport_security (GearyServiceInformation* self)
{
	GearyTlsNegotiationMethod result;
	GearyTlsNegotiationMethod _tmp0_;
#line 98 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0);
#line 98 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = self->priv->_transport_security;
#line 98 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 98 "../src/engine/api/geary-service-information.vala"
	return result;
#line 892 "geary-service-information.c"
}

void
geary_service_information_set_transport_security (GearyServiceInformation* self,
                                                  GearyTlsNegotiationMethod value)
{
#line 98 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 98 "../src/engine/api/geary-service-information.vala"
	if (geary_service_information_get_transport_security (self) != value) {
#line 98 "../src/engine/api/geary-service-information.vala"
		self->priv->_transport_security = value;
#line 98 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY]);
#line 907 "geary-service-information.c"
	}
}

GearyCredentialsRequirement
geary_service_information_get_credentials_requirement (GearyServiceInformation* self)
{
	GearyCredentialsRequirement result;
	GearyCredentialsRequirement _tmp0_;
#line 103 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), 0);
#line 103 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = self->priv->_credentials_requirement;
#line 103 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 103 "../src/engine/api/geary-service-information.vala"
	return result;
#line 924 "geary-service-information.c"
}

void
geary_service_information_set_credentials_requirement (GearyServiceInformation* self,
                                                       GearyCredentialsRequirement value)
{
#line 103 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 103 "../src/engine/api/geary-service-information.vala"
	if (geary_service_information_get_credentials_requirement (self) != value) {
#line 103 "../src/engine/api/geary-service-information.vala"
		self->priv->_credentials_requirement = value;
#line 103 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY]);
#line 939 "geary-service-information.c"
	}
}

GearyCredentials*
geary_service_information_get_credentials (GearyServiceInformation* self)
{
	GearyCredentials* result;
	GearyCredentials* _tmp0_;
#line 106 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), NULL);
#line 106 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = self->priv->_credentials;
#line 106 "../src/engine/api/geary-service-information.vala"
	result = _tmp0_;
#line 106 "../src/engine/api/geary-service-information.vala"
	return result;
#line 956 "geary-service-information.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 106 "../src/engine/api/geary-service-information.vala"
	return self ? g_object_ref (self) : NULL;
#line 964 "geary-service-information.c"
}

void
geary_service_information_set_credentials (GearyServiceInformation* self,
                                           GearyCredentials* value)
{
#line 106 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 106 "../src/engine/api/geary-service-information.vala"
	if (geary_service_information_get_credentials (self) != value) {
#line 975 "geary-service-information.c"
		GearyCredentials* _tmp0_;
#line 106 "../src/engine/api/geary-service-information.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 106 "../src/engine/api/geary-service-information.vala"
		_g_object_unref0 (self->priv->_credentials);
#line 106 "../src/engine/api/geary-service-information.vala"
		self->priv->_credentials = _tmp0_;
#line 106 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY]);
#line 985 "geary-service-information.c"
	}
}

gboolean
geary_service_information_get_remember_password (GearyServiceInformation* self)
{
	gboolean result;
#line 114 "../src/engine/api/geary-service-information.vala"
	g_return_val_if_fail (GEARY_IS_SERVICE_INFORMATION (self), FALSE);
#line 114 "../src/engine/api/geary-service-information.vala"
	result = self->priv->_remember_password;
#line 114 "../src/engine/api/geary-service-information.vala"
	return result;
#line 999 "geary-service-information.c"
}

void
geary_service_information_set_remember_password (GearyServiceInformation* self,
                                                 gboolean value)
{
#line 114 "../src/engine/api/geary-service-information.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (self));
#line 114 "../src/engine/api/geary-service-information.vala"
	if (geary_service_information_get_remember_password (self) != value) {
#line 114 "../src/engine/api/geary-service-information.vala"
		self->priv->_remember_password = value;
#line 114 "../src/engine/api/geary-service-information.vala"
		g_object_notify_by_pspec ((GObject *) self, geary_service_information_properties[GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY]);
#line 1014 "geary-service-information.c"
	}
}

static void
geary_service_information_class_init (GearyServiceInformationClass * klass,
                                      gpointer klass_data)
{
#line 85 "../src/engine/api/geary-service-information.vala"
	geary_service_information_parent_class = g_type_class_peek_parent (klass);
#line 85 "../src/engine/api/geary-service-information.vala"
	g_type_class_adjust_private_offset (klass, &GearyServiceInformation_private_offset);
#line 85 "../src/engine/api/geary-service-information.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_service_information_get_property;
#line 85 "../src/engine/api/geary-service-information.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_service_information_set_property;
#line 85 "../src/engine/api/geary-service-information.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_service_information_finalize;
#line 1032 "geary-service-information.c"
	/** Specifies the network protocol for this service. */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY] = g_param_spec_enum ("protocol", "protocol", "protocol", GEARY_TYPE_PROTOCOL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1036 "geary-service-information.c"
	/** The server's address. */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_HOST_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_HOST_PROPERTY] = g_param_spec_string ("host", "host", "host", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1040 "geary-service-information.c"
	/** The server's port. */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_PORT_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_PORT_PROPERTY] = g_param_spec_uint ("port", "port", "port", 0, G_MAXUINT, (guint16) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1044 "geary-service-information.c"
	/** The transport security method to use */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY] = g_param_spec_enum ("transport-security", "transport-security", "transport-security", GEARY_TYPE_TLS_NEGOTIATION_METHOD, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1048 "geary-service-information.c"
	/**
	     * Determines the source of auth credentials for SMTP services.
	     */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY] = g_param_spec_enum ("credentials-requirement", "credentials-requirement", "credentials-requirement", GEARY_CREDENTIALS_TYPE_REQUIREMENT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1054 "geary-service-information.c"
	/** The credentials used for authenticating. */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY] = g_param_spec_object ("credentials", "credentials", "credentials", GEARY_TYPE_CREDENTIALS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1058 "geary-service-information.c"
	/**
	     * Whether the password should be remembered.
	     *
	     * This only makes sense with providers that support saving the
	     * password.
	     */
#line 85 "../src/engine/api/geary-service-information.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY, geary_service_information_properties[GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY] = g_param_spec_boolean ("remember-password", "remember-password", "remember-password", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1067 "geary-service-information.c"
}

static void
geary_service_information_instance_init (GearyServiceInformation * self,
                                         gpointer klass)
{
	gchar* _tmp0_;
#line 85 "../src/engine/api/geary-service-information.vala"
	self->priv = geary_service_information_get_instance_private (self);
#line 92 "../src/engine/api/geary-service-information.vala"
	_tmp0_ = g_strdup ("");
#line 92 "../src/engine/api/geary-service-information.vala"
	self->priv->_host = _tmp0_;
#line 95 "../src/engine/api/geary-service-information.vala"
	self->priv->_port = (guint16) 0;
#line 106 "../src/engine/api/geary-service-information.vala"
	self->priv->_credentials = NULL;
#line 114 "../src/engine/api/geary-service-information.vala"
	self->priv->_remember_password = TRUE;
#line 1087 "geary-service-information.c"
}

static void
geary_service_information_finalize (GObject * obj)
{
	GearyServiceInformation * self;
#line 85 "../src/engine/api/geary-service-information.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformation);
#line 92 "../src/engine/api/geary-service-information.vala"
	_g_free0 (self->priv->_host);
#line 106 "../src/engine/api/geary-service-information.vala"
	_g_object_unref0 (self->priv->_credentials);
#line 85 "../src/engine/api/geary-service-information.vala"
	G_OBJECT_CLASS (geary_service_information_parent_class)->finalize (obj);
#line 1102 "geary-service-information.c"
}

/**
 * Encapsulates configuration information for a network service.
 */
GType
geary_service_information_get_type (void)
{
	static volatile gsize geary_service_information_type_id__volatile = 0;
	if (g_once_init_enter (&geary_service_information_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyServiceInformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_service_information_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyServiceInformation), 0, (GInstanceInitFunc) geary_service_information_instance_init, NULL };
		GType geary_service_information_type_id;
		geary_service_information_type_id = g_type_register_static (G_TYPE_OBJECT, "GearyServiceInformation", &g_define_type_info, 0);
		GearyServiceInformation_private_offset = g_type_add_instance_private (geary_service_information_type_id, sizeof (GearyServiceInformationPrivate));
		g_once_init_leave (&geary_service_information_type_id__volatile, geary_service_information_type_id);
	}
	return geary_service_information_type_id__volatile;
}

static void
_vala_geary_service_information_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	GearyServiceInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformation);
#line 85 "../src/engine/api/geary-service-information.vala"
	switch (property_id) {
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_enum (value, geary_service_information_get_protocol (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_HOST_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_string (value, geary_service_information_get_host (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_PORT_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_uint (value, geary_service_information_get_port (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_enum (value, geary_service_information_get_transport_security (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_enum (value, geary_service_information_get_credentials_requirement (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_object (value, geary_service_information_get_credentials (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		g_value_set_boolean (value, geary_service_information_get_remember_password (self));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 1174 "geary-service-information.c"
		default:
#line 85 "../src/engine/api/geary-service-information.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 1180 "geary-service-information.c"
	}
}

static void
_vala_geary_service_information_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	GearyServiceInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformation);
#line 85 "../src/engine/api/geary-service-information.vala"
	switch (property_id) {
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_PROTOCOL_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_protocol (self, g_value_get_enum (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_HOST_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_host (self, g_value_get_string (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_PORT_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_port (self, g_value_get_uint (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_TRANSPORT_SECURITY_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_transport_security (self, g_value_get_enum (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_CREDENTIALS_REQUIREMENT_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_credentials_requirement (self, g_value_get_enum (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_CREDENTIALS_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_credentials (self, g_value_get_object (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 85 "../src/engine/api/geary-service-information.vala"
		case GEARY_SERVICE_INFORMATION_REMEMBER_PASSWORD_PROPERTY:
#line 85 "../src/engine/api/geary-service-information.vala"
		geary_service_information_set_remember_password (self, g_value_get_boolean (value));
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 1236 "geary-service-information.c"
		default:
#line 85 "../src/engine/api/geary-service-information.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 85 "../src/engine/api/geary-service-information.vala"
		break;
#line 1242 "geary-service-information.c"
	}
}

