/* mime-data-format.c generated by valac 0.44.1, the Vala compiler
 * generated from mime-data-format.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED,
	GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL,
	GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED
} GearyMimeDataFormatEncoding;

#define GEARY_MIME_DATA_FORMAT_TYPE_ENCODING (geary_mime_data_format_encoding_get_type ())

GType geary_mime_data_format_encoding_get_type (void) G_GNUC_CONST;
GearyMimeDataFormatEncoding geary_mime_data_format_get_encoding_requirement (const gchar* str);
gboolean geary_string_is_empty (const gchar* str);
#define GEARY_STRING_EOS '\0'
static gboolean _vala_char_array_contains (gchar * stack,
                                    int stack_length,
                                    const gchar needle);

const gchar GEARY_MIME_DATA_FORMAT_CONTENT_TYPE_TOKEN_SPECIALS[15] = {'(', ')', '<', '>', '@', ',', ';', ':', '\\', '"', '/', '[', ']', '?', '='};

GType
geary_mime_data_format_encoding_get_type (void)
{
	static volatile gsize geary_mime_data_format_encoding_type_id__volatile = 0;
	if (g_once_init_enter (&geary_mime_data_format_encoding_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED, "GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED", "quoting-required"}, {GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL, "GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL", "quoting-optional"}, {GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED, "GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED", "unallowed"}, {0, NULL, NULL}};
		GType geary_mime_data_format_encoding_type_id;
		geary_mime_data_format_encoding_type_id = g_enum_register_static ("GearyMimeDataFormatEncoding", values);
		g_once_init_leave (&geary_mime_data_format_encoding_type_id__volatile, geary_mime_data_format_encoding_type_id);
	}
	return geary_mime_data_format_encoding_type_id__volatile;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 61 "mime-data-format.c"
}

static gboolean
_vala_char_array_contains (gchar * stack,
                           int stack_length,
                           const gchar needle)
{
	int i;
#line 38 "../src/engine/mime/mime-data-format.vala"
	for (i = 0; i < stack_length; i++) {
#line 38 "../src/engine/mime/mime-data-format.vala"
		if (needle == stack[i]) {
#line 38 "../src/engine/mime/mime-data-format.vala"
			return TRUE;
#line 76 "mime-data-format.c"
		}
	}
#line 38 "../src/engine/mime/mime-data-format.vala"
	return FALSE;
#line 81 "mime-data-format.c"
}

GearyMimeDataFormatEncoding
geary_mime_data_format_get_encoding_requirement (const gchar* str)
{
	GearyMimeDataFormatEncoding result = 0;
	GearyMimeDataFormatEncoding encoding = 0;
	gint index = 0;
#line 23 "../src/engine/mime/mime-data-format.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 24 "../src/engine/mime/mime-data-format.vala"
	if (geary_string_is_empty (str)) {
#line 25 "../src/engine/mime/mime-data-format.vala"
		result = GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED;
#line 25 "../src/engine/mime/mime-data-format.vala"
		return result;
#line 98 "mime-data-format.c"
	}
#line 27 "../src/engine/mime/mime-data-format.vala"
	encoding = GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL;
#line 28 "../src/engine/mime/mime-data-format.vala"
	index = 0;
#line 104 "mime-data-format.c"
	{
		gboolean _tmp0_ = FALSE;
#line 29 "../src/engine/mime/mime-data-format.vala"
		_tmp0_ = TRUE;
#line 29 "../src/engine/mime/mime-data-format.vala"
		while (TRUE) {
#line 111 "mime-data-format.c"
			gchar ch = '\0';
			gint _tmp1_;
			gboolean _tmp2_ = FALSE;
#line 29 "../src/engine/mime/mime-data-format.vala"
			if (!_tmp0_) {
#line 117 "mime-data-format.c"
			}
#line 29 "../src/engine/mime/mime-data-format.vala"
			_tmp0_ = FALSE;
#line 30 "../src/engine/mime/mime-data-format.vala"
			_tmp1_ = index;
#line 30 "../src/engine/mime/mime-data-format.vala"
			index = _tmp1_ + 1;
#line 30 "../src/engine/mime/mime-data-format.vala"
			ch = string_get (str, (glong) _tmp1_);
#line 31 "../src/engine/mime/mime-data-format.vala"
			if (ch == GEARY_STRING_EOS) {
#line 32 "../src/engine/mime/mime-data-format.vala"
				break;
#line 131 "mime-data-format.c"
			}
#line 34 "../src/engine/mime/mime-data-format.vala"
			if (g_ascii_iscntrl (ch)) {
#line 35 "../src/engine/mime/mime-data-format.vala"
				result = GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED;
#line 35 "../src/engine/mime/mime-data-format.vala"
				return result;
#line 139 "mime-data-format.c"
			}
#line 38 "../src/engine/mime/mime-data-format.vala"
			if (g_ascii_isspace (ch)) {
#line 38 "../src/engine/mime/mime-data-format.vala"
				_tmp2_ = TRUE;
#line 145 "mime-data-format.c"
			} else {
#line 38 "../src/engine/mime/mime-data-format.vala"
				_tmp2_ = _vala_char_array_contains (GEARY_MIME_DATA_FORMAT_CONTENT_TYPE_TOKEN_SPECIALS, G_N_ELEMENTS (GEARY_MIME_DATA_FORMAT_CONTENT_TYPE_TOKEN_SPECIALS), ch);
#line 149 "mime-data-format.c"
			}
#line 38 "../src/engine/mime/mime-data-format.vala"
			if (_tmp2_) {
#line 39 "../src/engine/mime/mime-data-format.vala"
				encoding = GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED;
#line 155 "mime-data-format.c"
			}
		}
	}
#line 42 "../src/engine/mime/mime-data-format.vala"
	result = encoding;
#line 42 "../src/engine/mime/mime-data-format.vala"
	return result;
#line 163 "mime-data-format.c"
}

