/* util-html.c generated by valac 0.44.1, the Vala compiler
 * generated from util-html.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <libxml/HTMLtree.h>
#include <libxml/HTMLparser.h>
#include <libxml/tree.h>
#include <libxml/parser.h>

#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

extern GRegex* geary_html_WHITESPACE_REGEX;
GRegex* geary_html_WHITESPACE_REGEX = NULL;
extern gint geary_html_init_count;
gint geary_html_init_count = 0;
extern GeeHashSet* geary_html_breaking_elements;
GeeHashSet* geary_html_breaking_elements = NULL;
extern GeeHashSet* geary_html_spacing_elements;
GeeHashSet* geary_html_spacing_elements = NULL;
extern GeeHashSet* geary_html_alt_text_elements;
GeeHashSet* geary_html_alt_text_elements = NULL;
extern GeeHashSet* geary_html_ignored_elements;
GeeHashSet* geary_html_ignored_elements = NULL;

#define GEARY_HTML_URL_REGEX "(?i)\\b((?:[a-z][\\w-]+:(?:/{1,3}|[a-z0-9%])|www\\d{0,3}[.]|[a-z0-9.\\" \
"-]+[.][a-z]{2,4}/)(?:[^\\s()<>]+|\\(([^\\s()<>]+|(\\([^\\s()<>]+\\)))*" \
"\\))+(?:\\(([^\\s()<>]+|(\\([^\\s()<>]+\\)))*\\)|[^\\s`!()\\[\\]{};:'\"" \
".,<>?«»“”‘’]))"
void geary_html_init (void);
void geary_html_init_element_sets (void);
guint geary_ascii_stri_hash (const gchar* str);
static guint _geary_ascii_stri_hash_gee_hash_data_func (gconstpointer v,
                                                 gpointer self);
gboolean geary_ascii_stri_equal (const gchar* a,
                                 const gchar* b);
static gboolean _geary_ascii_stri_equal_gee_equal_data_func (gconstpointer a,
                                                      gconstpointer b,
                                                      gpointer self);
gchar* geary_html_escape_markup (const gchar* plain);
gboolean geary_string_is_empty (const gchar* str);
gchar* geary_html_preserve_whitespace (const gchar* text);
static gboolean ____lambda165_ (GMatchInfo* info,
                         GString* _result_);
static gboolean _____lambda165__gregex_eval_callback (GMatchInfo* match_info,
                                               GString* _result_,
                                               gpointer self);
gchar* geary_html_smart_escape (const gchar* text);
gchar* geary_html_html_to_text (const gchar* html,
                                gboolean include_blockquotes,
                                const gchar* encoding);
void geary_html_recurse_html_nodes_for_text (xmlNode* node,
                                             gboolean include_blockquotes,
                                             GString* text);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

/**
 * Must be called before ''any'' call to the HTML namespace.
 *
 * This will be initialized by the Engine when it's opened; or call this
 * directly to use these functions earlier.
 */
void
geary_html_init (void)
{
	gint _tmp0_;
	GError* _inner_error0_ = NULL;
#line 28 "../src/engine/util/util-html.vala"
	_tmp0_ = geary_html_init_count;
#line 28 "../src/engine/util/util-html.vala"
	geary_html_init_count = _tmp0_ + 1;
#line 28 "../src/engine/util/util-html.vala"
	if (_tmp0_ != 0) {
#line 29 "../src/engine/util/util-html.vala"
		return;
#line 96 "util-html.c"
	}
#line 31 "../src/engine/util/util-html.vala"
	geary_html_init_element_sets ();
#line 100 "util-html.c"
	{
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
#line 34 "../src/engine/util/util-html.vala"
		_tmp2_ = g_regex_new ("(\\R|\\t|[ ]+)", 0, 0, &_inner_error0_);
#line 34 "../src/engine/util/util-html.vala"
		_tmp1_ = _tmp2_;
#line 34 "../src/engine/util/util-html.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "util-html.c"
			goto __catch284_g_error;
		}
#line 34 "../src/engine/util/util-html.vala"
		_tmp3_ = _tmp1_;
#line 34 "../src/engine/util/util-html.vala"
		_tmp1_ = NULL;
#line 34 "../src/engine/util/util-html.vala"
		_g_regex_unref0 (geary_html_WHITESPACE_REGEX);
#line 34 "../src/engine/util/util-html.vala"
		geary_html_WHITESPACE_REGEX = _tmp3_;
#line 33 "../src/engine/util/util-html.vala"
		_g_regex_unref0 (_tmp1_);
#line 124 "util-html.c"
	}
	goto __finally284;
	__catch284_g_error:
	{
		GError* err = NULL;
#line 33 "../src/engine/util/util-html.vala"
		err = _inner_error0_;
#line 33 "../src/engine/util/util-html.vala"
		_inner_error0_ = NULL;
#line 36 "../src/engine/util/util-html.vala"
		_vala_assert (TRUE, "true");
#line 33 "../src/engine/util/util-html.vala"
		_g_error_free0 (err);
#line 138 "util-html.c"
	}
	__finally284:
#line 33 "../src/engine/util/util-html.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 33 "../src/engine/util/util-html.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 33 "../src/engine/util/util-html.vala"
		g_clear_error (&_inner_error0_);
#line 33 "../src/engine/util/util-html.vala"
		return;
#line 149 "util-html.c"
	}
}

static guint
_geary_ascii_stri_hash_gee_hash_data_func (gconstpointer v,
                                           gpointer self)
{
	guint result;
	result = geary_ascii_stri_hash ((const gchar*) v);
#line 49 "../src/engine/util/util-html.vala"
	return result;
#line 161 "util-html.c"
}

static gboolean
_geary_ascii_stri_equal_gee_equal_data_func (gconstpointer a,
                                             gconstpointer b,
                                             gpointer self)
{
	gboolean result;
	result = geary_ascii_stri_equal ((const gchar*) a, (const gchar*) b);
#line 49 "../src/engine/util/util-html.vala"
	return result;
#line 173 "util-html.c"
}

void
geary_html_init_element_sets (void)
{
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar** _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	GeeHashSet* _tmp29_;
	GeeHashSet* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar** _tmp36_;
	gchar** _tmp37_;
	gint _tmp37__length1;
	GeeHashSet* _tmp38_;
	GeeHashSet* _tmp39_;
	gchar* _tmp40_;
	gchar** _tmp41_;
	gchar** _tmp42_;
	gint _tmp42__length1;
	GeeHashSet* _tmp43_;
	GeeHashSet* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar** _tmp52_;
	gchar** _tmp53_;
	gint _tmp53__length1;
#line 49 "../src/engine/util/util-html.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _geary_ascii_stri_hash_gee_hash_data_func, NULL, NULL, _geary_ascii_stri_equal_gee_equal_data_func, NULL, NULL);
#line 49 "../src/engine/util/util-html.vala"
	_g_object_unref0 (geary_html_breaking_elements);
#line 49 "../src/engine/util/util-html.vala"
	geary_html_breaking_elements = _tmp0_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp1_ = geary_html_breaking_elements;
#line 50 "../src/engine/util/util-html.vala"
	_tmp2_ = g_strdup ("address");
#line 50 "../src/engine/util/util-html.vala"
	_tmp3_ = g_strdup ("blockquote");
#line 50 "../src/engine/util/util-html.vala"
	_tmp4_ = g_strdup ("br");
#line 50 "../src/engine/util/util-html.vala"
	_tmp5_ = g_strdup ("caption");
#line 50 "../src/engine/util/util-html.vala"
	_tmp6_ = g_strdup ("center");
#line 50 "../src/engine/util/util-html.vala"
	_tmp7_ = g_strdup ("div");
#line 50 "../src/engine/util/util-html.vala"
	_tmp8_ = g_strdup ("dt");
#line 50 "../src/engine/util/util-html.vala"
	_tmp9_ = g_strdup ("embed");
#line 50 "../src/engine/util/util-html.vala"
	_tmp10_ = g_strdup ("form");
#line 50 "../src/engine/util/util-html.vala"
	_tmp11_ = g_strdup ("h1");
#line 50 "../src/engine/util/util-html.vala"
	_tmp12_ = g_strdup ("h2");
#line 50 "../src/engine/util/util-html.vala"
	_tmp13_ = g_strdup ("h3");
#line 50 "../src/engine/util/util-html.vala"
	_tmp14_ = g_strdup ("h4");
#line 50 "../src/engine/util/util-html.vala"
	_tmp15_ = g_strdup ("h5");
#line 50 "../src/engine/util/util-html.vala"
	_tmp16_ = g_strdup ("h6");
#line 50 "../src/engine/util/util-html.vala"
	_tmp17_ = g_strdup ("hr");
#line 50 "../src/engine/util/util-html.vala"
	_tmp18_ = g_strdup ("iframe");
#line 50 "../src/engine/util/util-html.vala"
	_tmp19_ = g_strdup ("li");
#line 50 "../src/engine/util/util-html.vala"
	_tmp20_ = g_strdup ("map");
#line 50 "../src/engine/util/util-html.vala"
	_tmp21_ = g_strdup ("menu");
#line 50 "../src/engine/util/util-html.vala"
	_tmp22_ = g_strdup ("noscript");
#line 50 "../src/engine/util/util-html.vala"
	_tmp23_ = g_strdup ("object");
#line 50 "../src/engine/util/util-html.vala"
	_tmp24_ = g_strdup ("p");
#line 50 "../src/engine/util/util-html.vala"
	_tmp25_ = g_strdup ("pre");
#line 50 "../src/engine/util/util-html.vala"
	_tmp26_ = g_strdup ("tr");
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_ = g_new0 (gchar*, 25 + 1);
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[0] = _tmp2_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[1] = _tmp3_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[2] = _tmp4_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[3] = _tmp5_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[4] = _tmp6_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[5] = _tmp7_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[6] = _tmp8_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[7] = _tmp9_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[8] = _tmp10_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[9] = _tmp11_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[10] = _tmp12_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[11] = _tmp13_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[12] = _tmp14_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[13] = _tmp15_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[14] = _tmp16_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[15] = _tmp17_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[16] = _tmp18_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[17] = _tmp19_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[18] = _tmp20_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[19] = _tmp21_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[20] = _tmp22_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[21] = _tmp23_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[22] = _tmp24_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[23] = _tmp25_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp27_[24] = _tmp26_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp28_ = _tmp27_;
#line 50 "../src/engine/util/util-html.vala"
	_tmp28__length1 = 25;
#line 50 "../src/engine/util/util-html.vala"
	gee_collection_add_all_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection), _tmp28_, (gint) 25);
#line 50 "../src/engine/util/util-html.vala"
	_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 78 "../src/engine/util/util-html.vala"
	_tmp29_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _geary_ascii_stri_hash_gee_hash_data_func, NULL, NULL, _geary_ascii_stri_equal_gee_equal_data_func, NULL, NULL);
#line 78 "../src/engine/util/util-html.vala"
	_g_object_unref0 (geary_html_spacing_elements);
#line 78 "../src/engine/util/util-html.vala"
	geary_html_spacing_elements = _tmp29_;
#line 79 "../src/engine/util/util-html.vala"
	_tmp30_ = geary_html_spacing_elements;
#line 79 "../src/engine/util/util-html.vala"
	_tmp31_ = g_strdup ("dt");
#line 79 "../src/engine/util/util-html.vala"
	_tmp32_ = g_strdup ("dd");
#line 79 "../src/engine/util/util-html.vala"
	_tmp33_ = g_strdup ("img");
#line 79 "../src/engine/util/util-html.vala"
	_tmp34_ = g_strdup ("td");
#line 79 "../src/engine/util/util-html.vala"
	_tmp35_ = g_strdup ("th");
#line 79 "../src/engine/util/util-html.vala"
	_tmp36_ = g_new0 (gchar*, 5 + 1);
#line 79 "../src/engine/util/util-html.vala"
	_tmp36_[0] = _tmp31_;
#line 79 "../src/engine/util/util-html.vala"
	_tmp36_[1] = _tmp32_;
#line 79 "../src/engine/util/util-html.vala"
	_tmp36_[2] = _tmp33_;
#line 79 "../src/engine/util/util-html.vala"
	_tmp36_[3] = _tmp34_;
#line 79 "../src/engine/util/util-html.vala"
	_tmp36_[4] = _tmp35_;
#line 79 "../src/engine/util/util-html.vala"
	_tmp37_ = _tmp36_;
#line 79 "../src/engine/util/util-html.vala"
	_tmp37__length1 = 5;
#line 79 "../src/engine/util/util-html.vala"
	gee_collection_add_all_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_COLLECTION, GeeCollection), _tmp37_, (gint) 5);
#line 79 "../src/engine/util/util-html.vala"
	_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
#line 88 "../src/engine/util/util-html.vala"
	_tmp38_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _geary_ascii_stri_hash_gee_hash_data_func, NULL, NULL, _geary_ascii_stri_equal_gee_equal_data_func, NULL, NULL);
#line 88 "../src/engine/util/util-html.vala"
	_g_object_unref0 (geary_html_alt_text_elements);
#line 88 "../src/engine/util/util-html.vala"
	geary_html_alt_text_elements = _tmp38_;
#line 89 "../src/engine/util/util-html.vala"
	_tmp39_ = geary_html_alt_text_elements;
#line 89 "../src/engine/util/util-html.vala"
	_tmp40_ = g_strdup ("img");
#line 89 "../src/engine/util/util-html.vala"
	_tmp41_ = g_new0 (gchar*, 1 + 1);
#line 89 "../src/engine/util/util-html.vala"
	_tmp41_[0] = _tmp40_;
#line 89 "../src/engine/util/util-html.vala"
	_tmp42_ = _tmp41_;
#line 89 "../src/engine/util/util-html.vala"
	_tmp42__length1 = 1;
#line 89 "../src/engine/util/util-html.vala"
	gee_collection_add_all_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection), _tmp42_, (gint) 1);
#line 89 "../src/engine/util/util-html.vala"
	_tmp42_ = (_vala_array_free (_tmp42_, _tmp42__length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/engine/util/util-html.vala"
	_tmp43_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _geary_ascii_stri_hash_gee_hash_data_func, NULL, NULL, _geary_ascii_stri_equal_gee_equal_data_func, NULL, NULL);
#line 94 "../src/engine/util/util-html.vala"
	_g_object_unref0 (geary_html_ignored_elements);
#line 94 "../src/engine/util/util-html.vala"
	geary_html_ignored_elements = _tmp43_;
#line 95 "../src/engine/util/util-html.vala"
	_tmp44_ = geary_html_ignored_elements;
#line 95 "../src/engine/util/util-html.vala"
	_tmp45_ = g_strdup ("base");
#line 95 "../src/engine/util/util-html.vala"
	_tmp46_ = g_strdup ("link");
#line 95 "../src/engine/util/util-html.vala"
	_tmp47_ = g_strdup ("meta");
#line 95 "../src/engine/util/util-html.vala"
	_tmp48_ = g_strdup ("head");
#line 95 "../src/engine/util/util-html.vala"
	_tmp49_ = g_strdup ("script");
#line 95 "../src/engine/util/util-html.vala"
	_tmp50_ = g_strdup ("style");
#line 95 "../src/engine/util/util-html.vala"
	_tmp51_ = g_strdup ("template");
#line 95 "../src/engine/util/util-html.vala"
	_tmp52_ = g_new0 (gchar*, 7 + 1);
#line 95 "../src/engine/util/util-html.vala"
	_tmp52_[0] = _tmp45_;
#line 95 "../src/engine/util/util-html.vala"
	_tmp52_[1] = _tmp46_;
#line 95 "../src/engine/util/util-html.vala"
	_tmp52_[2] = _tmp47_;
#line 95 "../src/engine/util/util-html.vala"
	_tmp52_[3] = _tmp48_;
#line 95 "../src/engine/util/util-html.vala"
	_tmp52_[4] = _tmp49_;
#line 95 "../src/engine/util/util-html.vala"
	_tmp52_[5] = _tmp50_;
#line 95 "../src/engine/util/util-html.vala"
	_tmp52_[6] = _tmp51_;
#line 95 "../src/engine/util/util-html.vala"
	_tmp53_ = _tmp52_;
#line 95 "../src/engine/util/util-html.vala"
	_tmp53__length1 = 7;
#line 95 "../src/engine/util/util-html.vala"
	gee_collection_add_all_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, GEE_TYPE_COLLECTION, GeeCollection), _tmp53_, (gint) 7);
#line 95 "../src/engine/util/util-html.vala"
	_tmp53_ = (_vala_array_free (_tmp53_, _tmp53__length1, (GDestroyNotify) g_free), NULL);
#line 461 "util-html.c"
}

/** Converts plain text to HTML with reserved characters escaped. */
inline gchar*
geary_html_escape_markup (const gchar* plain)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 108 "../src/engine/util/util-html.vala"
	if (!geary_string_is_empty (plain)) {
#line 108 "../src/engine/util/util-html.vala"
		_tmp1_ = g_utf8_validate (plain, (gssize) -1, NULL);
#line 475 "util-html.c"
	} else {
#line 108 "../src/engine/util/util-html.vala"
		_tmp1_ = FALSE;
#line 479 "util-html.c"
	}
#line 108 "../src/engine/util/util-html.vala"
	if (_tmp1_) {
#line 483 "util-html.c"
		gchar* _tmp2_;
#line 109 "../src/engine/util/util-html.vala"
		_tmp2_ = g_markup_escape_text (plain, (gssize) -1);
#line 109 "../src/engine/util/util-html.vala"
		_g_free0 (_tmp0_);
#line 109 "../src/engine/util/util-html.vala"
		_tmp0_ = _tmp2_;
#line 491 "util-html.c"
	} else {
		gchar* _tmp3_;
#line 109 "../src/engine/util/util-html.vala"
		_tmp3_ = g_strdup ("");
#line 109 "../src/engine/util/util-html.vala"
		_g_free0 (_tmp0_);
#line 109 "../src/engine/util/util-html.vala"
		_tmp0_ = _tmp3_;
#line 500 "util-html.c"
	}
#line 108 "../src/engine/util/util-html.vala"
	result = _tmp0_;
#line 108 "../src/engine/util/util-html.vala"
	return result;
#line 506 "util-html.c"
}

/** Converts plain text to HTML with whitespace (SP, CR, LF) preserved. */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 524 "util-html.c"
}

static gboolean
____lambda165_ (GMatchInfo* info,
                GString* _result_)
{
	gboolean result = FALSE;
	gchar* match = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 118 "../src/engine/util/util-html.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 118 "../src/engine/util/util-html.vala"
	g_return_val_if_fail (_result_ != NULL, FALSE);
#line 119 "../src/engine/util/util-html.vala"
	_tmp0_ = g_match_info_fetch (info, 0);
#line 119 "../src/engine/util/util-html.vala"
	match = _tmp0_;
#line 120 "../src/engine/util/util-html.vala"
	_tmp1_ = match;
#line 120 "../src/engine/util/util-html.vala"
	if (string_get (_tmp1_, (glong) 0) == ' ') {
#line 121 "../src/engine/util/util-html.vala"
		g_string_append_c (_result_, ' ');
#line 549 "util-html.c"
		{
			gint len = 0;
			const gchar* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
#line 122 "../src/engine/util/util-html.vala"
			_tmp2_ = match;
#line 122 "../src/engine/util/util-html.vala"
			_tmp3_ = strlen (_tmp2_);
#line 122 "../src/engine/util/util-html.vala"
			_tmp4_ = _tmp3_;
#line 122 "../src/engine/util/util-html.vala"
			len = _tmp4_ - 1;
#line 563 "util-html.c"
			{
				gboolean _tmp5_ = FALSE;
#line 122 "../src/engine/util/util-html.vala"
				_tmp5_ = TRUE;
#line 122 "../src/engine/util/util-html.vala"
				while (TRUE) {
#line 122 "../src/engine/util/util-html.vala"
					if (!_tmp5_) {
#line 572 "util-html.c"
						gint _tmp6_;
#line 122 "../src/engine/util/util-html.vala"
						_tmp6_ = len;
#line 122 "../src/engine/util/util-html.vala"
						len = _tmp6_ - 1;
#line 578 "util-html.c"
					}
#line 122 "../src/engine/util/util-html.vala"
					_tmp5_ = FALSE;
#line 122 "../src/engine/util/util-html.vala"
					if (!(len > 0)) {
#line 122 "../src/engine/util/util-html.vala"
						break;
#line 586 "util-html.c"
					}
#line 123 "../src/engine/util/util-html.vala"
					g_string_append (_result_, "&nbsp;");
#line 590 "util-html.c"
				}
			}
		}
	} else {
		const gchar* _tmp7_;
#line 125 "../src/engine/util/util-html.vala"
		_tmp7_ = match;
#line 125 "../src/engine/util/util-html.vala"
		if (g_strcmp0 (_tmp7_, "\t") == 0) {
#line 126 "../src/engine/util/util-html.vala"
			g_string_append (_result_, " &nbsp;&nbsp;&nbsp;");
#line 602 "util-html.c"
		} else {
#line 128 "../src/engine/util/util-html.vala"
			g_string_append (_result_, "<br>");
#line 606 "util-html.c"
		}
	}
#line 130 "../src/engine/util/util-html.vala"
	result = FALSE;
#line 130 "../src/engine/util/util-html.vala"
	_g_free0 (match);
#line 130 "../src/engine/util/util-html.vala"
	return result;
#line 615 "util-html.c"
}

static gboolean
_____lambda165__gregex_eval_callback (GMatchInfo* match_info,
                                      GString* _result_,
                                      gpointer self)
{
	gboolean result;
	result = ____lambda165_ (match_info, _result_);
#line 117 "../src/engine/util/util-html.vala"
	return result;
#line 627 "util-html.c"
}

gchar*
geary_html_preserve_whitespace (const gchar* text)
{
	gchar* result = NULL;
	gchar* preserved = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 114 "../src/engine/util/util-html.vala"
	_tmp0_ = g_strdup ("");
#line 114 "../src/engine/util/util-html.vala"
	preserved = _tmp0_;
#line 115 "../src/engine/util/util-html.vala"
	if (!geary_string_is_empty (text)) {
#line 643 "util-html.c"
		{
			gchar* _tmp1_ = NULL;
			GRegex* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 117 "../src/engine/util/util-html.vala"
			_tmp2_ = geary_html_WHITESPACE_REGEX;
#line 117 "../src/engine/util/util-html.vala"
			_tmp3_ = g_regex_replace_eval (_tmp2_, text, (gssize) -1, 0, 0, _____lambda165__gregex_eval_callback, NULL, &_inner_error0_);
#line 117 "../src/engine/util/util-html.vala"
			_tmp1_ = _tmp3_;
#line 117 "../src/engine/util/util-html.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 657 "util-html.c"
				goto __catch285_g_error;
			}
#line 117 "../src/engine/util/util-html.vala"
			_tmp4_ = _tmp1_;
#line 117 "../src/engine/util/util-html.vala"
			_tmp1_ = NULL;
#line 117 "../src/engine/util/util-html.vala"
			_g_free0 (preserved);
#line 117 "../src/engine/util/util-html.vala"
			preserved = _tmp4_;
#line 116 "../src/engine/util/util-html.vala"
			_g_free0 (_tmp1_);
#line 670 "util-html.c"
		}
		goto __finally285;
		__catch285_g_error:
		{
			GError* err = NULL;
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 116 "../src/engine/util/util-html.vala"
			err = _inner_error0_;
#line 116 "../src/engine/util/util-html.vala"
			_inner_error0_ = NULL;
#line 133 "../src/engine/util/util-html.vala"
			_tmp5_ = err;
#line 133 "../src/engine/util/util-html.vala"
			_tmp6_ = _tmp5_->message;
#line 133 "../src/engine/util/util-html.vala"
			g_debug ("util-html.vala:133: Error preserving whitespace: %s", _tmp6_);
#line 116 "../src/engine/util/util-html.vala"
			_g_error_free0 (err);
#line 690 "util-html.c"
		}
		__finally285:
#line 116 "../src/engine/util/util-html.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/engine/util/util-html.vala"
			_g_free0 (preserved);
#line 116 "../src/engine/util/util-html.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/engine/util/util-html.vala"
			g_clear_error (&_inner_error0_);
#line 116 "../src/engine/util/util-html.vala"
			return NULL;
#line 703 "util-html.c"
		}
	}
#line 136 "../src/engine/util/util-html.vala"
	result = preserved;
#line 136 "../src/engine/util/util-html.vala"
	return result;
#line 710 "util-html.c"
}

/**
 * Escape reserved HTML entities and preserves whitespace, if needed.
 *
 * Returns a string with reserved HTML entities escaped and
 * whitespace preserved if the given string does not have HTML
 * tags.
 */
gchar*
geary_html_smart_escape (const gchar* text)
{
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* escaped = NULL;
	gchar* _tmp1_;
#line 147 "../src/engine/util/util-html.vala"
	_tmp0_ = text;
#line 147 "../src/engine/util/util-html.vala"
	if (_tmp0_ == NULL) {
#line 147 "../src/engine/util/util-html.vala"
		_tmp0_ = "";
#line 733 "util-html.c"
	}
#line 147 "../src/engine/util/util-html.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 147 "../src/engine/util/util-html.vala"
	escaped = _tmp1_;
#line 148 "../src/engine/util/util-html.vala"
	if (text != NULL) {
#line 741 "util-html.c"
		gboolean is_html = FALSE;
#line 149 "../src/engine/util/util-html.vala"
		is_html = g_regex_match_simple ("<[A-Z]+ ?(?: [^>]*)?\\/?>", text, G_REGEX_CASELESS, 0);
#line 152 "../src/engine/util/util-html.vala"
		if (!is_html) {
#line 747 "util-html.c"
			const gchar* _tmp2_;
			gchar* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
#line 153 "../src/engine/util/util-html.vala"
			_tmp2_ = escaped;
#line 153 "../src/engine/util/util-html.vala"
			_tmp3_ = geary_html_escape_markup (_tmp2_);
#line 153 "../src/engine/util/util-html.vala"
			_g_free0 (escaped);
#line 153 "../src/engine/util/util-html.vala"
			escaped = _tmp3_;
#line 154 "../src/engine/util/util-html.vala"
			_tmp4_ = escaped;
#line 154 "../src/engine/util/util-html.vala"
			_tmp5_ = geary_html_preserve_whitespace (_tmp4_);
#line 154 "../src/engine/util/util-html.vala"
			_g_free0 (escaped);
#line 154 "../src/engine/util/util-html.vala"
			escaped = _tmp5_;
#line 768 "util-html.c"
		}
	}
#line 157 "../src/engine/util/util-html.vala"
	result = escaped;
#line 157 "../src/engine/util/util-html.vala"
	return result;
#line 775 "util-html.c"
}

/**
 * Does a very approximate conversion from HTML to text.
 *
 * This does more than stripping tags -- it inserts line breaks where
 * appropriate, decodes entities, etc. Note the full string is parsed
 * by libxml's HTML parser to create a DOM-like tree representation,
 * which is then walked, so this function can be somewhat
 * computationally expensive.
 */
gchar*
geary_html_html_to_text (const gchar* html,
                         gboolean include_blockquotes,
                         const gchar* encoding)
{
	gchar* result = NULL;
	xmlDoc* doc = NULL;
	xmlDoc* _tmp0_;
	GString* text = NULL;
	GString* _tmp1_;
	xmlDoc* _tmp2_;
	GString* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
#line 169 "../src/engine/util/util-html.vala"
	g_return_val_if_fail (html != NULL, NULL);
#line 169 "../src/engine/util/util-html.vala"
	g_return_val_if_fail (encoding != NULL, NULL);
#line 172 "../src/engine/util/util-html.vala"
	_tmp0_ = htmlReadDoc ((xmlChar*) html, "", encoding, (gint) (((((HTML_PARSE_RECOVER | HTML_PARSE_NOERROR) | HTML_PARSE_NOWARNING) | HTML_PARSE_NOBLANKS) | HTML_PARSE_NONET) | HTML_PARSE_COMPACT));
#line 172 "../src/engine/util/util-html.vala"
	doc = _tmp0_;
#line 176 "../src/engine/util/util-html.vala"
	_tmp1_ = g_string_new ("");
#line 176 "../src/engine/util/util-html.vala"
	text = _tmp1_;
#line 177 "../src/engine/util/util-html.vala"
	_tmp2_ = doc;
#line 177 "../src/engine/util/util-html.vala"
	if (_tmp2_ != NULL) {
#line 817 "util-html.c"
		xmlDoc* _tmp3_;
		xmlNode* _tmp4_;
		GString* _tmp5_;
		xmlDoc* _tmp6_;
#line 178 "../src/engine/util/util-html.vala"
		_tmp3_ = doc;
#line 178 "../src/engine/util/util-html.vala"
		_tmp4_ = xmlDocGetRootElement (_tmp3_);
#line 178 "../src/engine/util/util-html.vala"
		_tmp5_ = text;
#line 178 "../src/engine/util/util-html.vala"
		geary_html_recurse_html_nodes_for_text (_tmp4_, include_blockquotes, _tmp5_);
#line 179 "../src/engine/util/util-html.vala"
		_tmp6_ = doc;
#line 179 "../src/engine/util/util-html.vala"
		xmlFreeDoc (_tmp6_);
#line 834 "util-html.c"
	}
#line 182 "../src/engine/util/util-html.vala"
	_tmp7_ = text;
#line 182 "../src/engine/util/util-html.vala"
	_tmp8_ = _tmp7_->str;
#line 182 "../src/engine/util/util-html.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 182 "../src/engine/util/util-html.vala"
	result = _tmp9_;
#line 182 "../src/engine/util/util-html.vala"
	_g_string_free0 (text);
#line 182 "../src/engine/util/util-html.vala"
	return result;
#line 848 "util-html.c"
}

void
geary_html_recurse_html_nodes_for_text (xmlNode* node,
                                        gboolean include_blockquotes,
                                        GString* text)
{
#line 185 "../src/engine/util/util-html.vala"
	g_return_if_fail (text != NULL);
#line 858 "util-html.c"
	{
		xmlNode* n = NULL;
#line 188 "../src/engine/util/util-html.vala"
		n = node;
#line 863 "util-html.c"
		{
			gboolean _tmp0_ = FALSE;
#line 188 "../src/engine/util/util-html.vala"
			_tmp0_ = TRUE;
#line 188 "../src/engine/util/util-html.vala"
			while (TRUE) {
#line 870 "util-html.c"
				xmlNode* _tmp3_;
				xmlNode* _tmp4_;
				xmlElementType _tmp5_;
#line 188 "../src/engine/util/util-html.vala"
				if (!_tmp0_) {
#line 876 "util-html.c"
					xmlNode* _tmp1_;
					xmlNode* _tmp2_;
#line 188 "../src/engine/util/util-html.vala"
					_tmp1_ = n;
#line 188 "../src/engine/util/util-html.vala"
					_tmp2_ = _tmp1_->next;
#line 188 "../src/engine/util/util-html.vala"
					n = _tmp2_;
#line 885 "util-html.c"
				}
#line 188 "../src/engine/util/util-html.vala"
				_tmp0_ = FALSE;
#line 188 "../src/engine/util/util-html.vala"
				_tmp3_ = n;
#line 188 "../src/engine/util/util-html.vala"
				if (!(_tmp3_ != NULL)) {
#line 188 "../src/engine/util/util-html.vala"
					break;
#line 895 "util-html.c"
				}
#line 189 "../src/engine/util/util-html.vala"
				_tmp4_ = n;
#line 189 "../src/engine/util/util-html.vala"
				_tmp5_ = _tmp4_->type;
#line 189 "../src/engine/util/util-html.vala"
				if (_tmp5_ == XML_TEXT_NODE) {
#line 903 "util-html.c"
					xmlNode* _tmp6_;
					const gchar* _tmp7_;
#line 190 "../src/engine/util/util-html.vala"
					_tmp6_ = n;
#line 190 "../src/engine/util/util-html.vala"
					_tmp7_ = _tmp6_->content;
#line 190 "../src/engine/util/util-html.vala"
					g_string_append (text, _tmp7_);
#line 912 "util-html.c"
				} else {
					xmlNode* _tmp8_;
					xmlElementType _tmp9_;
#line 191 "../src/engine/util/util-html.vala"
					_tmp8_ = n;
#line 191 "../src/engine/util/util-html.vala"
					_tmp9_ = _tmp8_->type;
#line 191 "../src/engine/util/util-html.vala"
					if (_tmp9_ == XML_ELEMENT_NODE) {
#line 922 "util-html.c"
						gchar* name = NULL;
						xmlNode* _tmp10_;
						const gchar* _tmp11_;
						gchar* _tmp12_;
						gboolean _tmp13_ = FALSE;
#line 192 "../src/engine/util/util-html.vala"
						_tmp10_ = n;
#line 192 "../src/engine/util/util-html.vala"
						_tmp11_ = _tmp10_->name;
#line 192 "../src/engine/util/util-html.vala"
						_tmp12_ = g_strdup (_tmp11_);
#line 192 "../src/engine/util/util-html.vala"
						name = _tmp12_;
#line 193 "../src/engine/util/util-html.vala"
						if (include_blockquotes) {
#line 193 "../src/engine/util/util-html.vala"
							_tmp13_ = TRUE;
#line 940 "util-html.c"
						} else {
							const gchar* _tmp14_;
#line 193 "../src/engine/util/util-html.vala"
							_tmp14_ = name;
#line 193 "../src/engine/util/util-html.vala"
							_tmp13_ = g_strcmp0 (_tmp14_, "blockquote") != 0;
#line 947 "util-html.c"
						}
#line 193 "../src/engine/util/util-html.vala"
						if (_tmp13_) {
#line 951 "util-html.c"
							GeeHashSet* _tmp15_;
							const gchar* _tmp16_;
							GeeHashSet* _tmp20_;
							const gchar* _tmp21_;
							GeeHashSet* _tmp24_;
							const gchar* _tmp25_;
							GeeHashSet* _tmp26_;
							const gchar* _tmp27_;
#line 194 "../src/engine/util/util-html.vala"
							_tmp15_ = geary_html_alt_text_elements;
#line 194 "../src/engine/util/util-html.vala"
							_tmp16_ = name;
#line 194 "../src/engine/util/util-html.vala"
							if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp16_)) {
#line 966 "util-html.c"
								gchar* alt_text = NULL;
								gchar* _tmp17_;
								const gchar* _tmp18_;
#line 195 "../src/engine/util/util-html.vala"
								_tmp17_ = (gchar*) xmlGetProp (node, (xmlChar*) "alt");
#line 195 "../src/engine/util/util-html.vala"
								alt_text = _tmp17_;
#line 196 "../src/engine/util/util-html.vala"
								_tmp18_ = alt_text;
#line 196 "../src/engine/util/util-html.vala"
								if (_tmp18_ != NULL) {
#line 978 "util-html.c"
									const gchar* _tmp19_;
#line 197 "../src/engine/util/util-html.vala"
									_tmp19_ = alt_text;
#line 197 "../src/engine/util/util-html.vala"
									g_string_append (text, _tmp19_);
#line 984 "util-html.c"
								}
#line 194 "../src/engine/util/util-html.vala"
								_g_free0 (alt_text);
#line 988 "util-html.c"
							}
#line 201 "../src/engine/util/util-html.vala"
							_tmp20_ = geary_html_ignored_elements;
#line 201 "../src/engine/util/util-html.vala"
							_tmp21_ = name;
#line 201 "../src/engine/util/util-html.vala"
							if (!gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp21_)) {
#line 996 "util-html.c"
								xmlNode* _tmp22_;
								xmlNode* _tmp23_;
#line 202 "../src/engine/util/util-html.vala"
								_tmp22_ = n;
#line 202 "../src/engine/util/util-html.vala"
								_tmp23_ = _tmp22_->children;
#line 202 "../src/engine/util/util-html.vala"
								geary_html_recurse_html_nodes_for_text (_tmp23_, include_blockquotes, text);
#line 1005 "util-html.c"
							}
#line 205 "../src/engine/util/util-html.vala"
							_tmp24_ = geary_html_spacing_elements;
#line 205 "../src/engine/util/util-html.vala"
							_tmp25_ = name;
#line 205 "../src/engine/util/util-html.vala"
							if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp25_)) {
#line 206 "../src/engine/util/util-html.vala"
								g_string_append (text, " ");
#line 1015 "util-html.c"
							}
#line 209 "../src/engine/util/util-html.vala"
							_tmp26_ = geary_html_breaking_elements;
#line 209 "../src/engine/util/util-html.vala"
							_tmp27_ = name;
#line 209 "../src/engine/util/util-html.vala"
							if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp27_)) {
#line 210 "../src/engine/util/util-html.vala"
								g_string_append (text, "\n");
#line 1025 "util-html.c"
							}
						}
#line 191 "../src/engine/util/util-html.vala"
						_g_free0 (name);
#line 1030 "util-html.c"
					}
				}
			}
		}
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

