/* util-js.c generated by valac 0.44.1, the Vala compiler
 * generated from util-js.vala, do not modify */

/*
 * Copyright 2017 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <JavaScriptCore/JavaScript.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define GEARY_JS_TYPE_CALLABLE (geary_js_callable_get_type ())
#define GEARY_JS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallable))
#define GEARY_JS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))
#define GEARY_JS_IS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_IS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_JS_TYPE_CALLABLE))
#define GEARY_JS_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_JS_TYPE_CALLABLE, GearyJSCallableClass))

typedef struct _GearyJSCallable GearyJSCallable;
typedef struct _GearyJSCallableClass GearyJSCallableClass;
typedef struct _GearyJSCallablePrivate GearyJSCallablePrivate;
typedef struct _GearyJSParamSpecCallable GearyJSParamSpecCallable;

/**
     * Errors produced by functions in {@link Geary.JS}.
     */
typedef enum  {
	GEARY_JS_ERROR_EXCEPTION,
	GEARY_JS_ERROR_TYPE
} GearyJSError;
#define GEARY_JS_ERROR geary_js_error_quark ()
struct _GearyJSCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GearyJSCallablePrivate * priv;
};

struct _GearyJSCallableClass {
	GTypeClass parent_class;
	void (*finalize) (GearyJSCallable *self);
};

struct _GearyJSCallablePrivate {
	gchar* base_name;
	gchar** safe_args;
	gint safe_args_length1;
	gint _safe_args_size_;
};

struct _GearyJSParamSpecCallable {
	GParamSpec parent_instance;
};

static gint GearyJSCallable_private_offset;
static gpointer geary_js_callable_parent_class = NULL;

GQuark geary_js_error_quark (void);
gboolean geary_js_is_null (const struct OpaqueJSContext* context,
                           const struct OpaqueJSValue* js);
gdouble geary_js_to_number (const struct OpaqueJSContext* context,
                            const struct OpaqueJSValue* value,
                            GError** error);
void geary_js_check_exception (const struct OpaqueJSContext* context,
                               const struct OpaqueJSValue* err_value,
                               GError** error);
gchar* geary_js_to_string (const struct OpaqueJSContext* context,
                           const struct OpaqueJSValue* value,
                           GError** error);
gchar* geary_js_to_native_string (struct OpaqueJSString* js);
struct OpaqueJSValue* geary_js_to_object (const struct OpaqueJSContext* context,
                                          const struct OpaqueJSValue* value,
                                          GError** error);
const struct OpaqueJSValue* geary_js_get_property (const struct OpaqueJSContext* context,
                                                   struct OpaqueJSValue* object,
                                                   const gchar* name,
                                                   GError** error);
const gchar* JS_type_to_string (JSType self);
static const char* _JS_type_to_string (JSType value);
gchar* geary_js_escape_string (const gchar* value);
gpointer geary_js_callable_ref (gpointer instance);
void geary_js_callable_unref (gpointer instance);
GParamSpec* geary_js_param_spec_callable (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void geary_js_value_set_callable (GValue* value,
                                  gpointer v_object);
void geary_js_value_take_callable (GValue* value,
                                   gpointer v_object);
gpointer geary_js_value_get_callable (const GValue* value);
GType geary_js_callable_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyJSCallable, geary_js_callable_unref)
GearyJSCallable* geary_js_callable (const gchar* base_name);
GearyJSCallable* geary_js_callable_new (const gchar* base_name);
GearyJSCallable* geary_js_callable_construct (GType object_type,
                                              const gchar* base_name);
gchar* geary_js_callable_to_string (GearyJSCallable* self);
GearyJSCallable* geary_js_callable_string (GearyJSCallable* self,
                                           const gchar* value);
static inline void geary_js_callable_add_param (GearyJSCallable* self,
                                  const gchar* value);
GearyJSCallable* geary_js_callable_double (GearyJSCallable* self,
                                           gdouble value);
GearyJSCallable* geary_js_callable_int (GearyJSCallable* self,
                                        gint value);
GearyJSCallable* geary_js_callable_bool (GearyJSCallable* self,
                                         gboolean value);
static void _vala_array_add24 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void geary_js_callable_finalize (GearyJSCallable * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

GQuark
geary_js_error_quark (void)
{
	return g_quark_from_static_string ("geary-js-error-quark");
}

/**
     * Determines if a {@link JS.Value} object is {{{null}}}.
     *
     * @return `true` if `js` is `null` or has a {@link JS.Type} of
     * `NULL` according to `context`.
     */
inline gboolean
geary_js_is_null (const struct OpaqueJSContext* context,
                  const struct OpaqueJSValue* js)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 44 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 46 "../src/engine/util/util-js.vala"
	if (js == NULL) {
#line 46 "../src/engine/util/util-js.vala"
		_tmp0_ = TRUE;
#line 159 "util-js.c"
	} else {
#line 46 "../src/engine/util/util-js.vala"
		_tmp0_ = JSValueGetType (context, js) == kJSTypeNull;
#line 163 "util-js.c"
	}
#line 46 "../src/engine/util/util-js.vala"
	result = _tmp0_;
#line 46 "../src/engine/util/util-js.vala"
	return result;
#line 169 "util-js.c"
}

/**
     * Returns a JSC Value as a number.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
gdouble
geary_js_to_number (const struct OpaqueJSContext* context,
                    const struct OpaqueJSValue* value,
                    GError** error)
{
	gdouble result = 0.0;
	const struct OpaqueJSValue* err = NULL;
	gdouble number = 0.0;
	const struct OpaqueJSValue* _tmp3_ = NULL;
	gdouble _tmp4_;
	const struct OpaqueJSValue* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 55 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, 0.0);
#line 55 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, 0.0);
#line 58 "../src/engine/util/util-js.vala"
	if (!JSValueIsNumber (context, value)) {
#line 196 "util-js.c"
		GError* _tmp0_;
#line 59 "../src/engine/util/util-js.vala"
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Number object");
#line 59 "../src/engine/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 59 "../src/engine/util/util-js.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 204 "util-js.c"
			gdouble _tmp1_ = -1.0;
#line 59 "../src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 59 "../src/engine/util/util-js.vala"
			return _tmp1_;
#line 210 "util-js.c"
		} else {
			gdouble _tmp2_ = -1.0;
#line 59 "../src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "../src/engine/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 59 "../src/engine/util/util-js.vala"
			return _tmp2_;
#line 219 "util-js.c"
		}
	}
#line 62 "../src/engine/util/util-js.vala"
	err = NULL;
#line 63 "../src/engine/util/util-js.vala"
	_tmp4_ = JSValueToNumber (context, value, &_tmp3_);
#line 63 "../src/engine/util/util-js.vala"
	_0 (err);
#line 63 "../src/engine/util/util-js.vala"
	err = _tmp3_;
#line 63 "../src/engine/util/util-js.vala"
	number = _tmp4_;
#line 64 "../src/engine/util/util-js.vala"
	_tmp5_ = err;
#line 64 "../src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp5_, &_inner_error0_);
#line 64 "../src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/engine/util/util-js.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 240 "util-js.c"
			gdouble _tmp6_ = -1.0;
#line 64 "../src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 64 "../src/engine/util/util-js.vala"
			_0 (err);
#line 64 "../src/engine/util/util-js.vala"
			return _tmp6_;
#line 248 "util-js.c"
		} else {
			gdouble _tmp7_ = -1.0;
#line 64 "../src/engine/util/util-js.vala"
			_0 (err);
#line 64 "../src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/engine/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 64 "../src/engine/util/util-js.vala"
			return _tmp7_;
#line 259 "util-js.c"
		}
	}
#line 65 "../src/engine/util/util-js.vala"
	result = number;
#line 65 "../src/engine/util/util-js.vala"
	_0 (err);
#line 65 "../src/engine/util/util-js.vala"
	return result;
#line 268 "util-js.c"
}

/**
     * Returns a JSC Value as a string.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `String`.
     */
gchar*
geary_js_to_string (const struct OpaqueJSContext* context,
                    const struct OpaqueJSValue* value,
                    GError** error)
{
	gchar* result = NULL;
	const struct OpaqueJSValue* err = NULL;
	struct OpaqueJSString* js_str = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSString* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 74 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 74 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 77 "../src/engine/util/util-js.vala"
	if (!JSValueIsString (context, value)) {
#line 296 "util-js.c"
		GError* _tmp0_;
#line 78 "../src/engine/util/util-js.vala"
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS String object");
#line 78 "../src/engine/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 78 "../src/engine/util/util-js.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 78 "../src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 78 "../src/engine/util/util-js.vala"
			return NULL;
#line 308 "util-js.c"
		} else {
#line 78 "../src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../src/engine/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 78 "../src/engine/util/util-js.vala"
			return NULL;
#line 316 "util-js.c"
		}
	}
#line 81 "../src/engine/util/util-js.vala"
	err = NULL;
#line 82 "../src/engine/util/util-js.vala"
	_tmp2_ = JSValueToStringCopy (context, value, &_tmp1_);
#line 82 "../src/engine/util/util-js.vala"
	_0 (err);
#line 82 "../src/engine/util/util-js.vala"
	err = _tmp1_;
#line 82 "../src/engine/util/util-js.vala"
	js_str = _tmp2_;
#line 83 "../src/engine/util/util-js.vala"
	_tmp3_ = err;
#line 83 "../src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp3_, &_inner_error0_);
#line 83 "../src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 83 "../src/engine/util/util-js.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 83 "../src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 83 "../src/engine/util/util-js.vala"
			_JSStringRelease0 (js_str);
#line 83 "../src/engine/util/util-js.vala"
			_0 (err);
#line 83 "../src/engine/util/util-js.vala"
			return NULL;
#line 345 "util-js.c"
		} else {
#line 83 "../src/engine/util/util-js.vala"
			_JSStringRelease0 (js_str);
#line 83 "../src/engine/util/util-js.vala"
			_0 (err);
#line 83 "../src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../src/engine/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 83 "../src/engine/util/util-js.vala"
			return NULL;
#line 357 "util-js.c"
		}
	}
#line 85 "../src/engine/util/util-js.vala"
	_tmp4_ = geary_js_to_native_string (js_str);
#line 85 "../src/engine/util/util-js.vala"
	result = _tmp4_;
#line 85 "../src/engine/util/util-js.vala"
	_JSStringRelease0 (js_str);
#line 85 "../src/engine/util/util-js.vala"
	_0 (err);
#line 85 "../src/engine/util/util-js.vala"
	return result;
#line 370 "util-js.c"
}

/**
     * Returns a JSC Value as an object.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * value is not a JavaScript `Object`.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
struct OpaqueJSValue*
geary_js_to_object (const struct OpaqueJSContext* context,
                    const struct OpaqueJSValue* value,
                    GError** error)
{
	struct OpaqueJSValue* result = NULL;
	const struct OpaqueJSValue* err = NULL;
	struct OpaqueJSValue* js_obj = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	struct OpaqueJSValue* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 97 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 97 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 100 "../src/engine/util/util-js.vala"
	if (!JSValueIsObject (context, value)) {
#line 400 "util-js.c"
		GError* _tmp0_;
#line 101 "../src/engine/util/util-js.vala"
		_tmp0_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_TYPE, "Value is not a JS Object");
#line 101 "../src/engine/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 101 "../src/engine/util/util-js.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 101 "../src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 101 "../src/engine/util/util-js.vala"
			return NULL;
#line 412 "util-js.c"
		} else {
#line 101 "../src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "../src/engine/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 101 "../src/engine/util/util-js.vala"
			return NULL;
#line 420 "util-js.c"
		}
	}
#line 104 "../src/engine/util/util-js.vala"
	err = NULL;
#line 105 "../src/engine/util/util-js.vala"
	_tmp2_ = JSValueToObject (context, value, &_tmp1_);
#line 105 "../src/engine/util/util-js.vala"
	_0 (err);
#line 105 "../src/engine/util/util-js.vala"
	err = _tmp1_;
#line 105 "../src/engine/util/util-js.vala"
	js_obj = _tmp2_;
#line 106 "../src/engine/util/util-js.vala"
	_tmp3_ = err;
#line 106 "../src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp3_, &_inner_error0_);
#line 106 "../src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/engine/util/util-js.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 106 "../src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 106 "../src/engine/util/util-js.vala"
			_0 (js_obj);
#line 106 "../src/engine/util/util-js.vala"
			_0 (err);
#line 106 "../src/engine/util/util-js.vala"
			return NULL;
#line 449 "util-js.c"
		} else {
#line 106 "../src/engine/util/util-js.vala"
			_0 (js_obj);
#line 106 "../src/engine/util/util-js.vala"
			_0 (err);
#line 106 "../src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "../src/engine/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 106 "../src/engine/util/util-js.vala"
			return NULL;
#line 461 "util-js.c"
		}
	}
#line 108 "../src/engine/util/util-js.vala"
	result = js_obj;
#line 108 "../src/engine/util/util-js.vala"
	_0 (err);
#line 108 "../src/engine/util/util-js.vala"
	return result;
#line 470 "util-js.c"
}

/**
     * Returns a JSC {@link JS.String} as a Vala {@link string}.
     */
inline gchar*
geary_js_to_native_string (struct OpaqueJSString* js)
{
	gchar* result = NULL;
	gsize len = 0UL;
	guint8* str = NULL;
	guint8* _tmp0_;
	gint str_length1;
	gint _str_size_;
	gchar* _tmp1_;
#line 114 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (js != NULL, NULL);
#line 115 "../src/engine/util/util-js.vala"
	len = JSStringGetMaximumUTF8CStringSize (js);
#line 116 "../src/engine/util/util-js.vala"
	_tmp0_ = g_new0 (guint8, len);
#line 116 "../src/engine/util/util-js.vala"
	str = _tmp0_;
#line 116 "../src/engine/util/util-js.vala"
	str_length1 = len;
#line 116 "../src/engine/util/util-js.vala"
	_str_size_ = str_length1;
#line 118 "../src/engine/util/util-js.vala"
	JSStringGetUTF8CString (js, str, (gsize) str_length1);
#line 122 "../src/engine/util/util-js.vala"
	_tmp1_ = g_strdup ((const gchar*) str);
#line 122 "../src/engine/util/util-js.vala"
	result = _tmp1_;
#line 122 "../src/engine/util/util-js.vala"
	str = (g_free (str), NULL);
#line 122 "../src/engine/util/util-js.vala"
	return result;
#line 508 "util-js.c"
}

/**
     * Returns the value of an object's property.
     *
     * This will raise a {@link Geary.JS.Error.TYPE} error if the
     * object does not contain the named property.
     *
     * Return type is nullable as a workaround for Bug 778046, it will
     * never actually be null.
     */
inline const struct OpaqueJSValue*
geary_js_get_property (const struct OpaqueJSContext* context,
                       struct OpaqueJSValue* object,
                       const gchar* name,
                       GError** error)
{
	const struct OpaqueJSValue* result = NULL;
	struct OpaqueJSString* js_name = NULL;
	struct OpaqueJSString* _tmp0_;
	const struct OpaqueJSValue* err = NULL;
	const struct OpaqueJSValue* prop = NULL;
	const struct OpaqueJSValue* _tmp1_ = NULL;
	const struct OpaqueJSValue* _tmp2_;
	const struct OpaqueJSValue* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 134 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 134 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (object != NULL, NULL);
#line 134 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 138 "../src/engine/util/util-js.vala"
	_tmp0_ = JSStringCreateWithUTF8CString (name);
#line 138 "../src/engine/util/util-js.vala"
	js_name = _tmp0_;
#line 139 "../src/engine/util/util-js.vala"
	err = NULL;
#line 140 "../src/engine/util/util-js.vala"
	_tmp2_ = JSObjectGetProperty (context, object, js_name, &_tmp1_);
#line 140 "../src/engine/util/util-js.vala"
	_0 (err);
#line 140 "../src/engine/util/util-js.vala"
	err = _tmp1_;
#line 140 "../src/engine/util/util-js.vala"
	prop = _tmp2_;
#line 141 "../src/engine/util/util-js.vala"
	_tmp3_ = err;
#line 141 "../src/engine/util/util-js.vala"
	geary_js_check_exception (context, _tmp3_, &_inner_error0_);
#line 141 "../src/engine/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "../src/engine/util/util-js.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 141 "../src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 141 "../src/engine/util/util-js.vala"
			_0 (prop);
#line 141 "../src/engine/util/util-js.vala"
			_0 (err);
#line 141 "../src/engine/util/util-js.vala"
			_JSStringRelease0 (js_name);
#line 141 "../src/engine/util/util-js.vala"
			return NULL;
#line 573 "util-js.c"
		} else {
#line 141 "../src/engine/util/util-js.vala"
			_0 (prop);
#line 141 "../src/engine/util/util-js.vala"
			_0 (err);
#line 141 "../src/engine/util/util-js.vala"
			_JSStringRelease0 (js_name);
#line 141 "../src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "../src/engine/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 141 "../src/engine/util/util-js.vala"
			return NULL;
#line 587 "util-js.c"
		}
	}
#line 143 "../src/engine/util/util-js.vala"
	result = prop;
#line 143 "../src/engine/util/util-js.vala"
	_0 (err);
#line 143 "../src/engine/util/util-js.vala"
	_JSStringRelease0 (js_name);
#line 143 "../src/engine/util/util-js.vala"
	return result;
#line 598 "util-js.c"
}

/**
     * Checks an JS exception returned from a JSC call.
     *
     * This method will raise a {@link Geary.JS.Error} if the given
     * `err_value` is not null (in a Vala or JS sense).
     */
static const char*
_JS_type_to_string (JSType value)
{
#line 162 "../src/engine/util/util-js.vala"
	switch (value) {
#line 162 "../src/engine/util/util-js.vala"
		case kJSTypeUndefined:
#line 162 "../src/engine/util/util-js.vala"
		return "kJSTypeUndefined";
#line 162 "../src/engine/util/util-js.vala"
		case kJSTypeNull:
#line 162 "../src/engine/util/util-js.vala"
		return "kJSTypeNull";
#line 162 "../src/engine/util/util-js.vala"
		case kJSTypeBoolean:
#line 162 "../src/engine/util/util-js.vala"
		return "kJSTypeBoolean";
#line 162 "../src/engine/util/util-js.vala"
		case kJSTypeNumber:
#line 162 "../src/engine/util/util-js.vala"
		return "kJSTypeNumber";
#line 162 "../src/engine/util/util-js.vala"
		case kJSTypeString:
#line 162 "../src/engine/util/util-js.vala"
		return "kJSTypeString";
#line 162 "../src/engine/util/util-js.vala"
		case kJSTypeObject:
#line 162 "../src/engine/util/util-js.vala"
		return "kJSTypeObject";
#line 636 "util-js.c"
	}
#line 162 "../src/engine/util/util-js.vala"
	return NULL;
#line 640 "util-js.c"
}

inline void
geary_js_check_exception (const struct OpaqueJSContext* context,
                          const struct OpaqueJSValue* err_value,
                          GError** error)
{
	GError* _inner_error0_ = NULL;
#line 152 "../src/engine/util/util-js.vala"
	g_return_if_fail (context != NULL);
#line 155 "../src/engine/util/util-js.vala"
	if (!geary_js_is_null (context, err_value)) {
#line 653 "util-js.c"
		const struct OpaqueJSValue* nested_err = NULL;
		JSType err_type = 0;
		struct OpaqueJSString* err_str = NULL;
		const struct OpaqueJSValue* _tmp0_ = NULL;
		struct OpaqueJSString* _tmp1_;
		const struct OpaqueJSValue* _tmp2_;
		JSType _tmp6_;
		const gchar* _tmp7_;
		struct OpaqueJSString* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GError* _tmp13_;
		GError* _tmp14_;
#line 156 "../src/engine/util/util-js.vala"
		nested_err = NULL;
#line 157 "../src/engine/util/util-js.vala"
		err_type = JSValueGetType (context, err_value);
#line 158 "../src/engine/util/util-js.vala"
		_tmp1_ = JSValueToStringCopy (context, err_value, &_tmp0_);
#line 158 "../src/engine/util/util-js.vala"
		_0 (nested_err);
#line 158 "../src/engine/util/util-js.vala"
		nested_err = _tmp0_;
#line 158 "../src/engine/util/util-js.vala"
		err_str = _tmp1_;
#line 161 "../src/engine/util/util-js.vala"
		_tmp2_ = nested_err;
#line 161 "../src/engine/util/util-js.vala"
		if (!geary_js_is_null (context, _tmp2_)) {
#line 685 "util-js.c"
			JSType _tmp3_;
			const gchar* _tmp4_;
			GError* _tmp5_;
#line 162 "../src/engine/util/util-js.vala"
			_tmp3_ = err_type;
#line 162 "../src/engine/util/util-js.vala"
			_tmp4_ = _JS_type_to_string (_tmp3_);
#line 162 "../src/engine/util/util-js.vala"
			_tmp5_ = g_error_new (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, "Nested exception getting exception %s as a string", _tmp4_);
#line 162 "../src/engine/util/util-js.vala"
			_inner_error0_ = _tmp5_;
#line 162 "../src/engine/util/util-js.vala"
			if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 162 "../src/engine/util/util-js.vala"
				g_propagate_error (error, _inner_error0_);
#line 162 "../src/engine/util/util-js.vala"
				_JSStringRelease0 (err_str);
#line 162 "../src/engine/util/util-js.vala"
				_0 (nested_err);
#line 162 "../src/engine/util/util-js.vala"
				return;
#line 707 "util-js.c"
			} else {
#line 162 "../src/engine/util/util-js.vala"
				_JSStringRelease0 (err_str);
#line 162 "../src/engine/util/util-js.vala"
				_0 (nested_err);
#line 162 "../src/engine/util/util-js.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 162 "../src/engine/util/util-js.vala"
				g_clear_error (&_inner_error0_);
#line 162 "../src/engine/util/util-js.vala"
				return;
#line 719 "util-js.c"
			}
		}
#line 168 "../src/engine/util/util-js.vala"
		_tmp6_ = err_type;
#line 168 "../src/engine/util/util-js.vala"
		_tmp7_ = _JS_type_to_string (_tmp6_);
#line 168 "../src/engine/util/util-js.vala"
		_tmp8_ = err_str;
#line 168 "../src/engine/util/util-js.vala"
		_tmp9_ = geary_js_to_native_string (_tmp8_);
#line 168 "../src/engine/util/util-js.vala"
		_tmp10_ = _tmp9_;
#line 168 "../src/engine/util/util-js.vala"
		_tmp11_ = g_strdup_printf ("JS exception thrown [%s]: %s", _tmp7_, _tmp10_);
#line 168 "../src/engine/util/util-js.vala"
		_tmp12_ = _tmp11_;
#line 168 "../src/engine/util/util-js.vala"
		_tmp13_ = g_error_new_literal (GEARY_JS_ERROR, GEARY_JS_ERROR_EXCEPTION, _tmp12_);
#line 168 "../src/engine/util/util-js.vala"
		_tmp14_ = _tmp13_;
#line 168 "../src/engine/util/util-js.vala"
		_g_free0 (_tmp12_);
#line 168 "../src/engine/util/util-js.vala"
		_g_free0 (_tmp10_);
#line 168 "../src/engine/util/util-js.vala"
		_inner_error0_ = _tmp14_;
#line 168 "../src/engine/util/util-js.vala"
		if (_inner_error0_->domain == GEARY_JS_ERROR) {
#line 168 "../src/engine/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 168 "../src/engine/util/util-js.vala"
			_JSStringRelease0 (err_str);
#line 168 "../src/engine/util/util-js.vala"
			_0 (nested_err);
#line 168 "../src/engine/util/util-js.vala"
			return;
#line 756 "util-js.c"
		} else {
#line 168 "../src/engine/util/util-js.vala"
			_JSStringRelease0 (err_str);
#line 168 "../src/engine/util/util-js.vala"
			_0 (nested_err);
#line 168 "../src/engine/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 168 "../src/engine/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 168 "../src/engine/util/util-js.vala"
			return;
#line 768 "util-js.c"
		}
#line 155 "../src/engine/util/util-js.vala"
		_JSStringRelease0 (err_str);
#line 155 "../src/engine/util/util-js.vala"
		_0 (nested_err);
#line 774 "util-js.c"
	}
}

/**
     * Escapes a string so as to be safe to use as a JS string literal.
     *
     * This does not append opening or closing quotes.
     */
static gboolean
string_valid_char (const gchar* self,
                   gint index)
{
	gboolean result = FALSE;
	guint8 c = 0U;
	guint8 _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 1186 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1187 "glib-2.0.vapi"
	_tmp0_ = ((guint8*) self)[index];
#line 1187 "glib-2.0.vapi"
	c = _tmp0_;
#line 1188 "glib-2.0.vapi"
	if (((gint) c) == 0x00) {
#line 1188 "glib-2.0.vapi"
		_tmp2_ = TRUE;
#line 802 "util-js.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 1188 "glib-2.0.vapi"
		if (((gint) c) >= 0x80) {
#line 1188 "glib-2.0.vapi"
			_tmp3_ = ((gint) c) < 0xc2;
#line 809 "util-js.c"
		} else {
#line 1188 "glib-2.0.vapi"
			_tmp3_ = FALSE;
#line 813 "util-js.c"
		}
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _tmp3_;
#line 817 "util-js.c"
	}
#line 1188 "glib-2.0.vapi"
	if (_tmp2_) {
#line 1188 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 823 "util-js.c"
	} else {
#line 1188 "glib-2.0.vapi"
		_tmp1_ = ((gint) c) >= 0xf5;
#line 827 "util-js.c"
	}
#line 1188 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1189 "glib-2.0.vapi"
		result = FALSE;
#line 1189 "glib-2.0.vapi"
		return result;
#line 835 "util-js.c"
	} else {
#line 1191 "glib-2.0.vapi"
		result = TRUE;
#line 1191 "glib-2.0.vapi"
		return result;
#line 841 "util-js.c"
	}
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1210 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1211 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1211 "glib-2.0.vapi"
	return result;
#line 856 "util-js.c"
}

static guint8*
g_string_get_data (GString* self,
                   gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 5000 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5001 "glib-2.0.vapi"
	_tmp0_ = self->str;
#line 5001 "glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 5001 "glib-2.0.vapi"
	res_length1 = -1;
#line 5001 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 5002 "glib-2.0.vapi"
	res_length1 = (gint) self->len;
#line 5003 "glib-2.0.vapi"
	_tmp1_ = res;
#line 5003 "glib-2.0.vapi"
	_tmp1__length1 = res_length1;
#line 5003 "glib-2.0.vapi"
	_tmp2_ = _tmp1_;
#line 5003 "glib-2.0.vapi"
	_tmp2__length1 = _tmp1__length1;
#line 5003 "glib-2.0.vapi"
	if (result_length1) {
#line 5003 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 896 "util-js.c"
	}
#line 5003 "glib-2.0.vapi"
	result = _tmp2_;
#line 5003 "glib-2.0.vapi"
	return result;
#line 902 "util-js.c"
}

gchar*
geary_js_escape_string (const gchar* value)
{
	gchar* result = NULL;
	GString* builder = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GString* _tmp2_;
	GString* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
	guint8* _tmp20_;
	gint _tmp20__length1;
	gchar* _tmp21_;
#line 180 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 181 "../src/engine/util/util-js.vala"
	_tmp0_ = strlen (value);
#line 181 "../src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 181 "../src/engine/util/util-js.vala"
	_tmp2_ = g_string_sized_new ((gsize) _tmp1_);
#line 181 "../src/engine/util/util-js.vala"
	builder = _tmp2_;
#line 929 "util-js.c"
	{
		gint i = 0;
#line 182 "../src/engine/util/util-js.vala"
		i = 0;
#line 934 "util-js.c"
		{
			gboolean _tmp3_ = FALSE;
#line 182 "../src/engine/util/util-js.vala"
			_tmp3_ = TRUE;
#line 182 "../src/engine/util/util-js.vala"
			while (TRUE) {
#line 941 "util-js.c"
				gint _tmp5_;
				gint _tmp6_;
#line 182 "../src/engine/util/util-js.vala"
				if (!_tmp3_) {
#line 946 "util-js.c"
					gint _tmp4_;
#line 182 "../src/engine/util/util-js.vala"
					_tmp4_ = i;
#line 182 "../src/engine/util/util-js.vala"
					i = _tmp4_ + 1;
#line 952 "util-js.c"
				}
#line 182 "../src/engine/util/util-js.vala"
				_tmp3_ = FALSE;
#line 182 "../src/engine/util/util-js.vala"
				_tmp5_ = strlen (value);
#line 182 "../src/engine/util/util-js.vala"
				_tmp6_ = _tmp5_;
#line 182 "../src/engine/util/util-js.vala"
				if (!(i < _tmp6_)) {
#line 182 "../src/engine/util/util-js.vala"
					break;
#line 964 "util-js.c"
				}
#line 183 "../src/engine/util/util-js.vala"
				if (string_valid_char (value, i)) {
#line 968 "util-js.c"
					gunichar c = 0U;
#line 184 "../src/engine/util/util-js.vala"
					c = string_get_char (value, (glong) i);
#line 185 "../src/engine/util/util-js.vala"
					switch (c) {
#line 185 "../src/engine/util/util-js.vala"
						case '\x00':
#line 976 "util-js.c"
						{
							GString* _tmp7_;
#line 187 "../src/engine/util/util-js.vala"
							_tmp7_ = builder;
#line 187 "../src/engine/util/util-js.vala"
							g_string_append (_tmp7_, "\x00");
#line 188 "../src/engine/util/util-js.vala"
							break;
#line 985 "util-js.c"
						}
#line 185 "../src/engine/util/util-js.vala"
						case '\'':
#line 989 "util-js.c"
						{
							GString* _tmp8_;
#line 190 "../src/engine/util/util-js.vala"
							_tmp8_ = builder;
#line 190 "../src/engine/util/util-js.vala"
							g_string_append (_tmp8_, "\\\'");
#line 191 "../src/engine/util/util-js.vala"
							break;
#line 998 "util-js.c"
						}
#line 185 "../src/engine/util/util-js.vala"
						case '"':
#line 1002 "util-js.c"
						{
							GString* _tmp9_;
#line 193 "../src/engine/util/util-js.vala"
							_tmp9_ = builder;
#line 193 "../src/engine/util/util-js.vala"
							g_string_append (_tmp9_, "\\\"");
#line 194 "../src/engine/util/util-js.vala"
							break;
#line 1011 "util-js.c"
						}
#line 185 "../src/engine/util/util-js.vala"
						case '\\':
#line 1015 "util-js.c"
						{
							GString* _tmp10_;
#line 196 "../src/engine/util/util-js.vala"
							_tmp10_ = builder;
#line 196 "../src/engine/util/util-js.vala"
							g_string_append (_tmp10_, "\\\\");
#line 197 "../src/engine/util/util-js.vala"
							break;
#line 1024 "util-js.c"
						}
#line 185 "../src/engine/util/util-js.vala"
						case '\n':
#line 1028 "util-js.c"
						{
							GString* _tmp11_;
#line 199 "../src/engine/util/util-js.vala"
							_tmp11_ = builder;
#line 199 "../src/engine/util/util-js.vala"
							g_string_append (_tmp11_, "\\n");
#line 200 "../src/engine/util/util-js.vala"
							break;
#line 1037 "util-js.c"
						}
#line 185 "../src/engine/util/util-js.vala"
						case '\r':
#line 1041 "util-js.c"
						{
							GString* _tmp12_;
#line 202 "../src/engine/util/util-js.vala"
							_tmp12_ = builder;
#line 202 "../src/engine/util/util-js.vala"
							g_string_append (_tmp12_, "\\r");
#line 203 "../src/engine/util/util-js.vala"
							break;
#line 1050 "util-js.c"
						}
#line 185 "../src/engine/util/util-js.vala"
						case '\x0b':
#line 1054 "util-js.c"
						{
							GString* _tmp13_;
#line 205 "../src/engine/util/util-js.vala"
							_tmp13_ = builder;
#line 205 "../src/engine/util/util-js.vala"
							g_string_append (_tmp13_, "\x0b");
#line 206 "../src/engine/util/util-js.vala"
							break;
#line 1063 "util-js.c"
						}
#line 185 "../src/engine/util/util-js.vala"
						case '\t':
#line 1067 "util-js.c"
						{
							GString* _tmp14_;
#line 208 "../src/engine/util/util-js.vala"
							_tmp14_ = builder;
#line 208 "../src/engine/util/util-js.vala"
							g_string_append (_tmp14_, "\\t");
#line 209 "../src/engine/util/util-js.vala"
							break;
#line 1076 "util-js.c"
						}
#line 185 "../src/engine/util/util-js.vala"
						case '\b':
#line 1080 "util-js.c"
						{
							GString* _tmp15_;
#line 211 "../src/engine/util/util-js.vala"
							_tmp15_ = builder;
#line 211 "../src/engine/util/util-js.vala"
							g_string_append (_tmp15_, "\\b");
#line 212 "../src/engine/util/util-js.vala"
							break;
#line 1089 "util-js.c"
						}
#line 185 "../src/engine/util/util-js.vala"
						case '\f':
#line 1093 "util-js.c"
						{
							GString* _tmp16_;
#line 214 "../src/engine/util/util-js.vala"
							_tmp16_ = builder;
#line 214 "../src/engine/util/util-js.vala"
							g_string_append (_tmp16_, "\\f");
#line 215 "../src/engine/util/util-js.vala"
							break;
#line 1102 "util-js.c"
						}
						default:
						{
							GString* _tmp17_;
#line 217 "../src/engine/util/util-js.vala"
							_tmp17_ = builder;
#line 217 "../src/engine/util/util-js.vala"
							g_string_append_unichar (_tmp17_, c);
#line 218 "../src/engine/util/util-js.vala"
							break;
#line 1113 "util-js.c"
						}
					}
				}
			}
		}
	}
#line 222 "../src/engine/util/util-js.vala"
	_tmp18_ = builder;
#line 222 "../src/engine/util/util-js.vala"
	_tmp19_ = g_string_get_data (_tmp18_, &_tmp19__length1);
#line 222 "../src/engine/util/util-js.vala"
	_tmp20_ = _tmp19_;
#line 222 "../src/engine/util/util-js.vala"
	_tmp20__length1 = _tmp19__length1;
#line 222 "../src/engine/util/util-js.vala"
	_tmp21_ = g_strdup ((const gchar*) _tmp20_);
#line 222 "../src/engine/util/util-js.vala"
	result = _tmp21_;
#line 222 "../src/engine/util/util-js.vala"
	_g_string_free0 (builder);
#line 222 "../src/engine/util/util-js.vala"
	return result;
#line 1136 "util-js.c"
}

/**
     * Convenience method for returning a new Callable instance.
     */
GearyJSCallable*
geary_js_callable (const gchar* base_name)
{
	GearyJSCallable* result = NULL;
	GearyJSCallable* _tmp0_;
#line 228 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 229 "../src/engine/util/util-js.vala"
	_tmp0_ = geary_js_callable_new (base_name);
#line 229 "../src/engine/util/util-js.vala"
	result = _tmp0_;
#line 229 "../src/engine/util/util-js.vala"
	return result;
#line 1155 "util-js.c"
}

static inline gpointer
geary_js_callable_get_instance_private (GearyJSCallable* self)
{
	return G_STRUCT_MEMBER_P (self, GearyJSCallable_private_offset);
}

GearyJSCallable*
geary_js_callable_construct (GType object_type,
                             const gchar* base_name)
{
	GearyJSCallable* self = NULL;
	gchar* _tmp0_;
#line 241 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 241 "../src/engine/util/util-js.vala"
	self = (GearyJSCallable*) g_type_create_instance (object_type);
#line 242 "../src/engine/util/util-js.vala"
	_tmp0_ = g_strdup (base_name);
#line 242 "../src/engine/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 242 "../src/engine/util/util-js.vala"
	self->priv->base_name = _tmp0_;
#line 241 "../src/engine/util/util-js.vala"
	return self;
#line 1182 "util-js.c"
}

GearyJSCallable*
geary_js_callable_new (const gchar* base_name)
{
#line 241 "../src/engine/util/util-js.vala"
	return geary_js_callable_construct (GEARY_JS_TYPE_CALLABLE, base_name);
#line 1190 "util-js.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 1204 "util-js.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1208 "util-js.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1214 "util-js.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1219 "util-js.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1225 "util-js.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1229 "util-js.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1233 "util-js.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1237 "util-js.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1241 "util-js.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1245 "util-js.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1259 "util-js.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 1268 "util-js.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1275 "util-js.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1281 "util-js.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1289 "util-js.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1293 "util-js.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1299 "util-js.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1304 "util-js.c"
						const gchar* _tmp9_;
#line 1154 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1154 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1310 "util-js.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1314 "util-js.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1318 "util-js.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 1324 "util-js.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1155 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1330 "util-js.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1155 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1155 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1155 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1342 "util-js.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1346 "util-js.c"
				}
#line 1155 "glib-2.0.vapi"
				len = len + _tmp10_;
#line 1350 "util-js.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		if (i == 0) {
#line 1355 "util-js.c"
			gchar* _tmp15_;
#line 1158 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp15_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 1363 "util-js.c"
		}
#line 1160 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1161 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1161 "glib-2.0.vapi"
		len = len + (_tmp17_ * (i - 1));
#line 1163 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1163 "glib-2.0.vapi"
		res = _tmp18_;
#line 1164 "glib-2.0.vapi"
		_tmp19_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp21_;
#line 1385 "util-js.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp22_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 1394 "util-js.c"
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp22_) {
#line 1403 "util-js.c"
					gint _tmp23_;
#line 1165 "glib-2.0.vapi"
					_tmp23_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp23_ + 1;
#line 1409 "util-js.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 1417 "util-js.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp24_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp25_;
#line 1167 "glib-2.0.vapi"
				_tmp27_ = str_array[i];
#line 1167 "glib-2.0.vapi"
				if (_tmp27_ != NULL) {
#line 1429 "util-js.c"
					const gchar* _tmp28_;
#line 1167 "glib-2.0.vapi"
					_tmp28_ = str_array[i];
#line 1167 "glib-2.0.vapi"
					_tmp26_ = (const gchar*) _tmp28_;
#line 1435 "util-js.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp26_ = "";
#line 1439 "util-js.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp29_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp30_;
#line 1447 "util-js.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp31_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp31_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 1458 "util-js.c"
	} else {
		gchar* _tmp32_;
#line 1172 "glib-2.0.vapi"
		_tmp32_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp32_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 1467 "util-js.c"
	}
}

gchar*
geary_js_callable_to_string (GearyJSCallable* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 245 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 246 "../src/engine/util/util-js.vala"
	_tmp0_ = self->priv->base_name;
#line 246 "../src/engine/util/util-js.vala"
	_tmp1_ = g_strconcat (_tmp0_, "(", NULL);
#line 246 "../src/engine/util/util-js.vala"
	_tmp2_ = _tmp1_;
#line 246 "../src/engine/util/util-js.vala"
	_tmp3_ = self->priv->safe_args;
#line 246 "../src/engine/util/util-js.vala"
	_tmp3__length1 = self->priv->safe_args_length1;
#line 246 "../src/engine/util/util-js.vala"
	_tmp4_ = _vala_g_strjoinv (",", _tmp3_, (gint) _tmp3__length1);
#line 246 "../src/engine/util/util-js.vala"
	_tmp5_ = _tmp4_;
#line 246 "../src/engine/util/util-js.vala"
	_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 246 "../src/engine/util/util-js.vala"
	_tmp7_ = _tmp6_;
#line 246 "../src/engine/util/util-js.vala"
	_tmp8_ = g_strconcat (_tmp7_, ");", NULL);
#line 246 "../src/engine/util/util-js.vala"
	_tmp9_ = _tmp8_;
#line 246 "../src/engine/util/util-js.vala"
	_g_free0 (_tmp7_);
#line 246 "../src/engine/util/util-js.vala"
	_g_free0 (_tmp5_);
#line 246 "../src/engine/util/util-js.vala"
	_g_free0 (_tmp2_);
#line 246 "../src/engine/util/util-js.vala"
	result = _tmp9_;
#line 246 "../src/engine/util/util-js.vala"
	return result;
#line 1520 "util-js.c"
}

static gpointer
_geary_js_callable_ref0 (gpointer self)
{
#line 251 "../src/engine/util/util-js.vala"
	return self ? geary_js_callable_ref (self) : NULL;
#line 1528 "util-js.c"
}

GearyJSCallable*
geary_js_callable_string (GearyJSCallable* self,
                          const gchar* value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GearyJSCallable* _tmp6_;
#line 249 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 249 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 250 "../src/engine/util/util-js.vala"
	_tmp0_ = geary_js_escape_string (value);
#line 250 "../src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 250 "../src/engine/util/util-js.vala"
	_tmp2_ = g_strconcat ("\"", _tmp1_, NULL);
#line 250 "../src/engine/util/util-js.vala"
	_tmp3_ = _tmp2_;
#line 250 "../src/engine/util/util-js.vala"
	_tmp4_ = g_strconcat (_tmp3_, "\"", NULL);
#line 250 "../src/engine/util/util-js.vala"
	_tmp5_ = _tmp4_;
#line 250 "../src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp5_);
#line 250 "../src/engine/util/util-js.vala"
	_g_free0 (_tmp5_);
#line 250 "../src/engine/util/util-js.vala"
	_g_free0 (_tmp3_);
#line 250 "../src/engine/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 251 "../src/engine/util/util-js.vala"
	_tmp6_ = _geary_js_callable_ref0 (self);
#line 251 "../src/engine/util/util-js.vala"
	result = _tmp6_;
#line 251 "../src/engine/util/util-js.vala"
	return result;
#line 1573 "util-js.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 938 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 938 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 938 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 938 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 938 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 938 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 938 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 938 "glib-2.0.vapi"
	result = _tmp4_;
#line 938 "glib-2.0.vapi"
	return result;
#line 1604 "util-js.c"
}

GearyJSCallable*
geary_js_callable_double (GearyJSCallable* self,
                          gdouble value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyJSCallable* _tmp2_;
#line 254 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 255 "../src/engine/util/util-js.vala"
	_tmp0_ = double_to_string (value);
#line 255 "../src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 255 "../src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp1_);
#line 255 "../src/engine/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 256 "../src/engine/util/util-js.vala"
	_tmp2_ = _geary_js_callable_ref0 (self);
#line 256 "../src/engine/util/util-js.vala"
	result = _tmp2_;
#line 256 "../src/engine/util/util-js.vala"
	return result;
#line 1631 "util-js.c"
}

GearyJSCallable*
geary_js_callable_int (GearyJSCallable* self,
                       gint value)
{
	GearyJSCallable* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GearyJSCallable* _tmp2_;
#line 259 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 260 "../src/engine/util/util-js.vala"
	_tmp0_ = g_strdup_printf ("%i", value);
#line 260 "../src/engine/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 260 "../src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp1_);
#line 260 "../src/engine/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 261 "../src/engine/util/util-js.vala"
	_tmp2_ = _geary_js_callable_ref0 (self);
#line 261 "../src/engine/util/util-js.vala"
	result = _tmp2_;
#line 261 "../src/engine/util/util-js.vala"
	return result;
#line 1658 "util-js.c"
}

GearyJSCallable*
geary_js_callable_bool (GearyJSCallable* self,
                        gboolean value)
{
	GearyJSCallable* result = NULL;
	const gchar* _tmp0_ = NULL;
	GearyJSCallable* _tmp1_;
#line 264 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (GEARY_JS_IS_CALLABLE (self), NULL);
#line 265 "../src/engine/util/util-js.vala"
	if (value) {
#line 265 "../src/engine/util/util-js.vala"
		_tmp0_ = "true";
#line 1674 "util-js.c"
	} else {
#line 265 "../src/engine/util/util-js.vala"
		_tmp0_ = "false";
#line 1678 "util-js.c"
	}
#line 265 "../src/engine/util/util-js.vala"
	geary_js_callable_add_param (self, _tmp0_);
#line 266 "../src/engine/util/util-js.vala"
	_tmp1_ = _geary_js_callable_ref0 (self);
#line 266 "../src/engine/util/util-js.vala"
	result = _tmp1_;
#line 266 "../src/engine/util/util-js.vala"
	return result;
#line 1688 "util-js.c"
}

static void
_vala_array_add24 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 270 "../src/engine/util/util-js.vala"
	if ((*length) == (*size)) {
#line 270 "../src/engine/util/util-js.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 270 "../src/engine/util/util-js.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1703 "util-js.c"
	}
#line 270 "../src/engine/util/util-js.vala"
	(*array)[(*length)++] = value;
#line 270 "../src/engine/util/util-js.vala"
	(*array)[*length] = NULL;
#line 1709 "util-js.c"
}

static inline void
geary_js_callable_add_param (GearyJSCallable* self,
                             const gchar* value)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
#line 269 "../src/engine/util/util-js.vala"
	g_return_if_fail (GEARY_JS_IS_CALLABLE (self));
#line 269 "../src/engine/util/util-js.vala"
	g_return_if_fail (value != NULL);
#line 270 "../src/engine/util/util-js.vala"
	_tmp0_ = self->priv->safe_args;
#line 270 "../src/engine/util/util-js.vala"
	_tmp0__length1 = self->priv->safe_args_length1;
#line 270 "../src/engine/util/util-js.vala"
	_tmp1_ = g_strdup (value);
#line 270 "../src/engine/util/util-js.vala"
	_vala_array_add24 (&self->priv->safe_args, &self->priv->safe_args_length1, &self->priv->_safe_args_size_, _tmp1_);
#line 1731 "util-js.c"
}

static void
geary_js_value_callable_init (GValue* value)
{
#line 235 "../src/engine/util/util-js.vala"
	value->data[0].v_pointer = NULL;
#line 1739 "util-js.c"
}

static void
geary_js_value_callable_free_value (GValue* value)
{
#line 235 "../src/engine/util/util-js.vala"
	if (value->data[0].v_pointer) {
#line 235 "../src/engine/util/util-js.vala"
		geary_js_callable_unref (value->data[0].v_pointer);
#line 1749 "util-js.c"
	}
}

static void
geary_js_value_callable_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 235 "../src/engine/util/util-js.vala"
	if (src_value->data[0].v_pointer) {
#line 235 "../src/engine/util/util-js.vala"
		dest_value->data[0].v_pointer = geary_js_callable_ref (src_value->data[0].v_pointer);
#line 1761 "util-js.c"
	} else {
#line 235 "../src/engine/util/util-js.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1765 "util-js.c"
	}
}

static gpointer
geary_js_value_callable_peek_pointer (const GValue* value)
{
#line 235 "../src/engine/util/util-js.vala"
	return value->data[0].v_pointer;
#line 1774 "util-js.c"
}

static gchar*
geary_js_value_callable_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 235 "../src/engine/util/util-js.vala"
	if (collect_values[0].v_pointer) {
#line 1785 "util-js.c"
		GearyJSCallable * object;
		object = collect_values[0].v_pointer;
#line 235 "../src/engine/util/util-js.vala"
		if (object->parent_instance.g_class == NULL) {
#line 235 "../src/engine/util/util-js.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1792 "util-js.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 235 "../src/engine/util/util-js.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1796 "util-js.c"
		}
#line 235 "../src/engine/util/util-js.vala"
		value->data[0].v_pointer = geary_js_callable_ref (object);
#line 1800 "util-js.c"
	} else {
#line 235 "../src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 1804 "util-js.c"
	}
#line 235 "../src/engine/util/util-js.vala"
	return NULL;
#line 1808 "util-js.c"
}

static gchar*
geary_js_value_callable_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	GearyJSCallable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 235 "../src/engine/util/util-js.vala"
	if (!object_p) {
#line 235 "../src/engine/util/util-js.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1823 "util-js.c"
	}
#line 235 "../src/engine/util/util-js.vala"
	if (!value->data[0].v_pointer) {
#line 235 "../src/engine/util/util-js.vala"
		*object_p = NULL;
#line 1829 "util-js.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 235 "../src/engine/util/util-js.vala"
		*object_p = value->data[0].v_pointer;
#line 1833 "util-js.c"
	} else {
#line 235 "../src/engine/util/util-js.vala"
		*object_p = geary_js_callable_ref (value->data[0].v_pointer);
#line 1837 "util-js.c"
	}
#line 235 "../src/engine/util/util-js.vala"
	return NULL;
#line 1841 "util-js.c"
}

GParamSpec*
geary_js_param_spec_callable (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	GearyJSParamSpecCallable* spec;
#line 235 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_JS_TYPE_CALLABLE), NULL);
#line 235 "../src/engine/util/util-js.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 235 "../src/engine/util/util-js.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 235 "../src/engine/util/util-js.vala"
	return G_PARAM_SPEC (spec);
#line 1860 "util-js.c"
}

gpointer
geary_js_value_get_callable (const GValue* value)
{
#line 235 "../src/engine/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE), NULL);
#line 235 "../src/engine/util/util-js.vala"
	return value->data[0].v_pointer;
#line 1870 "util-js.c"
}

void
geary_js_value_set_callable (GValue* value,
                             gpointer v_object)
{
	GearyJSCallable * old;
#line 235 "../src/engine/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
#line 235 "../src/engine/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 235 "../src/engine/util/util-js.vala"
	if (v_object) {
#line 235 "../src/engine/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
#line 235 "../src/engine/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 235 "../src/engine/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 235 "../src/engine/util/util-js.vala"
		geary_js_callable_ref (value->data[0].v_pointer);
#line 1892 "util-js.c"
	} else {
#line 235 "../src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 1896 "util-js.c"
	}
#line 235 "../src/engine/util/util-js.vala"
	if (old) {
#line 235 "../src/engine/util/util-js.vala"
		geary_js_callable_unref (old);
#line 1902 "util-js.c"
	}
}

void
geary_js_value_take_callable (GValue* value,
                              gpointer v_object)
{
	GearyJSCallable * old;
#line 235 "../src/engine/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_JS_TYPE_CALLABLE));
#line 235 "../src/engine/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 235 "../src/engine/util/util-js.vala"
	if (v_object) {
#line 235 "../src/engine/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_JS_TYPE_CALLABLE));
#line 235 "../src/engine/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 235 "../src/engine/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 1923 "util-js.c"
	} else {
#line 235 "../src/engine/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 1927 "util-js.c"
	}
#line 235 "../src/engine/util/util-js.vala"
	if (old) {
#line 235 "../src/engine/util/util-js.vala"
		geary_js_callable_unref (old);
#line 1933 "util-js.c"
	}
}

static void
geary_js_callable_class_init (GearyJSCallableClass * klass,
                              gpointer klass_data)
{
#line 235 "../src/engine/util/util-js.vala"
	geary_js_callable_parent_class = g_type_class_peek_parent (klass);
#line 235 "../src/engine/util/util-js.vala"
	((GearyJSCallableClass *) klass)->finalize = geary_js_callable_finalize;
#line 235 "../src/engine/util/util-js.vala"
	g_type_class_adjust_private_offset (klass, &GearyJSCallable_private_offset);
#line 1947 "util-js.c"
}

static void
geary_js_callable_instance_init (GearyJSCallable * self,
                                 gpointer klass)
{
	gchar** _tmp0_;
#line 235 "../src/engine/util/util-js.vala"
	self->priv = geary_js_callable_get_instance_private (self);
#line 238 "../src/engine/util/util-js.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 238 "../src/engine/util/util-js.vala"
	self->priv->safe_args = _tmp0_;
#line 238 "../src/engine/util/util-js.vala"
	self->priv->safe_args_length1 = 0;
#line 238 "../src/engine/util/util-js.vala"
	self->priv->_safe_args_size_ = self->priv->safe_args_length1;
#line 235 "../src/engine/util/util-js.vala"
	self->ref_count = 1;
#line 1967 "util-js.c"
}

static void
geary_js_callable_finalize (GearyJSCallable * obj)
{
	GearyJSCallable * self;
#line 235 "../src/engine/util/util-js.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_JS_TYPE_CALLABLE, GearyJSCallable);
#line 235 "../src/engine/util/util-js.vala"
	g_signal_handlers_destroy (self);
#line 237 "../src/engine/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 238 "../src/engine/util/util-js.vala"
	self->priv->safe_args = (_vala_array_free (self->priv->safe_args, self->priv->safe_args_length1, (GDestroyNotify) g_free), NULL);
#line 1982 "util-js.c"
}

/**
     * A class for constructing a well formed, safe, invokable JS call.
     */
GType
geary_js_callable_get_type (void)
{
	static volatile gsize geary_js_callable_type_id__volatile = 0;
	if (g_once_init_enter (&geary_js_callable_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { geary_js_value_callable_init, geary_js_value_callable_free_value, geary_js_value_callable_copy_value, geary_js_value_callable_peek_pointer, "p", geary_js_value_callable_collect_value, "p", geary_js_value_callable_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GearyJSCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_js_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyJSCallable), 0, (GInstanceInitFunc) geary_js_callable_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType geary_js_callable_type_id;
		geary_js_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearyJSCallable", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GearyJSCallable_private_offset = g_type_add_instance_private (geary_js_callable_type_id, sizeof (GearyJSCallablePrivate));
		g_once_init_leave (&geary_js_callable_type_id__volatile, geary_js_callable_type_id);
	}
	return geary_js_callable_type_id__volatile;
}

gpointer
geary_js_callable_ref (gpointer instance)
{
	GearyJSCallable * self;
	self = instance;
#line 235 "../src/engine/util/util-js.vala"
	g_atomic_int_inc (&self->ref_count);
#line 235 "../src/engine/util/util-js.vala"
	return instance;
#line 2013 "util-js.c"
}

void
geary_js_callable_unref (gpointer instance)
{
	GearyJSCallable * self;
	self = instance;
#line 235 "../src/engine/util/util-js.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 235 "../src/engine/util/util-js.vala"
		GEARY_JS_CALLABLE_GET_CLASS (self)->finalize (self);
#line 235 "../src/engine/util/util-js.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2027 "util-js.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

